;***************************************************************************
;*                                                                         *
;*     Z80 DisAssembler for the Amiga computer.   V1.0c    L.Davison '94   *
;*                                                                         *
;***************************************************************************

; Disassembly list of Micron2.bin

; ports used ...
; write 02,04,07,2A,2B,2C,46,48,49,4A,4C,4D,4F
; read  00,05,0B,0D,28,2D,33,49,4B,4E

LCD_D:	EQU	03h		; LCD data port
Port_05:	EQU	05h
RTC_A:	EQU	08h		; RTC address port
LCD_C:	EQU	23h		; LCD command port
RTC_D:	EQU	28h		; RTC data port
Port_2D:	EQU	2Dh
Port_47:	EQU	47h		; memory page

LAB_F5F3	EQU	F5F3h		; IRQ routine address
LAB_F5F6	EQU	F5F6h		; NMI routine address
LAB_FBDC	EQU	FBDCh		; cursor blink flag (0/1 = blink/no blink)
LAB_FBF4	EQU	FBF4h		; cursor y position
LAB_FBF5	EQU	FBF5h		; cursor x position
LAB_FD4B	EQU	FD4Bh		; saved date
LAB_FD4C	EQU	FD4Ch		; saved month
LAB_FDAB	EQU	FDABh		; ROM 0 checksum
LAB_FDAD	EQU	FDADh		; ROM 1 checksum
LAB_FDAF	EQU	FDAFh		; self test status flags result
LAB_FDB2	EQU	FDB2h		; bank select status flags
LAB_FDB3	EQU	FDB3h		; ROM 0 test result
LAB_FDB4	EQU	FDB4h		; ROM 1 test result
LAB_FDB5	EQU	FDB5h		; clock test status flags
LAB_FDB6	EQU	FDB6h		; powerdown test status flags
LAB_FEA7	EQU	FEA7h		; first RAM bank #
LAB_FEAB	EQU	FEABh		; contig RAM size (KB)
LAB_FEAD	EQU	FEADh		; full RAM size (KB)

LAB_0038	EQU	0038h		; IRQ vector
LAB_0066	EQU	0066h		; NMI vector

	ORG	0000h

	JP	LAB_F238	;0000:	C338F2
	NOP			;0003:	00
LAB_0004
	NOP			;0004:	00
LAB_0005
	DB	C3h			; JP opcode
LAB_0006
	DW	LAB_F180		; default jump address (BDOS function handler)

LAB_0008
	JP	LAB_F5E1	;0008:	C3E1F5
	NOP			;000B:	00
	NOP			;000C:	00
	NOP			;000D:	00
	NOP			;000E:	00
	NOP			;000F:	00
LAB_0010
	POP	HL			; pop return address
	LD	E,(HL)		; get next byte after RST (page #)
	LD	A,(LAB_F791)	; get current memory page
	CP	E			; compare with byte
	JP	NZ,LAB_D74B		; jump if not the same page (LAB_70FA)

	INC	HL			; else point to routine address
	LD	A,(HL)		; get subroutine address low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get subroutine address high byte
	LD	L,A			; copy subroutine address low byte to L
	JP	(HL)			; go do subroutine

	NOP			;001F:	00
LAB_0020
	JP	LAB_F5EA	;0020:	C3EAF5
	NOP			;0023:	00
	NOP			;0024:	00
	NOP			;0025:	00
	NOP			;0026:	00
	NOP			;0027:	00
	JP	LAB_F5ED	;0028:	C3EDF5
	NOP			;002B:	00
	NOP			;002C:	00
	NOP			;002D:	00
	NOP			;002E:	00
	NOP			;002F:	00
	JP	LAB_F5F0	;0030:	C3F0F5
	NOP			;0033:	00
	NOP			;0034:	00
	NOP			;0035:	00
	NOP			;0036:	00
	NOP			;0037:	00
LAB_0038
	JP	LAB_F5F3	; IRQ vector
	NOP			;003B:	00
	NOP			;003C:	00
	NOP			;003D:	00
	NOP			;003E:	00
	NOP			;003F:	00
LAB_0040
	LD	A,#00h		;0040:	3E00
	OUT	(Port_47),A		; reset memory page
	JP	LAB_3ADD	;0044:	C3DD3A
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h
LAB_0066
	JP	LAB_F5F6	; NMI vector
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h
LAB_0080
	LD	BC,0D00h	;0080:	01000D
	INC	D		;0083:	14
	NOP			;0084:	00
	NOP			;0085:	00
	NOP			;0086:	00
	NOP			;0087:	00
	RST	38h		;0088:	FF
	NOP			;0089:	00
	NOP			;008A:	00
	NOP			;008B:	00
	NOP			;008C:	00
	RST	38h		;008D:	FF
	NOP			;008E:	00
	NOP			;008F:	00
	NOP			;0090:	00
	RST	38h		;0091:	FF
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	NOP			;009A:	00
	ADD	A,B		;009B:	80
	RST	38h		;009C:	FF
	RST	38h		;009D:	FF
	NOP			;009E:	00
	NOP			;009F:	00
	RST	38h		;00A0:	FF
	RST	38h		;00A1:	FF
	NOP			;00A2:	00
	NOP			;00A3:	00
	NOP			;00A4:	00
	ADD	A,B		;00A5:	80
	NOP			;00A6:	00
	NOP			;00A7:	00
	NOP			;00A8:	00
	NOP			;00A9:	00
	NOP			;00AA:	00
	ADD	A,B		;00AB:	80
	NOP			;00AC:	00
	NOP			;00AD:	00
	RST	38h		;00AE:	FF
	RST	38h		;00AF:	FF
	NOP			;00B0:	00
	NOP			;00B1:	00
	NOP			;00B2:	00
	NOP			;00B3:	00
	NOP			;00B4:	00
	ADD	A,B		;00B5:	80
	RST	38h		;00B6:	FF
	RST	38h		;00B7:	FF
	RST	38h		;00B8:	FF
	RST	38h		;00B9:	FF
	LD	BC,0100h	;00BA:	010001
	NOP			;00BD:	00
	NOP			;00BE:	00
	NOP			;00BF:	00
	RRA			;00C0:	1F
	NOP			;00C1:	00
	INC	C		;00C2:	0C
	NOP			;00C3:	00
	LD	H,E		;00C4:	63
	NOP			;00C5:	00
	NOP			;00C6:	00
	INC	BC		;00C7:	03
	LD	B,#1Fh		;00C8:	061F
	DEC	E		;00CA:	1D
	RRA			;00CB:	1F
	LD	E,#1Fh		;00CC:	1E1F
	LD	E,#1Fh		;00CE:	1E1F
	RRA			;00D0:	1F
	LD	E,#1Fh		;00D1:	1E1F
	LD	E,#1Fh		;00D3:	1E1F
	RLA			;00D5:	17
	NOP			;00D6:	00
	DEC	SP		;00D7:	3B
	NOP			;00D8:	00
	NOP			;00D9:	00
	INC	BC		;00DA:	03
	SCF			;00DB:	37
	DB	01h

LAB_00DD				; (LAB_E357)
	DB	1Bh,"R",00h		; [ESC] "R" set cursor on
LAB_00E0				; (LAB_E35A)
	DB	1Bh,"K",00h		; [ESC] "K" clear display & home cursor
LAB_00E3				; (LAB_E35D)
	DB	1Bh,"Y",00h		; [ESC] "Y" set cursor Y position
LAB_00E6				; (LAB_E360)
	DB	1Bh,"X",00h		; [ESC] "X" set cursor X position
LAB_00E9				; (LAB_E363)
	DB	1Bh,"H",00h		; [ESC] "H" home cursor
LAB_00EC				; (LAB_E366)
	DB	1Bh,"C",00h		; [ESC] "C" invert cursor blink
LAB_00EF				; (LAB_E369)
	DB	1Bh,"B",00h		; [ESC] "B" set cursor off & blink ??
LAB_00F2				; (LAB_E36C)
	DB	1Bh,"A",00h		; [ESC] "A" set cursor on & no blink ??

	NOP			;00F5:	00
	NOP			;00F6:	00
	NOP			;00F7:	00
	DB	00h,00h,00h,00h,00h,00h,00h,00h

LAB_0100
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC5D)	; get word
	PUSH	HL			; push word
	CALL	LAB_65C0		; puts 0001h @ (LAB_E8D6) & word @ (LAB_E8D6)+2
	POP	DE			; dump word
	CALL	LAB_214C		; store word 0001h @ LAB_EB1C
	LD	HL,0001h		; set HL=0001
	RET				;

; copy string_1 to string_2 (& remove trailing spaces)

; stack is ..
; source string			(word)	pointer_1
; destination string		(word)	pointer_2
; destination string length	(byte)	offset_2
; source string length		(byte)	offset_1
; end.

LAB_0115
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
LAB_011B
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get offset_1 byte
	LD	D,#00h		; clear high byte (byte is unsigned 0-255)
	LD	HL,0000h		; clear HL (set compare word to 0)
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL
					; (LAB_7BC1 ROM 1)
	JP	Z,LAB_0155		; jump if offset_1 was =0 ??

					; offset_1 was >0

	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get offset_1 byte
	LD	D,#00h		; clear high byte
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		; get pointer_1 low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get pointer_1 high byte
	LD	L,A			; copy low byte to L
	ADD	HL,DE			; add offset_1 byte
	DEC	HL			; decrement pointer
	LD	E,(HL)		; get byte from pointer_1+offset_1
	LD	D,#00h		; clear high byte
	LD	HL,0020h		; compare with ' ' chr ??
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_0155		; exit loop if not ' '

					; decrement offset_1 and loop

	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get pointer to last pushed but 3 before call
	PUSH	HL			; push pointer
	LD	L,(HL)		; get offset_1
	DEC	HL			; decrement it
	EX	DE,HL			; copy to DE
	POP	HL			; restore pointer
	LD	(HL),E		; save decremented offset_1 value
	JP	LAB_011B		; go loop

					; gets here if offset_1=0 or (pointer_1+offset_1)<>' '

LAB_0155
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get offset_1 byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; save to stack
LAB_015D
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get offset_2 byte
	LD	D,#00h		; clear high byte
	POP	HL			; pop offset_1 byte
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_018C		; jump if offset_1<=offset_2

	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get offset_2 low byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; push offset_2 on stack
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get pointer_2 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer_2 high byte
	PUSH	DE			; push pointer_2 on stack
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get pointer_1 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer_1 high byte
	PUSH	DE			; push pointer_1 on stack
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	JP	LAB_01E2		; set HL=0001 & return

					; copy pointer_1 string to pointer_2
LAB_018C
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	A,(HL)		; get offset_1
	OR	A			; set the flags
	JP	Z,LAB_01B3		; iff null string go clear pointer_2 string

					; copy pointer_1 string to pointer_2 (shorten _2 if needed)

	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get offset_1 byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; save as chr count
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get pointer_2 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer_2 high byte
	PUSH	DE			; push destination pointer
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get pointer_1 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer_1 high byte
	PUSH	DE			; push source pointer
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count

					; reduce pointer_2 string to pointer_1 string length
					; (pad with nulls)
LAB_01B3
	LD	HL,0000h		; set fill byte to null
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get offset_1 byte
	LD	D,#00h		; clear offset_1 high byte
	PUSH	DE			; push offset_1
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get offset_2 byte
	LD	D,#00h		; clear high byte
	POP	HL			; get offset_1 back
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL			; push offset_2-offset_1
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get offset_1 byte
	LD	D,#00h		; clear high byte
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	A,(HL)		; get pointer_2 low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get pointer_2 high byte
	LD	L,A			; copy low byte to L
	ADD	HL,DE			; add offset_1
	PUSH	HL			; push destination pointer
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
LAB_01E2
	LD	HL,0001h		; set HL = 0001
	RET				;

; copy string from pointer_1 to pointer_2, pad string_2 with spaces if longer

; stack is ..
; pointer_1	(word)
; pointer_2	(word)
; ??	(byte)
; ??	(byte)
; end.

LAB_01E6
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
LAB_01EC
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get ??2 byte
	LD	D,#00h		; clear high byte
	LD	HL,0000h		; clear HL
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL
					; (LAB_7BC1 ROM 1)
	JP	Z,LAB_024A		; jump if ??2 =0

					; ??2 was not null

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get pointer_1 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer_1 high byte
	EX	DE,HL			; copy to HL
	LD	E,(HL)		; get byte from pointer
	PUSH	DE			; push it
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get pointer_2 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer_2 high byte
	EX	DE,HL			; copy to DE
	POP	DE			; get byte back
	LD	(HL),E		; copy to pointer_2
	LD	A,E			; copy byte
	OR	E			; set the flags
	JP	Z,LAB_024A		; jump if zero byte

	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	PUSH	HL			; save pointer
	LD	L,(HL)		; get ??2
	DEC	HL			; decrement it
	EX	DE,HL			; copy to DE
	POP	HL			; restore pointer
	LD	(HL),E		; save ??2
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	PUSH	HL			; save pointer
	LD	L,(HL)		; get ??3
	DEC	HL			; decrement it
	EX	DE,HL			; copy to DE
	POP	HL			; restore pointer
	LD	(HL),E		; save ??3
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	PUSH	HL			; save pointer
	LD	A,(HL)		; get pointer_2 low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get pointer_2 high byte
	LD	L,A			; copy low byte to L
	INC	HL			; increment pointer
	EX	DE,HL			; copy to DE
	POP	HL			; restore pointer
	LD	(HL),E		; save pointer_2 low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save pointer_2 high byte
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL			; save pointer
	LD	A,(HL)		; get pointer_1 low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get pointer_1 high byte
	LD	L,A			; copy low byte to L
	INC	HL			; increment pointer
	EX	DE,HL			; copy to DE
	POP	HL			; restore pointer
	LD	(HL),E		; save pointer_1 low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save pointer_1 high byte
	JP	LAB_01EC		; loop

LAB_024A
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	A,(HL)		; get ??3 byte
	OR	A			; set the flags
	JP	Z,LAB_026D		; jump if ??3 =0

					; ??3 wasn't null

	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get ??3 byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; push count
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get pointer_2 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer_2 high byte
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
LAB_026D
	LD	HL,0001h		; set HL=0001
	RET				;

; stack
; pointer	(word)
; pointer_1	(word)
; ??	(word)
; end.

LAB_0271
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after
					; putting (HL=0) in Z (LAB_71E6 ROM 1)

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get table pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get table pointer high byte
	LD	HL,000Ch		; offset to add
	ADD	HL,DE			; add table pointer
	PUSH	HL			; save table pointer+0Ch

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get table pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get table pointer high byte
	LD	HL,000Ah		; offset to add
	ADD	HL,DE			; add table pointer
	LD	E,(HL)		; get byte from table pointer+0Ah
	LD	D,#00h		; clear high byte
	PUSH	DE			; save byte

	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get ?? pointer1 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ?? pointer1 high byte
	PUSH	DE			; save ?? pointer1
	CALL	LAB_DBEE		; search for null byte from pointer
					; returns offset to null in HL
	POP	DE			; dump ?? pointer1
	PUSH	HL			; save offset

	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get table pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get table pointer high byte
	LD	HL,0008h		; offset to add
	ADD	HL,DE			; add table pointer
	LD	E,(HL)		; get byte from table pointer+08h
	LD	D,#00h		; clear high byte
	PUSH	DE			; save byte

	LD	HL,0018h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get ?? pointer2 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ?? pointer2 high byte
	PUSH	DE			; save ?? pointer2

	LD	HL,0018h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get ?? pointer1 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ?? pointer1 high byte
	PUSH	DE			; save ?? pointer1

	LD	HL,0018h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get table pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get table pointer high byte
	EX	DE,HL			; swap into HL
	LD	E,(HL)		; get ?? pointerS low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ?? pointerS high byte
	EX	DE,HL			; swap into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	EX	DE,HL			; swap back
	LD	HL,000Ch		; 0Ch ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	JP	NZ,LAB_02DE	;02D3:	C2DE02

	LD	HL,238Ch	;02D6:	218C23
	PUSH	HL		;02D9:	E5
	CALL	LAB_170A	;02DA:	CD0A17
	POP	DE		;02DD:	D1
LAB_02DE
	RET				;

; just does HL=0000h

LAB_02DF
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h		; set HL = 0000h
	RET				;

; copy (LAB_EC6D) to (LAB_EB43)

LAB_02E9
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC6D)	;02EF:	2A6DEC
	LD	(LAB_EB43),HL	;02F2:	2243EB
	LD	HL,0001h		; set HL = 0001h
	RET				;

; copy (LAB_EB43) to (LAB_EC6D)

LAB_02F9
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EB43)	;02FF:	2A43EB
	LD	(LAB_EC6D),HL	;0302:	226DEC
	LD	HL,0001h		; set HL = 0001h
	RET				;

; copy (LAB_EC6F) to (LAB_EB43)

LAB_0309
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC6F)	;030F:	2A6FEC
	LD	(LAB_EB43),HL	;0312:	2243EB
	LD	HL,0001h		; set HL = 0001h
	RET				;

; copy word from (LAB_EB43) to(LAB_EC6F)

LAB_0319
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EB43)	;031F:	2A43EB
	LD	(LAB_EC6F),HL	;0322:	226FEC
	LD	HL,0001h		; set HL = 0001h
	RET				;

; just does HL=0001h

LAB_0329
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_0333
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	CALL	LAB_2116		; get HL from (LAB_EC41)
	LD	DE,000Dh	;033C:	110D00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_03BF	;0342:	CABF03
	LD	HL,LAB_D0F0	;0345:	21F0D0 (LAB_7C3A)
	LD	(LAB_D2CD),HL	;0348:	22CDD2
	LD	A,(LAB_EC7E)	;034B:	3A7EEC
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,HL		;0351:	29
	LD	DE,LAB_D081	;0352:	1181D0
	ADD	HL,DE		;0355:	19
	LD	E,(HL)		;0356:	5E
	INC	HL		;0357:	23
	LD	D,(HL)		;0358:	56
	EX	DE,HL		;0359:	EB
	LD	(LAB_D2CB),HL	;035A:	22CBD2
	LD	HL,(LAB_D2CB)	;035D:	2ACBD2
	LD	DE,LAB_D0F0	;0360:	11F0D0
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
LAB_0366
	JP	Z,LAB_038C	;0366:	CA8C03
	LD	HL,(LAB_D2CD)	;0369:	2ACDD2
	PUSH	HL		;036C:	E5
	LD	HL,(LAB_D2CB)	;036D:	2ACBD2
	PUSH	HL		;0370:	E5
	LD	HL,LAB_EC71	;0371:	2171EC
	PUSH	HL		;0374:	E5
	CALL	LAB_07EE	;0375:	CDEE07
	POP	DE		;0378:	D1
	POP	DE		;0379:	D1
	POP	DE		;037A:	D1
	LD	DE,0000h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_038C		; jump if DE+ve

	CALL	LAB_177B	;0385:	CD7B17
	CALL	LAB_0100	;0388:	CD0001
	RET				;

LAB_038C
	LD	A,(LAB_ECC7)	;038C:	3AC7EC
	OR	A		;038F:	B7
	JP	Z,LAB_03AA	;0390:	CAAA03
	LD	A,(LAB_ECC8)	;0393:	3AC8EC
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0001h	;0399:	110100
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	PUSH	HL		;039F:	E5
	CALL	LAB_EF18	;03A0:	CD18EF
	POP	DE		;03A3:	D1
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EB18),HL	;03A7:	2218EB
LAB_03AA
	LD	HL,LAB_EC71	;03AA:	2171EC
	PUSH	HL		;03AD:	E5
	CALL	LAB_106F	;03AE:	CD6F10
	POP	DE		;03B1:	D1
	LD	HL,0000h	;03B2:	210000
	LD	(LAB_EB18),HL	;03B5:	2218EB
	CALL	LAB_177B	;03B8:	CD7B17
	CALL	LAB_0100	;03BB:	CD0001
	RET				;

LAB_03BF
	LD	HL,0001h		; set HL = 0001h
	RET				;

; get system time ??

LAB_03C3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	CALL	LAB_2116		; get HL from (LAB_EC41)
	JP	NZ,LAB_03DF		; exit if ??

	LD	HL,LAB_EC7F		; point to hour/minute
	PUSH	HL			; push pointer
	CALL	LAB_EF0C	;03D3:	CD0CEF
	POP	DE			; dump pointer
	LD	HL,LAB_EC81		; point to date, month & year
	PUSH	HL			; push pointer
	CALL	LAB_EF08	;03DB:	CD08EF
	POP	DE			; dump pointer
LAB_03DF
	LD	HL,0001h		; set HL = 0001h
	RET				;

; set clock from ??

LAB_03E3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC61)	;03E9:	2A61EC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_0407		; if null exit

	LD	HL,(LAB_EC7F)	; get hour/minute (H = hour, L = minute)
	PUSH	HL			; push hour/minute
	CALL	LAB_EF20		; set RTC hours & minutes
	POP	DE			; dump hour/minute
	LD	HL,LAB_EC81		; point to date, month & year
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC5B		; does push (LAB_E3B1).L	(LAB_7796 ROM 1)
	CALL	LAB_EF1C		; set RTC date, month & year
	POP	DE			; dump month/date
	POP	DE			; dump year
LAB_0407
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_040B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	CALL	LAB_2116		; get HL from (LAB_EC41)
	JP	NZ,LAB_041D	;0414:	C21D04

	CALL	LAB_0A42	;0417:	CD420A
	LD	(LAB_EC87),HL	;041A:	2287EC
LAB_041D
	LD	HL,0001h		; set HL = 0001h
	RET				;

; set HL = 0001h, whatever (LAB_EC41) is

LAB_0421
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	CALL	LAB_2116		; get HL from (LAB_EC41)
	JP	Z,LAB_0431	;042A:	CA3104

	LD	HL,0001h		; set HL = 0001h eh?
	RET				;

LAB_0431
	LD	HL,0001h		; set HL = 0001h huh?
	RET				;

; null terminated string out to screen

; stack is ..
; pointer
; end.

LAB_0435
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
LAB_043B
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get string pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get string pointer high byte
	EX	DE,HL			; swap pointer to HL
	LD	A,(HL)		; get character from string
	OR	A			; set the flags
	JP	Z,LAB_0464		; exit if null byte

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL			; save string pointer pointer
	LD	A,(HL)		; get string pointer low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get string pointer high byte
	LD	L,A			; copy low byte to L
	INC	HL			; point to next character
	EX	DE,HL			; swap pointer to DE
	POP	HL			; restore string pointer pointer
	LD	(HL),E		; save new string pointer low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save new string pointer low byte
	EX	DE,HL			; swap pointer to HL
	DEC	HL			; point to current character
	LD	E,(HL)		; get character
	LD	D,#00h		; clear high byte
	PUSH	DE			; push character
	CALL	LAB_720D		; character out to screen & buffer
	POP	DE			; dump character
	JP	LAB_043B		; loop

LAB_0464
	RET				;

; print centre justified string on line #

; stack is ..
; string pointer
; cursor Y
; end.

LAB_0465
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
LAB_046B
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get string pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get string pointer high byte
	EX	DE,HL			; swap to HL
	LD	(LAB_D2D3),HL	; save string end pointer
LAB_0476
	LD	HL,(LAB_D2D3)	; get string end pointer
	LD	A,(HL)		; get character from string
	OR	A			; set the flags
	JP	Z,LAB_0497		; jump if null

	LD	HL,(LAB_D2D3)	; get string end pointer
	LD	E,(HL)		; get character from string
	LD	D,#00h		; clear high byte
	LD	HL,000Ah		; HL = [LF]
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_0497		; jump if character was [LF]

	LD	HL,(LAB_D2D3)	; get string end pointer
	INC	HL			; increment to next character
	LD	(LAB_D2D3),HL	; save new string end pointer
	JP	LAB_0476		; loop for next character

LAB_0497
	LD	HL,(LAB_D2D3)	; get string end pointer
	EX	DE,HL			; swap to DE
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get string pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get string pointer high byte
	LD	L,A			; copy low byte to L
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL			; save string length result
	LD	HL,0014h		; load HL with line length
	POP	DE			; pop string length result
	EX	DE,HL			; swap string & line length
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_D2D1),HL	; save line - string length
	LD	HL,(LAB_D2D1)	; get line - string length
	LD	DE,0000h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_04C5		; jump if (line - string length)=>0

	LD	HL,0000h		; else set result as zero
	JP	LAB_04CF		; jump round calculate

LAB_04C5
	LD	HL,(LAB_D2D1)	; get line - string length
	LD	DE,0001h		; set for /2
	EX	DE,HL			; swap so the right way round
	CALL	LAB_DFE4		; does signed HL = DE>>HL (HL=0 to 1Fh) (LAB_7B1F ROM 1)
LAB_04CF
	PUSH	HL			; save cursor X
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		; get cursor Y low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get cursor Y high byte
	PUSH	DE			; save cursor Y
	CALL	LAB_70AE		; set cursor X,Y
	POP	DE			; dump cursor Y
	POP	DE			; dump cursor X
LAB_04DD
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get string pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get string pointer high byte
	LD	HL,(LAB_D2D3)	; get string/buffer end pointer
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_0509		; jump if at string end

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL			; save string pointer pointer
	LD	A,(HL)		; get string pointer low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get string pointer high byte
	LD	L,A			; copy low byte to L
	INC	HL			; point to next character
	EX	DE,HL			; swap pointer to DE
	POP	HL			; restore string pointer pointer
	LD	(HL),E		; save new string pointer low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save new string pointer low byte
	EX	DE,HL			; swap pointer to HL
	DEC	HL			; point to current character
	LD	E,(HL)		; get character
	LD	D,#00h		; clear high byte
	PUSH	DE			; push character
	CALL	LAB_720D		; character out to screen & buffer
	POP	DE			; dump character
	JP	LAB_04DD		; loop

					; reached 00h or [LF]
LAB_0509
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	PUSH	HL			; save pointer to last but 1
	LD	A,(HL)		; get line # low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get line # high byte
	LD	L,A			; copy low byte to L
	INC	HL			; increment line #
	EX	DE,HL			; swap line # to DE
	POP	HL			; restore pointer to last but 1
	LD	(HL),E		; save line # low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save line # high byte
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL			; save pointer to last pushed
	LD	A,(HL)		; get string pointer low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get string pointer high byte
	LD	L,A			; copy low byte to L
	INC	HL			; increment string pointer
	EX	DE,HL			; swap string pointer to DE
	POP	HL			; restore pointer to last pushed
	LD	(HL),E		; save new string pointer low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save new string pointer high byte
	EX	DE,HL			; swap pointer to HL
	DEC	HL			; decrement to last byte
	LD	A,(HL)		; get last byte
	OR	A			; set the flags
	JP	NZ,LAB_046B		; loop if not null

	RET				;

; stack is ..
; ??
; pointer ??
; end.

LAB_052F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;0535:	210000
	PUSH	HL		;0538:	E5
	LD	HL,0000h	;0539:	210000
	PUSH	HL		;053C:	E5
	LD	HL,0005h	;053D:	210500
	PUSH	HL		;0540:	E5
	LD	HL,0002h	;0541:	210200
	PUSH	HL		;0544:	E5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;0549:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;054B:	56
	PUSH	DE		;054C:	D5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;0551:	E5
	CALL	LAB_53C6	;0552:	CDC653
	EX	DE,HL		;0555:	EB
	LD	HL,000Ch		; C ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,0000h	;055B:	210000
	PUSH	HL		;055E:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;0563:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0565:	56
	LD	HL,0005h	;0566:	210500
	ADD	HL,DE		;0569:	19
	POP	DE		;056A:	D1
	LD	(HL),E		;056B:	73
	RET				;

LAB_056D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,LAB_D2D6		; point to error string space ???
	PUSH	HL			; push pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;057B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;057D:	56
	PUSH	DE		;057E:	D5
	CALL	LAB_052F	;057F:	CD2F05
	POP	DE		;0582:	D1
	POP	DE		;0583:	D1
	LD	HL,0000h	;0584:	210000
	PUSH	HL		;0587:	E5
	CALL	LAB_71AB		; does nothing ??
	POP	DE		;058B:	D1
	LD	HL,0000h	;058C:	210000
	PUSH	HL		;058F:	E5
	CALL	LAB_7206		; does nothing ??
	POP	DE		;0593:	D1
	LD	HL,0014h		; 20d wide
	PUSH	HL			; push x size
	LD	HL,0008h		; 8d high
	PUSH	HL			; push y size
	LD	HL,0000h		; x = 0
	PUSH	HL			; push x
	LD	HL,0000h		; y = 0
	PUSH	HL			; push y
	PUSH	HL			; push y
	CALL	LAB_6FBA		; clear screen area
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,0000h		; line 0
	PUSH	HL			; push line #
	LD	HL,LAB_D090		; points to 'PARCON 1000         ',0Ah,'*** Error ***',00h
	PUSH	HL			; push string pointer
	CALL	LAB_0465		; print centre justified string on line #
	POP	DE			; dump string pointer
	POP	DE			; dump line #
	LD	HL,0002h		; line 2
	PUSH	HL			; push line #
	LD	HL,LAB_D2D6		; points to ????
	PUSH	HL			; push string pointer
	CALL	LAB_0465		; print centre justified string on line #
	POP	DE			; dump string pointer
	POP	DE			; dump line #
	LD	HL,0003h		; line 3
	PUSH	HL			; push line #
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;05CF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;05D1:	56
	PUSH	DE			; push string pointer
	CALL	LAB_0465		; print centre justified string on line #
	POP	DE			; dump string pointer
	POP	DE			; dump line #
	CALL	LAB_05DC		; do press >> to cont & wait for [ENTER]
	RET				;

; do press >> to cont & wait for [ENTER]

LAB_05DC
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
LAB_05E2
	CALL	LAB_EEF8		; get key status without waiting
	JP	Z,LAB_05EE		; jump if no key

	CALL	LAB_EEE8		; get byte from key buffer ??
	JP	LAB_05E2		; loop until no key

LAB_05EE
	LD	HL,0007h		; line 7
	PUSH	HL			; push line #
	LD	HL,LAB_D0B3		; points to 'Press >> to continue',00h (LAB_7BFD)
	PUSH	HL			; push string pointer
	CALL	LAB_0465		; print centre justified string on line #
	POP	DE			; dump string pointer
	POP	DE			; dump line #
LAB_05FB
	CALL	LAB_EEE8		; get byte from key buffer ??
	LD	DE,000Dh		; set compare value [ENTER]
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_060A		; jump if was [ENTER]

	JP	LAB_05FB		; else loop until it is [ENTER]

LAB_060A
	RET				;

LAB_060B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;0611:	210000
	LD	A,L		;0614:	7D
	LD	(LAB_EC71),A	;0615:	3271EC
	LD	HL,LAB_EC7E	;0618:	217EEC
	PUSH	HL		;061B:	E5
	LD	HL,LAB_D0C8		; points to 'PLINTH',00h
	PUSH	HL		;061F:	E5
	LD	HL,LAB_758B	;0620:	218B75
	PUSH	HL		;0623:	E5
	CALL	LAB_0271	;0624:	CD7102
	POP	DE		;0627:	D1
	POP	DE		;0628:	D1
	POP	DE		;0629:	D1
	CALL	LAB_0AD3		; does HL = ((LAB_ECDA)+1)*32
	LD	(LAB_EC85),HL	;062D:	2285EC
	LD	HL,0051h	;0630:	215100
	LD	A,L		;0633:	7D
	LD	(LAB_EC89),A	;0634:	3289EC
	LD	HL,00E5h	;0637:	21E500
	LD	(LAB_EC8A),HL	;063A:	228AEC
	LD	HL,(LAB_EC8A)	;063D:	2A8AEC
	CALL	LAB_E02B		; does CPL HL. sets Z flag (LAB_7B66 ROM 1)
	LD	(LAB_EC8C),HL	;0643:	228CEC
	LD	HL,0000h	;0646:	210000
	LD	A,L		;0649:	7D
	LD	(LAB_EC8E),A	;064A:	328EEC
	LD	HL,LAB_EC97	;064D:	2197EC
	PUSH	HL		;0650:	E5
	LD	HL,LAB_D0CF		; points to 'LOCAL LINK',00h (LAB_7C19)
	PUSH	HL		;0654:	E5
	LD	HL,LAB_75EB	;0655:	21EB75
	PUSH	HL		;0658:	E5
	CALL	LAB_0271	;0659:	CD7102
	POP	DE		;065C:	D1
	POP	DE		;065D:	D1
	POP	DE		;065E:	D1
	LD	HL,LAB_EC98	;065F:	2198EC
	PUSH	HL		;0662:	E5
	LD	HL,LAB_D0DA		; points to '9600',00h (LAB_7C24)
	PUSH	HL		;0666:	E5
	LD	HL,LAB_760D	;0667:	210D76
	PUSH	HL		;066A:	E5
	CALL	LAB_0271	;066B:	CD7102
	POP	DE		;066E:	D1
	POP	DE		;066F:	D1
	POP	DE		;0670:	D1
	LD	HL,0000h	;0671:	210000
	LD	A,L		;0674:	7D
	LD	(LAB_EC99),A	;0675:	3299EC
	LD	HL,0000h	;0678:	210000
	LD	A,L		;067B:	7D
	LD	(LAB_ECA2),A	;067C:	32A2EC
	LD	HL,0000h	;067F:	210000
	LD	A,L		;0682:	7D
	LD	(LAB_ECAB),A	;0683:	32ABEC
	LD	HL,0000h	;0686:	210000
	LD	A,L		;0689:	7D
	LD	(LAB_ECB4),A	;068A:	32B4EC
	LD	HL,0000h	;068D:	210000
	LD	(LAB_EC6F),HL	;0690:	226FEC
	LD	(LAB_EC6D),HL	;0693:	226DEC
	LD	HL,0000h	;0696:	210000
	LD	A,L		;0699:	7D
	LD	(LAB_ECC7),A	;069A:	32C7EC
	LD	HL,0000h	;069D:	210000
	LD	A,L		;06A0:	7D
	LD	(LAB_ECC8),A	;06A1:	32C8EC
	RET				;

; BOOT routine eventually gets here

LAB_06A5
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC8A)	;06AB:	2A8AEC
	CALL	LAB_E02B		; does complement HL. sets Z flag (LAB_7B66 ROM 1)
	PUSH	HL			; save complemented value
	LD	HL,(LAB_EC8C)	;06B2:	2A8CEC
	POP	DE			; complemented value to DE
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	LD	(LAB_D2DC),HL	; save compare result
	CALL	LAB_659F		; setup -
					; LAB_E89C = 0000h	LAB_E8D6 = LAB_E89E
					; LAB_EC5D = 0000h	LAB_E898 = LAB_F118
	CALL	LAB_1803		; setup screen & other ??
	LD	HL,LAB_EF68		; set pointer
	PUSH	HL			; push word
	CALL	LAB_6621		; saves word @ (LAB_E898)
	POP	DE			; dump word
	LD	HL,0000h	;06CA:	210000
	LD	(LAB_D2DE),HL	;06CD:	22DED2
	JP	LAB_06DA	;06D0:	C3DA06

LAB_06D3
	LD	HL,(LAB_D2DE)	;06D3:	2ADED2
	INC	HL		;06D6:	23
	LD	(LAB_D2DE),HL	;06D7:	22DED2
LAB_06DA
	LD	HL,(LAB_D2DE)	;06DA:	2ADED2
	LD	DE,0005h	;06DD:	110500
	EX	DE,HL		;06E0:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_0702		; jump if HL<=DE

	LD	HL,(LAB_D2DC)	;06E7:	2ADCD2
	PUSH	HL		;06EA:	E5
	LD	HL,(LAB_D2DE)	;06EB:	2ADED2
	ADD	HL,HL			; *2
	LD	DE,LAB_D081	;06EF:	1181D0
	ADD	HL,DE		;06F2:	19
	LD	E,(HL)		;06F3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;06F5:	56
	EX	DE,HL		;06F6:	EB
	LD	E,(HL)		;06F7:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;06F9:	56
	EX	DE,HL			; swap ?? vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;06FE:	D1
	JP	LAB_06D3	;06FF:	C3D306

LAB_0702
	LD	HL,(LAB_D2DC)	;0702:	2ADCD2
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_0718	;0707:	CA1807

	CALL	LAB_060B	;070A:	CD0B06
	LD	HL,7715h	;070D:	211577
	PUSH	HL		;0710:	E5
	CALL	LAB_6633	;0711:	CD3366
	POP	DE		;0714:	D1
	JP	LAB_0720	;0715:	C32007

LAB_0718
	LD	HL,7751h	;0718:	215177
	PUSH	HL		;071B:	E5
	CALL	LAB_6633	;071C:	CD3366
	POP	DE		;071F:	D1
LAB_0720
	RET				;

; copy string from LAB_EC8E to destination

; stack is ..
; destination
; end.

LAB_0721
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,LAB_EC8E		; set source pointer
	PUSH	HL			; push source pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get destination pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination pointer high byte
	PUSH	DE			; push destination pointer
	CALL	LAB_DB6D		; copy null terminated string from source to destination
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get destination pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination pointer high byte
	EX	DE,HL			; swap to HL
	RET				;

; stack is ..
; vector
; ??
; ??
; ??
; end.

LAB_0741
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
LAB_0747
	LD	HL,0080h	;0747:	218000
	PUSH	HL		;074A:	E5
	LD	HL,LAB_D2E2	;074B:	21E2D2
	PUSH	HL		;074E:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;0753:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0755:	56
	PUSH	DE		;0756:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;075B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;075D:	56
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;0762:	D1
	POP	DE		;0763:	D1
	POP	DE		;0764:	D1
	LD	(LAB_D2E0),HL	;0765:	22E0D2
	LD	DE,0080h	;0768:	118000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_0795	;076E:	CA9507
	LD	HL,0080h	;0771:	218000
	PUSH	HL		;0774:	E5
	LD	HL,D2E2h	;0775:	21E2D2
	PUSH	HL		;0778:	E5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;077D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;077F:	56
	PUSH	DE		;0780:	D5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;0785:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0787:	56
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;078C:	D1
	POP	DE		;078D:	D1
	POP	DE		;078E:	D1
	JP	Z,LAB_0795	;078F:	CA9507
	JP	LAB_0747	;0792:	C34707
LAB_0795
	LD	HL,(LAB_D2E0)	;0795:	2AE0D2
	LD	DE,0080h	;0798:	118000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_07A5	;079E:	CAA507
	LD	HL,FFFFh	;07A1:	21FFFF
	RET				;

LAB_07A5
	LD	HL,(LAB_D2E0)	;07A5:	2AE0D2
	LD	DE,0000h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_07B6		; jump if DE+ve
	LD	HL,FFFFh	;07B2:	21FFFF
	RET				;

LAB_07B6
	LD	HL,(LAB_D2E0)	;07B6:	2AE0D2
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_07E6	;07BB:	CAE607

	LD	HL,(LAB_D2E0)	;07BE:	2AE0D2
	PUSH	HL		;07C1:	E5
	LD	HL,D2E2h	;07C2:	21E2D2
	PUSH	HL		;07C5:	E5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;07CA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;07CC:	56
	PUSH	DE		;07CD:	D5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;07D2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;07D4:	56
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;07D9:	D1
	POP	DE		;07DA:	D1
	POP	DE		;07DB:	D1
	EX	DE,HL		;07DC:	EB
	LD	HL,(LAB_D2E0)	;07DD:	2AE0D2
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_07EA	;07E3:	CAEA07
LAB_07E6
	LD	HL,0000h	;07E6:	210000
	RET				;

LAB_07EA
	LD	HL,FFFFh	;07EA:	21FFFF
	RET				;

; stack is ..
; ??
; ??pointer (table?)
; ??pointer (table?)
; end.

LAB_07EE
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;07F4:	210000
	PUSH	HL		;07F7:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;07FC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;07FE:	56
	PUSH	DE		;07FF:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get ?? low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ?? high byte
	LD	HL,0004h		; offset is 0004h
	ADD	HL,DE			; add pointer to offset
	LD	E,(HL)		; get ??vector low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ??vector high byte
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;0812:	D1
	POP	DE		;0813:	D1
	LD	(LAB_D362),HL	;0814:	2262D3
	LD	DE,0000h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_0825		; jump if DE+ve

	LD	HL,FFFFh	;0821:	21FFFF
	RET				;

LAB_0825
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;0829:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;082B:	56
	PUSH	DE		;082C:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;0831:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0833:	56
	EX	DE,HL			; swap pointer to HL
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	E,(HL)		; get ??vector low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ??vector high byte
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;083E:	D1
	LD	(LAB_D364),HL	;083F:	2264D3
	LD	DE,0000h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_0867		; jump if DE+ve

	LD	HL,(LAB_D362)	;084C:	2A62D3
	PUSH	HL		;084F:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;0854:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0856:	56
	LD	HL,000Ah	;0857:	210A00
	ADD	HL,DE		;085A:	19
	LD	E,(HL)		;085B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;085D:	56
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;0862:	D1
	LD	HL,FFFFh	;0863:	21FFFF
	RET				;

LAB_0867
	LD	HL,(LAB_D364)	;0867:	2A64D3
	PUSH	HL		;086A:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;086F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0871:	56
	LD	HL,0008h	;0872:	210800
	ADD	HL,DE		;0875:	19
	LD	E,(HL)		;0876:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0878:	56
LAB_0879
	PUSH	DE		;0879:	D5
	LD	HL,(LAB_D362)	;087A:	2A62D3
	PUSH	HL		;087D:	E5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;0882:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0884:	56
	LD	HL,0006h	;0885:	210600
	ADD	HL,DE		;0888:	19
	LD	E,(HL)		;0889:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;088B:	56
	PUSH	DE			; push ?? vector
	CALL	LAB_0741	;088D:	CD4107
	EX	DE,HL			; swap result to DE (discarded later!)
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	EX	DE,HL		;0896:	EB
	LD	(LAB_D366),HL	;0897:	2266D3
	LD	HL,(LAB_D362)	;089A:	2A62D3
	PUSH	HL		;089D:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;08A2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;08A4:	56
	LD	HL,000Ah	;08A5:	210A00
	ADD	HL,DE		;08A8:	19
	LD	E,(HL)		;08A9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;08AB:	56
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;08B0:	D1
	EX	DE,HL		;08B1:	EB
	LD	HL,(LAB_D366)	;08B2:	2A66D3
	CALL	LAB_E033		; does OR HL,DE. sets Z flag (LAB_7B6E ROM 1)
	LD	(LAB_D366),HL	;08B8:	2266D3
	LD	HL,(LAB_D364)	;08BB:	2A64D3
	PUSH	HL		;08BE:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;08C3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;08C5:	56
	LD	HL,000Ah	;08C6:	210A00
	ADD	HL,DE		;08C9:	19
	LD	E,(HL)		;08CA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;08CC:	56
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;08D1:	D1
	EX	DE,HL		;08D2:	EB
	LD	HL,(LAB_D366)	;08D3:	2A66D3
	CALL	LAB_E033		; does OR HL,DE. sets Z flag (LAB_7B6E ROM 1)
	LD	(LAB_D366),HL	;08D9:	2266D3
	LD	HL,(LAB_D366)	;08DC:	2A66D3
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_0903	;08E1:	CA0309

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;08E8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;08EA:	56
	PUSH	DE		;08EB:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;08F0:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;08F2:	56
	LD	HL,000Ch	;08F3:	210C00
	ADD	HL,DE		;08F6:	19
	LD	E,(HL)		;08F7:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;08F9:	56
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;08FE:	D1
	LD	HL,FFFFh	;08FF:	21FFFF
	RET				;

LAB_0903
	LD	HL,0000h	;0903:	210000
	RET				;

; execute BIOS function 3Fh with carry clear

; stack is ..
; DE
; end.

LAB_0907
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h		; set AF
	PUSH	HL			; push AF
	LD	HL,0000h		; set BC
	PUSH	HL			; push BC
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get DE low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get DE high byte
	PUSH	DE			; push DE
	LD	HL,0000h		; set HL
	PUSH	HL			; push HL
	LD	HL,003Fh		; offset is 3Fh to LAB_F324 (LAB_3841)
	PUSH	HL			; push offset
	CALL	LAB_D893		; set registers & execute routine @ warm+offset
	EX	DE,HL			; swap result to DE
	LD	HL,000Ah		; A ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	RET				;

; execute BIOS function 3Fh with carry set

; stack is ..
; DE
; end.

LAB_092F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set AF
	PUSH	HL			; push AF
	LD	HL,0000h		; set BC
	PUSH	HL			; push BC
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get DE low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get DE high byte
	PUSH	DE			; push DE
	LD	HL,0000h		; set HL
	PUSH	HL			; push HL
	LD	HL,003Fh		; offset is 3Fh to LAB_F324 (LAB_3841)
	PUSH	HL			; push offset
	CALL	LAB_D893		; set registers & execute routine @ warm+offset
	EX	DE,HL			; swap result to DE
	LD	HL,000Ah		; A ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	RET				;

LAB_0957
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,LAB_ECEA	;095D:	21EAEC
	LD	(LAB_D37A),HL	;0960:	227AD3
	JP	LAB_0970	;0963:	C37009

LAB_0966
	LD	HL,(LAB_D37A)	;0966:	2A7AD3
	LD	DE,000Ah	;0969:	110A00
	ADD	HL,DE		;096C:	19
	LD	(LAB_D37A),HL	;096D:	227AD3
LAB_0970
	LD	HL,(LAB_ECE8)	;0970:	2AE8EC
	LD	DE,000Ah	;0973:	110A00
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	LD	DE,LAB_ECEA		; pointer to table, 0Ah bytes per entry ??
	ADD	HL,DE		;097C:	19
	PUSH	HL		;097D:	E5
	LD	HL,(LAB_D37A)	;097E:	2A7AD3
	POP	DE		;0981:	D1
	EX	DE,HL		;0982:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_09C1	;0986:	CAC109
	LD	HL,(LAB_D37A)	;0989:	2A7AD3
	LD	DE,0006h	;098C:	110600
	ADD	HL,DE		;098F:	19
	LD	E,(HL)		;0990:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0992:	56
	PUSH	DE		;0993:	D5
	LD	HL,(LAB_D37A)	;0994:	2A7AD3
	LD	DE,0004h	;0997:	110400
	ADD	HL,DE		;099A:	19
	LD	E,(HL)		;099B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;099D:	56
	PUSH	DE		;099E:	D5
	LD	HL,(LAB_D37A)	;099F:	2A7AD3
	INC	HL		;09A2:	23
	INC	HL		;09A3:	23
	LD	E,(HL)		;09A4:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;09A6:	56
	LD	HL,(LAB_ECD8)	;09A7:	2AD8EC
	ADD	HL,DE		;09AA:	19
	PUSH	HL		;09AB:	E5
	CALL	LAB_D7CB	;09AC:	CDCBD7
	POP	DE		;09AF:	D1
	POP	DE		;09B0:	D1
	POP	DE		;09B1:	D1
	PUSH	HL		;09B2:	E5
	LD	HL,(LAB_D37A)	;09B3:	2A7AD3
	LD	DE,0008h	;09B6:	110800
	ADD	HL,DE		;09B9:	19
	POP	DE		;09BA:	D1
	LD	(HL),E		;09BB:	73
	INC	HL			; increment pointer
	LD	(HL),D		;09BD:	72
	JP	LAB_0966	;09BE:	C36609
LAB_09C1
	RET				;

LAB_09C2
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,LAB_ECEA		; pointer to table, 0Ah bytes per entry ??
	LD	(LAB_D37C),HL	;09CB:	227CD3
	JP	LAB_09DB	;09CE:	C3DB09
LAB_09D1
	LD	HL,(LAB_D37C)	;09D1:	2A7CD3
	LD	DE,000Ah	;09D4:	110A00
	ADD	HL,DE		;09D7:	19
	LD	(LAB_D37C),HL	;09D8:	227CD3
LAB_09DB
	LD	HL,(LAB_ECE8)	;09DB:	2AE8EC
	LD	DE,000Ah	;09DE:	110A00
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	LD	DE,ECEAh	;09E4:	11EAEC
	ADD	HL,DE		;09E7:	19
	PUSH	HL		;09E8:	E5
	LD	HL,(LAB_D37C)	;09E9:	2A7CD3
	POP	DE		;09EC:	D1
	EX	DE,HL		;09ED:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_0A3E	;09F1:	CA3E0A
	LD	HL,(LAB_D37C)	;09F4:	2A7CD3
	LD	DE,0008h	;09F7:	110800
	ADD	HL,DE		;09FA:	19
	LD	E,(HL)		;09FB:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;09FD:	56
	PUSH	DE		;09FE:	D5
	LD	HL,(LAB_D37C)	;09FF:	2A7CD3
	LD	DE,0006h	;0A02:	110600
	ADD	HL,DE		;0A05:	19
	LD	E,(HL)		;0A06:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0A08:	56
	PUSH	DE		;0A09:	D5
	LD	HL,(LAB_D37C)	;0A0A:	2A7CD3
	LD	DE,0004h	;0A0D:	110400
	ADD	HL,DE		;0A10:	19
	LD	E,(HL)		;0A11:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0A13:	56
	PUSH	DE		;0A14:	D5
	LD	HL,(LAB_D37C)	;0A15:	2A7CD3
	INC	HL		;0A18:	23
	INC	HL		;0A19:	23
	LD	E,(HL)		;0A1A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0A1C:	56
	LD	HL,(LAB_ECD8)	;0A1D:	2AD8EC
	ADD	HL,DE		;0A20:	19
	PUSH	HL		;0A21:	E5
	CALL	LAB_D7CB	;0A22:	CDCBD7
	POP	DE		;0A25:	D1
	POP	DE		;0A26:	D1
	POP	DE		;0A27:	D1
	POP	DE		;0A28:	D1
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_0A3B	;0A2C:	CA3B0A

	LD	HL,2332h	;0A2F:	213223
	PUSH	HL		;0A32:	E5
	CALL	LAB_1761		; save word @ LAB_D2C9 if empty (=0)
	POP	DE		;0A36:	D1
	LD	HL,0000h	;0A37:	210000
	RET				;

LAB_0A3B
	JP	LAB_09D1	;0A3B:	C3D109

LAB_0A3E
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_0A42
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,LAB_D37E	;0A48:	217ED3
	PUSH	HL			; push DE
	CALL	LAB_0907		; execute BIOS function 3Fh with carry clear
	POP	DE			; dump DE
	LD	A,(LAB_D381)	;0A50:	3A81D3
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;0A56:	E5
	LD	HL,(LAB_D37E)	;0A57:	2A7ED3
	POP	DE		;0A5A:	D1
	EX	DE,HL		;0A5B:	EB
	CALL	LAB_DFFE		; does HL = DE<<HL (HL=0 to 1Fh) (LAB_7B39 ROM 1)
	LD	DE,0003h	;0A5F:	110300
	EX	DE,HL		;0A62:	EB
	CALL	LAB_E00E		; does HL = DE>>HL (HL=0 to 1Fh) (LAB_7B49 ROM 1)
	RET				;

LAB_0A67
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_ECC9)	;0A6D:	2AC9EC
	LD	DE,0003h	;0A70:	110300
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_0A7F	;0A76:	CA7F0A
	LD	HL,0000h	;0A79:	210000
	LD	(LAB_ECC9),HL	;0A7C:	22C9EC
LAB_0A7F
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;0A83:	7E
	INC	HL			; increment pointer
	OR	(HL)		;0A85:	B6
	JP	NZ,LAB_0A8A	;0A86:	C28A0A
	RET				;

LAB_0A8A
	LD	HL,D385h	;0A8A:	2185D3
	PUSH	HL			; push DE
	CALL	LAB_0907		; execute BIOS function 3Fh with carry clear
	POP	DE			; dump DE
	LD	A,(LAB_D38B)	;0A92:	3A8BD3
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	(LAB_ECD8),HL	;0A98:	22D8EC
	LD	A,(LAB_D388)	;0A9B:	3A88D3
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;0AA1:	E5
	LD	HL,(LAB_D385)	;0AA2:	2A85D3
	POP	DE		;0AA5:	D1
	EX	DE,HL		;0AA6:	EB
	CALL	LAB_DFFE		; does HL = DE<<HL (HL=0 to 1Fh) (LAB_7B39 ROM 1)
	LD	DE,00FDh	;0AAA:	11FD00
	ADD	HL,DE		;0AAD:	19
	LD	DE,00FEh	;0AAE:	11FE00
	EX	DE,HL		;0AB1:	EB
	CALL	LAB_DF6D	;0AB2:	CD6DDF
	LD	(LAB_ECDA),HL	;0AB5:	22DAEC
	LD	HL,(LAB_ECDA)	;0AB8:	2ADAEC
	LD	DE,0001h	;0ABB:	110100
	EX	DE,HL		;0ABE:	EB
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_0AD2	;0AC2:	CAD20A
	LD	HL,8000h	;0AC5:	210080
	PUSH	HL		;0AC8:	E5
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;0ACC:	E5
	CALL	LAB_0AE3	;0ACD:	CDE30A
	POP	DE		;0AD0:	D1
	POP	DE		;0AD1:	D1
LAB_0AD2
	RET				;

; does HL = ((LAB_ECDA)+1)*32

LAB_0AD3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_ECDA)	;0AD9:	2ADAEC
	INC	HL			; +1
	ADD	HL,HL			; *2
	ADD	HL,HL			; *4
	ADD	HL,HL			; *8
	ADD	HL,HL			; *16
	ADD	HL,HL			; *32
	RET				;

LAB_0AE3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;0AED:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0AEF:	56
	LD	HL,8000h	;0AF0:	210080
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_0B04	;0AF6:	CA040B
	LD	HL,8000h	;0AF9:	210080
	EX	DE,HL		;0AFC:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	(HL),E		;0B01:	73
	INC	HL			; increment pointer
	LD	(HL),D		;0B03:	72
LAB_0B04
	LD	HL,(LAB_ECD8)	;0B04:	2AD8EC
	EX	DE,HL		;0B07:	EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;0B0C:	E5
	LD	A,(HL)		;0B0D:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;0B0F:	66
	LD	L,A		;0B10:	6F
	ADD	HL,DE		;0B11:	19
	EX	DE,HL		;0B12:	EB
	POP	HL		;0B13:	E1
	LD	(HL),E		;0B14:	73
	INC	HL			; increment pointer
	LD	(HL),D		;0B16:	72
	LD	HL,D38Ch	;0B17:	218CD3
	PUSH	HL			; push DE
	CALL	LAB_0907		; execute BIOS function 3Fh with carry clear
	POP	DE			; dump DE
	LD	A,(LAB_D392)	;0B1F:	3A92D3
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	EX	DE,HL		;0B25:	EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;0B2A:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;0B2C:	66
	LD	L,A		;0B2D:	6F
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	NZ,LAB_0B5B	;0B31:	C25B0B
	LD	A,(LAB_D392)	;0B34:	3A92D3
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	EX	DE,HL		;0B3A:	EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;0B3F:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;0B41:	66
	LD	L,A		;0B42:	6F
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_0B5C	;0B46:	CA5C0B
	LD	HL,(LAB_D390)	;0B49:	2A90D3
	EX	DE,HL		;0B4C:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;0B51:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;0B53:	66
	LD	L,A		;0B54:	6F
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_0B5C	;0B58:	CA5C0B
LAB_0B5B
	RET				;

LAB_0B5C
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;0B60:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0B62:	56
	EX	DE,HL		;0B63:	EB
	LD	(LAB_D390),HL	;0B64:	2290D3
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;0B6B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0B6D:	56
	EX	DE,HL		;0B6E:	EB
	LD	A,L		;0B6F:	7D
	LD	(LAB_D392),A	;0B70:	3292D3
	LD	HL,0000h	;0B73:	210000
	LD	(LAB_D38C),HL	;0B76:	228CD3
	LD	HL,D38Ch	;0B79:	218CD3
	PUSH	HL			; push DE
	CALL	LAB_092F		; execute BIOS function 3Fh with carry set
	POP	DE			; dump DE
	RET				;

; copy string from source to LAB_ECCB & ??

; stack is ..
; source
; end.

LAB_0B82
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; set source pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; set source pointer high byte
	PUSH	DE			; push source pointer
	LD	HL,LAB_ECCB		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB6D		; copy null terminated string from source to destination
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	LD	HL,0002h	;0B99:	210200
	LD	(LAB_ECC9),HL	;0B9C:	22C9EC
	LD	HL,0000h	;0B9F:	210000
	LD	(LAB_D370),HL	;0BA2:	2270D3
	CALL	LAB_0CE7	;0BA5:	CDE70C
	LD	HL,0000h	;0BA8:	210000
	RET				;

LAB_0BAC
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_ECC9)	;0BB2:	2AC9EC
	LD	DE,0004h	;0BB5:	110400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_0BE5	;0BBB:	CAE50B
	LD	HL,(LAB_ECDC)	;0BBE:	2ADCEC
	LD	DE,C8C9h	;0BC1:	11C9C8
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_0BDC	;0BC7:	CADC0B
	LD	HL,232Ch	;0BCA:	212C23
	PUSH	HL		;0BCD:	E5
	CALL	LAB_1761		; save word @ LAB_D2C9 if empty (=0)
	POP	DE		;0BD1:	D1
	LD	HL,0000h	;0BD2:	210000
	LD	(LAB_ECC9),HL	;0BD5:	22C9EC
	LD	HL,FFFFh	;0BD8:	21FFFF
	RET				;

LAB_0BDC
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;0BE0:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0BE2:	56
	EX	DE,HL		;0BE3:	EB
	RET				;

LAB_0BE5
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;0BE9:	7E
	INC	HL			; increment pointer
	OR	(HL)		;0BEB:	B6
	JP	NZ,LAB_0BFB	;0BEC:	C2FB0B
	LD	HL,(LAB_ECC9)	;0BEF:	2AC9EC
	LD	DE,0002h	;0BF2:	110200
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_0C07	;0BF8:	CA070C
LAB_0BFB
	LD	HL,232Fh	;0BFB:	212F23
	PUSH	HL		;0BFE:	E5
	CALL	LAB_1761		; save word @ LAB_D2C9 if empty (=0)
	POP	DE		;0C02:	D1
	LD	HL,FFFFh	;0C03:	21FFFF
	RET				;

LAB_0C07
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;0C0B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0C0D:	56
	EX	DE,HL		;0C0E:	EB
	LD	(LAB_D393),HL	;0C0F:	2293D3
LAB_0C12
	LD	HL,(LAB_ECC9)	;0C12:	2AC9EC
	LD	DE,0002h	;0C15:	110200
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_0CC2	;0C1B:	CAC20C
	LD	HL,(LAB_D393)	;0C1E:	2A93D3
	LD	DE,0000h	;0C21:	110000
	EX	DE,HL		;0C24:	EB
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_0CC2	;0C28:	CAC20C
	LD	HL,(LAB_D36C)	;0C2B:	2A6CD3
	EX	DE,HL		;0C2E:	EB
	LD	HL,(LAB_D393)	;0C2F:	2A93D3
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_0C3E	;0C35:	CA3E0C
	LD	HL,(LAB_D36C)	;0C38:	2A6CD3
	JP	LAB_0C41	;0C3B:	C3410C
LAB_0C3E
	LD	HL,(LAB_D393)	;0C3E:	2A93D3
LAB_0C41
	LD	(LAB_D395),HL	;0C41:	2295D3
	LD	HL,(LAB_D395)	;0C44:	2A95D3
	PUSH	HL		;0C47:	E5
	LD	HL,(LAB_D36A)	;0C48:	2A6AD3
	PUSH	HL		;0C4B:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;0C50:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0C52:	56
	PUSH	DE		;0C53:	D5
	LD	HL,(LAB_ECD8)	;0C54:	2AD8EC
	EX	DE,HL		;0C57:	EB
	LD	HL,(LAB_D368)	;0C58:	2A68D3
	ADD	HL,DE		;0C5B:	19
	PUSH	HL		;0C5C:	E5
	CALL	LAB_D7C5	;0C5D:	CDC5D7 (LAB_7174 ROM 1)
	EX	DE,HL		;0C60:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,(LAB_D395)	;0C66:	2A95D3
	EX	DE,HL		;0C69:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;0C6E:	E5
	LD	A,(HL)		;0C6F:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;0C71:	66
	LD	L,A		;0C72:	6F
	ADD	HL,DE		;0C73:	19
	EX	DE,HL		;0C74:	EB
	POP	HL		;0C75:	E1
	LD	(HL),E		;0C76:	73
	INC	HL			; increment pointer
	LD	(HL),D		;0C78:	72
	LD	HL,(LAB_D395)	;0C79:	2A95D3
	EX	DE,HL		;0C7C:	EB
	LD	HL,(LAB_D393)	;0C7D:	2A93D3
	EX	DE,HL		;0C80:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_D393),HL	;0C84:	2293D3
	LD	HL,(LAB_D395)	;0C87:	2A95D3
	EX	DE,HL		;0C8A:	EB
	LD	HL,(LAB_D36A)	;0C8B:	2A6AD3
	ADD	HL,DE		;0C8E:	19
	LD	(LAB_D36A),HL	;0C8F:	226AD3
	LD	HL,(LAB_D395)	;0C92:	2A95D3
	EX	DE,HL		;0C95:	EB
	LD	HL,(LAB_D36E)	;0C96:	2A6ED3
	ADD	HL,DE		;0C99:	19
	LD	(LAB_D36E),HL	;0C9A:	226ED3
	LD	HL,(LAB_D395)	;0C9D:	2A95D3
	EX	DE,HL		;0CA0:	EB
	LD	HL,(LAB_D36C)	;0CA1:	2A6CD3
	EX	DE,HL		;0CA4:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_D36C),HL	;0CA8:	226CD3
	JP	NZ,LAB_0CBF	;0CAB:	C2BF0C
	CALL	LAB_0CE7	;0CAE:	CDE70C
	LD	DE,0000h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_0CBF		; jump if DE+ve

	LD	HL,FFFFh	;0CBB:	21FFFF
	RET				;

LAB_0CBF
	JP	LAB_0C12	;0CBF:	C3120C
LAB_0CC2
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;0CC6:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0CC8:	56
	EX	DE,HL		;0CC9:	EB
	RET				;

; save word @ LAB_D2C9 if empty (=0) then save 0000h @ LAB_ECC9

; stack is
; word
; end.

LAB_0CCB
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;0CD5:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0CD7:	56
	PUSH	DE		;0CD8:	D5
	CALL	LAB_1761		; save word @ LAB_D2C9 if empty (=0)
	POP	DE		;0CDC:	D1
	LD	HL,0000h	;0CDD:	210000
	LD	(LAB_ECC9),HL	;0CE0:	22C9EC
	LD	HL,FFFFh	;0CE3:	21FFFF
	RET				;

LAB_0CE7
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,D370h	;0CED:	2170D3
	PUSH	HL		;0CF0:	E5
	CALL	LAB_D9F9	;0CF1:	CDF9D9
	POP	DE		;0CF4:	D1
	JP	Z,LAB_0CFC	;0CF5:	CAFC0C
	LD	HL,0000h	;0CF8:	210000
	RET				;

LAB_0CFC
	LD	HL,0000h	;0CFC:	210000
	LD	(LAB_D368),HL	;0CFF:	2268D3
	LD	HL,LAB_ECDC	;0D02:	21DCEC
	LD	(LAB_D36A),HL	;0D05:	226AD3
	LD	HL,000Eh	;0D08:	210E00
	LD	(LAB_D36C),HL	;0D0B:	226CD3
	LD	HL,0000h	;0D0E:	210000
	LD	(LAB_D36E),HL	;0D11:	226ED3
	LD	HL,LAB_D370	;0D14:	2170D3
	PUSH	HL		;0D17:	E5
	CALL	LAB_D9F9	;0D18:	CDF9D9
	POP	DE		;0D1B:	D1
	LD	HL,(LAB_D36E)	;0D1C:	2A6ED3
	LD	(LAB_D399),HL	;0D1F:	2299D3
	LD	HL,(LAB_D399)	;0D22:	2A99D3
	LD	DE,000Eh	;0D25:	110E00
	EX	DE,HL		;0D28:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	NZ,LAB_0D3B	;0D2C:	C23B0D
	LD	HL,(LAB_ECDC)	;0D2F:	2ADCEC
	LD	DE,C8C9h	;0D32:	11C9C8
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_0DD7	;0D38:	CAD70D
LAB_0D3B
	LD	HL,0100h	;0D3B:	210001
	PUSH	HL		;0D3E:	E5
	LD	HL,0000h	;0D3F:	210000
	PUSH	HL		;0D42:	E5
	CALL	LAB_0AE3	;0D43:	CDE30A
	POP	DE		;0D46:	D1
	POP	DE		;0D47:	D1
	LD	HL,(LAB_D399)	;0D48:	2A99D3
	PUSH	HL		;0D4B:	E5
	LD	HL,0100h	;0D4C:	210001
	PUSH	HL		;0D4F:	E5
	LD	HL,LAB_ECDC	;0D50:	21DCEC
	PUSH	HL		;0D53:	E5
	LD	HL,(LAB_ECD8)	;0D54:	2AD8EC
	PUSH	HL		;0D57:	E5
	CALL	LAB_D7C5	;0D58:	CDC5D7
	EX	DE,HL		;0D5B:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,0000h	;0D61:	210000
	LD	(LAB_ECDC),HL	;0D64:	22DCEC
	LD	HL,0000h	;0D67:	210000
	LD	(LAB_ECE4),HL	;0D6A:	22E4EC
	LD	HL,0100h	;0D6D:	210001
	LD	(LAB_ECE6),HL	;0D70:	22E6EC
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_ECE8),HL	;0D76:	22E8EC
	LD	HL,0000h	;0D79:	210000
	LD	(LAB_ECEC),HL	;0D7C:	22ECEC
	LD	HL,0100h	;0D7F:	210001
	LD	(LAB_ECEE),HL	;0D82:	22EEEC
	LD	HL,(LAB_D399)	;0D85:	2A99D3
	LD	(LAB_ECF0),HL	;0D88:	22F0EC
	LD	HL,0000h	;0D8B:	210000
	LD	(LAB_D368),HL	;0D8E:	2268D3
	LD	HL,(LAB_D399)	;0D91:	2A99D3
	LD	DE,0100h	;0D94:	110001
	ADD	HL,DE		;0D97:	19
	LD	(LAB_D36A),HL	;0D98:	226AD3
	LD	HL,(LAB_D399)	;0D9B:	2A99D3
	LD	DE,0100h	;0D9E:	110001
	ADD	HL,DE		;0DA1:	19
	PUSH	HL		;0DA2:	E5
	LD	HL,(LAB_E3BD)	;0DA3:	2ABDE3
	POP	DE		;0DA6:	D1
	EX	DE,HL		;0DA7:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_D36C),HL	;0DAB:	226CD3
	LD	HL,0000h	;0DAE:	210000
	LD	(LAB_D36E),HL	;0DB1:	226ED3
	LD	HL,D370h	;0DB4:	2170D3
	PUSH	HL		;0DB7:	E5
	CALL	LAB_D9F9	;0DB8:	CDF9D9
	POP	DE		;0DBB:	D1
	LD	HL,(LAB_D36E)	;0DBC:	2A6ED3
	LD	(LAB_D399),HL	;0DBF:	2299D3
	LD	HL,(LAB_D399)	;0DC2:	2A99D3
	EX	DE,HL		;0DC5:	EB
	LD	HL,(LAB_ECF0)	;0DC6:	2AF0EC
	ADD	HL,DE		;0DC9:	19
	LD	(LAB_ECF0),HL	;0DCA:	22F0EC
	LD	HL,0004h	;0DCD:	210400
	LD	(LAB_ECC9),HL	;0DD0:	22C9EC
	LD	HL,0000h	;0DD3:	210000
	RET				;

LAB_0DD7
	LD	HL,(LAB_ECDE)	;0DD7:	2ADEEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_0DF4	;0DDC:	CAF40D

	LD	HL,(LAB_ECDE)	;0DDF:	2ADEEC
	LD	DE,00E5h	;0DE2:	11E500
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_0DF4	;0DE8:	CAF40D
	LD	HL,2331h	;0DEB:	213123
	PUSH	HL		;0DEE:	E5
LAB_0DEF
	CALL	LAB_0CCB		; save word @ LAB_D2C9 if empty (=0)
					; then save 0000h @ LAB_ECC9
	POP	DE		;0DF2:	D1
	RET				;

LAB_0DF4
	LD	HL,(LAB_ECE8)	;0DF4:	2AE8EC
	LD	DE,0005h	;0DF7:	110500
	EX	DE,HL		;0DFA:	EB
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	NZ,LAB_0E0E	;0DFE:	C20E0E
	LD	HL,(LAB_ECE0)	;0E01:	2AE0EC
	EX	DE,HL		;0E04:	EB
	LD	HL,(LAB_ECDA)	;0E05:	2ADAEC
	CALL	LAB_E0D9		; does CP DE,HL, returns HL=1 if HL<=DE (LAB_7C14 ROM 1)
	JP	Z,LAB_0E17	;0E0B:	CA170E
LAB_0E0E
	LD	HL,2334h	;0E0E:	213423
	PUSH	HL		;0E11:	E5
	CALL	LAB_0CCB		; save word @ LAB_D2C9 if empty (=0)
					; then save 0000h @ LAB_ECC9
	POP	DE		;0E15:	D1
	RET				;

LAB_0E17
	LD	HL,(LAB_ECE2)	;0E17:	2AE2EC
	PUSH	HL		;0E1A:	E5
	LD	HL,(LAB_ECE0)	;0E1B:	2AE0EC
	PUSH	HL		;0E1E:	E5
	CALL	LAB_0AE3	;0E1F:	CDE30A
	POP	DE		;0E22:	D1
	POP	DE		;0E23:	D1
	LD	HL,LAB_ECEA		; pointer to table, 0Ah bytes per entry ??
	LD	(LAB_D39B),HL	;0E27:	229BD3
	JP	LAB_0E37	;0E2A:	C3370E
LAB_0E2D
	LD	HL,(LAB_D39B)	;0E2D:	2A9BD3
	LD	DE,000Ah	;0E30:	110A00
	ADD	HL,DE		;0E33:	19
	LD	(LAB_D39B),HL	;0E34:	229BD3
LAB_0E37
	LD	HL,(LAB_ECE8)	;0E37:	2AE8EC
	LD	DE,000Ah	;0E3A:	110A00
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	LD	DE,ECEAh	;0E40:	11EAEC
	ADD	HL,DE		;0E43:	19
	PUSH	HL		;0E44:	E5
	LD	HL,(LAB_D39B)	;0E45:	2A9BD3
	POP	DE		;0E48:	D1
	EX	DE,HL		;0E49:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_0FDC	;0E4D:	CADC0F
	LD	HL,0000h	;0E50:	210000
	LD	(LAB_D368),HL	;0E53:	2268D3
	LD	HL,(LAB_D39B)	;0E56:	2A9BD3
	LD	(LAB_D36A),HL	;0E59:	226AD3
	LD	HL,0008h	;0E5C:	210800
	LD	(LAB_D36C),HL	;0E5F:	226CD3
	LD	HL,0000h	;0E62:	210000
	LD	(LAB_D36E),HL	;0E65:	226ED3
	LD	HL,D370h	;0E68:	2170D3
	PUSH	HL		;0E6B:	E5
	CALL	LAB_D9F9	;0E6C:	CDF9D9
	POP	DE		;0E6F:	D1
	LD	HL,(LAB_D36E)	;0E70:	2A6ED3
	LD	DE,0008h	;0E73:	110800
	EX	DE,HL		;0E76:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_0E86	;0E7A:	CA860E
	LD	HL,232Bh	;0E7D:	212B23
	PUSH	HL		;0E80:	E5
	CALL	LAB_0CCB		; save word @ LAB_D2C9 if empty (=0)
					; then save 0000h @ LAB_ECC9
	POP	DE		;0E84:	D1
	RET				;

LAB_0E86
	LD	HL,(LAB_D39B)	;0E86:	2A9BD3
	LD	DE,0006h	;0E89:	110600
	ADD	HL,DE		;0E8C:	19
	LD	E,(HL)		;0E8D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0E8F:	56
	PUSH	DE		;0E90:	D5
	LD	HL,(LAB_D39B)	;0E91:	2A9BD3
	LD	DE,0004h	;0E94:	110400
	ADD	HL,DE		;0E97:	19
	LD	E,(HL)		;0E98:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0E9A:	56
	POP	HL		;0E9B:	E1
	ADD	HL,DE		;0E9C:	19
	EX	DE,HL		;0E9D:	EB
	LD	HL,(LAB_E3BD)	;0E9E:	2ABDE3
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_0EB0	;0EA4:	CAB00E
	LD	HL,232Ah	;0EA7:	212A23
	PUSH	HL		;0EAA:	E5
	CALL	LAB_0CCB		; save word @ LAB_D2C9 if empty (=0)
					; then save 0000h @ LAB_ECC9
	POP	DE		;0EAE:	D1
	RET				;

LAB_0EB0
	LD	HL,(LAB_D39B)	;0EB0:	2A9BD3
	LD	E,(HL)		;0EB3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0EB5:	56
	EX	DE,HL		;0EB6:	EB
	JP	LAB_0FCA	;0EB7:	C3CA0F

LAB_0EBA
	LD	HL,(LAB_D39B)	;0EBA:	2A9BD3
	INC	HL		;0EBD:	23
	INC	HL		;0EBE:	23
	LD	E,(HL)		;0EBF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0EC1:	56
	EX	DE,HL		;0EC2:	EB
	LD	(LAB_D368),HL	;0EC3:	2268D3
	LD	HL,(LAB_D39B)	;0EC6:	2A9BD3
	LD	DE,0004h	;0EC9:	110400
	ADD	HL,DE		;0ECC:	19
	LD	E,(HL)		;0ECD:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0ECF:	56
	EX	DE,HL		;0ED0:	EB
	LD	(LAB_D36A),HL	;0ED1:	226AD3
	LD	HL,(LAB_D39B)	;0ED4:	2A9BD3
	LD	DE,0006h	;0ED7:	110600
	ADD	HL,DE		;0EDA:	19
	LD	E,(HL)		;0EDB:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0EDD:	56
	EX	DE,HL		;0EDE:	EB
	LD	(LAB_D36C),HL	;0EDF:	226CD3
	LD	HL,0000h	;0EE2:	210000
	LD	(LAB_D36E),HL	;0EE5:	226ED3
	LD	HL,D370h	;0EE8:	2170D3
	PUSH	HL		;0EEB:	E5
	CALL	LAB_D9F9	;0EEC:	CDF9D9
	POP	DE		;0EEF:	D1
	LD	HL,(LAB_D36E)	;0EF0:	2A6ED3
	LD	HL,(LAB_D39B)	;0EF3:	2A9BD3
	LD	DE,0006h	;0EF6:	110600
	ADD	HL,DE		;0EF9:	19
	LD	E,(HL)		;0EFA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0EFC:	56
	PUSH	DE		;0EFD:	D5
	LD	HL,(LAB_D36E)	;0EFE:	2A6ED3
	POP	DE		;0F01:	D1
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_0F11	;0F05:	CA110F
	LD	HL,232Bh	;0F08:	212B23
	PUSH	HL		;0F0B:	E5
	CALL	LAB_0CCB		; save word @ LAB_D2C9 if empty (=0)
					; then save 0000h @ LAB_ECC9
	POP	DE		;0F0F:	D1
	RET				;

LAB_0F11
	JP	LAB_0FD9	;0F11:	C3D90F

LAB_0F14
	LD	HL,(LAB_D39B)	;0F14:	2A9BD3
	LD	DE,0004h	;0F17:	110400
	ADD	HL,DE		;0F1A:	19
	LD	E,(HL)		;0F1B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0F1D:	56
	EX	DE,HL		;0F1E:	EB
	LD	(LAB_D397),HL	;0F1F:	2297D3
	JP	LAB_0F30	;0F22:	C3300F
LAB_0F25
	LD	HL,0004h	;0F25:	210400
	EX	DE,HL		;0F28:	EB
	LD	HL,(LAB_D397)	;0F29:	2A97D3
	ADD	HL,DE		;0F2C:	19
	LD	(LAB_D397),HL	;0F2D:	2297D3
LAB_0F30
	LD	HL,(LAB_D39B)	;0F30:	2A9BD3
	LD	DE,0006h	;0F33:	110600
	ADD	HL,DE		;0F36:	19
	LD	E,(HL)		;0F37:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0F39:	56
	PUSH	DE		;0F3A:	D5
	LD	HL,(LAB_D39B)	;0F3B:	2A9BD3
	LD	DE,0004h	;0F3E:	110400
	ADD	HL,DE		;0F41:	19
	LD	E,(HL)		;0F42:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0F44:	56
	POP	HL		;0F45:	E1
	ADD	HL,DE		;0F46:	19
	PUSH	HL		;0F47:	E5
	LD	HL,(LAB_D397)	;0F48:	2A97D3
	POP	DE		;0F4B:	D1
	EX	DE,HL		;0F4C:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_0FC7	;0F50:	CAC70F
	LD	HL,0000h	;0F53:	210000
	LD	(LAB_D368),HL	;0F56:	2268D3
	LD	HL,D372h	;0F59:	2172D3
	LD	(LAB_D36A),HL	;0F5C:	226AD3
	LD	HL,0004h	;0F5F:	210400
	LD	(LAB_D36C),HL	;0F62:	226CD3
	LD	HL,0000h	;0F65:	210000
	LD	(LAB_D36E),HL	;0F68:	226ED3
	LD	HL,D370h	;0F6B:	2170D3
	PUSH	HL		;0F6E:	E5
	CALL	LAB_D9F9	;0F6F:	CDF9D9
	POP	DE		;0F72:	D1
	LD	HL,(LAB_D36E)	;0F73:	2A6ED3
	LD	DE,0004h	;0F76:	110400
	EX	DE,HL		;0F79:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_0F89	;0F7D:	CA890F
	LD	HL,232Bh	;0F80:	212B23
	PUSH	HL		;0F83:	E5
	CALL	LAB_0CCB		; save word @ LAB_D2C9 if empty (=0)
					; then save 0000h @ LAB_ECC9
	POP	DE		;0F87:	D1
	RET				;

LAB_0F89
	LD	HL,00D7h	;0F89:	21D700
	LD	A,L		;0F8C:	7D
	LD	(LAB_D376),A	;0F8D:	3276D3
	LD	HL,(LAB_ECD8)	;0F90:	2AD8EC
	EX	DE,HL		;0F93:	EB
	LD	HL,(LAB_D372)	;0F94:	2A72D3
	ADD	HL,DE		;0F97:	19
	LD	A,L		;0F98:	7D
	LD	(LAB_D377),A	;0F99:	3277D3
	LD	HL,(LAB_D374)	;0F9C:	2A74D3
	LD	(LAB_D378),HL	;0F9F:	2278D3
	LD	HL,0004h	;0FA2:	210400
	PUSH	HL		;0FA5:	E5
	LD	HL,(LAB_D397)	;0FA6:	2A97D3
	PUSH	HL		;0FA9:	E5
	LD	HL,D376h	;0FAA:	2176D3
	PUSH	HL		;0FAD:	E5
	LD	HL,(LAB_D39B)	;0FAE:	2A9BD3
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	E,(HL)		;0FB3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;0FB5:	56
	LD	HL,(LAB_ECD8)	;0FB6:	2AD8EC
	ADD	HL,DE		;0FB9:	19
	PUSH	HL		;0FBA:	E5
	CALL	LAB_D7C5	;0FBB:	CDC5D7
	EX	DE,HL		;0FBE:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	JP	LAB_0F25	;0FC4:	C3250F
LAB_0FC7
	JP	LAB_0FD9	;0FC7:	C3D90F
LAB_0FCA
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0002h			; 2 items

	DW	0000h
	DW	LAB_0EBA

	DW	0001h
	DW	LAB_0F14

	DW	LAB_0FD9		; not found return address

LAB_0FD9
	JP	LAB_0E2D	;0FD9:	C32D0E
LAB_0FDC
	LD	HL,0004h	;0FDC:	210400
	LD	(LAB_ECC9),HL	;0FDF:	22C9EC
	LD	HL,0000h	;0FE2:	210000
	RET				;

; save 2335h @ LAB_D2C9 if empty (=0)

LAB_0FE6
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,2335h		; set word
	PUSH	HL			; push word
	CALL	LAB_1761		; save word @ LAB_D2C9 if empty (=0)
	POP	DE			; dump word
	LD	HL,FFFFh		; set HL
	RET				;

; set HL = FFFFh

LAB_0FF8
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,FFFFh		; set HL
	RET				;

LAB_1002
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;100C:	7E
	INC	HL			; increment pointer
	OR	(HL)		;100E:	B6
	JP	Z,LAB_101E	;100F:	CA1E10

	LD	HL,2330h	;1012:	213023
	PUSH	HL		;1015:	E5
	CALL	LAB_1761		; save word @ LAB_D2C9 if empty (=0)
	POP	DE		;1019:	D1
	LD	HL,FFFFh	;101A:	21FFFF
	RET				;

LAB_101E
	LD	HL,(LAB_ECC9)	;101E:	2AC9EC
	JP	LAB_104B	;1021:	C34B10
LAB_1024
	CALL	LAB_0CE7	;1024:	CDE70C
	LD	HL,(LAB_ECC9)	;1027:	2AC9EC
	LD	DE,0002h	;102A:	110200
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_1024	;1030:	C22410
	LD	HL,(LAB_ECC9)	;1033:	2AC9EC
	LD	DE,0004h	;1036:	110400
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	NZ,LAB_105E	;103C:	C25E10
LAB_103F
	CALL	LAB_0957	;103F:	CD5709
LAB_1042
	LD	HL,0003h	;1042:	210300
	LD	(LAB_ECC9),HL	;1045:	22C9EC
	JP	LAB_105E	;1048:	C35E10
LAB_104B
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0003

	DW	0001
	DW	LAB_1042

	DW	0002
	DW	LAB_1024

	DW	0004
	DW	LAB_103F

	DW	LAB_105E

LAB_105E
	LD	HL,0000h	;105E:	210000
	RET				;

LAB_1062
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;1068:	210000
	LD	(LAB_ECC9),HL	;106B:	22C9EC
	RET				;

; stack is ..
; ??
; end.

LAB_106F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_ECC9)	;1075:	2AC9EC
	LD	DE,0003h	;1078:	110300
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_108C	;107E:	CA8C10

	LD	HL,2328h	;1081:	212823
	PUSH	HL		;1084:	E5
	CALL	LAB_1761		; save word @ LAB_D2C9 if empty (=0)
	POP	DE		;1088:	D1
	JP	LAB_10CB	;1089:	C3CB10

LAB_108C
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get string 2 pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get string 2 pointer high byte
	PUSH	DE			; push string 2 pointer
	LD	HL,LAB_ECCB		; set string 1 pointer
	PUSH	HL			; push string 1 pointer
	CALL	LAB_DB35		; compare string 1 & string 2 until a difference is found
					; or string 1 terminates
	POP	DE			; dump string 1 pointer
	POP	DE			; dump string 2 pointer
	JP	Z,LAB_10AB		; jump if match or end string 1

	LD	HL,2329h	;10A0:	212923
	PUSH	HL		;10A3:	E5
	CALL	LAB_1761		; save word @ LAB_D2C9 if empty (=0)
	POP	DE		;10A7:	D1
	JP	LAB_10CB	;10A8:	C3CB10

LAB_10AB
	CALL	LAB_09C2	;10AB:	CDC209
	JP	Z,LAB_10CB	;10AE:	CACB10
	LD	HL,(LAB_ECD8)	;10B1:	2AD8EC
	PUSH	HL		;10B4:	E5
	CALL	LAB_D7B8	;10B5:	CDB8D7
	POP	DE		;10B8:	D1
	LD	HL,(LAB_ECE6)	;10B9:	2AE6EC
	PUSH	HL		;10BC:	E5
	LD	HL,(LAB_ECD8)	;10BD:	2AD8EC
	EX	DE,HL		;10C0:	EB
	LD	HL,(LAB_ECE4)	;10C1:	2AE4EC
	ADD	HL,DE		;10C4:	19
	PUSH	HL		;10C5:	E5
	CALL	LAB_D7F0	;10C6:	CDF0D7
	POP	DE		;10C9:	D1
	POP	DE		;10CA:	D1
LAB_10CB
	LD	HL,FFFFh	;10CB:	21FFFF
	RET				;

LAB_10CF
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;10D5:	210000
	LD	(LAB_D463),HL	;10D8:	2263D4
	CALL	LAB_2116		; get HL from (LAB_EC41)
	JP	LAB_1163	;10DE:	C36311

LAB_10E1
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_10E5
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_D463),HL	;10E8:	2263D4
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_10EF
	LD	HL,(LAB_EB1A)	;10EF:	2A1AEB
	LD	DE,EC97h	;10F2:	1197EC
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_1133	;10F8:	CA3311

LAB_10FB
	LD	A,(LAB_EC97)	;10FB:	3A97EC
	LD	L,A		;10FE:	6F
	INC	HL		;10FF:	23
	LD	A,L		;1100:	7D
	LD	(LAB_EC97),A	;1101:	3297EC
	LD	H,#00h		;1104:	2600
	LD	DE,0004h	;1106:	110400
	EX	DE,HL		;1109:	EB
	CALL	LAB_E0D9		; does CP DE,HL, returns HL=1 if HL<=DE (LAB_7C14 ROM 1)
	JP	Z,LAB_1117	;110D:	CA1711
	LD	HL,0000h	;1110:	210000
	LD	A,L		;1113:	7D
	LD	(LAB_EC97),A	;1114:	3297EC
LAB_1117
	LD	A,(LAB_EC97)	;1117:	3A97EC
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;111D:	E5
	LD	HL,0001h		; set HL = 0001h
	POP	DE		;1121:	D1
	EX	DE,HL		;1122:	EB
	CALL	LAB_DFFE		; does HL = DE<<HL (HL=0 to 1Fh) (LAB_7B39 ROM 1)
	EX	DE,HL		;1126:	EB
	LD	HL,(LAB_D465)	;1127:	2A65D4
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_10FB	;112D:	CAFB10
	JP	LAB_115B	;1130:	C35B11
LAB_1133
	LD	HL,(LAB_EB1A)	;1133:	2A1AEB
	LD	DE,EC98h	;1136:	1198EC
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_115B	;113C:	CA5B11
	LD	A,(LAB_EC98)	;113F:	3A98EC
	LD	L,A		;1142:	6F
	INC	HL		;1143:	23
	LD	A,L		;1144:	7D
	LD	(LAB_EC98),A	;1145:	3298EC
	LD	H,#00h		;1148:	2600
	LD	DE,0006h	;114A:	110600
	EX	DE,HL		;114D:	EB
	CALL	LAB_E0D9		; does CP DE,HL, returns HL=1 if HL<=DE (LAB_7C14 ROM 1)
	JP	Z,LAB_115B	;1151:	CA5B11
	LD	HL,0000h	;1154:	210000
	LD	A,L		;1157:	7D
	LD	(LAB_EC98),A	;1158:	3298EC
LAB_115B
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_115F
	LD	HL,0000h	;115F:	210000
	RET				;

LAB_1163
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0003

	DW	000Dh
	DW	LAB_10E1

	DW	0014
	DW	LAB_10E5

	DW	00DB
	DW	LAB_10EF

	DW	LAB_115F

LAB_1176
	RET				;

LAB_1177
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	RET				;


LAB_117E
	LD	DE,0000h		; needed for routine
LAB_1181
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_D100)	;1184:	2A00D1
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_1190	;1189:	C29011

	LD	HL,FFFFh	;118C:	21FFFF
	RET				;

LAB_1190
	LD	HL,(LAB_D0FE)	;1190:	2AFED0
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_11A4	;1195:	CAA411

	LD	HL,(LAB_D0FE)	;1198:	2AFED0
	LD	DE,0005h	;119B:	110500
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_11A7	;11A1:	CAA711
LAB_11A4
	CALL	LAB_EE00	;11A4:	CD00EE
LAB_11A7
	CALL	LAB_EE14	;11A7:	CD14EE
	LD	HL,0000h	;11AA:	210000
	LD	(LAB_D100),HL	;11AD:	2200D1
	LD	HL,(LAB_D0FE)	;11B0:	2AFED0
	LD	DE,0005h	;11B3:	110500
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_11D9	;11B9:	CAD911

	LD	HL,0000h	;11BC:	210000
	PUSH	HL		;11BF:	E5
	LD	A,(LAB_D422)	;11C0:	3A22D4
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,D423h	;11C6:	1123D4
	ADD	HL,DE		;11C9:	19
	POP	DE		;11CA:	D1
	LD	(HL),E		;11CB:	73
	LD	HL,LAB_D425		; set message pointer
	PUSH	HL			; push message pointer
	LD	HL,2337h		; set error #
	PUSH	HL			; push error #
	CALL	LAB_6602		; display error # & message ??
	POP	DE			; dump error #
	POP	DE			; dump message pointer
LAB_11D9
	LD	HL,270Fh	;11D9:	210F27
	PUSH	HL		;11DC:	E5
	CALL	LAB_1761		; save word @ LAB_D2C9 if empty (=0)
	POP	DE		;11E0:	D1
	LD	HL,FFFFh	;11E1:	21FFFF
	RET				;

LAB_11E5
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_D100)	;11EB:	2A00D1
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_11F7	;11F0:	CAF711

	LD	HL,FFFFh	;11F3:	21FFFF
	RET				;

LAB_11F7
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;11FB:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;11FE:	EB
	JP	LAB_1214	;11FF:	C31412

LAB_1202
	LD	HL,FFFFh	;1202:	21FFFF
	LD	(LAB_D465),HL	;1205:	2265D4
	JP	LAB_1223	;1208:	C32312

LAB_120B
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_D465),HL	;120E:	2265D4
	JP	LAB_1223	;1211:	C32312

LAB_1214
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0002

	DW	0000
	DW	LAB_1202

	DW	0001
	DW	LAB_120B

	DW	LAB_1202

LAB_1223
	LD	A,(LAB_EC97)	;1223:	3A97EC
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;1229:	E5
	LD	HL,0001h		; set HL = 0001h
	POP	DE		;122D:	D1
	EX	DE,HL		;122E:	EB
	CALL	LAB_DFFE		; does HL = DE<<HL (HL=0 to 1Fh) (LAB_7B39 ROM 1)
	EX	DE,HL		;1232:	EB
	LD	HL,(LAB_D465)	;1233:	2A65D4
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_1243	;1239:	C24312

	LD	HL,0000h	;123C:	210000
	LD	A,L		;123F:	7D
	LD	(LAB_EC97),A	;1240:	3297EC
LAB_1243
	LD	HL,00FFh	;1243:	21FF00
	LD	A,L		;1246:	7D
	LD	(LAB_EC98),A	;1247:	3298EC
	LD	HL,0000h	;124A:	210000
	LD	A,L		;124D:	7D
	LD	(LAB_ECA2),A	;124E:	32A2EC
	LD	A,L		;1251:	7D
	LD	(LAB_ECAB),A	;1252:	32ABEC
	LD	A,L		;1255:	7D
	LD	(LAB_EC99),A	;1256:	3299EC
	LD	HL,793Ah	;1259:	213A79
	PUSH	HL		;125C:	E5
	CALL	LAB_6633	;125D:	CD3366
	POP	DE		;1260:	D1
	LD	HL,(LAB_D463)	;1261:	2A63D4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_126D	;1266:	CA6D12

	LD	HL,FFFFh	;1269:	21FFFF
	RET				;

LAB_126D
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1271:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1273:	56
	EX	DE,HL		;1274:	EB
	LD	(LAB_D100),HL	;1275:	2200D1
	LD	HL,D39Eh	;1278:	219ED3
	LD	(LAB_D41E),HL	;127B:	221ED4
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1282:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1284:	56
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_1294		;jump if DE<>1

	LD	HL,0000h	;128E:	210000
	JP	LAB_1297	;1291:	C39712
LAB_1294
	LD	HL,0080h	;1294:	218000
LAB_1297
	LD	(LAB_D420),HL	;1297:	2220D4
	LD	A,(LAB_EC97)	;129A:	3A97EC
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0006h		; 6 bytes per entry
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	LD	DE,LAB_D108		; pointer to ?? table (LAB_7C52)
	ADD	HL,DE		;12A9:	19
	LD	(LAB_D467),HL	;12AA:	2267D4
	LD	HL,LAB_ECA2	;12AD:	21A2EC
	PUSH	HL		;12B0:	E5
	LD	HL,LAB_EC99	;12B1:	2199EC
	PUSH	HL		;12B4:	E5
	LD	HL,LAB_EC8E	;12B5:	218EEC
	PUSH	HL		;12B8:	E5
	LD	HL,LAB_D120		; pointer to ?? table (LAB_7C6A)
	PUSH	HL		;12BC:	E5
	LD	HL,LAB_ECAB	;12BD:	21ABEC
	PUSH	HL		;12C0:	E5
	LD	HL,003Ch	;12C1:	213C00
	PUSH	HL		;12C4:	E5
	LD	A,(LAB_EC98)	;12C5:	3A98EC
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0006h	;12CB:	110600
	EX	DE,HL		;12CE:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_12E6	;12D2:	CAE612

	LD	A,(LAB_EC98)	;12D5:	3A98EC
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,LAB_D102	;12DB:	1102D1 (LAB_7C4C)
	ADD	HL,DE		;12DE:	19
	LD	E,(HL)		;12DF:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;12E2:	EB
	JP	LAB_12F0	;12E3:	C3F012

LAB_12E6
	LD	HL,(LAB_D467)	;12E6:	2A67D4
	INC	HL		;12E9:	23
	INC	HL		;12EA:	23
	INC	HL		;12EB:	23
	LD	E,(HL)		;12EC:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;12EF:	EB
LAB_12F0
	PUSH	HL		;12F0:	E5
	LD	HL,0000h	;12F1:	210000
	PUSH	HL		;12F4:	E5
	LD	HL,(LAB_D467)	;12F5:	2A67D4
	LD	E,(HL)		;12F8:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;12FB:	D5
	LD	HL,001Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1300:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;1303:	D5
	CALL	LAB_EE20	;1304:	CD20EE
	EX	DE,HL		;1307:	EB
	LD	HL,0014h		; 14 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	EX	DE,HL		;130D:	EB
	LD	(LAB_D0FE),HL	;130E:	22FED0
	LD	HL,(LAB_D0FE)	;1311:	2AFED0
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_131D	;1316:	CA1D13

	CALL	LAB_117E	;1319:	CD7E11
	RET				;

LAB_131D
	LD	HL,(LAB_D467)	;131D:	2A67D4
	LD	DE,0004h	;1320:	110400
	ADD	HL,DE		;1323:	19
	LD	E,(HL)		;1324:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1326:	56
	PUSH	DE		;1327:	D5
	LD	HL,(LAB_D467)	;1328:	2A67D4
	INC	HL		;132B:	23
	LD	E,(HL)		;132C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;132E:	56
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;1333:	D1
	LD	(LAB_D0FE),HL	;1334:	22FED0
	LD	HL,(LAB_D0FE)	;1337:	2AFED0
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_1343	;133C:	CA4313

	CALL	LAB_117E	;133F:	CD7E11
	RET				;

LAB_1343
	LD	HL,D422h	;1343:	2122D4
	PUSH	HL		;1346:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;134B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;134D:	56
	PUSH	DE		;134E:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1353:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1355:	56
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_1365		; jump if DE<>1

	LD	HL,0003h	;135F:	210300
	JP	LAB_1368	;1362:	C36813
LAB_1365
	LD	HL,0004h	;1365:	210400
LAB_1368
	PUSH	HL		;1368:	E5
	CALL	LAB_EE0C	;1369:	CD0CEE
	POP	DE		;136C:	D1
	POP	DE		;136D:	D1
	POP	DE		;136E:	D1
	LD	(LAB_D0FE),HL	;136F:	22FED0
	LD	HL,(LAB_D0FE)	;1372:	2AFED0
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_137E	;1377:	CA7E13

	CALL	LAB_117E	;137A:	CD7E11
	RET				;

LAB_137E
	LD	HL,0000h	;137E:	210000
	RET				;

LAB_1382
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,2336h	;1388:	213623
	PUSH	HL		;138B:	E5
	CALL	LAB_1761		; save word @ LAB_D2C9 if empty (=0)
	POP	DE		;138F:	D1
	LD	HL,FFFFh	;1390:	21FFFF
	RET				;

LAB_1394
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;139D:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;13A2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;13A4:	56
	PUSH	DE		;13A5:	D5
	LD	HL,0000h	;13A6:	210000
	PUSH	HL		;13A9:	E5
	CALL	LAB_11E5	;13AA:	CDE511
	POP	DE		;13AD:	D1
	POP	DE		;13AE:	D1
	POP	DE		;13AF:	D1
	RET				;

LAB_13B1
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,FFFFh	;13B7:	21FFFF
	RET				;

LAB_13BB
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;13C4:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;13C9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;13CB:	56
	PUSH	DE		;13CC:	D5
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;13D0:	E5
	CALL	LAB_11E5	;13D1:	CDE511
	POP	DE		;13D4:	D1
	POP	DE		;13D5:	D1
	POP	DE		;13D6:	D1
	RET				;

LAB_13D8
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_D100)	;13DE:	2A00D1
	LD	DE,0001h	;13E1:	110100
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_13EE	;13E7:	CAEE13
	LD	HL,FFFFh	;13EA:	21FFFF
	RET				;

LAB_13EE
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;13F2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;13F4:	56
	EX	DE,HL		;13F5:	EB
	LD	(LAB_D46B),HL	;13F6:	226BD4
LAB_13F9
	LD	HL,(LAB_D46B)	;13F9:	2A6BD4
	LD	DE,0000h	;13FC:	110000
	EX	DE,HL		;13FF:	EB
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL
					; (LAB_7BC1 ROM 1)
	JP	Z,LAB_14BA	;1403:	CABA14
	LD	HL,(LAB_D420)	;1406:	2A20D4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_144E	;140B:	C24E14

	LD	HL,(LAB_D0FE)	;140E:	2AFED0
	LD	DE,0008h	;1411:	110800
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_14BA	;1417:	C2BA14
	LD	HL,D39Dh	;141A:	219DD3
	PUSH	HL		;141D:	E5
	CALL	LAB_EE2C	;141E:	CD2CEE
	POP	DE		;1421:	D1
	LD	(LAB_D0FE),HL	;1422:	22FED0
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_143A	;1427:	CA3A14

	LD	HL,(LAB_D0FE)	;142A:	2AFED0
	LD	DE,0008h	;142D:	110800
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_143A	;1433:	CA3A14
	CALL	LAB_117E	;1436:	CD7E11
	RET				;

LAB_143A
	LD	HL,D39Eh	;143A:	219ED3
	LD	(LAB_D41E),HL	;143D:	221ED4
	LD	A,(LAB_D39D)	;1440:	3A9DD3
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	(LAB_D420),HL	;1446:	2220D4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_14BA	;144B:	CABA14

LAB_144E
	LD	HL,(LAB_D46B)	;144E:	2A6BD4
	EX	DE,HL		;1451:	EB
	LD	HL,(LAB_D420)	;1452:	2A20D4
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_1461	;1458:	CA6114
	LD	HL,(LAB_D46B)	;145B:	2A6BD4
	JP	LAB_1464	;145E:	C36414
LAB_1461
	LD	HL,(LAB_D420)	;1461:	2A20D4
LAB_1464
	LD	(LAB_D469),HL	;1464:	2269D4
	LD	HL,(LAB_D469)	;1467:	2A69D4
	PUSH	HL		;146A:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;146F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1471:	56
	PUSH	DE		;1472:	D5
	LD	HL,(LAB_D41E)	;1473:	2A1ED4
	PUSH	HL		;1476:	E5
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	LD	HL,(LAB_D469)	;147D:	2A69D4
	EX	DE,HL		;1480:	EB
	LD	HL,(LAB_D46B)	;1481:	2A6BD4
	EX	DE,HL		;1484:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_D46B),HL	;1488:	226BD4
	LD	HL,(LAB_D469)	;148B:	2A69D4
	EX	DE,HL		;148E:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;1493:	E5
	LD	A,(HL)		;1494:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;1496:	66
	LD	L,A		;1497:	6F
	ADD	HL,DE		;1498:	19
	EX	DE,HL		;1499:	EB
	POP	HL		;149A:	E1
	LD	(HL),E		;149B:	73
	INC	HL			; increment pointer
	LD	(HL),D		;149D:	72
	LD	HL,(LAB_D469)	;149E:	2A69D4
	EX	DE,HL		;14A1:	EB
	LD	HL,(LAB_D420)	;14A2:	2A20D4
	EX	DE,HL		;14A5:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_D420),HL	;14A9:	2220D4
	LD	HL,(LAB_D469)	;14AC:	2A69D4
	EX	DE,HL		;14AF:	EB
	LD	HL,(LAB_D41E)	;14B0:	2A1ED4
	ADD	HL,DE		;14B3:	19
	LD	(LAB_D41E),HL	;14B4:	221ED4
	JP	LAB_13F9	;14B7:	C3F913
LAB_14BA
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;14BE:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;14C0:	56
	LD	HL,(LAB_D46B)	;14C1:	2A6BD4
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	RET				;

LAB_14C8
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	RET				;

LAB_14CF
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;14D9:	7E
	INC	HL			; increment pointer
	OR	(HL)		;14DB:	B6
	JP	Z,LAB_14E3	;14DC:	CAE314

	LD	HL,FFFFh	;14DF:	21FFFF
	RET				;

LAB_14E3
	LD	HL,(LAB_D100)	;14E3:	2A00D1
	JP	LAB_1503	;14E6:	C30315

LAB_14E9
	LD	HL,FFFFh	;14E9:	21FFFF
	RET				;

LAB_14ED
	LD	HL,(LAB_D0FE)	;14ED:	2AFED0
	LD	DE,0008h	;14F0:	110800
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_14FD	;14F6:	CAFD14
	CALL	LAB_117E	;14F9:	CD7E11
	RET				;

LAB_14FD
	JP	LAB_1516	;14FD:	C31615

LAB_1500
	JP	LAB_1516	;1500:	C31615

LAB_1503
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0003

	DW	0000
	DW	LAB_14E9

	DW	0001
	DW	LAB_14ED

	DW	0002
	DW	LAB_1500

	DW	LAB_1516

LAB_1516
	LD	HL,0000h	;1516:	210000
	LD	(LAB_D100),HL	;1519:	2200D1
	CALL	LAB_EE3C	;151C:	CD3CEE
	LD	(LAB_D0FE),HL	;151F:	22FED0
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_152B	;1524:	CA2B15

	CALL	LAB_117E	;1527:	CD7E11
	RET				;

LAB_152B
	CALL	LAB_EE14	;152B:	CD14EE
	LD	(LAB_D0FE),HL	;152E:	22FED0
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_153A	;1533:	CA3A15

	LD	HL,FFFFh	;1536:	21FFFF
	RET				;

LAB_153A
	LD	HL,0000h	;153A:	210000
	RET				;

; set HL=-1

LAB_153E
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,FFFFh		; set HL=-1
	RET				;

; stack is ..
; ??
; end.

LAB_1548
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;1552:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1554:	56
	LD	HL,FFFFh		; set compare value
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_1566		; jump if DE<>-1

	LD	HL,(LAB_EC3F)	;155E:	2A3FEC
	PUSH	HL		;1561:	E5
	CALL	LAB_1761		; save word @ LAB_D2C9 if empty (=0)
	POP	DE		;1565:	D1
LAB_1566
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;156A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;156C:	56
	EX	DE,HL			; swap to HL
	RET				;

; clears bytes @ LAB_E8E2, +29h, ++29h & +++29h
; clears words @ LAB_EC3F & LAB_E986

LAB_156F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	CALL	LAB_6784		; clears bytes @ LAB_E8E2, +29h, ++29h & +++29h
					; clears words @ LAB_EC3F & LAB_E986
	RET				;

; stack is ..
; ??
; count ??
; source
; end.

LAB_1579
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get low byte
	EX	DE,HL			; swap to HL
	LD	A,L			; copy to A
	LD	(LAB_D46D),A	;1586:	326DD4
	LD	HL,003Ah	;1589:	213A00
	LD	A,L		;158C:	7D
	LD	(LAB_D46E),A	;158D:	326ED4
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get source pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get source pointer high byte
	PUSH	DE			; push source pointer
	LD	HL,LAB_D46F		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB6D		; copy null terminated string from source to destination
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;15A5:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;15A7:	56
	PUSH	DE		;15A8:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;15AD:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;15AF:	56
	PUSH	DE		;15B0:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;15B5:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;15B7:	56
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;15BC:	D1
	POP	DE		;15BD:	D1
	LD	(LAB_D47D),HL	;15BE:	227DD4
	LD	DE,0000h	;15C1:	110000
	EX	DE,HL		;15C4:	EB
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_15CF	;15C8:	CACF15
	LD	HL,(LAB_D47D)	;15CB:	2A7DD4
	RET				;

LAB_15CF
	LD	HL,(LAB_D47D)	;15CF:	2A7DD4
	PUSH	HL		;15D2:	E5
	CALL	LAB_1548	;15D3:	CD4815
	POP	DE		;15D6:	D1
	RET				;

LAB_15D8
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;15E2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;15E4:	56
	PUSH	DE		;15E5:	D5
	LD	HL,0041h	;15E6:	214100
	PUSH	HL		;15E9:	E5
	LD	HL,LAB_EFB4	;15EA:	21B4EF
	PUSH	HL		;15ED:	E5
	CALL	LAB_1579	;15EE:	CD7915
	POP	DE		;15F1:	D1
	POP	DE		;15F2:	D1
	POP	DE		;15F3:	D1
	RET				;

LAB_15F5
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;15FF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1601:	56
	PUSH	DE		;1602:	D5
	LD	HL,0042h	;1603:	214200
	PUSH	HL		;1606:	E5
	LD	HL,LAB_EFB4	;1607:	21B4EF
	PUSH	HL		;160A:	E5
	CALL	LAB_1579	;160B:	CD7915
	POP	DE		;160E:	D1
	POP	DE		;160F:	D1
	POP	DE		;1610:	D1
	RET				;

LAB_1612
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;161C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;161E:	56
	PUSH	DE		;161F:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1624:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1626:	56
	PUSH	DE		;1627:	D5
	LD	HL,0041h	;1628:	214100
	PUSH	HL		;162B:	E5
	LD	HL,LAB_EFC8	;162C:	21C8EF
	PUSH	HL		;162F:	E5
	CALL	LAB_1579	;1630:	CD7915
	EX	DE,HL		;1633:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	EX	DE,HL		;1639:	EB
	RET				;

LAB_163B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;1645:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1647:	56
	PUSH	DE		;1648:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;164D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;164F:	56
	PUSH	DE		;1650:	D5
	LD	HL,0042h	;1651:	214200
	PUSH	HL		;1654:	E5
	LD	HL,LAB_EFC8	;1655:	21C8EF
	PUSH	HL		;1658:	E5
	CALL	LAB_1579	;1659:	CD7915
	EX	DE,HL		;165C:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	EX	DE,HL		;1662:	EB
	RET				;

LAB_1664
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;166E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1670:	56
	PUSH	DE		;1671:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1676:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1678:	56
	PUSH	DE		;1679:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;167E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1680:	56
	PUSH	DE		;1681:	D5
	CALL	LAB_6B6D	;1682:	CD6D6B
	POP	DE		;1685:	D1
	POP	DE		;1686:	D1
	POP	DE		;1687:	D1
	PUSH	HL		;1688:	E5
	CALL	LAB_1548	;1689:	CD4815
	POP	DE		;168C:	D1
	RET				;

LAB_168E
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1698:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;169A:	56
	PUSH	DE		;169B:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;16A0:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;16A2:	56
	PUSH	DE		;16A3:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;16A8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;16AA:	56
	PUSH	DE		;16AB:	D5
	CALL	LAB_6C84	;16AC:	CD846C
	POP	DE		;16AF:	D1
	POP	DE		;16B0:	D1
	POP	DE		;16B1:	D1
	PUSH	HL		;16B2:	E5
	CALL	LAB_1548	;16B3:	CD4815
	POP	DE		;16B6:	D1
	RET				;

LAB_16B8
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;16C2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;16C4:	56
	PUSH	DE		;16C5:	D5
	CALL	LAB_696F	;16C6:	CD6F69
	POP	DE		;16C9:	D1
	PUSH	HL		;16CA:	E5
	CALL	LAB_1548	;16CB:	CD4815
	POP	DE		;16CE:	D1
	RET				;

LAB_16D0
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;16DA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;16DC:	56
	PUSH	DE		;16DD:	D5
	LD	HL,0041h	;16DE:	214100
	PUSH	HL		;16E1:	E5
	LD	HL,LAB_EFB8	;16E2:	21B8EF
	PUSH	HL		;16E5:	E5
	CALL	LAB_1579	;16E6:	CD7915
	POP	DE		;16E9:	D1
	POP	DE		;16EA:	D1
	POP	DE		;16EB:	D1
	RET				;

LAB_16ED
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;16F7:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;16F9:	56
	PUSH	DE		;16FA:	D5
	LD	HL,0042h	;16FB:	214200
	PUSH	HL		;16FE:	E5
	LD	HL,LAB_EFB8	;16FF:	21B8EF
	PUSH	HL		;1702:	E5
	CALL	LAB_1579	;1703:	CD7915
	POP	DE		;1706:	D1
	POP	DE		;1707:	D1
	POP	DE		;1708:	D1
	RET				;

; stack is ..
; error #
; end.

LAB_170A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,LAB_D159		; set message table pointer (LAB_7CA3)
	LD	(LAB_D47F),HL	; save message table pointer
	JP	LAB_1723		; skip increment

LAB_1719
	LD	HL,(LAB_D47F)	; get message table pointer
	LD	DE,0004h		; offset to next entry
	ADD	HL,DE			; add offset
	LD	(LAB_D47F),HL	; save message table pointer
LAB_1723
	LD	HL,(LAB_D47F)	; get message table pointer
	LD	E,(HL)		; get table # low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get table # high byte
	LD	HL,0000h		; compare with last entry marker
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_174A		; jump if was last entry

	LD	HL,(LAB_D47F)	; get message table pointer
	LD	E,(HL)		; get table # low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get table # high byte
	PUSH	DE			; save table #
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get error # low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get error # high byte
	POP	HL			; restore table #
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_174A		; jump if match

	JP	LAB_1719		; else go do next

LAB_174A
	LD	HL,(LAB_D47F)	; get message table pointer
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	E,(HL)		; get string pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get string pointer high byte
	PUSH	DE			; push it
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get error # low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get error # high byte
	PUSH	DE			; push it
	CALL	LAB_6602		; display error # & message ??
	POP	DE			; dump error #
	POP	DE			; dump message pointer
	RET				;

; save word @ LAB_D2C9 if empty (=0)

; stack is
; word
; end.

LAB_1761
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_D2C9)	; get word allready @ LAB_D2C9
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_177A		; exit if not empty (RET Z would be better)

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get word low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get word high byte
	EX	DE,HL			; swap to HL
	LD	(LAB_D2C9),HL	; save word
LAB_177A
	RET				;

LAB_177B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_D2C9)	; get word allready @ LAB_D2C9
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_179D		; jump if empty

	LD	HL,(LAB_D2C9)	; get word allready @ LAB_D2C9
	LD	DE,270Fh	;178C:	110F27
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_179D	;1792:	CA9D17

	LD	HL,(LAB_D2C9)	; get word allready @ LAB_D2C9
	PUSH	HL		;1798:	E5
	CALL	LAB_170A	;1799:	CD0A17
	POP	DE		;179C:	D1
LAB_179D
	LD	HL,0000h	;179D:	210000
	LD	(LAB_D2C9),HL	; save word
	RET				;

LAB_17A4
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;17AA:	210000
	PUSH	HL		;17AD:	E5
	CALL	LAB_35D8	;17AE:	CDD835
	POP	DE		;17B1:	D1
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;17B6:	7E
	INC	HL			; increment pointer
	OR	(HL)		;17B8:	B6
	JP	Z,LAB_17E3	;17B9:	CAE317

	LD	HL,(LAB_EC49)	;17BC:	2A49EC
	LD	DE,000Bh	;17BF:	110B00
	ADD	HL,DE		;17C2:	19
	LD	E,(HL)		;17C3:	5E
	LD	D,#00h		; clear high byte
	LD	HL,(LAB_EB04)	;17C6:	2A04EB
	ADD	HL,DE		;17C9:	19
	LD	(LAB_EC67),HL	;17CA:	2267EC
	LD	HL,(LAB_EC49)	;17CD:	2A49EC
	INC	HL		;17D0:	23
	INC	HL		;17D1:	23
	LD	E,(HL)		;17D2:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;17D5:	EB
	LD	(LAB_EC65),HL	;17D6:	2265EC
	LD	HL,007Eh	;17D9:	217E00
	LD	A,L		;17DC:	7D
	LD	(LAB_E720),A	;17DD:	3220E7
	JP	LAB_17EA	;17E0:	C3EA17
LAB_17E3
	LD	HL,0020h	;17E3:	212000
	LD	A,L		;17E6:	7D
	LD	(LAB_E720),A	;17E7:	3220E7
LAB_17EA
	LD	HL,(LAB_EC65)	;17EA:	2A65EC
	PUSH	HL		;17ED:	E5
	LD	HL,(LAB_EC67)	;17EE:	2A67EC
	PUSH	HL		;17F1:	E5
	CALL	LAB_70AE		; set cursor X,Y
	POP	DE			; dump cursor Y
	POP	DE			; dump cursor X
	LD	A,(LAB_E720)	;17F7:	3A20E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push character
	CALL	LAB_720D		; character out to screen & buffer
	POP	DE			; dump character
	RET				;

; setup screen & other ??

LAB_1803
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	CALL	LAB_6F61		; clear screen & screen buffer ??
	CALL	LAB_EEEC		; setup LAB_E69D & LAB_E6A9 to LAB_E6AD
	CALL	LAB_EF14		; do BDOS function 2Dh
	CALL	LAB_EF28		; null routine
	LD	HL,0000h		; cursor blink off
	PUSH	HL			; push flag
	CALL	LAB_71B2		; set cursor blink on/off
	POP	DE			; dump cursor flag
	LD	HL,0000h	;181D:	210000
	LD	(LAB_EC49),HL	;1820:	2249EC
	LD	HL,0000h	;1823:	210000
	LD	(LAB_EC41),HL	;1826:	2241EC
	LD	HL,0000h	;1829:	210000
	LD	(LAB_EC5F),HL	;182C:	225FEC
	LD	HL,0000h	;182F:	210000
	LD	(LAB_EB02),HL	;1832:	2202EB
	LD	HL,LAB_F118	;1835:	2118F1
	LD	(LAB_EC69),HL	;1838:	2269EC
	RET				;

; stack is ..
; ??

LAB_183C
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;1846:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1848:	56
	EX	DE,HL		;1849:	EB
	LD	(LAB_EC49),HL	;184A:	2249EC
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;1851:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1853:	56
	LD	HL,000Dh	;1854:	210D00
	ADD	HL,DE		;1857:	19
	LD	E,(HL)		;1858:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;185B:	EB
	LD	(LAB_EC45),HL	;185C:	2245EC
	LD	HL,0000h	;185F:	210000
	LD	(LAB_EB55),HL	;1862:	2255EB
	LD	HL,0000h	;1865:	210000
	LD	(LAB_EB04),HL	;1868:	2204EB
	LD	HL,(LAB_EC49)	;186B:	2A49EC
	LD	DE,000Eh	;186E:	110E00
	ADD	HL,DE		;1871:	19
	LD	(LAB_EB14),HL	;1872:	2214EB
	LD	(LAB_E721),HL	;1875:	2221E7
	LD	HL,LAB_EB57	;1878:	2157EB
	LD	(LAB_EB53),HL	;187B:	2253EB
	LD	(LAB_E723),HL	;187E:	2223E7
	LD	HL,0000h	;1881:	210000
	LD	A,L		;1884:	7D
	LD	(LAB_E725),A	;1885:	3225E7
	JP	LAB_18B1	;1888:	C3B118
LAB_188B
	LD	A,(LAB_E725)	;188B:	3A25E7
	LD	L,A		;188E:	6F
	INC	HL		;188F:	23
	LD	A,L		;1890:	7D
	LD	(LAB_E725),A	;1891:	3225E7
	DEC	HL			; -1 (don't need this)
	LD	HL,(LAB_E721)	;1895:	2A21E7
	LD	DE,0009h		; +9
	ADD	HL,DE			; add 9
	LD	(LAB_E721),HL	;189C:	2221E7
	LD	DE,FFF7h		; -9 (don't need)
	ADD	HL,DE			; add -9 (either of these)
	LD	HL,(LAB_E723)	;18A3:	2A23E7
	LD	DE,000Ah		; +10
	ADD	HL,DE			; add 10
	LD	(LAB_E723),HL	;18AA:	2223E7
	LD	DE,FFF6h		; -10
	ADD	HL,DE			; add -10
LAB_18B1
	LD	A,(LAB_E725)	;18B1:	3A25E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	EX	DE,HL		;18B7:	EB
	LD	HL,(LAB_EC45)	;18B8:	2A45EC
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_198A	;18BE:	CA8A19
	LD	HL,(LAB_E721)	;18C1:	2A21E7
	LD	E,(HL)		;18C4:	5E
	PUSH	DE		;18C5:	D5
	LD	HL,(LAB_E723)	;18C6:	2A23E7
	POP	DE		;18C9:	D1
	LD	(HL),E		;18CA:	73
	LD	HL,(LAB_E721)	;18CB:	2A21E7
	INC	HL		;18CE:	23
	INC	HL		;18CF:	23
	LD	E,(HL)		;18D0:	5E
	PUSH	DE		;18D1:	D5
	LD	HL,(LAB_E723)	;18D2:	2A23E7
	INC	HL		;18D5:	23
	POP	DE		;18D6:	D1
	LD	(HL),E		;18D7:	73
	LD	HL,0000h	;18D8:	210000
	PUSH	HL		;18DB:	E5
	LD	HL,(LAB_E723)	;18DC:	2A23E7
	INC	HL		;18DF:	23
	INC	HL		;18E0:	23
	POP	DE		;18E1:	D1
	LD	(HL),E		;18E2:	73
	LD	HL,0000h	;18E3:	210000
	PUSH	HL		;18E6:	E5
	LD	HL,(LAB_E723)	;18E7:	2A23E7
	INC	HL		;18EA:	23
	INC	HL		;18EB:	23
	INC	HL		;18EC:	23
	POP	DE		;18ED:	D1
	LD	(HL),E		;18EE:	73
	LD	HL,(LAB_E721)	;18EF:	2A21E7
	LD	DE,0005h	;18F2:	110500
	ADD	HL,DE		;18F5:	19
	LD	E,(HL)		;18F6:	5E
	INC	HL		;18F7:	23
	LD	D,(HL)		;18F8:	56
	PUSH	DE		;18F9:	D5
	LD	HL,(LAB_E723)	;18FA:	2A23E7
	LD	DE,0004h	;18FD:	110400
	ADD	HL,DE		;1900:	19
	POP	DE		;1901:	D1
	LD	(HL),E		;1902:	73
	INC	HL			; increment pointer
	LD	(HL),D		;1904:	72
	LD	HL,(LAB_E721)	;1905:	2A21E7
	LD	A,(HL)		;1908:	7E
	OR	A		;1909:	B7
	JP	Z,LAB_1935	;190A:	CA3519
	LD	HL,0000h	;190D:	210000
	PUSH	HL		;1910:	E5
	LD	HL,(LAB_E723)	;1911:	2A23E7
	LD	DE,0006h	;1914:	110600
	ADD	HL,DE		;1917:	19
	POP	DE		;1918:	D1
	LD	(HL),E		;1919:	73
	INC	HL			; increment pointer
	LD	(HL),D		;191B:	72
	LD	HL,(LAB_E721)	;191C:	2A21E7
	LD	DE,0007h	;191F:	110700
	ADD	HL,DE		;1922:	19
	LD	E,(HL)		;1923:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1925:	56
	PUSH	DE		;1926:	D5
	LD	HL,(LAB_E723)	;1927:	2A23E7
	LD	DE,0008h	;192A:	110800
	ADD	HL,DE		;192D:	19
	POP	DE		;192E:	D1
	LD	(HL),E		;192F:	73
	INC	HL			; increment pointer
	LD	(HL),D		;1931:	72
	JP	LAB_1968	;1932:	C36819

LAB_1935
	LD	HL,(LAB_E721)	;1935:	2A21E7
	LD	DE,0007h	;1938:	110700
	ADD	HL,DE		;193B:	19
	LD	E,(HL)		;193C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;193E:	56
	PUSH	DE		;193F:	D5
	LD	HL,(LAB_E723)	;1940:	2A23E7
	LD	DE,0006h	;1943:	110600
	ADD	HL,DE		;1946:	19
	POP	DE		;1947:	D1
	LD	(HL),E		;1948:	73
	INC	HL			; increment pointer
	LD	(HL),D		;194A:	72
	LD	HL,(LAB_E723)	;194B:	2A23E7
	LD	DE,0006h	;194E:	110600
	ADD	HL,DE		;1951:	19
	LD	E,(HL)		;1952:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1954:	56
	LD	HL,0017h	;1955:	211700
	ADD	HL,DE		;1958:	19
	LD	E,(HL)		;1959:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;195B:	56
	PUSH	DE		;195C:	D5
	LD	HL,(LAB_E723)	;195D:	2A23E7
	LD	DE,0008h	;1960:	110800
	ADD	HL,DE		;1963:	19
	POP	DE		;1964:	D1
	LD	(HL),E		;1965:	73
	INC	HL			; increment pointer
	LD	(HL),D		;1967:	72
LAB_1968
	LD	HL,(LAB_E721)	;1968:	2A21E7
	INC	HL		;196B:	23
	INC	HL		;196C:	23
	LD	A,(HL)		;196D:	7E
	OR	A		;196E:	B7
	JP	Z,LAB_1987	;196F:	CA8719
	LD	A,(LAB_E725)	;1972:	3A25E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	(LAB_EB55),HL	;1978:	2255EB
	LD	HL,(LAB_E721)	;197B:	2A21E7
	LD	(LAB_EB14),HL	;197E:	2214EB
	LD	HL,(LAB_E723)	;1981:	2A23E7
	LD	(LAB_EB53),HL	;1984:	2253EB
LAB_1987
	JP	LAB_188B	;1987:	C38B18
LAB_198A
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_198E
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;1994:	210000
	PUSH	HL		;1997:	E5
	CALL	LAB_35D8	;1998:	CDD835
	POP	DE		;199B:	D1
	LD	HL,(LAB_EC49)	;199C:	2A49EC
	INC	HL		;199F:	23
	INC	HL		;19A0:	23
	INC	HL		;19A1:	23
	LD	A,(HL)		;19A2:	7E
	OR	A		;19A3:	B7
	JP	Z,LAB_19D9	;19A4:	CAD919

	LD	HL,(LAB_EC49)	;19A7:	2A49EC
	LD	DE,0004h	;19AA:	110400
	ADD	HL,DE		;19AD:	19
	LD	E,(HL)		;19AE:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;19B1:	D5
	LD	HL,(LAB_EC49)	;19B2:	2A49EC
	INC	HL		;19B5:	23
	INC	HL		;19B6:	23
	INC	HL		;19B7:	23
	LD	E,(HL)		;19B8:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;19BB:	D5
	LD	HL,(LAB_EC49)	;19BC:	2A49EC
	INC	HL		;19BF:	23
	INC	HL		;19C0:	23
	LD	E,(HL)		;19C1:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;19C4:	D5
	LD	HL,(LAB_EC49)	;19C5:	2A49EC
	INC	HL		;19C8:	23
	LD	E,(HL)		;19C9:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push y
	CALL	LAB_6FBA		; clear screen area
	EX	DE,HL		;19D0:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	JP	LAB_19F2	;19D6:	C3F219

LAB_19D9
	LD	HL,0014h		; 20d wide
	PUSH	HL			; push x size
	LD	HL,0008h		; 8d high
	PUSH	HL			; push y size
	LD	HL,0000h		; x = 0
	PUSH	HL			; push x
	LD	HL,0000h		; y = 0
	PUSH	HL			; push y
	CALL	LAB_6FBA		; clear screen area
	EX	DE,HL		;19EC:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
LAB_19F2
	LD	HL,(LAB_EC49)	;19F2:	2A49EC
	LD	DE,0007h	;19F5:	110700
	ADD	HL,DE		;19F8:	19
	LD	E,(HL)		;19F9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;19FB:	56
	EX	DE,HL		;19FC:	EB
	LD	(LAB_E726),HL	;19FD:	2226E7
	LD	HL,0000h	;1A00:	210000
	LD	A,L		;1A03:	7D
	LD	(LAB_E72A),A	;1A04:	322AE7
	JP	LAB_1A22	;1A07:	C3221A

LAB_1A0A
	LD	A,(LAB_E72A)	;1A0A:	3A2AE7
	LD	L,A		;1A0D:	6F
	INC	HL		;1A0E:	23
	LD	A,L		;1A0F:	7D
	LD	(LAB_E72A),A	;1A10:	322AE7
	DEC	HL		;1A13:	2B
	LD	HL,(LAB_E726)	;1A14:	2A26E7
	LD	DE,0004h	;1A17:	110400
	ADD	HL,DE		;1A1A:	19
	LD	(LAB_E726),HL	;1A1B:	2226E7
	LD	DE,FFFCh	;1A1E:	11FCFF
	ADD	HL,DE		;1A21:	19
LAB_1A22
	LD	HL,(LAB_EC49)	;1A22:	2A49EC
	LD	DE,0005h	;1A25:	110500
	ADD	HL,DE		;1A28:	19
	LD	E,(HL)		;1A29:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;1A2C:	D5
	LD	A,(LAB_E72A)	;1A2D:	3A2AE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;1A33:	D1
	EX	DE,HL		;1A34:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_1A5F	;1A38:	CA5F1A
	LD	HL,(LAB_E726)	;1A3B:	2A26E7
	INC	HL		;1A3E:	23
	LD	E,(HL)		;1A3F:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;1A42:	D5
	LD	HL,(LAB_E726)	;1A43:	2A26E7
	LD	E,(HL)		;1A46:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;1A49:	D5
	CALL	LAB_70AE		; set cursor X,Y
	POP	DE			; dump cursor Y
	POP	DE			; dump cursor X
	LD	HL,(LAB_E726)	;1A4F:	2A26E7
	INC	HL		;1A52:	23
	INC	HL		;1A53:	23
	LD	E,(HL)		;1A54:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1A56:	56
	PUSH	DE		;1A57:	D5
	CALL	LAB_35A2	;1A58:	CDA235
	POP	DE		;1A5B:	D1
	JP	LAB_1A0A	;1A5C:	C30A1A
LAB_1A5F
	LD	HL,(LAB_EC49)	;1A5F:	2A49EC
	LD	E,(HL)		;1A62:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_1ADC		; jump if DE<>1

	LD	HL,(LAB_EC49)	;1A6E:	2A49EC
	LD	DE,0009h	;1A71:	110900
	ADD	HL,DE		;1A74:	19
	LD	E,(HL)		;1A75:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1A77:	56
	EX	DE,HL		;1A78:	EB
	LD	(LAB_E728),HL	;1A79:	2228E7
	LD	HL,0000h	;1A7C:	210000
	LD	A,L		;1A7F:	7D
	LD	(LAB_E72A),A	;1A80:	322AE7
	JP	LAB_1A9E	;1A83:	C39E1A
LAB_1A86
	LD	A,(LAB_E72A)	;1A86:	3A2AE7
	LD	L,A		;1A89:	6F
	INC	HL		;1A8A:	23
	LD	A,L		;1A8B:	7D
	LD	(LAB_E72A),A	;1A8C:	322AE7
	DEC	HL		;1A8F:	2B
	LD	HL,(LAB_E728)	;1A90:	2A28E7
	LD	DE,0005h	;1A93:	110500
	ADD	HL,DE		;1A96:	19
	LD	(LAB_E728),HL	;1A97:	2228E7
	LD	DE,FFFBh	;1A9A:	11FBFF
	ADD	HL,DE		;1A9D:	19
LAB_1A9E
	LD	HL,(LAB_EC49)	;1A9E:	2A49EC
	LD	DE,0006h	;1AA1:	110600
	ADD	HL,DE		;1AA4:	19
	LD	E,(HL)		;1AA5:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;1AA8:	D5
	LD	A,(LAB_E72A)	;1AA9:	3A2AE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;1AAF:	D1
	EX	DE,HL		;1AB0:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_1ADC	;1AB4:	CADC1A
	LD	HL,(LAB_E728)	;1AB7:	2A28E7
	INC	HL		;1ABA:	23
	LD	E,(HL)		;1ABB:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;1ABE:	D5
	LD	HL,(LAB_E728)	;1ABF:	2A28E7
	LD	E,(HL)		;1AC2:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;1AC5:	D5
	CALL	LAB_70AE		; set cursor X,Y
	POP	DE			; dump cursor Y
	POP	DE			; dump cursor X
	LD	HL,(LAB_E728)	;1ACB:	2A28E7
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	E,(HL)		;1AD1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1AD3:	56
	PUSH	DE		;1AD4:	D5
	CALL	LAB_35A2	;1AD5:	CDA235
	POP	DE		;1AD8:	D1
	JP	LAB_1A86	;1AD9:	C3861A
LAB_1ADC
	RET				;

LAB_1ADD
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;1AE3:	210000
	LD	(LAB_EC3B),HL	;1AE6:	223BEC
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1AED:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1AEF:	56
	EX	DE,HL		;1AF0:	EB
	LD	(LAB_EC4D),HL	;1AF1:	224DEC
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1AF8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1AFA:	56
	PUSH	DE		;1AFB:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1B00:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1B02:	56
	PUSH	DE		;1B03:	D5
	CALL	LAB_1B0A	;1B04:	CD0A1B
	POP	DE		;1B07:	D1
	POP	DE		;1B08:	D1
	RET				;

LAB_1B0A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;1B14:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1B16:	56
	EX	DE,HL		;1B17:	EB
	LD	(LAB_E72D),HL	;1B18:	222DE7
	LD	HL,0000h	;1B1B:	210000
	PUSH	HL		;1B1E:	E5
	CALL	LAB_41D5	;1B1F:	CDD541
	POP	DE		;1B22:	D1
	JP	Z,LAB_1B7C	;1B23:	CA7C1B

LAB_1B26
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;1B2A:	7E
	INC	HL			; increment pointer
	OR	(HL)		;1B2C:	B6
	JP	Z,LAB_1B38	;1B2D:	CA381B
	LD	HL,(LAB_E72D)	;1B30:	2A2DE7
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_1B42	;1B35:	C2421B

LAB_1B38
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;1B3B:	7D
	LD	(LAB_E72C),A	;1B3C:	322CE7
	JP	LAB_1B57	;1B3F:	C3571B
LAB_1B42
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1B46:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1B48:	56
	EX	DE,HL		;1B49:	EB
	LD	E,(HL)		;1B4A:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0002h	;1B4D:	210200
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	LD	A,L		;1B53:	7D
	LD	(LAB_E72C),A	;1B54:	322CE7
LAB_1B57
	LD	A,(LAB_E72C)	;1B57:	3A2CE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;1B5D:	E5
	CALL	LAB_463F	;1B5E:	CD3F46
	POP	DE		;1B61:	D1
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;1B66:	E5
	LD	A,(HL)		;1B67:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;1B69:	66
	LD	L,A		;1B6A:	6F
	INC	HL			; increment pointer
	EX	DE,HL		;1B6C:	EB
	POP	HL		;1B6D:	E1
	LD	(HL),E		;1B6E:	73
	INC	HL			; increment pointer
	LD	(HL),D		;1B70:	72
	LD	HL,0000h	;1B71:	210000
	PUSH	HL		;1B74:	E5
	CALL	LAB_4281	;1B75:	CD8142
	POP	DE		;1B78:	D1
	JP	NZ,LAB_1B26	;1B79:	C2261B
LAB_1B7C
	RET				;

; stack is ..
; ??
; ??
; ??
; ??
; ??
; ??
; end.

LAB_1B7D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;1B83:	210000
	LD	(LAB_EC6B),HL	;1B86:	226BEC
	LD	HL,0000h	;1B89:	210000
	LD	(LAB_EC41),HL	;1B8C:	2241EC
	LD	HL,0000h	;1B8F:	210000
	LD	(LAB_EB1C),HL	;1B92:	221CEB
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1B99:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1B9B:	56
	EX	DE,HL		;1B9C:	EB
	LD	(LAB_EC4D),HL	;1B9D:	224DEC
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1BA4:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1BA6:	56
	EX	DE,HL		;1BA7:	EB
	LD	(LAB_EC53),HL	;1BA8:	2253EC
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1BAF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1BB1:	56
	EX	DE,HL		;1BB2:	EB
	LD	(LAB_EB00),HL	;1BB3:	2200EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;1BBA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1BBC:	56
	EX	DE,HL		;1BBD:	EB
	LD	(LAB_EC51),HL	;1BBE:	2251EC
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1BC5:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;1BC8:	EB
	LD	(LAB_EB10),HL	;1BC9:	2210EB
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1BD0:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1BD2:	56
	EX	DE,HL		;1BD3:	EB
	LD	(LAB_EB0A),HL	;1BD4:	220AEB
	LD	HL,0000h		; clear area
	PUSH	HL			; push fill byte
	LD	HL,0040h		; 40h bytes to fill
	PUSH	HL			; push count
	LD	HL,LAB_EBFB		; set destination
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,(LAB_EB10)	;1BE9:	2A10EB
	PUSH	HL		;1BEC:	E5
	LD	HL,(LAB_EC41)	;1BED:	2A41EC
	PUSH	HL		;1BF0:	E5
	CALL	LAB_3BA8	;1BF1:	CDA83B
	POP	DE		;1BF4:	D1
	POP	DE		;1BF5:	D1
	LD	HL,(LAB_EB02)	;1BF6:	2A02EB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_1C0D	;1BFB:	CA0D1C

	LD	HL,(LAB_EB53)	;1BFE:	2A53EB
	LD	DE,0006h	;1C01:	110600
	ADD	HL,DE		;1C04:	19
	LD	E,(HL)		;1C05:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1C07:	56
	PUSH	DE		;1C08:	D5
	CALL	LAB_EE78	;1C09:	CD78EE
	POP	DE		;1C0C:	D1
LAB_1C0D
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;1C11:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_1C2F		; jump if DE bit0<>1

	LD	HL,(LAB_EC49)	;1C1D:	2A49EC
	LD	DE,000Ch	;1C20:	110C00
	ADD	HL,DE		;1C23:	19
	LD	A,(HL)		;1C24:	7E
	OR	A		;1C25:	B7
	JP	Z,LAB_1C2F	;1C26:	CA2F1C
	CALL	LAB_2659	;1C29:	CD5926
	JP	LAB_1C51	;1C2C:	C3511C
LAB_1C2F
	LD	HL,(LAB_EB02)	;1C2F:	2A02EB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_1C44	;1C34:	CA441C

	LD	HL,0000h	;1C37:	210000
	PUSH	HL		;1C3A:	E5
	LD	HL,000Bh	;1C3B:	210B00
	PUSH	HL		;1C3E:	E5
	CALL	LAB_3BA8	;1C3F:	CDA83B
	POP	DE		;1C42:	D1
	POP	DE		;1C43:	D1
LAB_1C44
	LD	HL,(LAB_EC4D)	;1C44:	2A4DEC
	PUSH	HL		;1C47:	E5
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;1C4B:	E5
	CALL	LAB_1B0A	;1C4C:	CD0A1B
	POP	DE		;1C4F:	D1
	POP	DE		;1C50:	D1
LAB_1C51
	LD	HL,0000h	;1C51:	210000
	LD	(LAB_EB02),HL	;1C54:	2202EB
	LD	HL,0000h	;1C57:	210000
	LD	(LAB_EC61),HL	;1C5A:	2261EC
	LD	HL,0000h	;1C5D:	210000
	LD	(LAB_EBF9),HL	;1C60:	22F9EB
	LD	HL,(LAB_EC4D)	;1C63:	2A4DEC
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_1C74	;1C68:	C2741C

	LD	HL,0000h	;1C6B:	210000
	LD	(LAB_EB1E),HL	;1C6E:	221EEB
	JP	LAB_1C7F	;1C71:	C37F1C
LAB_1C74
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;1C77:	E5
	CALL	LAB_41D5	;1C78:	CDD541
	POP	DE		;1C7B:	D1
	LD	(LAB_EB1E),HL	;1C7C:	221EEB
LAB_1C7F
	LD	HL,(LAB_EB3D)	;1C7F:	2A3DEB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_1C98	;1C84:	CA981C

	LD	HL,(LAB_EB3D)	;1C87:	2A3DEB
	PUSH	HL		;1C8A:	E5
	CALL	LAB_2CD3	;1C8B:	CDD32C
	POP	DE		;1C8E:	D1
	LD	HL,0000h	;1C8F:	210000
	LD	(LAB_EB3D),HL	;1C92:	223DEB
	JP	LAB_1CAE	;1C95:	C3AE1C
LAB_1C98
	LD	HL,(LAB_EC5F)	;1C98:	2A5FEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_1CAE	;1C9D:	CAAE1C

LAB_1CA0
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;1CA3:	E5
	CALL	LAB_4281	;1CA4:	CD8142
	POP	DE		;1CA7:	D1
	JP	Z,LAB_1CAE	;1CA8:	CAAE1C
	JP	LAB_1CA0	;1CAB:	C3A01C
LAB_1CAE
	LD	HL,(LAB_EC49)	;1CAE:	2A49EC
	LD	DE,000Ch	;1CB1:	110C00
	ADD	HL,DE		;1CB4:	19
	LD	A,(HL)		;1CB5:	7E
	OR	A		;1CB6:	B7
	JP	Z,LAB_1CC2	;1CB7:	CAC21C
	LD	HL,(LAB_EB1E)	;1CBA:	2A1EEB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_1CC8	;1CBF:	CAC81C

LAB_1CC2
	LD	HL,0000h	;1CC2:	210000
	JP	LAB_1CCB	;1CC5:	C3CB1C
LAB_1CC8
	LD	HL,0001h		; set HL = 0001h
LAB_1CCB
	LD	A,L		;1CCB:	7D
	LD	(LAB_E730),A	;1CCC:	3230E7
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;1CD2:	7D
	LD	(LAB_E731),A	;1CD3:	3231E7
LAB_1CD6
	LD	HL,(LAB_EB1C)	;1CD6:	2A1CEB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_1D75	;1CDB:	C2751D

	LD	A,(LAB_E730)	;1CDE:	3A30E7
	OR	A		;1CE1:	B7
	JP	Z,LAB_1CED	;1CE2:	CAED1C
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;1CE8:	E5
	CALL	LAB_17A4	;1CE9:	CDA417
	POP	DE		;1CEC:	D1
LAB_1CED
	LD	HL,(LAB_EB1E)	;1CED:	2A1EEB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_1D1E	;1CF2:	CA1E1D

	LD	A,(LAB_E731)	;1CF5:	3A31E7
	OR	A		;1CF8:	B7
	JP	Z,LAB_1D13	;1CF9:	CA131D
	LD	HL,(LAB_EB16)	;1CFC:	2A16EB
	LD	E,(HL)		;1CFF:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0002h		; set HL = 0002h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL		;1D08:	E5
	CALL	LAB_463F	;1D09:	CD3F46
	POP	DE		;1D0C:	D1
	LD	HL,0000h	;1D0D:	210000
	LD	(LAB_EBF9),HL	;1D10:	22F9EB
LAB_1D13
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;1D16:	E5
	CALL	LAB_2E6F	;1D17:	CD6F2E
	POP	DE		;1D1A:	D1
	JP	LAB_1D4F	;1D1B:	C34F1D
LAB_1D1E
	LD	HL,0001h		; set cursor on/off flag
	PUSH	HL			; push flag
	CALL	LAB_EEF0		; set cursor on/off
	POP	DE			; dump flag
	LD	HL,0000h	;1D26:	210000
	LD	A,L		;1D29:	7D
	LD	(LAB_E731),A	;1D2A:	3231E7
LAB_1D2D
	LD	A,(LAB_E731)	;1D2D:	3A31E7
	OR	A		;1D30:	B7
	JP	NZ,LAB_1D4F	;1D31:	C24F1D

	CALL	LAB_EEE8		; get byte from key buffer ??
	LD	(LAB_EC41),HL	;1D37:	2241EC
	CALL	LAB_2C4F	;1D3A:	CD4F2C
	LD	A,L		;1D3D:	7D
	LD	(LAB_E731),A	;1D3E:	3231E7
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_1D4C	;1D43:	C24C1D

	LD	HL,(LAB_EC69)	; get ??vector
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
LAB_1D4C
	JP	LAB_1D2D	;1D4C:	C32D1D
LAB_1D4F
	CALL	LAB_2D3A	;1D4F:	CD3A2D
	LD	A,L		;1D52:	7D
	LD	(LAB_E731),A	;1D53:	3231E7
	LD	A,(LAB_E730)	;1D56:	3A30E7
	OR	A		;1D59:	B7
	JP	Z,LAB_1D65	;1D5A:	CA651D
	LD	HL,0000h	;1D5D:	210000
	PUSH	HL		;1D60:	E5
	CALL	LAB_17A4	;1D61:	CDA417
	POP	DE		;1D64:	D1
LAB_1D65
	LD	A,(LAB_E731)	;1D65:	3A31E7
	OR	A		;1D68:	B7
	JP	NZ,LAB_1D72	;1D69:	C2721D
	LD	HL,0000h	;1D6C:	210000
	LD	(LAB_EB1C),HL	;1D6F:	221CEB
LAB_1D72
	JP	LAB_1CD6	;1D72:	C3D61C
LAB_1D75
	LD	HL,0001h		; set HL = 0001h
	RET				;

; does nothing

LAB_1D79
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	RET				;

LAB_1D80
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EC6B),HL	;1D89:	226BEC
	LD	HL,(LAB_EC49)	;1D8C:	2A49EC
	LD	E,(HL)		;1D8F:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_1D9F	;1D98:	CA9F1D
	LD	HL,0000h	;1D9B:	210000
	RET				;

LAB_1D9F
	LD	HL,0000h	;1D9F:	210000
	PUSH	HL		;1DA2:	E5
	LD	HL,0000h	;1DA3:	210000
	PUSH	HL		;1DA6:	E5
	CALL	LAB_1ADD	;1DA7:	CDDD1A
	POP	DE		;1DAA:	D1
	POP	DE		;1DAB:	D1
	LD	HL,0000h	;1DAC:	210000
	PUSH	HL		;1DAF:	E5
	CALL	LAB_35D8	;1DB0:	CDD835
	POP	DE		;1DB3:	D1
	LD	HL,(LAB_EB43)	;1DB4:	2A43EB
	LD	DE,0000h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_1DC7		; jump if DE+ve

	LD	HL,0000h	;1DC1:	210000
	LD	(LAB_EB43),HL	;1DC4:	2243EB
LAB_1DC7
	LD	HL,(LAB_EB43)	;1DC7:	2A43EB
	LD	A,L		;1DCA:	7D
	LD	(LAB_E739),A	;1DCB:	3239E7
	LD	HL,(LAB_EB43)	;1DCE:	2A43EB
	LD	DE,0005h	;1DD1:	110500
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	PUSH	HL		;1DD7:	E5
	LD	HL,(LAB_EC49)	;1DD8:	2A49EC
	LD	DE,0009h	;1DDB:	110900
	ADD	HL,DE		;1DDE:	19
	LD	E,(HL)		;1DDF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1DE1:	56
	POP	HL		;1DE2:	E1
	ADD	HL,DE		;1DE3:	19
	LD	(LAB_E734),HL	;1DE4:	2234E7
	LD	HL,(LAB_EC49)	;1DE7:	2A49EC
	LD	DE,0009h	;1DEA:	110900
	ADD	HL,DE		;1DED:	19
	LD	E,(HL)		;1DEE:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1DF0:	56
	EX	DE,HL		;1DF1:	EB
	INC	HL		;1DF2:	23
	INC	HL		;1DF3:	23
	LD	E,(HL)		;1DF4:	5E
	LD	D,#00h		; clear high byte
	LD	HL,LAB_E104	;1DF7:	2104E1
	ADD	HL,DE		;1DFA:	19
	INC	HL		;1DFB:	23
	LD	E,(HL)		;1DFC:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;1DFF:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL			; push flag
	CALL	LAB_EEF0		; set cursor on/off
	POP	DE			; dump flag
LAB_1E0A
	LD	HL,0001h		; set HL = 0001h
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_1FF2	;1E0F:	CAF21F

	LD	HL,0000h	;1E12:	210000
	LD	A,L		;1E15:	7D
	LD	(LAB_E73A),A	;1E16:	323AE7
	LD	HL,(LAB_E734)	;1E19:	2A34E7
	INC	HL		;1E1C:	23
	LD	E,(HL)		;1E1D:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;1E20:	EB
	DEC	HL		;1E21:	2B
	PUSH	HL		;1E22:	E5
	LD	HL,(LAB_E734)	;1E23:	2A34E7
	LD	E,(HL)		;1E26:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;1E29:	D5
	CALL	LAB_70AE		; set cursor X,Y
	POP	DE			; dump cursor Y
	POP	DE			; dump cursor X
	LD	HL,007Eh	;1E2F:	217E00
	PUSH	HL			; push character
	CALL	LAB_720D		; character out to screen & buffer
	POP	DE			; dump character
	CALL	LAB_EEE8		; get byte from key buffer ??
	LD	(LAB_EC41),HL	;1E3A:	2241EC
	LD	HL,(LAB_E734)	;1E3D:	2A34E7
	INC	HL		;1E40:	23
	LD	E,(HL)		;1E41:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;1E44:	EB
	DEC	HL		;1E45:	2B
	PUSH	HL		;1E46:	E5
	LD	HL,(LAB_E734)	;1E47:	2A34E7
	LD	E,(HL)		;1E4A:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;1E4D:	D5
	CALL	LAB_70AE		; set cursor X,Y
	POP	DE			; dump cursor Y
	POP	DE			; dump cursor X
	LD	HL,0020h		; character is " "
	PUSH	HL			; push character
	CALL	LAB_720D		; character out to screen & buffer
	POP	DE			; dump character
	LD	HL,(LAB_EC41)	;1E5B:	2A41EC
	JP	LAB_1F96	;1E5E:	C3961F

LAB_1E61
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;1E64:	7D
	LD	(LAB_E73A),A	;1E65:	323AE7
	LD	HL,(LAB_EC49)	;1E68:	2A49EC
	LD	DE,0006h	;1E6B:	110600
	ADD	HL,DE		;1E6E:	19
	LD	E,(HL)		;1E6F:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;1E72:	EB
	DEC	HL		;1E73:	2B
	PUSH	HL		;1E74:	E5
	LD	A,(LAB_E739)	;1E75:	3A39E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;1E7B:	D1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_1E8B	;1E7F:	CA8B1E
	LD	HL,(LAB_EC69)	;1E82:	2A69EC
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	JP	LAB_1E9E	;1E88:	C39E1E
LAB_1E8B
	LD	A,(LAB_E739)	;1E8B:	3A39E7
	LD	L,A		;1E8E:	6F
	INC	HL		;1E8F:	23
	LD	A,L		;1E90:	7D
	LD	(LAB_E739),A	;1E91:	3239E7
	LD	HL,(LAB_E734)	;1E94:	2A34E7
	LD	DE,0005h	;1E97:	110500
	ADD	HL,DE		;1E9A:	19
	LD	(LAB_E734),HL	;1E9B:	2234E7
LAB_1E9E
	JP	LAB_1FB5	;1E9E:	C3B51F

LAB_1EA1
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;1EA4:	7D
	LD	(LAB_E73A),A	;1EA5:	323AE7
	LD	A,(LAB_E739)	;1EA8:	3A39E7
	OR	A		;1EAB:	B7
	JP	NZ,LAB_1EB8	;1EAC:	C2B81E
	LD	HL,(LAB_EC69)	;1EAF:	2A69EC
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	JP	LAB_1ECB	;1EB5:	C3CB1E
LAB_1EB8
	LD	A,(LAB_E739)	;1EB8:	3A39E7
	LD	L,A		;1EBB:	6F
	DEC	HL		;1EBC:	2B
	LD	A,L		;1EBD:	7D
	LD	(LAB_E739),A	;1EBE:	3239E7
	LD	HL,(LAB_E734)	;1EC1:	2A34E7
	LD	DE,FFFBh	;1EC4:	11FBFF
	ADD	HL,DE		;1EC7:	19
	LD	(LAB_E734),HL	;1EC8:	2234E7
LAB_1ECB
	JP	LAB_1FB5	;1ECB:	C3B51F

LAB_1ECE
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;1ED1:	7D
	LD	(LAB_E73A),A	;1ED2:	323AE7
	LD	HL,0000h	;1ED5:	210000
	LD	A,L		;1ED8:	7D
	LD	(LAB_E739),A	;1ED9:	3239E7
	LD	HL,(LAB_EC49)	;1EDC:	2A49EC
	LD	DE,0009h	;1EDF:	110900
	ADD	HL,DE		;1EE2:	19
	LD	E,(HL)		;1EE3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1EE5:	56
	EX	DE,HL		;1EE6:	EB
	LD	(LAB_E734),HL	;1EE7:	2234E7
	JP	LAB_1FB5	;1EEA:	C3B51F

LAB_1EED
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;1EF0:	7D
	LD	(LAB_E73A),A	;1EF1:	323AE7
	LD	HL,(LAB_EC49)	;1EF4:	2A49EC
	LD	DE,0006h	;1EF7:	110600
	ADD	HL,DE		;1EFA:	19
	LD	E,(HL)		;1EFB:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;1EFE:	EB
	DEC	HL		;1EFF:	2B
	LD	A,L		;1F00:	7D
	LD	(LAB_E739),A	;1F01:	3239E7
	LD	HL,(LAB_EC49)	;1F04:	2A49EC
	LD	DE,0009h	;1F07:	110900
	ADD	HL,DE		;1F0A:	19
	LD	E,(HL)		;1F0B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1F0D:	56
	PUSH	DE		;1F0E:	D5
	LD	A,(LAB_E739)	;1F0F:	3A39E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0005h	;1F15:	110500
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	POP	DE		;1F1B:	D1
	ADD	HL,DE		;1F1C:	19
	LD	(LAB_E734),HL	;1F1D:	2234E7
	JP	LAB_1FB5	;1F20:	C3B51F

LAB_1F23
	LD	HL,(LAB_EC49)	;1F23:	2A49EC
	LD	DE,0009h	;1F26:	110900
	ADD	HL,DE		;1F29:	19
	LD	E,(HL)		;1F2A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;1F2C:	56
	EX	DE,HL		;1F2D:	EB
	LD	(LAB_E736),HL	;1F2E:	2236E7
	LD	HL,0000h	;1F31:	210000
	LD	A,L		;1F34:	7D
	LD	(LAB_E738),A	;1F35:	3238E7
	JP	LAB_1F53	;1F38:	C3531F
LAB_1F3B
	LD	A,(LAB_E738)	;1F3B:	3A38E7
	LD	L,A		;1F3E:	6F
	INC	HL		;1F3F:	23
	LD	A,L		;1F40:	7D
	LD	(LAB_E738),A	;1F41:	3238E7
	DEC	HL		;1F44:	2B
	LD	HL,(LAB_E736)	;1F45:	2A36E7
	LD	DE,0005h	;1F48:	110500
	ADD	HL,DE		;1F4B:	19
	LD	(LAB_E736),HL	;1F4C:	2236E7
	LD	DE,FFFBh	;1F4F:	11FBFF
	ADD	HL,DE		;1F52:	19
LAB_1F53
	LD	HL,(LAB_EC49)	;1F53:	2A49EC
	LD	DE,0006h	;1F56:	110600
	ADD	HL,DE		;1F59:	19
	LD	E,(HL)		;1F5A:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;1F5D:	D5
	LD	A,(LAB_E738)	;1F5E:	3A38E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;1F64:	D1
	EX	DE,HL		;1F65:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_1F93	;1F69:	CA931F
	LD	HL,(LAB_EC41)	;1F6C:	2A41EC
	PUSH	HL		;1F6F:	E5
	CALL	LAB_D8CE	;1F70:	CDCED8
	POP	DE		;1F73:	D1
	PUSH	HL		;1F74:	E5
	LD	HL,(LAB_E736)	;1F75:	2A36E7
	INC	HL		;1F78:	23
	INC	HL		;1F79:	23
	LD	E,(HL)		;1F7A:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;1F7D:	D5
	CALL	LAB_D8CE	;1F7E:	CDCED8
	POP	DE		;1F81:	D1
	POP	DE		;1F82:	D1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_1F90	;1F86:	CA901F
	LD	A,(LAB_E738)	;1F89:	3A38E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

LAB_1F90
	JP	LAB_1F3B	;1F90:	C33B1F
LAB_1F93
	JP	LAB_1FB5	;1F93:	C3B51F
LAB_1F96
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0006

	DW	0001
	DW	LAB_1EA1

	DW	0006
	DW	LAB_1E61

	DW	000B
	DW	LAB_1E61

	DW	000C
	DW	LAB_1EA1

	DW	0011
	DW	LAB_1ECE

	DW	0012
	DW	LAB_1EED

	DW	LAB_1F23

LAB_1FB5
	LD	HL,(LAB_EC41)	;1FB5:	2A41EC
	LD	DE,000Dh	;1FB8:	110D00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_1FC8	;1FBE:	CAC81F
	LD	A,(LAB_E739)	;1FC1:	3A39E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

LAB_1FC8
	LD	HL,(LAB_EC41)	;1FC8:	2A41EC
	LD	DE,0014h	;1FCB:	111400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_1FE2	;1FD1:	CAE21F
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;1FD8:	7E
	INC	HL			; increment pointer
	OR	(HL)		;1FDA:	B6
	JP	Z,LAB_1FE2	;1FDB:	CAE21F
	LD	HL,FFFFh	;1FDE:	21FFFF
	RET				;

LAB_1FE2
	LD	A,(LAB_E73A)	;1FE2:	3A3AE7
	OR	A		;1FE5:	B7
	JP	NZ,LAB_1FEF	;1FE6:	C2EF1F
	LD	HL,(LAB_EC69)	;1FE9:	2A69EC
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
LAB_1FEF
	JP	LAB_1E0A	;1FEF:	C30A1E
LAB_1FF2
	RET				;

LAB_1FF3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0003h	;1FF9:	210300
	LD	(LAB_EC6B),HL	;1FFC:	226BEC
	LD	HL,0000h	;1FFF:	210000
	LD	(LAB_EB1C),HL	;2002:	221CEB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;2009:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;200B:	56
	EX	DE,HL		;200C:	EB
	LD	(LAB_EB00),HL	;200D:	2200EB
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;2014:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;2017:	EB
	LD	(LAB_EB10),HL	;2018:	2210EB
	LD	HL,0000h	;201B:	210000
	LD	(LAB_EC4D),HL	;201E:	224DEC
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;2025:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;2027:	56
	EX	DE,HL		;2028:	EB
	LD	(LAB_EC53),HL	;2029:	2253EC
	LD	HL,(LAB_EB10)	;202C:	2A10EB
	LD	DE,0001h	;202F:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_2041	;2035:	CA4120

	LD	HL,0011h	;2038:	211100
	LD	(LAB_EC41),HL	;203B:	2241EC
	JP	LAB_2047	;203E:	C34720

LAB_2041
	LD	HL,0000h	;2041:	210000
	LD	(LAB_EC41),HL	;2044:	2241EC
LAB_2047
	LD	HL,FFFFh	;2047:	21FFFF
	LD	(LAB_E73B),HL	;204A:	223BE7
LAB_204D
	LD	HL,(LAB_EB1C)	;204D:	2A1CEB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_2112	;2052:	C21221

	LD	HL,(LAB_EB10)	;2055:	2A10EB
	PUSH	HL		;2058:	E5
	LD	HL,(LAB_EC41)	;2059:	2A41EC
	PUSH	HL		;205C:	E5
	CALL	LAB_3BA8	;205D:	CDA83B
	POP	DE		;2060:	D1
	POP	DE		;2061:	D1
	LD	HL,000Bh	;2062:	210B00
	LD	(LAB_EC41),HL	;2065:	2241EC
	LD	HL,(LAB_E73B)	;2068:	2A3BE7
	PUSH	HL		;206B:	E5
	CALL	LAB_47FF	;206C:	CDFF47
	POP	DE		;206F:	D1
	JP	Z,LAB_2079	;2070:	CA7920
	LD	HL,0000h	;2073:	210000
	JP	LAB_207C	;2076:	C37C20
LAB_2079
	LD	HL,0001h		; set HL = 0001h
LAB_207C
	LD	(LAB_EB1C),HL	;207C:	221CEB
	LD	HL,(LAB_EC49)	;207F:	2A49EC
	LD	DE,000Ch	;2082:	110C00
	ADD	HL,DE		;2085:	19
	LD	A,(HL)		;2086:	7E
	OR	A		;2087:	B7
	JP	Z,LAB_2099	;2088:	CA9920
	LD	HL,(LAB_EC49)	;208B:	2A49EC
	LD	DE,000Bh	;208E:	110B00
	ADD	HL,DE		;2091:	19
	LD	E,(HL)		;2092:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;2095:	EB
	LD	(LAB_E73B),HL	;2096:	223BE7
LAB_2099
	LD	HL,0000h	;2099:	210000
	LD	(LAB_EB4F),HL	;209C:	224FEB
	LD	HL,0000h	;209F:	210000
	LD	(LAB_EB12),HL	;20A2:	2212EB
	LD	HL,0002h	;20A5:	210200
	LD	(LAB_EBF7),HL	;20A8:	22F7EB
	LD	HL,(LAB_EB00)	;20AB:	2A00EB
	LD	DE,F168h	;20AE:	1168F1
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_20BA	;20B4:	CABA20
	CALL	LAB_6280	;20B7:	CD8062
LAB_20BA
	LD	HL,(LAB_EB00)	;20BA:	2A00EB
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	LD	HL,0003h	;20C0:	210300
	LD	(LAB_EBF7),HL	;20C3:	22F7EB
	CALL	LAB_6280	;20C6:	CD8062
	CALL	LAB_3804	;20C9:	CD0438
	JP	Z,LAB_20D5	;20CC:	CAD520

	LD	HL,0000h	;20CF:	210000
	JP	LAB_20D8	;20D2:	C3D820
LAB_20D5
	LD	HL,0001h		; set HL = 0001h
LAB_20D8
	EX	DE,HL		;20D8:	EB
	LD	HL,(LAB_EB1C)	;20D9:	2A1CEB
	CALL	LAB_E033		; does OR HL,DE. sets Z flag (LAB_7B6E ROM 1)
	LD	(LAB_EB1C),HL	;20DF:	221CEB
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EBF7),HL	;20E5:	22F7EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;20EC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;20EE:	56
	LD	HL,F168h	;20EF:	2168F1
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_20FB	;20F5:	CAFB20
	CALL	LAB_6280	;20F8:	CD8062
LAB_20FB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;20FF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;2101:	56
	EX	DE,HL			; swap ??vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	LD	HL,0000h	;2106:	210000
	LD	(LAB_EBF7),HL	;2109:	22F7EB
	CALL	LAB_6280	;210C:	CD8062
	JP	LAB_204D	;210F:	C34D20
LAB_2112
	LD	HL,0001h		; set HL = 0001h
	RET				;

; get HL from (LAB_EC41)

LAB_2116
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC41)	;211C:	2A41EC
	RET				;

; save byte @ LAB_EC41

; stack is
; ?? (byte)
; end.

LAB_2120
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get ?? byte
	LD	D,#00h		; clear high byte
	EX	DE,HL			; swap to HL
	LD	(LAB_EC41),HL	; save byte
	RET				;

; store word 0001h @ LAB_EB12

LAB_2132
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EB12),HL	;213B:	2212EB
	RET				;

; store word 0001h @ LAB_EB4F

LAB_213F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EB4F),HL	; save it
	RET				;

; store word 0001h @ LAB_EB1C

LAB_214C
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EB1C),HL	; save it
	RET				;

; store word @ LAB_EB3B

; stack is
; ??
; end.

LAB_2159
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get ?? low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ?? high byte
	EX	DE,HL			; swap to HL
	LD	(LAB_EB3B),HL	; save it
	RET				;

; save word @ LAB_EB3D

; stack is ..
; word
; end.

LAB_216B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;2175:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;2177:	56
	EX	DE,HL		;2178:	EB
	LD	(LAB_EB3D),HL	;2179:	223DEB
	RET				;

LAB_217D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	(LAB_E73D),HL	; save last pushed but 2 pointer
	LD	HL,0000h	;218A:	210000
	LD	(LAB_EC4D),HL	;218D:	224DEC
	LD	HL,0000h	;2190:	210000
	LD	(LAB_EB4F),HL	;2193:	224FEB
	LD	HL,0000h	;2196:	210000
	LD	(LAB_EB12),HL	;2199:	2212EB
	LD	HL,0000h	;219C:	210000
	PUSH	HL		;219F:	E5
	LD	HL,0000h	;21A0:	210000
	PUSH	HL		;21A3:	E5
	CALL	LAB_3BA8	;21A4:	CDA83B
	POP	DE		;21A7:	D1
	POP	DE		;21A8:	D1

LAB_21A9
	LD	HL,(LAB_E73D)	; get last pushed but n pointer
	LD	A,(HL)		; get ?? high byte
	INC	HL			; increment pointer
	OR	(HL)			; OR in low byte
	JP	Z,LAB_21E7		; exit loop if null

	LD	HL,(LAB_E73D)	; get last pushed but n pointer
	LD	E,(HL)		;21B5:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;21B7:	56
	PUSH	DE		;21B8:	D5
	CALL	LAB_EE88	;21B9:	CD88EE
	POP	DE		;21BC:	D1
	JP	NZ,LAB_21C4	;21BD:	C2C421

	LD	HL,0000h	;21C0:	210000
	RET				;

LAB_21C4
	LD	HL,LAB_E73F	;21C4:	213FE7
	PUSH	HL		;21C7:	E5
	LD	HL,(LAB_E73D)	; get last pushed but n pointer
	LD	E,(HL)		;21CB:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;21CD:	56
	PUSH	DE		;21CE:	D5
	CALL	LAB_EE9C	;21CF:	CD9CEE
	POP	DE		;21D2:	D1
	POP	DE		;21D3:	D1
	LD	HL,(LAB_E73F)	;21D4:	2A3FE7
	PUSH	HL		;21D7:	E5
	CALL	LAB_3B7B	;21D8:	CD7B3B
	POP	DE		;21DB:	D1
	LD	HL,(LAB_E73D)	; get last pushed but n pointer
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	(LAB_E73D),HL	; save last pushed but n+1 pointer
	JP	LAB_21A9	;21E4:	C3A921

LAB_21E7
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;21EB:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;21ED:	56
	PUSH	DE		;21EE:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;21F3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;21F5:	56
	PUSH	DE		;21F6:	D5
	LD	HL,0000h	;21F7:	210000
	PUSH	HL		;21FA:	E5
	CALL	LAB_46F8	;21FB:	CDF846
	POP	DE		;21FE:	D1
	POP	DE		;21FF:	D1
	POP	DE		;2200:	D1
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_2205
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;220E:	7D
	LD	(LAB_E741),A	;220F:	3241E7
	LD	HL,0000h	;2212:	210000
	PUSH	HL		;2215:	E5
	CALL	LAB_41D5	;2216:	CDD541
	POP	DE		;2219:	D1
	JP	Z,LAB_2276	;221A:	CA7622
LAB_221D
	LD	HL,(LAB_EC5B)	;221D:	2A5BEC
	LD	A,(HL)		;2220:	7E
	OR	A		;2221:	B7
	JP	NZ,LAB_226B	;2222:	C26B22
	LD	HL,(LAB_EC5B)	;2225:	2A5BEC
	INC	HL		;2228:	23
	INC	HL		;2229:	23
	LD	E,(HL)		;222A:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push byte count
	LD	HL,LAB_EB20	;222E:	2120EB
	PUSH	HL			; push destination pointer
	LD	HL,(LAB_EC5B)	;2232:	2A5BEC
	INC	HL		;2235:	23
	LD	E,(HL)		;2236:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;223D:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;223F:	66
	LD	L,A		;2240:	6F
	ADD	HL,DE		;2241:	19
	PUSH	HL			; push source pointer
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	LD	HL,0000h	;2249:	210000
	PUSH	HL		;224C:	E5
	CALL	LAB_2E6F	;224D:	CD6F2E
	POP	DE		;2250:	D1
	CALL	LAB_23FD	;2251:	CDFD23
	JP	NZ,LAB_226B	;2254:	C26B22

	LD	HL,LAB_E2FF		; set message pointer
	PUSH	HL			; push message pointer
	LD	HL,03E9h		; set error #
	PUSH	HL			; push error #
	CALL	LAB_6602		; display error # & message ??
	POP	DE			; dump error #
	POP	DE			; dump message pointer
	LD	HL,0000h	;2264:	210000
	LD	A,L		;2267:	7D
	LD	(LAB_E741),A	;2268:	3241E7
LAB_226B
	LD	HL,0000h	;226B:	210000
	PUSH	HL		;226E:	E5
	CALL	LAB_4281	;226F:	CD8142
	POP	DE		;2272:	D1
	JP	NZ,LAB_221D	;2273:	C21D22
LAB_2276
	LD	A,(LAB_E741)	;2276:	3A41E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

; store word 0000h @ LAB_EC41

LAB_227D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;2283:	210000
	LD	(LAB_EC41),HL	;2286:	2241EC
	RET				;

; store word 0001h @ LAB_EB02

LAB_228A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EB02),HL	;2293:	2202EB
	RET				;

; move string down, pad with chr

; stack is ..
; pointer
; length
; character

LAB_2297
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer high byte
	EX	DE,HL			; swap to HL
	LD	(LAB_E746),HL	; set destination pointer
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL			; save pointer pointer
	LD	A,(HL)		; get pointer low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get pointer high byte
	LD	L,A			; copy low byte to L
	INC	HL			; +1
	EX	DE,HL			; swap to DE
	POP	HL			; restore pointer pointer
	LD	(HL),E		; save pointer low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save pointer high byte
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E744),HL	; set count = 1
	JP	LAB_22C7		; skip initial increment

LAB_22C0
	LD	HL,(LAB_E744)	; get count
	INC	HL			; +1
	LD	(LAB_E744),HL	; save count
LAB_22C7
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get length byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; not needed
	LD	HL,(LAB_E744)	; get count
	POP	DE			; not needed
	EX	DE,HL			; swap count & length
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_22FA		; jump if length <= count (i.e. done)

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL			; save pointer pointer
	LD	A,(HL)		; get pointer low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get pointer high byte
	LD	L,A			; copy low byte to L
	INC	HL			; +1
	EX	DE,HL			; swap to DE
	POP	HL			; restore pointer pointer
	LD	(HL),E		; save pointer low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save pointer high byte
	EX	DE,HL			; swap pointer to HL
	DEC	HL			; -1
	LD	E,(HL)		; get byte
	PUSH	DE			; not needed
	LD	HL,(LAB_E746)	; get destination pointer
	INC	HL			; +1
	LD	(LAB_E746),HL	; save destination pointer
	DEC	HL			; -1
	POP	DE			; not needed
	LD	(HL),E		; save byte to destination
	JP	LAB_22C0		; loop

LAB_22FA
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get pad character
	PUSH	DE			; not needed
	LD	HL,(LAB_E746)	; get destination pointer
	POP	DE			; not needed
	LD	(HL),E		; put pad character in string
	RET				;

; inserts chr at pointer, moves (length) string up 1

; stack is ..
; pointer
; length
; character

LAB_2306
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get length
	LD	D,#00h		; clear high byte
	EX	DE,HL			; swap to HL
	DEC	HL			;-1
	DEC	HL			;-2
	EX	DE,HL			; swap back to DE
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL			; push pointer pointer
	LD	A,(HL)		; get pointer low byte
	INC	HL			; increment pointer pointer
	LD	H,(HL)		; get pointer high byte
	LD	L,A			; copy low byte to L
	ADD	HL,DE			; add length-2
	EX	DE,HL			; swap to DE
	POP	HL			; restore pointer pointer
	LD	(HL),E		; save pointer low byte
	INC	HL			; increment pointer pointer
	LD	(HL),D		; save pointer high byte
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get pointer low byte
	INC	HL			; increment pointer pointer
	LD	D,(HL)		; get pointer high byte
	EX	DE,HL			; swap to HL
	INC	HL			; +1
	LD	(LAB_E74A),HL	; save as destination pointer
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E748),HL	; save count
	JP	LAB_2342		; skip increment first time

LAB_233B
	LD	HL,(LAB_E748)	; get count
	INC	HL			; +1
	LD	(LAB_E748),HL	; save count
LAB_2342
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get length
	LD	D,#00h		; clear high byte
	PUSH	DE			; not needed
	LD	HL,(LAB_E748)	; get count
	POP	DE			; not needed
	EX	DE,HL			; swap length & count
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_2375		; jump if count => length

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL			; save pointer pointer
	LD	A,(HL)		; get pointer low byte
	INC	HL			; increment pointer pointer
	LD	H,(HL)		; get pointer high byte
	LD	L,A			; copy low byte to L
	DEC	HL			; -1
	EX	DE,HL			; swap to DE
	POP	HL			; restore pointer pointer
	LD	(HL),E		; save pointer low byte
	INC	HL			; increment pointer pointer
	LD	(HL),D		; save pointer high byte
	EX	DE,HL			; swap to HL
	INC	HL			; +1
	LD	E,(HL)		; get byte from string
	PUSH	DE			; save it
	LD	HL,(LAB_E74A)	; get local pointer
	DEC	HL			; -1
	LD	(LAB_E74A),HL	; save local pointer
	INC	HL			; +1
	POP	DE			; restore pointer
	LD	(HL),E		; save byte
	JP	LAB_233B		; loop

LAB_2375
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get insert character
	PUSH	DE			; not needed
	LD	HL,(LAB_E74A)	; get local pointer
	POP	DE			; not needed
	LD	(HL),E		; insert byte
	RET				;

LAB_2381
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	A,(HL)		;238B:	7E
	INC	HL			; increment pointer
	OR	(HL)		;238D:	B6
	JP	NZ,LAB_23AC	;238E:	C2AC23
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;2395:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;2397:	56
	LD	HL,0002h	;2398:	210200
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_23AC	;239E:	CAAC23
	LD	HL,0000h		; set cursor on/off flag
	PUSH	HL			; push flag
	CALL	LAB_EEF0		; set cursor on/off
	POP	DE			; dump flag
	JP	LAB_23FC	;23A9:	C3FC23

LAB_23AC
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;23B0:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;23B2:	56
	LD	HL,0039h	;23B3:	213900
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_23F4	;23B9:	C2F423
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;23C0:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;23C2:	56
	LD	HL,LAB_E104	;23C3:	2104E1
	ADD	HL,DE		;23C6:	19
	INC	HL		;23C7:	23
	LD	E,(HL)		;23C8:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0003h	;23CB:	210300
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_23EE	;23D1:	C2EE23
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;23D8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;23DA:	56
	LD	HL,0020h	;23DB:	212000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_23EE	;23E1:	C2EE23

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;23E8:	7E
	INC	HL			; increment pointer
	OR	(HL)		;23EA:	B6
	JP	NZ,LAB_23F4	;23EB:	C2F423

LAB_23EE
	LD	HL,0000h	;23EE:	210000
	JP	LAB_23F7	;23F1:	C3F723

LAB_23F4
	LD	HL,0001h		; set HL = 0001h
LAB_23F7
	PUSH	HL			; push flag
	CALL	LAB_EEF0		; set cursor on/off
	POP	DE			; dump flag
LAB_23FC
	RET				;

LAB_23FD
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC43)	;2403:	2A43EC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_240F	;2408:	CA0F24

	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_240F
	LD	HL,(LAB_EC5B)	;240F:	2A5BEC
	INC	HL		;2412:	23
	INC	HL		;2413:	23
	LD	E,(HL)		;2414:	5E
	EX	DE,HL		;2415:	EB
	LD	A,L		;2416:	7D
	LD	(LAB_E74D),A	;2417:	324DE7
	LD	HL,(LAB_EC57)	;241A:	2A57EC
	LD	DE,0008h	;241D:	110800
	ADD	HL,DE		;2420:	19
	LD	E,(HL)		;2421:	5E
	EX	DE,HL		;2422:	EB
	LD	A,L		;2423:	7D
	LD	(LAB_E74C),A	;2424:	324CE7
	LD	HL,(LAB_EC57)	;2427:	2A57EC
	LD	DE,000Ch	;242A:	110C00
	ADD	HL,DE		;242D:	19
	LD	(LAB_E74E),HL	;242E:	224EE7
	LD	HL,(LAB_EC57)	;2431:	2A57EC
	LD	DE,000Ah	;2434:	110A00
	ADD	HL,DE		;2437:	19
	LD	E,(HL)		;2438:	5E
	EX	DE,HL		;2439:	EB
	LD	A,L		;243A:	7D
	LD	(LAB_E752),A	;243B:	3252E7
	LD	HL,(LAB_EB1A)	;243E:	2A1AEB
	LD	(LAB_E750),HL	;2441:	2250E7
	LD	HL,(LAB_EC57)	;2444:	2A57EC
	LD	DE,000Bh	;2447:	110B00
	ADD	HL,DE		;244A:	19
	LD	E,(HL)		;244B:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;244E:	D5
	LD	HL,(LAB_EC3D)	;244F:	2A3DEC
	POP	DE		;2452:	D1
	EX	DE,HL		;2453:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_245E	;2457:	CA5E24
	LD	HL,0000h	;245A:	210000
	RET				;

LAB_245E
	LD	HL,(LAB_E74E)	;245E:	2A4EE7
	PUSH	HL		;2461:	E5
	LD	A,(LAB_E752)	;2462:	3A52E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;2468:	E5
	LD	A,(LAB_E74D)	;2469:	3A4DE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;246F:	E5
	LD	HL,LAB_EB20	;2470:	2120EB
	PUSH	HL		;2473:	E5
	LD	HL,(LAB_EB49)	;2474:	2A49EB
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	EX	DE,HL		;247A:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	JP	NZ,LAB_2487	;2480:	C28724
	LD	HL,0000h	;2483:	210000
	RET				;

LAB_2487
	LD	HL,(LAB_E74E)	;2487:	2A4EE7
	PUSH	HL		;248A:	E5
	LD	A,(LAB_E752)	;248B:	3A52E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;2491:	E5
	LD	A,(LAB_E74D)	;2492:	3A4DE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;2498:	E5
	LD	A,(LAB_E74C)	;2499:	3A4CE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;249F:	E5
	LD	HL,(LAB_E750)	;24A0:	2A50E7
	PUSH	HL		;24A3:	E5
	LD	HL,LAB_EB20	;24A4:	2120EB
	PUSH	HL		;24A7:	E5
	LD	HL,(LAB_EB47)	;24A8:	2A47EB
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	EX	DE,HL		;24AE:	EB
	LD	HL,000Ch		; C ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	EX	DE,HL		;24B4:	EB
	RET				;

LAB_24B6
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;24BF:	E5
	CALL	LAB_41D5	;24C0:	CDD541
	POP	DE		;24C3:	D1
LAB_24C4
	LD	HL,(LAB_EB16)	;24C4:	2A16EB
	LD	E,(HL)		;24C7:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0002h	;24CA:	210200
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL		;24D0:	E5
	CALL	LAB_444F	;24D1:	CD4F44
	POP	DE		;24D4:	D1
	LD	HL,(LAB_EB16)	;24D5:	2A16EB
	LD	E,(HL)		;24D8:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_24FA		; jump if DE bit0=0

	LD	HL,(LAB_EB06)	;24E4:	2A06EB
	LD	DE,EBFBh	;24E7:	11FBEB
	ADD	HL,DE		;24EA:	19
	LD	A,(HL)		;24EB:	7E
	OR	A		;24EC:	B7
	JP	NZ,LAB_24FA	;24ED:	C2FA24
	CALL	LAB_23FD	;24F0:	CDFD23
	JP	NZ,LAB_24FA	;24F3:	C2FA24
	LD	HL,0000h	;24F6:	210000
	RET				;

LAB_24FA
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;24FD:	E5
	CALL	LAB_4281	;24FE:	CD8142
	POP	DE		;2501:	D1
	JP	NZ,LAB_24C4	;2502:	C2C424
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_2509
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;250F:	210000
	PUSH	HL		;2512:	E5
	CALL	LAB_35D8	;2513:	CDD835
	POP	DE		;2516:	D1
	LD	HL,(LAB_EC49)	;2517:	2A49EC
	LD	DE,0004h	;251A:	110400
	ADD	HL,DE		;251D:	19
	LD	E,(HL)		;251E:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;2521:	D5
	LD	HL,(LAB_EC49)	;2522:	2A49EC
	LD	DE,000Ch	;2525:	110C00
	ADD	HL,DE		;2528:	19
	LD	E,(HL)		;2529:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;252C:	D5
	LD	HL,(LAB_EC49)	;252D:	2A49EC
	INC	HL		;2530:	23
	INC	HL		;2531:	23
	LD	E,(HL)		;2532:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;2535:	D5
	LD	HL,(LAB_EC49)	;2536:	2A49EC
	LD	DE,000Bh	;2539:	110B00
	ADD	HL,DE		;253C:	19
	LD	E,(HL)		;253D:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push y
	CALL	LAB_6FBA		; clear screen area
	EX	DE,HL		;2544:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	RET				;

LAB_254B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC49)	;2551:	2A49EC
	LD	DE,000Ch	;2554:	110C00
	ADD	HL,DE		;2557:	19
	LD	A,(HL)		;2558:	7E
	OR	A		;2559:	B7
	JP	NZ,LAB_255E	;255A:	C25E25

	RET				;

LAB_255E
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;2562:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;2564:	56
	EX	DE,HL		;2565:	EB
	JP	LAB_257C	;2566:	C37C25

LAB_2569
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E753),HL	;256C:	2253E7
	JP	LAB_2593	;256F:	C39325

LAB_2572
	LD	HL,0000h	;2572:	210000
	LD	(LAB_E753),HL	;2575:	2253E7
	JP	LAB_2593	;2578:	C39325

LAB_257B
	RET				;

LAB_257C
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0004

	DW	0001
	DW	LAB_2569

	DW	0006
	DW	LAB_2572

	DW	000B
	DW	LAB_2572

	DW	000C
	DW	LAB_2569

	DW	LAB_257B

LAB_2593
	LD	HL,(LAB_EC49)	;2593:	2A49EC
	LD	DE,0004h	;2596:	110400
	ADD	HL,DE		;2599:	19
	LD	E,(HL)		;259A:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;259D:	EB
	LD	(LAB_E755),HL	;259E:	2255E7
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_25AC	;25A3:	C2AC25

	LD	HL,0014h	;25A6:	211400
	LD	(LAB_E755),HL	;25A9:	2255E7
LAB_25AC
	LD	HL,0000h	;25AC:	210000
	PUSH	HL		;25AF:	E5
	CALL	LAB_35D8	;25B0:	CDD835
	POP	DE		;25B3:	D1
	LD	HL,(LAB_E753)	;25B4:	2A53E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_2604	;25B9:	CA0426

	LD	HL,(LAB_EB04)	;25BC:	2A04EB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_25FA	;25C1:	C2FA25

	LD	HL,(LAB_E755)	;25C4:	2A55E7
	PUSH	HL			; push x size
	LD	HL,(LAB_EC49)	;25C8:	2A49EC
	LD	DE,000Ch	;25CB:	110C00
	ADD	HL,DE		;25CE:	19
	LD	E,(HL)		;25CF:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push y size
	LD	HL,(LAB_EC49)	;25D3:	2A49EC
	INC	HL		;25D6:	23
	INC	HL		;25D7:	23
	LD	E,(HL)		;25D8:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push x
	LD	HL,(LAB_EC49)	;25DC:	2A49EC
	LD	DE,000Bh	;25DF:	110B00
	ADD	HL,DE		;25E2:	19
	LD	E,(HL)		;25E3:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push y
	CALL	LAB_73DE		; scroll region down ??
	EX	DE,HL		;25EA:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,(LAB_EC67)	;25F0:	2A67EC
	INC	HL		;25F3:	23
	LD	(LAB_EC67),HL	;25F4:	2267EC
	JP	LAB_2601		; does JP LAB_2658 (which is RET)

LAB_25FA
	LD	HL,(LAB_EB04)	;25FA:	2A04EB
	DEC	HL		;25FD:	2B
	LD	(LAB_EB04),HL	;25FE:	2204EB
LAB_2601
	JP	LAB_2658		; does RET

LAB_2604
	LD	HL,(LAB_EC49)	;2604:	2A49EC
	LD	DE,000Ch	;2607:	110C00
	ADD	HL,DE		;260A:	19
	LD	E,(HL)		;260B:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;260E:	EB
	DEC	HL		;260F:	2B
	PUSH	HL		;2610:	E5
	LD	HL,(LAB_EB04)	;2611:	2A04EB
	POP	DE		;2614:	D1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_2651	;2618:	CA5126

	LD	HL,(LAB_E755)	;261B:	2A55E7
	PUSH	HL			; push x size
	LD	HL,(LAB_EC49)	;261F:	2A49EC
	LD	DE,000Ch	;2622:	110C00
	ADD	HL,DE		;2625:	19
	LD	E,(HL)		;2626:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push y size
	LD	HL,(LAB_EC49)	;262A:	2A49EC
	INC	HL		;262D:	23
	INC	HL		;262E:	23
	LD	E,(HL)		;262F:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push x
	LD	HL,(LAB_EC49)	;2633:	2A49EC
	LD	DE,000Bh	;2636:	110B00
	ADD	HL,DE		;2639:	19
	LD	E,(HL)		;263A:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push y
	CALL	LAB_7288		; scroll region up ??
	EX	DE,HL		;2641:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,(LAB_EC67)	;2647:	2A67EC
	DEC	HL		;264A:	2B
	LD	(LAB_EC67),HL	;264B:	2267EC
	JP	LAB_2658	;264E:	C35826
LAB_2651
	LD	HL,(LAB_EB04)	;2651:	2A04EB
	INC	HL		;2654:	23
	LD	(LAB_EB04),HL	;2655:	2204EB
LAB_2658
	RET				;

LAB_2659
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	CALL	LAB_2509	;265F:	CD0925
	LD	HL,0000h	;2662:	210000
	LD	(LAB_E769),HL	;2665:	2269E7
	LD	HL,(LAB_EB53)	;2668:	2A53EB
	LD	DE,0006h	;266B:	110600
	ADD	HL,DE		;266E:	19
	LD	E,(HL)		;266F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;2671:	56
	EX	DE,HL		;2672:	EB
	LD	(LAB_E761),HL	;2673:	2261E7
	LD	HL,LAB_E75B	;2676:	215BE7
	PUSH	HL		;2679:	E5
	LD	HL,(LAB_E761)	;267A:	2A61E7
	PUSH	HL		;267D:	E5
	CALL	LAB_EEB0	;267E:	CDB0EE
	POP	DE		;2681:	D1
	POP	DE		;2682:	D1
	LD	HL,LAB_E75Dh	;2683:	215DE7
	PUSH	HL		;2686:	E5
	LD	HL,(LAB_E761)	;2687:	2A61E7
	PUSH	HL		;268A:	E5
	CALL	LAB_EEBC	;268B:	CDBCEE
	POP	DE		;268E:	D1
	POP	DE		;268F:	D1
	LD	HL,(LAB_E75D)	;2690:	2A5DE7
	EX	DE,HL		;2693:	EB
	LD	HL,(LAB_E75B)	;2694:	2A5BE7
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_26A9	;269A:	C2A926
	LD	HL,(LAB_EB10)	;269D:	2A10EB
	LD	DE,0004h	;26A0:	110400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_26AF	;26A6:	CAAF26
LAB_26A9
	LD	HL,0000h	;26A9:	210000
	LD	(LAB_EB02),HL	;26AC:	2202EB
LAB_26AF
	LD	HL,LAB_E759	;26AF:	2159E7
	PUSH	HL		;26B2:	E5
	LD	HL,(LAB_E761)	;26B3:	2A61E7
	PUSH	HL		;26B6:	E5
	CALL	LAB_EED0	;26B7:	CDD0EE
	POP	DE		;26BA:	D1
	POP	DE		;26BB:	D1
	LD	HL,(LAB_E759)	;26BC:	2A59E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_26D0	;26C1:	CAD026

	LD	HL,(LAB_EB10)	;26C4:	2A10EB
	LD	DE,0024h	;26C7:	112400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_26D6	;26CD:	CAD626
LAB_26D0
	LD	HL,0000h	;26D0:	210000
	JP	LAB_26D9	;26D3:	C3D926
LAB_26D6
	LD	HL,0001h		; set HL = 0001h
LAB_26D9
	LD	(LAB_E76B),HL	;26D9:	226BE7
	LD	HL,(LAB_E76B)	;26DC:	2A6BE7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_27BC	;26E1:	CABC27

	LD	HL,(LAB_EC49)	;26E4:	2A49EC
	LD	DE,000Ch	;26E7:	110C00
	ADD	HL,DE		;26EA:	19
	LD	E,(HL)		;26EB:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;26EE:	EB
	LD	(LAB_E75F),HL	;26EF:	225FE7
	LD	HL,(LAB_E75F)	;26F2:	2A5FE7
	LD	DE,0001h	;26F5:	110100
	EX	DE,HL		;26F8:	EB
	CALL	LAB_E00E		; does HL = DE>>HL (HL=0 to 1Fh) (LAB_7B49 ROM 1)
	LD	(LAB_E769),HL	;26FC:	2269E7
	LD	HL,LAB_E757	;26FF:	2157E7
	PUSH	HL		;2702:	E5
	LD	HL,(LAB_E761)	;2703:	2A61E7
	PUSH	HL		;2706:	E5
	CALL	LAB_EEC8	;2707:	CDC8EE
	POP	DE		;270A:	D1
	POP	DE		;270B:	D1
	LD	HL,(LAB_E757)	;270C:	2A57E7
	DEC	HL		;270F:	2B
	LD	(LAB_E757),HL	;2710:	2257E7
	LD	HL,LAB_E763	;2713:	2163E7
	PUSH	HL		;2716:	E5
	LD	HL,(LAB_E761)	;2717:	2A61E7
	PUSH	HL		;271A:	E5
	CALL	LAB_EEC0	;271B:	CDC0EE
	POP	DE		;271E:	D1
	POP	DE		;271F:	D1
	LD	HL,(LAB_EB02)	;2720:	2A02EB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_272E	;2725:	CA2E27

	LD	HL,0001h		; set HL = 0001h
	JP	LAB_2731	;272B:	C33127
LAB_272E
	LD	HL,0000h	;272E:	210000
LAB_2731
	PUSH	HL		;2731:	E5
	LD	HL,(LAB_E759)	;2732:	2A59E7
	EX	DE,HL		;2735:	EB
	LD	HL,(LAB_E757)	;2736:	2A57E7
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	POP	DE		;273C:	D1
	ADD	HL,DE		;273D:	19
	LD	(LAB_E76D),HL	;273E:	226DE7
	LD	HL,(LAB_E75F)	;2741:	2A5FE7
	EX	DE,HL		;2744:	EB
	LD	HL,(LAB_E769)	;2745:	2A69E7
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL		;274B:	E5
	LD	HL,(LAB_E76D)	;274C:	2A6DE7
	POP	DE		;274F:	D1
	EX	DE,HL		;2750:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_2764	;2754:	CA6427
	LD	HL,(LAB_E75F)	;2757:	2A5FE7
	EX	DE,HL		;275A:	EB
	LD	HL,(LAB_E76D)	;275B:	2A6DE7
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_E769),HL	;2761:	2269E7
LAB_2764
	LD	HL,(LAB_E769)	;2764:	2A69E7
	EX	DE,HL		;2767:	EB
	LD	HL,(LAB_E757)	;2768:	2A57E7
	CALL	LAB_E0D9		; does CP DE,HL, returns HL=1 if HL<=DE (LAB_7C14 ROM 1)
	JP	Z,LAB_2788	;276E:	CA8827
	LD	HL,(LAB_E761)	;2771:	2A61E7
	PUSH	HL		;2774:	E5
	CALL	LAB_EE6C	;2775:	CD6CEE
	POP	DE		;2778:	D1
	LD	HL,(LAB_E757)	;2779:	2A57E7
	LD	(LAB_E769),HL	;277C:	2269E7
	LD	HL,0000h	;277F:	210000
	LD	(LAB_E757),HL	;2782:	2257E7
	JP	LAB_27AF	;2785:	C3AF27
LAB_2788
	LD	HL,(LAB_E769)	;2788:	2A69E7
	LD	(LAB_E76F),HL	;278B:	226FE7
LAB_278E
	LD	HL,(LAB_E76F)	;278E:	2A6FE7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_27AF	;2793:	CAAF27

	LD	HL,(LAB_E761)	;2796:	2A61E7
	PUSH	HL		;2799:	E5
	CALL	LAB_EE80	;279A:	CD80EE
	POP	DE		;279D:	D1
	LD	HL,(LAB_E757)	;279E:	2A57E7
	DEC	HL		;27A1:	2B
	LD	(LAB_E757),HL	;27A2:	2257E7
	LD	HL,(LAB_E76F)	;27A5:	2A6FE7
	DEC	HL		;27A8:	2B
	LD	(LAB_E76F),HL	;27A9:	226FE7
	JP	LAB_278E	;27AC:	C38E27
LAB_27AF
	LD	HL,(LAB_EB10)	;27AF:	2A10EB
	PUSH	HL		;27B2:	E5
	LD	HL,0000h	;27B3:	210000
	PUSH	HL		;27B6:	E5
	CALL	LAB_3BA8	;27B7:	CDA83B
	POP	DE		;27BA:	D1
	POP	DE		;27BB:	D1
LAB_27BC
	LD	HL,0000h	;27BC:	210000
	LD	(LAB_EB04),HL	;27BF:	2204EB
LAB_27C2
	LD	HL,(LAB_EC4D)	;27C2:	2A4DEC
	PUSH	HL		;27C5:	E5
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;27C9:	E5
	CALL	LAB_1B0A	;27CA:	CD0A1B
	POP	DE		;27CD:	D1
	POP	DE		;27CE:	D1
	LD	HL,(LAB_E76B)	;27CF:	2A6BE7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_27F9	;27D4:	CAF927

	LD	HL,(LAB_EB04)	;27D7:	2A04EB
	INC	HL		;27DA:	23
	LD	(LAB_EB04),HL	;27DB:	2204EB
	EX	DE,HL		;27DE:	EB
	LD	HL,(LAB_E75F)	;27DF:	2A5FE7
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_27F9	;27E5:	CAF927
	LD	HL,(LAB_E757)	;27E8:	2A57E7
	INC	HL		;27EB:	23
	LD	(LAB_E757),HL	;27EC:	2257E7
	EX	DE,HL		;27EF:	EB
	LD	HL,(LAB_E759)	;27F0:	2A59E7
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	NZ,LAB_27FF	;27F6:	C2FF27
LAB_27F9
	LD	HL,0000h	;27F9:	210000
	JP	LAB_2802	;27FC:	C30228
LAB_27FF
	LD	HL,0001h		; set HL = 0001h
LAB_2802
	LD	(LAB_E767),HL	;2802:	2267E7
	LD	HL,(LAB_E767)	;2805:	2A67E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_281A	;280A:	CA1A28

	LD	HL,(LAB_EB10)	;280D:	2A10EB
	PUSH	HL		;2810:	E5
	LD	HL,000Bh	;2811:	210B00
	PUSH	HL		;2814:	E5
	CALL	LAB_3BA8	;2815:	CDA83B
	POP	DE		;2818:	D1
	POP	DE		;2819:	D1
LAB_281A
	LD	HL,(LAB_E767)	;281A:	2A67E7
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_27C2	;281F:	C2C227

	LD	HL,(LAB_EB02)	;2822:	2A02EB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_285C	;2827:	CA5C28

	LD	HL,(LAB_E759)	;282A:	2A59E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_285C	;282F:	CA5C28

	LD	HL,(LAB_EB10)	;2832:	2A10EB
	PUSH	HL		;2835:	E5
	LD	HL,000Bh	;2836:	210B00
	PUSH	HL		;2839:	E5
	CALL	LAB_3BA8	;283A:	CDA83B
	POP	DE		;283D:	D1
	POP	DE		;283E:	D1
	LD	HL,0000h	;283F:	210000
	PUSH	HL		;2842:	E5
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;2846:	E5
	CALL	LAB_1B0A	;2847:	CD0A1B
	POP	DE		;284A:	D1
	POP	DE		;284B:	D1
	LD	HL,0000h	;284C:	210000
	LD	(LAB_EB02),HL	;284F:	2202EB
	LD	HL,(LAB_E769)	;2852:	2A69E7
	INC	HL		;2855:	23
	LD	(LAB_E769),HL	;2856:	2269E7
	JP	LAB_2879	;2859:	C37928
LAB_285C
	LD	HL,(LAB_E76B)	;285C:	2A6BE7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_2879	;2861:	CA7928

	LD	HL,LAB_E763	;2864:	2163E7
	PUSH	HL		;2867:	E5
	CALL	LAB_EE88	;2868:	CD88EE
	POP	DE		;286B:	D1
	LD	HL,(LAB_EB10)	;286C:	2A10EB
	PUSH	HL		;286F:	E5
	LD	HL,0000h	;2870:	210000
	PUSH	HL		;2873:	E5
	CALL	LAB_3BA8	;2874:	CDA83B
	POP	DE		;2877:	D1
	POP	DE		;2878:	D1
LAB_2879
	LD	HL,(LAB_E769)	;2879:	2A69E7
	LD	(LAB_EB04),HL	;287C:	2204EB
	RET				;

LAB_2880
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC41)	;2886:	2A41EC
	JP	LAB_28EA	;2889:	C3EA28

LAB_288C
	LD	HL,0000h	;288C:	210000
	RET				;

LAB_2890
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;2893:	E5
	CALL	LAB_4281	;2894:	CD8142
	POP	DE		;2897:	D1
	JP	Z,LAB_289F	;2898:	CA9F28
	LD	HL,0000h	;289B:	210000
	RET				;

LAB_289F
	LD	HL,(LAB_EB10)	;289F:	2A10EB
	LD	DE,0001h	;28A2:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_28B3	;28A8:	C2B328
	LD	HL,(LAB_E742)	;28AB:	2A42E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_28B7	;28B0:	CAB728

LAB_28B3
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_28B7
	LD	HL,0002h	;28B7:	210200
	RET				;

LAB_28BB
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;28BE:	E5
	CALL	LAB_4367	;28BF:	CD6743
	POP	DE		;28C2:	D1
	JP	Z,LAB_28CA	;28C3:	CACA28
	LD	HL,0000h	;28C6:	210000
	RET				;


LAB_28CA
	LD	HL,(LAB_EB10)	;28CA:	2A10EB
	LD	DE,0001h	;28CD:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_28DE	;28D3:	C2DE28
	LD	HL,(LAB_E742)	;28D6:	2A42E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_28E2	;28DB:	CAE228

LAB_28DE
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_28E2
	LD	HL,0002h	;28E2:	210200
	RET				;

LAB_28E6
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_28EA
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0003

	DW	0001
	DW	LAB_28BB

	DW	0006
	DW	LAB_2890

	DW	0013
	DW	LAB_288C

	DW	LAB_28E6

LAB_28FD
	RET				;

; stack is ..
; byte ??
;

LAB_28FE
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #0 low byte
	LD	D,#00h		; clear high byte
LAB_290B
	LD	HL,002Eh		; set compare byte
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_2924		; jump if not ??

	LD	HL,(LAB_EC59)	;2914:	2A59EC
	INC	HL		;2917:	23
	LD	(LAB_EC59),HL	;2918:	2259EC
	LD	HL,0000h	;291B:	210000
	LD	(LAB_EC55),HL	;291E:	2255EC
	JP	LAB_2965		; exit

LAB_2924
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #0 low byte
	LD	D,#00h		; clear high byte
	LD	HL,002Dh		; set compare byte
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_293E		; jump if not ??

	LD	HL,(LAB_EC4B)	;2934:	2A4BEC
	INC	HL		;2937:	23
	LD	(LAB_EC4B),HL	;2938:	224BEC
	JP	LAB_2965		; exit

LAB_293E
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #0 low byte
	LD	D,#00h		; clear high byte
	LD	HL,LAB_E104		; set pointer to ?? table
	ADD	HL,DE			; add #0
	INC	HL			; +1
	LD	E,(HL)		; get byte
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;294D:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_2965	;2953:	CA6529

	LD	HL,(LAB_EC59)	;2956:	2A59EC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_2965		; exit if ??

	LD	HL,(LAB_EC55)	;295E:	2A55EC
	INC	HL		;2961:	23
	LD	(LAB_EC55),HL	;2962:	2255EC
LAB_2965
	RET				;

LAB_2966
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;2970:	5E
	LD	D,#00h		; clear high byte
	LD	HL,002Eh	;2973:	212E00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_298C	;2979:	CA8C29
	LD	HL,(LAB_EC59)	;297C:	2A59EC
	DEC	HL		;297F:	2B
	LD	(LAB_EC59),HL	;2980:	2259EC
	LD	HL,0000h	;2983:	210000
	LD	(LAB_EC55),HL	;2986:	2255EC
	JP	LAB_29CD	;2989:	C3CD29
LAB_298C
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;2990:	5E
	LD	D,#00h		; clear high byte
	LD	HL,002Dh	;2993:	212D00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_29A6	;2999:	CAA629
	LD	HL,(LAB_EC4B)	;299C:	2A4BEC
	DEC	HL		;299F:	2B
	LD	(LAB_EC4B),HL	;29A0:	224BEC
	JP	LAB_29CD	;29A3:	C3CD29
LAB_29A6
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;29AA:	5E
	LD	D,#00h		; clear high byte
	LD	HL,LAB_E104	;29AD:	2104E1
	ADD	HL,DE		;29B0:	19
	INC	HL		;29B1:	23
	LD	E,(HL)		;29B2:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;29B5:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_29CD	;29BB:	CACD29
	LD	HL,(LAB_EC59)	;29BE:	2A59EC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_29CD	;29C3:	CACD29

	LD	HL,(LAB_EC55)	;29C6:	2A55EC
	DEC	HL		;29C9:	2B
	LD	(LAB_EC55),HL	;29CA:	2255EC
LAB_29CD
	RET				;

LAB_29CE
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,LAB_EB20	;29D4:	2120EB
	LD	(LAB_E772),HL	;29D7:	2272E7
	LD	HL,0000h	;29DA:	210000
	LD	(LAB_EC55),HL	;29DD:	2255EC
	LD	(LAB_EC59),HL	;29E0:	2259EC
	LD	(LAB_EC4B),HL	;29E3:	224BEC
	LD	HL,0000h	;29E6:	210000
	LD	A,L		;29E9:	7D
	LD	(LAB_E771),A	;29EA:	3271E7
	JP	LAB_2A02	;29ED:	C3022A

LAB_29F0
	LD	A,(LAB_E771)	;29F0:	3A71E7
	LD	L,A		;29F3:	6F
	INC	HL		;29F4:	23
	LD	A,L		;29F5:	7D
	LD	(LAB_E771),A	;29F6:	3271E7
	DEC	HL			; not needed
	LD	HL,(LAB_E772)	;29FA:	2A72E7
	INC	HL		;29FD:	23
	LD	(LAB_E772),HL	;29FE:	2272E7
	DEC	HL			; not needed
LAB_2A02
	LD	HL,(LAB_EC5B)	;2A02:	2A5BEC
	INC	HL		;2A05:	23
	INC	HL		;2A06:	23
	LD	E,(HL)		;2A07:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;2A0A:	D5
	LD	A,(LAB_E771)	;2A0B:	3A71E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;2A11:	D1
	EX	DE,HL		;2A12:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_2A27	;2A16:	CA272A

	LD	HL,(LAB_E772)	;2A19:	2A72E7
	LD	E,(HL)		;2A1C:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;2A1F:	D5
	CALL	LAB_28FE	;2A20:	CDFE28
	POP	DE		;2A23:	D1
	JP	LAB_29F0		; loop

LAB_2A27
	RET				;

LAB_2A28
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC57)	;2A2E:	2A57EC
	LD	DE,000Ch	;2A31:	110C00
	ADD	HL,DE		;2A34:	19
	LD	(LAB_E776),HL	;2A35:	2276E7
	LD	HL,(LAB_EB1A)	;2A38:	2A1AEB
	LD	(LAB_E774),HL	;2A3B:	2274E7
	LD	HL,(LAB_EC57)	;2A3E:	2A57EC
	LD	DE,000Ah	;2A41:	110A00
	ADD	HL,DE		;2A44:	19
LAB_2A45
	LD	E,(HL)		;2A45:	5E
	EX	DE,HL		;2A46:	EB
	LD	A,L		;2A47:	7D
	LD	(LAB_E77A),A	;2A48:	327AE7
	LD	HL,(LAB_EC57)	;2A4B:	2A57EC
	LD	DE,0009h	;2A4E:	110900
	ADD	HL,DE		;2A51:	19
	LD	E,(HL)		;2A52:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_2AF2		; jump if DE bit0=0

	LD	A,(LAB_E77A)	;2A5E:	3A7AE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0002h	;2A64:	110200
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_2AB4	;2A6A:	CAB42A
	LD	HL,(LAB_E774)	;2A6D:	2A74E7
	PUSH	HL		;2A70:	E5
	CALL	LAB_DC2A		; copies four bytes from (HL) to LAB_E3B9 (LAB_7765)
	CALL	LAB_DC30		; copies next four bytes after the call to LAB_E3B1
					; returns to instruction after the bytes (LAB_776B)

	DB	01h,00h,00h,00h

	CALL	LAB_DCE9	; does ADC.L (LAB_E3B1),(LAB_E3B9) (LAB_7824)
	POP	HL		;2A7E:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
	LD	A,(LAB_E77A)	;2A82:	3A7AE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0001h	;2A88:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	INC	HL		;2A8E:	23
	INC	HL		;2A8F:	23
	PUSH	HL		;2A90:	E5
	LD	HL,(LAB_E776)	;2A91:	2A76E7
	PUSH	HL		;2A94:	E5
	LD	HL,(LAB_E774)	;2A95:	2A74E7
	PUSH	HL		;2A98:	E5
	CALL	LAB_583A	;2A99:	CD3A58
	POP	DE		;2A9C:	D1
	POP	DE		;2A9D:	D1
	POP	DE		;2A9E:	D1
	JP	NZ,LAB_2AB1	;2A9F:	C2B12A
	LD	HL,(LAB_E774)	;2AA2:	2A74E7
	PUSH	HL		;2AA5:	E5
	LD	HL,(LAB_E776)	;2AA6:	2A76E7
	INC	HL		;2AA9:	23
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	POP	HL		;2AAD:	E1
	CALL	LAB_DC49	;2AAE:	CD49DC
LAB_2AB1
	JP	LAB_2AEF	;2AB1:	C3EF2A
LAB_2AB4
	LD	HL,(LAB_E774)	;2AB4:	2A74E7
	PUSH	HL		;2AB7:	E5
	LD	A,(HL)		;2AB8:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;2ABA:	66
	LD	L,A		;2ABB:	6F
	INC	HL		;2ABC:	23
	EX	DE,HL		;2ABD:	EB
	POP	HL		;2ABE:	E1
	LD	(HL),E		;2ABF:	73
	INC	HL			; increment pointer
	LD	(HL),D		;2AC1:	72
	LD	A,(LAB_E77A)	;2AC2:	3A7AE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0001h	;2AC8:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL		;2ACE:	E5
	LD	HL,(LAB_E776)	;2ACF:	2A76E7
	PUSH	HL		;2AD2:	E5
	LD	HL,(LAB_E774)	;2AD3:	2A74E7
	PUSH	HL		;2AD6:	E5
	CALL	LAB_583A	;2AD7:	CD3A58
	POP	DE		;2ADA:	D1
	POP	DE		;2ADB:	D1
	POP	DE		;2ADC:	D1
	JP	NZ,LAB_2AEF	;2ADD:	C2EF2A

	LD	HL,(LAB_E776)	;2AE0:	2A76E7
	INC	HL		;2AE3:	23
	LD	E,(HL)		;2AE4:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;2AE6:	56
	PUSH	DE		;2AE7:	D5
	LD	HL,(LAB_E774)	;2AE8:	2A74E7
	POP	DE		;2AEB:	D1
	LD	(HL),E		;2AEC:	73
	INC	HL			; increment pointer
	LD	(HL),D		;2AEE:	72
LAB_2AEF
	JP	LAB_2B42	;2AEF:	C3422B

LAB_2AF2
	LD	HL,00FFh	;2AF2:	21FF00
	LD	A,L		;2AF5:	7D
	LD	(LAB_E77B),A	;2AF6:	327BE7
	LD	HL,(LAB_E776)	;2AF9:	2A76E7
	LD	E,(HL)		;2AFC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;2AFE:	56
	EX	DE,HL		;2AFF:	EB
	LD	(LAB_E778),HL	;2B00:	2278E7
LAB_2B03
	LD	HL,(LAB_E778)	;2B03:	2A78E7
	LD	A,(HL)		;2B06:	7E
	INC	HL			; increment pointer
	OR	(HL)		;2B08:	B6
	JP	Z,LAB_2B20	;2B09:	CA202B
	LD	A,(LAB_E77B)	;2B0C:	3A7BE7
	LD	L,A		;2B0F:	6F
	INC	HL		;2B10:	23
	LD	A,L		;2B11:	7D
	LD	(LAB_E77B),A	;2B12:	327BE7
	LD	HL,(LAB_E778)	;2B15:	2A78E7
	INC	HL		;2B18:	23
	INC	HL		;2B19:	23
	LD	(LAB_E778),HL	;2B1A:	2278E7
	JP	LAB_2B03	;2B1D:	C3032B

LAB_2B20
	LD	A,(LAB_E77B)	;2B20:	3A7BE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;2B26:	E5
	LD	HL,(LAB_E774)	;2B27:	2A74E7
	PUSH	HL		;2B2A:	E5
	LD	L,(HL)		;2B2B:	6E
	INC	HL		;2B2C:	23
	EX	DE,HL		;2B2D:	EB
	POP	HL		;2B2E:	E1
	LD	(HL),E		;2B2F:	73
	LD	D,#00h		; clear high byte
	POP	HL		;2B32:	E1
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_2B42	;2B36:	CA422B

	LD	HL,0000h	;2B39:	210000
	PUSH	HL		;2B3C:	E5
	LD	HL,(LAB_E774)	;2B3D:	2A74E7
	POP	DE		;2B40:	D1
	LD	(HL),E		;2B41:	73
LAB_2B42
	RET				;

LAB_2B43
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;2B49:	210000
	LD	(LAB_EC5F),HL	;2B4C:	225FEC
	LD	HL,0000h	;2B4F:	210000
	LD	(LAB_EB45),HL	;2B52:	2245EB
	LD	HL,(LAB_EB00)	;2B55:	2A00EB
	LD	DE,F168h	;2B58:	1168F1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_2B75	;2B5E:	CA752B
	LD	HL,(LAB_E742)	;2B61:	2A42E7
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_2B6F	;2B66:	C26F2B

	CALL	LAB_675A		; get HL from pointer @ LAB_E8D6
	JP	Z,LAB_2B75	;2B6C:	CA752B
LAB_2B6F
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EB1C),HL	;2B72:	221CEB
LAB_2B75
	LD	HL,(LAB_EC41)	;2B75:	2A41EC
	JP	LAB_2C24	;2B78:	C3242C

LAB_2B7B
	LD	HL,(LAB_EB10)	;2B7B:	2A10EB
	LD	DE,0001h	;2B7E:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_2B90	;2B84:	C2902B
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EC5F),HL	;2B8A:	225FEC
	JP	LAB_2C02	;2B8D:	C3022C

LAB_2B90
	LD	HL,(LAB_EB12)	;2B90:	2A12EB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_2BAE	;2B95:	C2AE2B

	CALL	LAB_38EF	;2B98:	CDEF38
	JP	Z,LAB_2BAA	;2B9B:	CAAA2B

	LD	HL,(LAB_EB10)	;2B9E:	2A10EB
	LD	DE,0001h	;2BA1:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_2BAE	;2BA7:	C2AE2B
LAB_2BAA
	LD	HL,0000h	;2BAA:	210000
	RET				;

LAB_2BAE
	JP	LAB_2BDB	;2BAE:	C3DB2B

LAB_2BB1
	LD	HL,(LAB_EB10)	;2BB1:	2A10EB
	LD	DE,0001h	;2BB4:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_2C02	;2BBA:	CA022C

LAB_2BBD
	LD	HL,(LAB_EB12)	;2BBD:	2A12EB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_2BDB	;2BC2:	C2DB2B

	CALL	LAB_3804	;2BC5:	CD0438
	JP	Z,LAB_2BD7	;2BC8:	CAD72B

	LD	HL,(LAB_EB10)	;2BCB:	2A10EB
	LD	DE,0001h	;2BCE:	110100
LAB_2BD1
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_2BDB	;2BD4:	C2DB2B
LAB_2BD7
	LD	HL,0000h	;2BD7:	210000
	RET				;

LAB_2BDB
	LD	HL,(LAB_EB4F)	;2BDB:	2A4FEB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_2BE6	;2BE0:	C2E62B

	CALL	LAB_3FCB	;2BE3:	CDCB3F
LAB_2BE6
	LD	HL,(LAB_EB1C)	;2BE6:	2A1CEB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_2BFC	;2BEB:	C2FC2B

	LD	HL,(LAB_EC41)	;2BEE:	2A41EC
	PUSH	HL		;2BF1:	E5
	CALL	LAB_254B	;2BF2:	CD4B25
	POP	DE		;2BF5:	D1
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EB45),HL	;2BF9:	2245EB
LAB_2BFC
	CALL	LAB_40A2	;2BFC:	CDA240
	JP	LAB_2C4B	;2BFF:	C34B2C

LAB_2C02
	LD	HL,(LAB_EB4F)	;2C02:	2A4FEB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_2C0D	;2C07:	C20D2C

	CALL	LAB_3FCB	;2C0A:	CDCB3F
LAB_2C0D
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EB1C),HL	;2C10:	221CEB
	JP	LAB_2C4B	;2C13:	C34B2C

LAB_2C16
	LD	HL,(LAB_EB4F)	;2C16:	2A4FEB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_2C21	;2C1B:	C2212C

	CALL	LAB_3FCB	;2C1E:	CDCB3F
LAB_2C21
	JP	LAB_2C4B	;2C21:	C34B2C

LAB_2C24
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0008

	DW	0001
	DW	LAB_2B7B

	DW	0006
	DW	LAB_2BB1

	DW	000B
	DW	LAB_2BBD

	DW	000C
	DW	LAB_2B90

	DW	000D
	DW	LAB_2C02

	DW	0011
	DW	LAB_2B90

	DW	0012
	DW	LAB_2BBD

	DW	0014
	DW	LAB_2C02

	DW	LAB_2C16

LAB_2C4B
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_2C4F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;2C55:	210000
	LD	(LAB_E742),HL	;2C58:	2242E7
	LD	HL,(LAB_EB0A)	;2C5B:	2A0AEB
	LD	(LAB_E77C),HL	;2C5E:	227CE7
LAB_2C61
	LD	HL,(LAB_E77C)	;2C61:	2A7CE7
	LD	A,(HL)		;2C64:	7E
	OR	A		;2C65:	B7
	JP	Z,LAB_2C8F	;2C66:	CA8F2C
	LD	HL,(LAB_E77C)	;2C69:	2A7CE7
	LD	E,(HL)		;2C6C:	5E
	LD	D,#00h		; clear high byte
	LD	HL,(LAB_EC41)	;2C6F:	2A41EC
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_2C82	;2C75:	CA822C
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E742),HL	;2C7B:	2242E7
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_2C82
	LD	HL,(LAB_E77C)	;2C82:	2A7CE7
	LD	DE,0004h	;2C85:	110400
	ADD	HL,DE		;2C88:	19
	LD	(LAB_E77C),HL	;2C89:	227CE7
	JP	LAB_2C61	;2C8C:	C3612C
LAB_2C8F
	LD	HL,(LAB_EC41)	;2C8F:	2A41EC
	JP	LAB_2CAC	;2C92:	C3AC2C

LAB_2C95
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_2C99
	LD	HL,(LAB_EB10)	;2C99:	2A10EB
	LD	DE,0001h	;2C9C:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_2CA9	;2CA2:	CAA92C
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_2CA9
	JP	LAB_2CCF	;2CA9:	C3CF2C

LAB_2CAC
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0007

	DW	0001
	DW	LAB_2C95

	DW	0006
	DW	LAB_2C95

	DW	000B
	DW	LAB_2C99

	DW	000C
	DW	LAB_2C99

	DW	0011
	DW	LAB_2C99

	DW	0012
	DW	LAB_2C99

	DW	0013
	DW	LAB_2C95

	DW	LAB_2CCF

LAB_2CCF
	LD	HL,0000h	;2CCF:	210000
	RET				;

LAB_2CD3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;2CDD:	7E
	INC	HL			; increment pointer
	OR	(HL)		;2CDF:	B6
	JP	Z,LAB_2D36	;2CE0:	CA362D
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;2CE6:	E5
	CALL	LAB_41D5	;2CE7:	CDD541
	POP	DE		;2CEA:	D1
LAB_2CEB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;2CEF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;2CF1:	56
	LD	HL,(LAB_EB1A)	;2CF2:	2A1AEB
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_2D1F	;2CF8:	CA1F2D
	LD	HL,(LAB_EB16)	;2CFB:	2A16EB
	LD	E,(HL)		;2CFE:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0002h	;2D01:	210200
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL		;2D07:	E5
	CALL	LAB_444F	;2D08:	CD4F44
	POP	DE		;2D0B:	D1
	LD	HL,(LAB_EB16)	;2D0C:	2A16EB
	LD	E,(HL)		;2D0F:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_2D1F		; jump if DE bit0=0

	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_2D1F
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;2D22:	E5
	CALL	LAB_4281	;2D23:	CD8142
	POP	DE		;2D26:	D1
	JP	NZ,LAB_2CEB	;2D27:	C2EB2C
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;2D2D:	E5
	CALL	LAB_41D5	;2D2E:	CDD541
	POP	DE		;2D31:	D1
	LD	HL,0000h	;2D32:	210000
	RET				;

LAB_2D36
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_2D3A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC5B)	;2D40:	2A5BEC
	LD	(LAB_E77E),HL	;2D43:	227EE7
	LD	HL,0000h	;2D46:	210000
	LD	(LAB_EB4F),HL	;2D49:	224FEB
	LD	HL,0000h	;2D4C:	210000
	LD	(LAB_EB12),HL	;2D4F:	2212EB
	LD	HL,(LAB_EBF9)	;2D52:	2AF9EB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_2D8C	;2D57:	CA8C2D

	LD	HL,(LAB_EC41)	;2D5A:	2A41EC
	LD	DE,0013h	;2D5D:	111300
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_2D84	;2D63:	CA842D
	CALL	LAB_23FD	;2D66:	CDFD23
	JP	Z,LAB_2E65	;2D69:	CA652E
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;2D6F:	E5
	LD	HL,(LAB_EB51)	;2D70:	2A51EB
	INC	HL		;2D73:	23
	INC	HL		;2D74:	23
	POP	DE		;2D75:	D1
	LD	(HL),E		;2D76:	73
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;2D7A:	E5
	LD	HL,(LAB_EB06)	;2D7B:	2A06EB
	LD	DE,EBFBh	;2D7E:	11FBEB
	ADD	HL,DE		;2D81:	19
	POP	DE		;2D82:	D1
	LD	(HL),E		;2D83:	73
LAB_2D84
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;2D87:	E5
	CALL	LAB_463F	;2D88:	CD3F46
	POP	DE		;2D8B:	D1
LAB_2D8C
	CALL	LAB_2880	;2D8C:	CD8028
	LD	A,L		;2D8F:	7D
	LD	(LAB_E784),A	;2D90:	3284E7
	LD	H,#00h		;2D93:	2600
	LD	DE,0002h	;2D95:	110200
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_2E65	;2D9B:	C2652E
	LD	A,(LAB_E784)	;2D9E:	3A84E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0001h	;2DA4:	110100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_2E61	;2DAA:	CA612E
	LD	HL,(LAB_EC3B)	;2DAD:	2A3BEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_2DBD	;2DB2:	CABD2D

	LD	HL,(LAB_EC61)	;2DB5:	2A61EC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_2DD9	;2DBA:	CAD92D

LAB_2DBD
	LD	HL,(LAB_EB3F)	;2DBD:	2A3FEB
	LD	(LAB_E782),HL	;2DC0:	2282E7
	CALL	LAB_24B6	;2DC3:	CDB624
	JP	Z,LAB_2E65	;2DC6:	CA652E
	LD	HL,(LAB_E77E)	;2DC9:	2A7EE7
	PUSH	HL		;2DCC:	E5
	CALL	LAB_418E	;2DCD:	CD8E41
	POP	DE		;2DD0:	D1
	LD	HL,(LAB_E782)	;2DD1:	2A82E7
	PUSH	HL		;2DD4:	E5
	CALL	LAB_35D8	;2DD5:	CDD835
	POP	DE		;2DD8:	D1
LAB_2DD9
	LD	HL,0000h	;2DD9:	210000
	LD	(LAB_EB3B),HL	;2DDC:	223BEB
	LD	HL,0002h	;2DDF:	210200
	LD	(LAB_EBF7),HL	;2DE2:	22F7EB
	LD	HL,(LAB_EB00)	;2DE5:	2A00EB
	LD	DE,F168h	;2DE8:	1168F1
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_2DF4	;2DEE:	CAF42D
	CALL	LAB_6280	;2DF1:	CD8062
LAB_2DF4
	LD	HL,(LAB_EB00)	;2DF4:	2A00EB
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	LD	(LAB_E780),HL	;2DFA:	2280E7
	LD	HL,0003h	;2DFD:	210300
	LD	(LAB_EBF7),HL	;2E00:	22F7EB
	CALL	LAB_6280	;2E03:	CD8062
	LD	HL,(LAB_EB3B)	;2E06:	2A3BEB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_2E19	;2E0B:	CA192E

	LD	HL,(LAB_EB3B)	;2E0E:	2A3BEB
	PUSH	HL		;2E11:	E5
	CALL	LAB_2CD3	;2E12:	CDD32C
	POP	DE		;2E15:	D1
	JP	LAB_2E65	;2E16:	C3652E
LAB_2E19
	LD	HL,(LAB_E780)	;2E19:	2A80E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_2E65	;2E1E:	CA652E

	CALL	LAB_2B43	;2E21:	CD432B
	JP	Z,LAB_2E65	;2E24:	CA652E
	LD	HL,0000h	;2E27:	210000
	LD	(LAB_EBF7),HL	;2E2A:	22F7EB
	LD	HL,(LAB_EC51)	;2E2D:	2A51EC
	LD	DE,F168h	;2E30:	1168F1
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_2E3C	;2E36:	CA3C2E
	CALL	LAB_6280	;2E39:	CD8062
LAB_2E3C
	LD	HL,(LAB_EC51)	;2E3C:	2A51EC
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	LD	(LAB_E780),HL	;2E42:	2280E7
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EBF7),HL	;2E48:	22F7EB
	CALL	LAB_6280	;2E4B:	CD8062
	LD	HL,(LAB_E780)	;2E4E:	2A80E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_2E65	;2E53:	CA652E

	LD	HL,(LAB_EB45)	;2E56:	2A45EB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_2E61	;2E5B:	CA612E

	CALL	LAB_40C4	;2E5E:	CDC440
LAB_2E61
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_2E65
	LD	HL,(LAB_EC69)	;2E65:	2A69EC
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	LD	HL,0000h	;2E6B:	210000
	RET				;




LAB_2E6F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC49)	;2E75:	2A49EC
	LD	DE,000Bh	;2E78:	110B00
	ADD	HL,DE		;2E7B:	19
	LD	E,(HL)		;2E7C:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;2E7F:	D5
	LD	HL,(LAB_EC5B)	;2E80:	2A5BEC
	LD	E,(HL)		;2E83:	5E
	EX	DE,HL		;2E84:	EB
	LD	A,L		;2E85:	7D
	LD	(LAB_E785),A	; set cursor y
	LD	H,#00h		;2E89:	2600
	POP	DE		;2E8B:	D1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_2EA1	;2E8F:	CAA12E

	LD	HL,(LAB_EB04)	;2E92:	2A04EB
	EX	DE,HL		;2E95:	EB
	LD	A,(LAB_E785)	; get cursor y
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,DE		;2E9C:	19
	LD	A,L		;2E9D:	7D
	LD	(LAB_E785),A	; set cursor y
LAB_2EA1
	LD	HL,(LAB_EC57)	;2EA1:	2A57EC
	LD	DE,000Ch	;2EA4:	110C00
	ADD	HL,DE		;2EA7:	19
	LD	(LAB_E796),HL	;2EA8:	2296E7
	LD	HL,(LAB_EC57)	;2EAB:	2A57EC
	LD	DE,000Ah	;2EAE:	110A00
	ADD	HL,DE		;2EB1:	19
	LD	E,(HL)		;2EB2:	5E
	EX	DE,HL		;2EB3:	EB
	LD	A,L		;2EB4:	7D
	LD	(LAB_E790),A	;2EB5:	3290E7
	LD	HL,(LAB_EC57)	;2EB8:	2A57EC
	LD	DE,0009h	;2EBB:	110900
	ADD	HL,DE		;2EBE:	19
	LD	E,(HL)		;2EBF:	5E
	EX	DE,HL		;2EC0:	EB
	LD	A,L		;2EC1:	7D
	LD	(LAB_E791),A	;2EC2:	3291E7
	LD	A,(LAB_E790)	;2EC5:	3A90E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0010h	;2ECB:	111000
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_2EF8	;2ED1:	C2F82E

	LD	A,(LAB_E791)	;2ED4:	3A91E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0001h	;2EDA:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_2EF2	;2EE0:	CAF22E

	LD	A,(LAB_E790)	;2EE3:	3A90E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0008h	;2EE9:	110800
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_2EF8	;2EEF:	CAF82E

LAB_2EF2
	LD	HL,0000h	;2EF2:	210000
	JP	LAB_2EFB	;2EF5:	C3FB2E

LAB_2EF8
	LD	HL,0001h		; set HL = 0001h
LAB_2EFB
	LD	A,L		;2EFB:	7D
	LD	(LAB_E792),A	;2EFC:	3292E7
	LD	A,(LAB_E791)	;2EFF:	3A91E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0002h	;2F05:	110200
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_2F1D	;2F0B:	C21D2F

	LD	A,(LAB_E791)	;2F0E:	3A91E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0080h	;2F14:	118000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_2F2E	;2F1A:	CA2E2F

LAB_2F1D
	LD	HL,(LAB_EC57)	;2F1D:	2A57EC
	LD	DE,000Ch	;2F20:	110C00
	ADD	HL,DE		;2F23:	19
	LD	E,(HL)		;2F24:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;2F26:	56
	EX	DE,HL		;2F27:	EB
	LD	(LAB_E793),HL	;2F28:	2293E7
	JP	LAB_2F34	;2F2B:	C3342F

LAB_2F2E
	LD	HL,0000h	;2F2E:	210000
	LD	(LAB_E793),HL	;2F31:	2293E7
LAB_2F34
	LD	A,(LAB_E790)	;2F34:	3A90E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0004h	;2F3A:	110400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_2F49	;2F40:	CA492F

	LD	HL,0030h	;2F43:	213000
	JP	LAB_2F4C	;2F46:	C34C2F

LAB_2F49
	LD	HL,0020h	;2F49:	212000
LAB_2F4C
	LD	A,L		;2F4C:	7D
	LD	(LAB_E78E),A	;2F4D:	328EE7
	LD	HL,(LAB_EC5B)	;2F50:	2A5BEC
	INC	HL		;2F53:	23
	INC	HL		;2F54:	23
	INC	HL		;2F55:	23
	LD	E,(HL)		;2F56:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;2F58:	56
	EX	DE,HL		;2F59:	EB
	LD	(LAB_E789),HL	;2F5A:	2289E7
	LD	HL,(LAB_EC5B)	;2F5D:	2A5BEC
	INC	HL		;2F60:	23
	INC	HL		;2F61:	23
	LD	E,(HL)		;2F62:	5E
	EX	DE,HL		;2F63:	EB
	LD	A,L		;2F64:	7D
	LD	(LAB_E787),A	; set string length
	LD	HL,(LAB_EBF9)	;2F68:	2AF9EB
	LD	(LAB_E798),HL	;2F6B:	2298E7
	CALL	LAB_29CE	;2F6E:	CDCE29
	LD	HL,(LAB_E789)	;2F71:	2A89E7
	LD	DE,0010h	;2F74:	111000
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL		;2F7A:	E5
	CALL	LAB_EEDC	;2F7B:	CDDCEE
	POP	DE		;2F7E:	D1
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; save string length
	LD	HL,(LAB_EC5B)	;2F86:	2A5BEC
	INC	HL		;2F89:	23
	LD	E,(HL)		;2F8A:	5E
	LD	D,#00h		; clear high byte
	POP	HL			; restore string length
	ADD	HL,DE		;2F8E:	19
	DEC	HL		;2F8F:	2B
	LD	A,L		;2F90:	7D
	LD	(LAB_E788),A	;2F91:	3288E7
LAB_2F94
	LD	A,(LAB_E792)	;2F94:	3A92E7
	OR	A		;2F97:	B7
	JP	Z,LAB_2FEC	;2F98:	CAEC2F

	LD	HL,LAB_EB20		; set string pointer
	LD	(LAB_E78B),HL	; save string pointer
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	(LAB_EC3D),HL	;2FA7:	223DEC
LAB_2FAA
	LD	HL,(LAB_E78B)	; get ?? string buffer pointer
	LD	E,(HL)		; get byte from string
	LD	D,#00h		; clear high byte
	LD	HL,0020h		; set compare character [SPACE]
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_2FD4		; jump if not [SPACE]

					; character was [SPACE]
	LD	HL,(LAB_EC3D)	;2FB9:	2A3DEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_2FD4	;2FBE:	CAD42F

	LD	HL,(LAB_EC3D)	;2FC1:	2A3DEC
	DEC	HL		;2FC4:	2B
	LD	(LAB_EC3D),HL	;2FC5:	223DEC
	INC	HL			; not needed
	LD	HL,(LAB_E78B)	; get ?? string buffer pointer
	INC	HL			; increment it
	LD	(LAB_E78B),HL	; save ?? string buffer pointer
	DEC	HL			; not needed
	JP	LAB_2FAA	;2FD1:	C3AA2F

					; character was not [SPACE]
LAB_2FD4
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,LAB_EB20		; set string pointer
	ADD	HL,DE			; add string length
	LD	(LAB_E78B),HL	; set ?? string buffer pointer
	LD	A,(LAB_E788)	;2FE1:	3A88E7
	LD	L,A		;2FE4:	6F
	LD	A,L		;2FE5:	7D
	LD	(LAB_E786),A	; set cursor x
	JP	LAB_3059	;2FE9:	C35930

LAB_2FEC
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,LAB_EB20		; set string pointer
	ADD	HL,DE			; add string length
	LD	(LAB_E78B),HL	; set ?? string buffer pointer
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	(LAB_EC3D),HL	;2FFF:	223DEC
LAB_3002
	LD	HL,(LAB_E78B)	; get ?? string buffer pointer
	DEC	HL			; -1
	LD	E,(HL)		; get previous character
	LD	D,#00h		; clear high byte
	LD	HL,0020h		; set compare byte [SPACE]
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_302D		; jump if was not [SPACE]

					; character was [SPACE]
	LD	HL,(LAB_EC3D)	;3012:	2A3DEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_302D	;3017:	CA2D30

	LD	HL,(LAB_EC3D)	; get ?? count
	DEC	HL			; -1
	LD	(LAB_EC3D),HL	; save ?? count
	INC	HL			; not needed
	LD	HL,(LAB_E78B)	; get ?? string buffer pointer
	DEC	HL			; -1
	LD	(LAB_E78B),HL	; save ?? string buffer pointer
	INC	HL			; not needed
	JP	LAB_3002		; loop

LAB_302D
	LD	HL,(LAB_EC5B)	;302D:	2A5BEC
	INC	HL		;3030:	23
	LD	E,(HL)		;3031:	5E
	LD	D,#00h		; clear high byte
	LD	HL,(LAB_EC3D)	;3034:	2A3DEC
	ADD	HL,DE		;3037:	19
	LD	A,L		;3038:	7D
	LD	(LAB_E786),A	; set cursor x
	LD	A,(LAB_E788)	;303C:	3A88E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;3042:	E5
	LD	A,(LAB_E786)	; get cursor x
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;3049:	D1
	EX	DE,HL		;304A:	EB
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_3059	;304E:	CA5930

	LD	A,(LAB_E788)	;3051:	3A88E7
	LD	L,A		;3054:	6F
	LD	A,L		;3055:	7D
	LD	(LAB_E786),A	; set cursor x
LAB_3059
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;305D:	7E
	OR	A		;305E:	B7
	JP	NZ,LAB_3063	;305F:	C26330

	RET				;

LAB_3063
	LD	HL,(LAB_E793)	;3063:	2A93E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_307E	;3068:	CA7E30

	LD	HL,(LAB_E793)	;306B:	2A93E7
	EX	DE,HL		;306E:	EB
	LD	HL,(LAB_EC3D)	;306F:	2A3DEC
	ADD	HL,DE		;3072:	19
	LD	E,(HL)		;3073:	5E
	EX	DE,HL		;3074:	EB
	LD	A,L		;3075:	7D
	LD	(LAB_E795),A	;3076:	3295E7
	LD	H,#00h		;3079:	2600
	JP	LAB_3081	;307B:	C38130
LAB_307E
	LD	HL,0000h	;307E:	210000
LAB_3081
	PUSH	HL		;3081:	E5
	LD	A,(LAB_E791)	;3082:	3A91E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;3088:	E5
	CALL	LAB_2381	;3089:	CD8123
	POP	DE		;308C:	D1
	POP	DE		;308D:	D1
	LD	A,(LAB_E790)	;308E:	3A90E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,00C0h	;3094:	11C000
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_30AE	;309A:	CAAE30

	LD	A,(LAB_E790)	;309D:	3A90E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0080h	;30A3:	118000
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL			; push flag
	CALL	LAB_EEF0		; set cursor on/off
	POP	DE			; dump flag
LAB_30AE
	LD	A,(LAB_E786)	; get cursor x
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push cursor x
	LD	A,(LAB_E785)	; get cursor y
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push cursor y
	CALL	LAB_70AE		; set cursor x,y
	POP	DE			; dump cursor y
	POP	DE			; dump cursor x
LAB_30C1
	LD	HL,0001h		; this funky ..
	LD	A,H			; .. bit of code ..
	OR	L			; .. does 'kin ..
	JP	Z,LAB_34AA		; .. nothing

	LD	HL,(LAB_E793)	;30C9:	2A93E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3107	;30CE:	CA0731

	LD	HL,(LAB_E793)	;30D1:	2A93E7
	EX	DE,HL		;30D4:	EB
	LD	HL,(LAB_EC3D)	;30D5:	2A3DEC
	ADD	HL,DE		;30D8:	19
	LD	E,(HL)		;30D9:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;30DC:	D5
	LD	A,(LAB_E795)	;30DD:	3A95E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;30E3:	D1
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_3107	;30E7:	CA0731

	LD	HL,(LAB_E793)	;30EA:	2A93E7
	EX	DE,HL		;30ED:	EB
	LD	HL,(LAB_EC3D)	;30EE:	2A3DEC
	ADD	HL,DE		;30F1:	19
	LD	E,(HL)		;30F2:	5E
	EX	DE,HL		;30F3:	EB
	LD	A,L		;30F4:	7D
	LD	(LAB_E795),A	;30F5:	3295E7
	LD	H,#00h		;30F8:	2600
	PUSH	HL		;30FA:	E5
	LD	A,(LAB_E791)	;30FB:	3A91E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;3101:	E5
	CALL	LAB_2381	;3102:	CD8123
	POP	DE		;3105:	D1
	POP	DE		;3106:	D1
LAB_3107
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;310A:	E5
	CALL	LAB_71B2		; set cursor blink on/off
	POP	DE			; dump cursor flag
	CALL	LAB_EEE8		; get byte from key buffer ??
	LD	(LAB_EC41),HL	; save key
	LD	A,L			; copy to A
	LD	(LAB_E78D),A	; save key
	LD	HL,0000h	;3119:	210000
	PUSH	HL		;311C:	E5
	CALL	LAB_71B2		; set cursor blink on/off
	POP	DE			; dump cursor flag
	CALL	LAB_2C4F	;3121:	CD4F2C
	JP	Z,LAB_3229	;3124:	CA2932

	LD	HL,(LAB_EC3B)	;3127:	2A3BEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3137	;312C:	CA3731

	LD	HL,(LAB_EC3D)	;312F:	2A3DEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_313D	;3134:	CA3D31

LAB_3137
	LD	HL,0000h	;3137:	210000
	JP	LAB_3140	;313A:	C34031

LAB_313D
	LD	HL,0001h		; set HL = 0001h
LAB_3140
	LD	(LAB_E79A),HL	;3140:	229AE7
	LD	HL,(LAB_E79A)	;3143:	2A9AE7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3158	;3148:	CA5831

	LD	HL,0000h	;314B:	210000
	PUSH	HL		;314E:	E5
	LD	HL,(LAB_EB06)	;314F:	2A06EB
	LD	DE,EBFBh	;3152:	11FBEB
	ADD	HL,DE		;3155:	19
	POP	DE		;3156:	D1
	LD	(HL),E		;3157:	73
LAB_3158
	LD	HL,(LAB_E798)	;3158:	2A98E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3177	;315D:	CA7731

	LD	A,(LAB_E78D)	;3160:	3A8DE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0013h	;3166:	111300
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_3177	;316C:	CA7731

	LD	HL,(LAB_E79A)	;316F:	2A9AE7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_317D	;3174:	CA7D31

LAB_3177
	LD	HL,0000h	;3177:	210000
	JP	LAB_3180	;317A:	C38031

LAB_317D
	LD	HL,0001h		; set HL = 0001h
LAB_3180
	LD	(LAB_EBF9),HL	;3180:	22F9EB
	LD	HL,(LAB_EBF9)	;3183:	2AF9EB
	EX	DE,HL		;3186:	EB
	LD	HL,(LAB_EC61)	;3187:	2A61EC
	CALL	LAB_E033		; does OR HL,DE. sets Z flag (LAB_7B6E ROM 1)
	LD	(LAB_EC61),HL	;318D:	2261EC
	LD	HL,(LAB_EC3D)	;3190:	2A3DEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_31B8	;3195:	CAB831

	LD	A,(LAB_E790)	;3198:	3A90E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0004h	;319E:	110400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_31B8	;31A4:	CAB831

	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; save string length
	LD	HL,(LAB_EC3D)	;31AE:	2A3DEC
	POP	DE			; restore string length
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	NZ,LAB_3423	;31B5:	C22334

LAB_31B8
	LD	HL,(LAB_EC3D)	;31B8:	2A3DEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3202	;31BD:	CA0232

	LD	HL,(LAB_E78B)	; get ?? string buffer pointer
	DEC	HL			; -1
	LD	E,(HL)		; get previous character
	LD	D,#00h		; clear high byte
	LD	HL,0020h		; set compare byte [SPACE]
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_3202		; jump if wa not [SPACE]

	LD	A,(LAB_E792)	;31D0:	3A92E7
	OR	A		;31D3:	B7
	JP	NZ,LAB_3202	;31D4:	C20232

	LD	HL,(LAB_E78B)	; get ?? string buffer pointer
	DEC	HL			; -1
	LD	(LAB_E78B),HL	; save ?? string buffer pointer
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; save string length
	LD	HL,(LAB_EC3D)	;31E5:	2A3DEC
	POP	DE			; restore string length
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_31F8	;31EC:	CAF831

	LD	A,(LAB_E786)	; get cursor x
	LD	L,A			; copy to L
	DEC	HL			; decrement cursor x
	LD	A,L			; copy to A
	LD	(LAB_E786),A	; save cursor x
LAB_31F8
	LD	HL,(LAB_EC3D)	;31F8:	2A3DEC
	DEC	HL		;31FB:	2B
	LD	(LAB_EC3D),HL	;31FC:	223DEC
	JP	LAB_31B8	;31FF:	C3B831

LAB_3202
	LD	HL,(LAB_EBF9)	;3202:	2AF9EB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3220	;3207:	CA2032

	LD	HL,(LAB_EC57)	;320A:	2A57EC
	LD	DE,000Bh	;320D:	110B00
	ADD	HL,DE		;3210:	19
	LD	E,(HL)		;3211:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;3214:	D5
	LD	HL,(LAB_EC3D)	;3215:	2A3DEC
	POP	DE		;3218:	D1
	EX	DE,HL		;3219:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	NZ,LAB_3423	;321D:	C22334

LAB_3220
	LD	HL,0000h	;3220:	210000
	PUSH	HL		;3223:	E5
	CALL	LAB_EEDC	;3224:	CDDCEE
	POP	DE		;3227:	D1
	RET				;

LAB_3229
	LD	A,(LAB_E78D)	; get key back
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,00DBh		; set compare byte [NEXT] key
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_3272		; jump if wasn't [NEXT] key

					; was [NEXT] key
	LD	HL,(LAB_EC57)	;3238:	2A57EC
	LD	DE,0009h	;323B:	110900
	ADD	HL,DE		;323E:	19
	LD	E,(HL)		;323F:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0009h	;3242:	210900
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_3423	;3248:	CA2334

	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;324E:	E5
	LD	HL,(LAB_EB06)	;324F:	2A06EB
	LD	DE,EBFBh	;3252:	11FBEB
	ADD	HL,DE		;3255:	19
	POP	DE		;3256:	D1
	LD	(HL),E		;3257:	73
	CALL	LAB_23FD	;3258:	CDFD23
	CALL	LAB_2A28	;325B:	CD282A
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;3261:	E5
	CALL	LAB_463F	;3262:	CD3F46
	POP	DE		;3265:	D1
	CALL	LAB_29CE	;3266:	CDCE29
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E798),HL	;326C:	2298E7
	JP	LAB_2F94	;326F:	C3942F

LAB_3272
	LD	A,(LAB_E78D)	; get key back
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,001Ah		; set compare byte [DEL]
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_32A2		; jump if was not [DEL]

					; was [DEL] key
	LD	HL,0000h	;3281:	210000
	PUSH	HL		;3284:	E5
	LD	HL,(LAB_EB06)	;3285:	2A06EB
	LD	DE,EBFBh	;3288:	11FBEB
	ADD	HL,DE		;328B:	19
	POP	DE		;328C:	D1
	LD	(HL),E		;328D:	73
	LD	HL,0000h	;328E:	210000
	PUSH	HL		;3291:	E5
	CALL	LAB_463F	;3292:	CD3F46
	POP	DE		;3295:	D1
	CALL	LAB_29CE	;3296:	CDCE29
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E798),HL	;329C:	2298E7
	JP	LAB_2F94	;329F:	C3942F

LAB_32A2
	LD	A,(LAB_E78D)	; get key back
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,007Fh		; set compare byte [DEL]
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_3334		; jump if was not [DEL]

					; was [DEL] key
	LD	HL,(LAB_EC3D)	;32B1:	2A3DEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3423	;32B6:	CA2334

	LD	A,(LAB_E792)	;32B9:	3A92E7
	OR	A		;32BC:	B7
	JP	Z,LAB_32E9	;32BD:	CAE932
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,LAB_EB20		; set string pointer
	ADD	HL,DE			; add string length
	DEC	HL			; -1
	LD	E,(HL)		; get byte from string
	EX	DE,HL			; copy to HL
	LD	A,L			; copy to A
	LD	(LAB_E78D),A	;32CE:	328DE7
	LD	HL,0020h		; will insert [SPACE]
	PUSH	HL			; push character
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push string length
	LD	HL,LAB_EB20		; set pointer
	PUSH	HL			; push pointer
	CALL	LAB_2306		; inserts chr at pointer, moves (length) string up 1
	POP	DE			; dump pointer
	POP	DE			; dump length
	POP	DE			; dump character
	JP	LAB_3319		;

LAB_32E9
	LD	HL,(LAB_E78B)	; get ?? string buffer pointer
	DEC	HL			; -1
	LD	(LAB_E78B),HL	; save ?? string buffer pointer
	LD	E,(HL)		; get byte from string
	EX	DE,HL			; swap to HL
	LD	A,L			; copy to A
	LD	(LAB_E78D),A	;32F3:	328DE7
	LD	HL,0020h		; set HL = " "
	PUSH	HL			; save it
	LD	HL,(LAB_E78B)	; get ?? string buffer pointer
	POP	DE			; restore " "
	LD	(HL),E		; put into string
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; save string length
	LD	HL,(LAB_EC3D)	;3306:	2A3DEC
	POP	DE			; restore string length
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_3319	;330D:	CA1933

	LD	A,(LAB_E786)	; get cursor x
	LD	L,A			; copy to L
	DEC	HL			; decrement cursor x
	LD	A,L			; copy to A
	LD	(LAB_E786),A	; save cursor x
LAB_3319
	LD	HL,(LAB_EC3D)	;3319:	2A3DEC
	DEC	HL		;331C:	2B
	LD	(LAB_EC3D),HL	;331D:	223DEC
	LD	A,(LAB_E78D)	;3320:	3A8DE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;3326:	E5
	CALL	LAB_2966	;3327:	CD6629
	POP	DE		;332A:	D1
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E798),HL	;332E:	2298E7
	JP	LAB_3420	;3331:	C32034

LAB_3334
	LD	A,(LAB_E78D)	; get key back
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0020h		; set comapre byte [SPACE]
	EX	DE,HL			; swap key and byte
	CALL	LAB_E0D9		; does CP DE,HL, returns HL=1 if HL<=DE (LAB_7C14 ROM 1)
	JP	Z,LAB_341D		; jump if non printing character <[SPACE]

	LD	A,(LAB_E790)	;3344:	3A90E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0020h	;334A:	112000
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_3362	;3350:	CA6233

	LD	A,(LAB_E78D)	;3353:	3A8DE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;3359:	E5
	CALL	LAB_D8CE	;335A:	CDCED8
	POP	DE		;335D:	D1
	LD	A,L		;335E:	7D
	LD	(LAB_E78D),A	;335F:	328DE7
LAB_3362
	LD	HL,(LAB_E796)	;3362:	2A96E7
	PUSH	HL		;3365:	E5
	LD	A,(LAB_E790)	;3366:	3A90E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;336C:	E5
	LD	A,(LAB_E78D)	;336D:	3A8DE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;3373:	E5
	LD	HL,(LAB_EB4B)	;3374:	2A4BEB
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;337A:	D1
	POP	DE		;337B:	D1
	POP	DE		;337C:	D1
	JP	Z,LAB_3423	;337D:	CA2334

	LD	HL,(LAB_EC3D)	;3380:	2A3DEC
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_339E	;3385:	C29E33

	LD	A,(LAB_E792)	;3388:	3A92E7
	OR	A		;338B:	B7
	JP	Z,LAB_339E	;338C:	CA9E33
	LD	A,(LAB_E78D)	;338F:	3A8DE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0020h	;3395:	112000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_341A	;339B:	C21A34

LAB_339E
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; save string length
	LD	HL,(LAB_EC3D)	;33A5:	2A3DEC
	POP	DE			; restore string length
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_3423	;33AC:	C22334

	LD	A,(LAB_E792)	;33AF:	3A92E7
	OR	A		;33B2:	B7
	JP	Z,LAB_33D1	;33B3:	CAD133

	LD	A,(LAB_E78D)	; get key back
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push pad character
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push string length
	LD	HL,LAB_EB20		; set pointer
	PUSH	HL			; push pointer
	CALL	LAB_2297		; move string down, pad with chr
	POP	DE			; dump pointer
	POP	DE			; dump length
	POP	DE			; dump pad character
	JP	LAB_3402	;33CE:	C30234

LAB_33D1
	LD	A,(LAB_E78D)	; get key back
	LD	L,A		;33D4:	6F
	PUSH	HL		;33D5:	E5
	LD	HL,(LAB_E78B)	;33D6:	2A8BE7
	INC	HL		;33D9:	23
	LD	(LAB_E78B),HL	;33DA:	228BE7
	DEC	HL		;33DD:	2B
	POP	DE		;33DE:	D1
	LD	(HL),E		;33DF:	73
	LD	A,(LAB_E788)	;33E0:	3A88E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;33E6:	E5
	LD	A,(LAB_E786)	; get cursor x
	LD	L,A			; copy to L
	INC	HL			; increment cursor x
	LD	A,L			; copy to A
	LD	(LAB_E786),A	; save cursor x
	LD	H,#00h		;33F0:	2600
	POP	DE		;33F2:	D1
	EX	DE,HL		;33F3:	EB
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_3402	;33F7:	CA0234
	LD	A,(LAB_E788)	;33FA:	3A88E7
	LD	L,A		;33FD:	6F
	LD	A,L		;33FE:	7D
	LD	(LAB_E786),A	; set cursor x
LAB_3402
	LD	HL,(LAB_EC3D)	;3402:	2A3DEC
	INC	HL		;3405:	23
	LD	(LAB_EC3D),HL	;3406:	223DEC
	LD	A,(LAB_E78D)	; get key back
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;340F:	E5
	CALL	LAB_28FE	;3410:	CDFE28
	POP	DE		;3413:	D1
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E798),HL	;3417:	2298E7
LAB_341A
	JP	LAB_3420	;341A:	C32034

LAB_341D
	JP	LAB_3423	;341D:	C32334

LAB_3420
	JP	LAB_3429	;3420:	C32934

LAB_3423
	LD	HL,(LAB_EC69)	;3423:	2A69EC
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
LAB_3429
	LD	HL,(LAB_E789)	;3429:	2A89E7
	LD	DE,0001h	;342C:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_3494	;3432:	C29434

	CALL	LAB_EEF8		; get key status without waiting
	JP	NZ,LAB_3494	;3438:	C29434

	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;343E:	E5
	CALL	LAB_35D8	;343F:	CDD835
	POP	DE		;3442:	D1
	LD	HL,(LAB_EC5B)	;3443:	2A5BEC
	INC	HL		;3446:	23
	LD	E,(HL)		; get cursor x from ??
	LD	D,#00h		; clear high byte
	PUSH	DE			; push cursor x
	LD	A,(LAB_E785)	; get cursor y
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push cursor y
	CALL	LAB_70AE		; set cursor X,Y
	POP	DE			; dump cursor Y
	POP	DE			; dump cursor X
	LD	HL,0000h		; clear HL
	LD	A,L			; copy to A
	LD	(LAB_E78F),A	; clear character pointer
	JP	LAB_346A		; skip initial increment

LAB_3461
	LD	A,(LAB_E78F)	; get character pointer
	LD	L,A			; copy to L
	INC	HL			; increment character pointer
	LD	A,L			; copy to A
	LD	(LAB_E78F),A	; save character pointer
LAB_346A
	LD	A,(LAB_E787)	; get string length
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; save it
	LD	A,(LAB_E78F)	; get character pointer
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE			; restore string length
	EX	DE,HL			; swap position & length
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_3494		; exit if length <= position (i.e. done)

	LD	A,(LAB_E78F)	; get character pointer
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,LAB_EB20		; string base
	ADD	HL,DE			; add to character pointer
	LD	E,(HL)		; get chr from string
	LD	D,#00h		; clear high byte
	PUSH	DE			; push character
	CALL	LAB_356E		; character out (does "_" if chr=" " & (LAB_EB0C).w=0)
	POP	DE			; dump character
	JP	LAB_3461		; loop

LAB_3494
	LD	A,(LAB_E786)	; get cursor x
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push cursor x
	LD	A,(LAB_E785)	; get cursor y
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push cursor x
	CALL	LAB_70AE		; set cursor x,y
	POP	DE			; dump cursor y
	POP	DE			; dump cursor x
	JP	LAB_30C1	;34A7:	C3C130

LAB_34AA
	RET				;

LAB_34AB
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;34B5:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;34B7:	56
	EX	DE,HL		;34B8:	EB
	LD	(LAB_E79C),HL	;34B9:	229CE7
	LD	HL,0000h	;34BC:	210000
	LD	A,L		;34BF:	7D
	LD	(LAB_E79E),A	;34C0:	329EE7
LAB_34C3
	LD	HL,(LAB_E79C)	;34C3:	2A9CE7
	LD	E,(HL)		;34C6:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0020h	;34C9:	212000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_34FD	;34CF:	CAFD34
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;34D6:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;34D9:	D5
	LD	A,(LAB_E79E)	;34DA:	3A9EE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;34E0:	D1
	EX	DE,HL		;34E1:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_34FD	;34E5:	CAFD34
	LD	HL,(LAB_E79C)	;34E8:	2A9CE7
	INC	HL		;34EB:	23
	LD	(LAB_E79C),HL	;34EC:	229CE7
	DEC	HL		;34EF:	2B
	LD	A,(LAB_E79E)	;34F0:	3A9EE7
	LD	L,A		;34F3:	6F
	INC	HL		;34F4:	23
	LD	A,L		;34F5:	7D
	LD	(LAB_E79E),A	;34F6:	329EE7
	DEC	HL		;34F9:	2B
	JP	LAB_34C3	;34FA:	C3C334
LAB_34FD
	LD	A,(LAB_E79E)	;34FD:	3A9EE7
	OR	A		;3500:	B7
	JP	Z,LAB_3519	;3501:	CA1935
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3508:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;350B:	D5
	LD	A,(LAB_E79E)	;350C:	3A9EE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;3512:	D1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_351A	;3516:	CA1A35
LAB_3519
	RET				;

LAB_351A
	LD	A,(LAB_E79E)	;351A:	3A9EE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;3520:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3525:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;3528:	E1
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL		;352C:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3531:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3533:	56
	PUSH	DE		;3534:	D5
	LD	HL,(LAB_E79C)	;3535:	2A9CE7
	PUSH	HL		;3538:	E5
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count

	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	A,(LAB_E79E)	;3543:	3A9EE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push count
	LD	A,(LAB_E79E)	;354A:	3A9EE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;3550:	E5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3555:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;355C:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;355E:	66
	LD	L,A		;355F:	6F
	ADD	HL,DE		;3560:	19
	POP	DE		;3561:	D1
	EX	DE,HL		;3562:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	RET				;

; character out (does "_" if chr=" " & (LAB_EB0C).w=0)

; stack is ..
; character
; end .

LAB_356E
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get character
	LD	D,#00h		; clear high byte
	LD	HL,0020h		; compare byte is [SPACE]
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_3595		; jump if not [SPACE}

	LD	HL,(LAB_EB0C)	; get ??
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3595		; jump if ?? not 0

	LD	HL,005Fh		; "_"
	EX	DE,HL			; copy to DE
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	(HL),E		; make character "_"
LAB_3595
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get character
	LD	D,#00h		; clear high byte
	PUSH	DE			; push character
	CALL	LAB_720D		; character out to screen & buffer
	POP	DE			; dump character
	RET				;

LAB_35A2
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
LAB_35A8
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;35AC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;35AE:	56
	EX	DE,HL		;35AF:	EB
	LD	A,(HL)		;35B0:	7E
	OR	A		;35B1:	B7
	JP	Z,LAB_35D7	;35B2:	CAD735

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;35B9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;35BB:	56
	EX	DE,HL		;35BC:	EB
	LD	E,(HL)		;35BD:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push character
	CALL	LAB_356E		; character out (does "_" if chr=" " & (LAB_EB0C).w=0)
	POP	DE			; dump character
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;35C9:	E5
	LD	A,(HL)		;35CA:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;35CC:	66
	LD	L,A		;35CD:	6F
	INC	HL		;35CE:	23
	EX	DE,HL		;35CF:	EB
	POP	HL		;35D0:	E1
	LD	(HL),E		;35D1:	73
	INC	HL			; increment pointer
	LD	(HL),D		;35D3:	72
	JP	LAB_35A8	;35D4:	C3A835
LAB_35D7
	RET				;

; stack is ..
;??
;

LAB_35D8
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #0 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get #0 high byte
	EX	DE,HL			; swap to HL
	LD	(LAB_EB3F),HL	; save #0
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #0 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get #0 high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	LD	DE,0000h	;35F6:	110000
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	LD	(LAB_EB0C),HL	;35FC:	220CEB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #0 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get #0 high byte
	LD	HL,0004h	;3606:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL		;360C:	E5
	CALL	LAB_7206		; does nothing ??
	POP	DE		;3610:	D1
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #0 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get #0 high byte
	LD	HL,0002h	;3618:	210200
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL		;361E:	E5
	CALL	LAB_71AB		; does nothing ??
	POP	DE		;3622:	D1
	RET				;

LAB_3624
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC43)	;362A:	2A43EC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3638	;362F:	CA3836
	LD	HL,0002h	;3632:	210200
	JP	LAB_3643	;3635:	C34336
LAB_3638
	LD	HL,(LAB_EC57)	;3638:	2A57EC
	LD	DE,0008h	;363B:	110800
	ADD	HL,DE		;363E:	19
	LD	E,(HL)		;363F:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;3642:	EB
LAB_3643
	LD	A,L		;3643:	7D
	LD	(LAB_E79F),A	;3644:	329FE7
	LD	HL,(LAB_EC43)	;3647:	2A43EC
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3668	;364C:	C26836
	LD	HL,(LAB_EC57)	;364F:	2A57EC
	LD	DE,0009h	;3652:	110900
	ADD	HL,DE		;3655:	19
	LD	E,(HL)		;3656:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_3668		; jump if DE bit0=1

	LD	HL,0000h	;3662:	210000
	JP	LAB_366B	;3665:	C36B36
LAB_3668
	LD	HL,0001h		; set HL = 0001h
LAB_366B
	LD	A,L		;366B:	7D
	LD	(LAB_E7A0),A	;366C:	32A0E7
	LD	HL,(LAB_EC43)	;366F:	2A43EC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_367D	;3674:	CA7D36
	LD	HL,0000h	;3677:	210000
	JP	LAB_3684	;367A:	C38436
LAB_367D
	LD	HL,(LAB_EC57)	;367D:	2A57EC
	LD	DE,000Ch	;3680:	110C00
	ADD	HL,DE		;3683:	19
LAB_3684
	LD	(LAB_E7A1),HL	;3684:	22A1E7
	LD	HL,(LAB_E7A1)	;3687:	2AA1E7
	PUSH	HL		;368A:	E5
	LD	HL,(LAB_EC57)	;368B:	2A57EC
	LD	DE,000Ah	;368E:	110A00
	ADD	HL,DE		;3691:	19
	LD	E,(HL)		;3692:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;3695:	D5
	LD	HL,(LAB_EC5B)	;3696:	2A5BEC
	INC	HL		;3699:	23
	INC	HL		;369A:	23
	LD	E,(HL)		;369B:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;369E:	D5
	LD	A,(LAB_E79F)	;369F:	3A9FE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;36A5:	E5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;36AA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;36AC:	56
	PUSH	DE		;36AD:	D5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;36B2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;36B4:	56
	PUSH	DE		;36B5:	D5
	LD	HL,(LAB_EB41)	;36B6:	2A41EB
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	EX	DE,HL		;36BC:	EB
	LD	HL,000Ch		; C ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	A,(LAB_E7A0)	;36C2:	3AA0E7
	OR	A		;36C5:	B7
	JP	Z,LAB_36F2	;36C6:	CAF236
	LD	HL,(LAB_EC57)	;36C9:	2A57EC
	LD	DE,000Ah	;36CC:	110A00
	ADD	HL,DE		;36CF:	19
	LD	E,(HL)		;36D0:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0008h	;36D3:	210800
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_36F2	;36D9:	CAF236
	LD	HL,(LAB_EC5B)	;36DC:	2A5BEC
	INC	HL		;36DF:	23
	INC	HL		;36E0:	23
	LD	E,(HL)		;36E1:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;36E4:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;36E9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;36EB:	56
	PUSH	DE		;36EC:	D5
	CALL	LAB_34AB	;36ED:	CDAB34
	POP	DE		;36F0:	D1
	POP	DE		;36F1:	D1
LAB_36F2
	RET				;

; setup LAB_EB4D, LAB_EC47 & LAB_EB51 for #

; stack is ..
; ??
; end.

LAB_36F3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;36FD:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;3700:	EB
	LD	(LAB_EB4D),HL	;3701:	224DEB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3708:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0009h	;370B:	210900
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	EX	DE,HL		;3711:	EB
	LD	HL,(LAB_EC49)	;3712:	2A49EC
	ADD	HL,DE		;3715:	19
	LD	DE,000Eh	;3716:	110E00
	ADD	HL,DE		;3719:	19
	LD	(LAB_EC47),HL	;371A:	2247EC
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #_0
	LD	D,#00h		; clear high byte
	LD	HL,000Ah		; 0Ah bytes per entry ??
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	LD	DE,LAB_EB57		; set base address
	ADD	HL,DE			; add base address
	LD	(LAB_EB51),HL	;372E:	2251EB
	RET				;

; stack is ..
; ?? string #
;

LAB_3732
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #_0
	LD	D,#00h		; clear high byte
	EX	DE,HL			; swap to HL
	LD	(LAB_EB0E),HL	; save #_0
	LD	HL,(LAB_EC47)	;3743:	2A47EC
	INC	HL		;3746:	23
	INC	HL		;3747:	23
	INC	HL		;3748:	23
	LD	E,(HL)		;3749:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;374B:	56
	PUSH	DE		;374C:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #_0
	LD	D,#00h		; clear high byte
	LD	HL,0006h		; 6 bytes per entry
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	POP	DE		;375A:	D1
	ADD	HL,DE		;375B:	19
	LD	(LAB_EC5B),HL	;375C:	225BEC
	LD	HL,(LAB_EC47)	;375F:	2A47EC
	LD	DE,0005h	;3762:	110500
	ADD	HL,DE		;3765:	19
	LD	E,(HL)		;3766:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3768:	56
	EX	DE,HL		;3769:	EB
	LD	(LAB_EC63),HL	;376A:	2263EC
	LD	HL,(LAB_EC5B)	;376D:	2A5BEC
	LD	DE,0005h	;3770:	110500
	ADD	HL,DE		;3773:	19
	LD	E,(HL)		;3774:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;3777:	EB
	ADD	HL,HL		;3778:	29
	ADD	HL,HL		;3779:	29
	EX	DE,HL		;377A:	EB
	LD	HL,(LAB_EC63)	;377B:	2A63EC
	ADD	HL,DE		;377E:	19
	INC	HL		;377F:	23
	INC	HL		;3780:	23
	LD	(LAB_EC4F),HL	;3781:	224FEC
	LD	HL,(LAB_EC4F)	;3784:	2A4FEC
	INC	HL		;3787:	23
	INC	HL		;3788:	23
	LD	E,(HL)		;3789:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;378B:	56
	EX	DE,HL		;378C:	EB
	LD	(LAB_EC57),HL	;378D:	2257EC
	LD	HL,(LAB_EC5B)	;3790:	2A5BEC
	INC	HL		;3793:	23
	INC	HL		;3794:	23
	INC	HL		;3795:	23
	LD	E,(HL)		;3796:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3798:	56
	LD	HL,006Eh	;3799:	216E00
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	LD	(LAB_EC43),HL	;379F:	2243EC
	LD	HL,(LAB_EB51)	;37A2:	2A51EB
	LD	DE,0008h	;37A5:	110800
	ADD	HL,DE		;37A8:	19
	LD	E,(HL)		;37A9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;37AB:	56
	PUSH	DE		;37AC:	D5
	LD	HL,(LAB_EC4F)	;37AD:	2A4FEC
	INC	HL		;37B0:	23
	LD	E,(HL)		;37B1:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;37B4:	E1
	ADD	HL,DE		;37B5:	19
	LD	(LAB_EB1A),HL	;37B6:	221AEB
	CALL	LAB_37BD	;37B9:	CDBD37
	RET				;

LAB_37BD
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC57)	;37C3:	2A57EC
	LD	DE,0004h	;37C6:	110400
	ADD	HL,DE		;37C9:	19
	LD	E,(HL)		;37CA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;37CC:	56
	EX	DE,HL		;37CD:	EB
	LD	(LAB_EB4B),HL	;37CE:	224BEB
	LD	HL,(LAB_EC57)	;37D1:	2A57EC
	LD	DE,0006h	;37D4:	110600
	ADD	HL,DE		;37D7:	19
	LD	E,(HL)		;37D8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;37DA:	56
	EX	DE,HL		;37DB:	EB
	LD	(LAB_EB49),HL	;37DC:	2249EB
	LD	HL,(LAB_EC57)	;37DF:	2A57EC
	LD	E,(HL)		;37E2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;37E4:	56
	EX	DE,HL		;37E5:	EB
	LD	(LAB_EB47),HL	;37E6:	2247EB
	LD	HL,(LAB_EC43)	;37E9:	2A43EC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_37F7	;37EE:	CAF737
	LD	HL,F100h	;37F1:	2100F1
	JP	LAB_3800	;37F4:	C30038
LAB_37F7
	LD	HL,(LAB_EC57)	;37F7:	2A57EC
	INC	HL		;37FA:	23
	INC	HL		;37FB:	23
	LD	E,(HL)		;37FC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;37FE:	56
	EX	DE,HL		;37FF:	EB
LAB_3800
	LD	(LAB_EB41),HL	;3800:	2241EB
	RET				;

LAB_3804
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EB10)	;380A:	2A10EB
	LD	DE,0001h	;380D:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_38DA	;3813:	CADA38
	LD	HL,(LAB_EB53)	;3816:	2A53EB
	LD	A,(HL)		;3819:	7E
	OR	A		;381A:	B7
	JP	Z,LAB_3822	;381B:	CA2238
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_3822
	LD	HL,(LAB_EC3B)	;3822:	2A3BEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3836	;3827:	CA3638
	LD	HL,(LAB_EC61)	;382A:	2A61EC
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3836	;382F:	C23638
	LD	HL,0000h	;3832:	210000
	RET				;

LAB_3836
	LD	HL,LAB_E7A9	;3836:	21A9E7
	PUSH	HL		;3839:	E5
	LD	HL,(LAB_EB53)	;383A:	2A53EB
	LD	DE,0006h	;383D:	110600
	ADD	HL,DE		;3840:	19
	LD	E,(HL)		;3841:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3843:	56
	PUSH	DE		;3844:	D5
	CALL	LAB_EEB0	;3845:	CDB0EE
	POP	DE		;3848:	D1
	POP	DE		;3849:	D1
	JP	Z,LAB_38DE	;384A:	CADE38
	LD	HL,LAB_E7A7	;384D:	21A7E7
	PUSH	HL		;3850:	E5
	LD	HL,(LAB_EB53)	;3851:	2A53EB
	LD	DE,0006h	;3854:	110600
	ADD	HL,DE		;3857:	19
	LD	E,(HL)		;3858:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;385A:	56
	PUSH	DE		;385B:	D5
	CALL	LAB_EEBC	;385C:	CDBCEE
	POP	DE		;385F:	D1
	POP	DE		;3860:	D1
	LD	HL,LAB_E7A3	;3861:	21A3E7
	PUSH	HL		;3864:	E5
	LD	HL,(LAB_EB53)	;3865:	2A53EB
	LD	DE,0006h	;3868:	110600
	ADD	HL,DE		;386B:	19
	LD	E,(HL)		;386C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;386E:	56
	PUSH	DE		;386F:	D5
	CALL	LAB_EED0	;3870:	CDD0EE
	POP	DE		;3873:	D1
	POP	DE		;3874:	D1
	LD	HL,LAB_E7A5	;3875:	21A5E7
	PUSH	HL		;3878:	E5
	LD	HL,(LAB_EB53)	;3879:	2A53EB
	LD	DE,0006h	;387C:	110600
	ADD	HL,DE		;387F:	19
	LD	E,(HL)		;3880:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3882:	56
	PUSH	DE		;3883:	D5
	CALL	LAB_EEC8	;3884:	CDC8EE
	POP	DE		;3887:	D1
	POP	DE		;3888:	D1
	LD	HL,(LAB_EB53)	;3889:	2A53EB
	INC	HL		;388C:	23
	INC	HL		;388D:	23
	INC	HL		;388E:	23
	LD	A,(HL)		;388F:	7E
	OR	A		;3890:	B7
	JP	NZ,LAB_38A2	;3891:	C2A238
	LD	HL,(LAB_E7A5)	;3894:	2AA5E7
	INC	HL		;3897:	23
	LD	(LAB_E7A5),HL	;3898:	22A5E7
	LD	HL,(LAB_E7A7)	;389B:	2AA7E7
	INC	HL		;389E:	23
	LD	(LAB_E7A7),HL	;389F:	22A7E7
LAB_38A2
	LD	HL,(LAB_EB10)	;38A2:	2A10EB
	LD	DE,0006h	;38A5:	110600
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	LD	(LAB_E7AB),HL	;38AB:	22ABE7
	LD	HL,(LAB_E7A5)	;38AE:	2AA5E7
	EX	DE,HL		;38B1:	EB
	LD	HL,(LAB_E7A3)	;38B2:	2AA3E7
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	NZ,LAB_38D6	;38B8:	C2D638
	LD	HL,(LAB_E7A7)	;38BB:	2AA7E7
	EX	DE,HL		;38BE:	EB
	LD	HL,(LAB_E7A9)	;38BF:	2AA9E7
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_38D0	;38C5:	CAD038
	LD	HL,(LAB_E7AB)	;38C8:	2AABE7
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_38D6	;38CD:	C2D638
LAB_38D0
	LD	HL,0000h	;38D0:	210000
	JP	LAB_38D9	;38D3:	C3D938

LAB_38D6
	LD	HL,0001h		; set HL = 0001h
LAB_38D9
	RET				;

LAB_38DA
	LD	HL,0000h	;38DA:	210000
	RET				;

LAB_38DE
	LD	HL,E300h	;38DE:	2100E3
	PUSH	HL			; push message pointer ??
	CALL	LAB_EE8C	;38E2:	CD8CEE
	PUSH	HL			; push error #
	CALL	LAB_6602		; display error # & message ??
	POP	DE			; dump error #
	POP	DE			; dump message pointer
	LD	HL,0000h	;38EB:	210000
	RET				;

LAB_38EF
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EB10)	;38F5:	2A10EB
	LD	DE,0001h	;38F8:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_3972	;38FE:	CA7239
	LD	HL,(LAB_EB10)	;3901:	2A10EB
	LD	DE,0004h	;3904:	110400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_3972	;390A:	C27239
	LD	HL,(LAB_EB53)	;390D:	2A53EB
	LD	A,(HL)		;3910:	7E
	OR	A		;3911:	B7
	JP	Z,LAB_3919	;3912:	CA1939
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_3919
	LD	HL,LAB_E7AD	;3919:	21ADE7
	PUSH	HL		;391C:	E5
	LD	HL,(LAB_EB53)	;391D:	2A53EB
	LD	DE,0006h	;3920:	110600
	ADD	HL,DE		;3923:	19
	LD	E,(HL)		;3924:	5E
	INC	HL		;3925:	23
	LD	D,(HL)		;3926:	56
	PUSH	DE		;3927:	D5
	CALL	LAB_EED0	;3928:	CDD0EE
	POP	DE		;392B:	D1
	POP	DE		;392C:	D1
	JP	Z,LAB_3976	;392D:	CA7639
	LD	HL,(LAB_E7AD)	;3930:	2AADE7
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3941	;3935:	C24139
	LD	HL,0000h	;3938:	210000
	LD	(LAB_E7AF),HL	;393B:	22AFE7
	JP	LAB_3967	;393E:	C36739
LAB_3941
	LD	HL,LAB_E7AF	;3941:	21AFE7
	PUSH	HL		;3944:	E5
	LD	HL,(LAB_EB53)	;3945:	2A53EB
	LD	DE,0006h	;3948:	110600
	ADD	HL,DE		;394B:	19
	LD	E,(HL)		;394C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;394E:	56
	PUSH	DE		;394F:	D5
	CALL	LAB_EEC8	;3950:	CDC8EE
	POP	DE		;3953:	D1
	POP	DE		;3954:	D1
	JP	Z,LAB_3976	;3955:	CA7639
	LD	HL,(LAB_EC3B)	;3958:	2A3BEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3967	;395D:	CA6739
	LD	HL,(LAB_E7AF)	;3960:	2AAFE7
	INC	HL		;3963:	23
	LD	(LAB_E7AF),HL	;3964:	22AFE7
LAB_3967
	LD	HL,(LAB_E7AF)	;3967:	2AAFE7
	LD	DE,0001h	;396A:	110100
	EX	DE,HL		;396D:	EB
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	RET				;

LAB_3972
	LD	HL,0000h	;3972:	210000
	RET				;

LAB_3976
	LD	HL,E301h	;3976:	2101E3
	PUSH	HL		;3979:	E5
	CALL	LAB_EE8C	;397A:	CD8CEE
	PUSH	HL			; push error #
	CALL	LAB_6602		; display error # & message ??
	POP	DE			; dump error #
	POP	DE			; dump message pointer
	LD	HL,0000h	;3983:	210000
	RET				;

LAB_3987
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3991:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3993:	56
	LD	HL,0017h	;3994:	211700
	ADD	HL,DE		;3997:	19
	LD	E,(HL)		;3998:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;399A:	56
	EX	DE,HL		;399B:	EB
	LD	(LAB_E7B3),HL	;399C:	22B3E7
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;39A3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;39A5:	56
	LD	HL,0019h	;39A6:	211900
	ADD	HL,DE		;39A9:	19
	LD	E,(HL)		;39AA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;39AC:	56
	EX	DE,HL		;39AD:	EB
	LD	(LAB_E7B5),HL	;39AE:	22B5E7
	LD	HL,(LAB_E7B5)	;39B1:	2AB5E7
	INC	HL		;39B4:	23
	INC	HL		;39B5:	23
	LD	(LAB_E7B7),HL	;39B6:	22B7E7
	LD	HL,0000h	;39B9:	210000
	LD	(LAB_E7B1),HL	;39BC:	22B1E7
	JP	LAB_39C9	;39BF:	C3C939
LAB_39C2
	LD	HL,(LAB_E7B1)	;39C2:	2AB1E7
	INC	HL		;39C5:	23
	LD	(LAB_E7B1),HL	;39C6:	22B1E7
LAB_39C9
	LD	HL,(LAB_E7B5)	;39C9:	2AB5E7
	INC	HL		;39CC:	23
	LD	E,(HL)		;39CD:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;39D0:	D5
	LD	HL,(LAB_E7B1)	;39D1:	2AB1E7
	POP	DE		;39D4:	D1
	EX	DE,HL		;39D5:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_3A03	;39D9:	CA033A
	LD	HL,(LAB_E7B7)	;39DC:	2AB7E7
	INC	HL		;39DF:	23
	INC	HL		;39E0:	23
	LD	E,(HL)		;39E1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;39E3:	56
	PUSH	DE		;39E4:	D5
	LD	HL,(LAB_E7B7)	;39E5:	2AB7E7
	INC	HL		;39E8:	23
	LD	E,(HL)		;39E9:	5E
	LD	D,#00h		; clear high byte
	LD	HL,(LAB_E7B3)	;39EC:	2AB3E7
	ADD	HL,DE		;39EF:	19
	PUSH	HL		;39F0:	E5
	CALL	LAB_3A04	;39F1:	CD043A
	POP	DE		;39F4:	D1
	POP	DE		;39F5:	D1
	LD	HL,(LAB_E7B7)	;39F6:	2AB7E7
	LD	DE,0004h	;39F9:	110400
	ADD	HL,DE		;39FC:	19
	LD	(LAB_E7B7),HL	;39FD:	22B7E7
	JP	LAB_39C2	;3A00:	C3C239

LAB_3A03
	RET				;

; stack is ..
; ?? word pointer
; ?? word pointer
; end.

; pointer points to the following ..
;
; +00
; +08 byte count
; +09 byte ?? number
; +0A byte ??

LAB_3A04
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;3A0E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3A10:	56
	LD	HL,0009h	;3A11:	210900
	ADD	HL,DE		;3A14:	19
	LD	E,(HL)		;3A15:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;3A18:	EB
	JP	LAB_3B53	;3A19:	C3533B

LAB_3A1C
	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;3A24:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3A26:	56
	LD	HL,0008h	;3A27:	210800
	ADD	HL,DE		;3A2A:	19
	LD	E,(HL)		;3A2B:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push count
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3A33:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3A35:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	JP	LAB_3B7A	;3A3D:	C37A3B

LAB_3A40
	LD	HL,00FFh	;3A40:	21FF00
	PUSH	HL		;3A43:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;3A48:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3A4A:	56
	EX	DE,HL		;3A4B:	EB
	POP	DE		;3A4C:	D1
	LD	(HL),E		;3A4D:	73
	JP	LAB_3B7A	;3A4E:	C37A3B

LAB_3A51
	LD	HL,00FFh		; set all of bits
	PUSH	HL			; push fill byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;3A59:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3A5B:	56
	LD	HL,0008h	;3A5C:	210800
	ADD	HL,DE		;3A5F:	19
	LD	E,(HL)		;3A60:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push count
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3A68:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3A6A:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	JP	LAB_3B7A	;3A72:	C37A3B

LAB_3A75
	LD	HL,0000h		; clear area
	PUSH	HL			; push fill byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;3A7D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3A7F:	56
	LD	HL,0008h	;3A80:	210800
	ADD	HL,DE		;3A83:	19
	LD	E,(HL)		;3A84:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push count
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3A8C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3A8E:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	JP	LAB_3B7A	;3A96:	C37A3B

					; copy 3 bytes from LAB_E302 to #_??
LAB_3A99
	LD	HL,0004h		; 4 bytes to copy
	PUSH	HL			; push byte count
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3AA1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3AA3:	56
	PUSH	DE			; push destination pointer
	LD	HL,LAB_E302		; set source pointer
	PUSH	HL			; push source pointer
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	JP	LAB_3B7A	;3AAF:	C37A3B

					; copy 8 bytes from LAB_E307 to #_??
LAB_3AB2
	LD	HL,0008h		; 8 bytes to copy
	PUSH	HL			; push byte count
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3ABA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3ABC:	56
	PUSH	DE			; push destination pointer
	LD	HL,LAB_E307		; set source pointer
	PUSH	HL			; push source pointer
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	JP	LAB_3B7A	;3AC8:	C37A3B

LAB_3ACB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;3ACF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3AD1:	56
	LD	HL,000Ah	;3AD2:	210A00
	ADD	HL,DE		;3AD5:	19
	LD	E,(HL)		;3AD6:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_3B06	;3ADF:	CA063B

	LD	HL,00FFh	;3AE2:	21FF00
	PUSH	HL			; push fill byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;3AEA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3AEC:	56
	LD	HL,0008h	;3AED:	210800
	ADD	HL,DE		;3AF0:	19
	LD	E,(HL)		;3AF1:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push count
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3AF9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3AFB:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	JP	LAB_3B50	;3B03:	C3503B

LAB_3B06
	LD	HL,0080h		; set fill byte
	PUSH	HL			; push fill byte
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL			; push count
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3B12:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3B14:	56
	LD	HL,0008h	;3B15:	210800
	ADD	HL,DE		;3B18:	19
	LD	E,(HL)		;3B19:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;3B20:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;3B22:	66
	LD	L,A		;3B23:	6F
	ADD	HL,DE		;3B24:	19
	DEC	HL			; -1
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte

	LD	HL,0000h		; clear area
	PUSH	HL			; push fill byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3B35:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3B37:	56
	LD	HL,0008h	;3B38:	210800
	ADD	HL,DE		;3B3B:	19
	LD	E,(HL)		;3B3C:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;3B3F:	EB
	DEC	HL		;3B40:	2B
	PUSH	HL			; push count
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3B46:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3B48:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
LAB_3B50
	JP	LAB_3B7A	;3B50:	C37A3B

LAB_3B53
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0008			; 8 entries

	DW	0001
	DW	LAB_3ACB

	DW	0002
	DW	LAB_3A1C

	DW	0004
	DW	LAB_3A99		; copy 3 bytes from LAB_E302 to #_??

	DW	0008
	DW	LAB_3A40

	DW	0010
	DW	LAB_3A75

	DW	0020
	DW	LAB_3A51

	DW	0040
	DW	LAB_3AB2		; copy 8 bytes from LAB_E307 to #_??

	DW	0080
	DW	LAB_3A1C

	DW	LAB_3B7A

LAB_3B7A
	RET				;

LAB_3B7B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3B85:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3B87:	56
	PUSH	DE		;3B88:	D5
	CALL	LAB_EE70	;3B89:	CD70EE
	POP	DE		;3B8C:	D1
	LD	(LAB_E7B9),HL	;3B8D:	22B9E7
	LD	HL,(LAB_E7B9)	;3B90:	2AB9E7
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3BA4	;3B95:	C2A43B

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3B9C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3B9E:	56
	PUSH	DE		;3B9F:	D5
	CALL	LAB_3987	;3BA0:	CD8739
	POP	DE		;3BA3:	D1
LAB_3BA4
	LD	HL,(LAB_E7B9)	;3BA4:	2AB9E7
	RET				;

; stack is ..
; ??
; ??
; end.

LAB_3BA8
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC45)	;3BAE:	2A45EC
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3BBA	;3BB3:	C2BA3B

	LD	HL,0000h	;3BB6:	210000
	RET				;

LAB_3BBA
	LD	HL,0000h	;3BBA:	210000
	PUSH	HL		;3BBD:	E5
	LD	HL,0040h	;3BBE:	214000
	PUSH	HL		;3BC1:	E5
	LD	HL,LAB_EBFB	;3BC2:	21FBEB
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,LAB_EB57	;3BCC:	2157EB
	LD	(LAB_E7BB),HL	;3BCF:	22BBE7
	LD	HL,0000h	;3BD2:	210000
	LD	(LAB_E7BD),HL	;3BD5:	22BDE7
	JP	LAB_3BF1	;3BD8:	C3F13B
LAB_3BDB
	LD	HL,(LAB_E7BD)	;3BDB:	2ABDE7
	INC	HL		;3BDE:	23
	LD	(LAB_E7BD),HL	;3BDF:	22BDE7
	DEC	HL		;3BE2:	2B
	LD	HL,(LAB_E7BB)	;3BE3:	2ABBE7
	LD	DE,000Ah	;3BE6:	110A00
	ADD	HL,DE		;3BE9:	19
	LD	(LAB_E7BB),HL	;3BEA:	22BBE7
	LD	DE,FFF6h	;3BED:	11F6FF
	ADD	HL,DE		;3BF0:	19
LAB_3BF1
	LD	HL,(LAB_E7BD)	;3BF1:	2ABDE7
	EX	DE,HL		;3BF4:	EB
	LD	HL,(LAB_EC45)	;3BF5:	2A45EC
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_3C18	;3BFB:	CA183C
	LD	HL,0000h	;3BFE:	210000
	PUSH	HL		;3C01:	E5
	LD	HL,(LAB_E7BB)	;3C02:	2ABBE7
	INC	HL		;3C05:	23
	INC	HL		;3C06:	23
	INC	HL		;3C07:	23
	POP	DE		;3C08:	D1
	LD	(HL),E		;3C09:	73
	LD	HL,0000h	;3C0A:	210000
	PUSH	HL		;3C0D:	E5
	LD	HL,(LAB_E7BB)	;3C0E:	2ABBE7
	INC	HL		;3C11:	23
	INC	HL		;3C12:	23
	POP	DE		;3C13:	D1
	LD	(HL),E		;3C14:	73
	JP	LAB_3BDB	;3C15:	C3DB3B
LAB_3C18
	LD	HL,(LAB_EB55)	;3C18:	2A55EB
	PUSH	HL		;3C1B:	E5
	CALL	LAB_36F3		; setup LAB_EB4D, LAB_EC47 & LAB_EB51 for #
	POP	DE		;3C1F:	D1
	LD	HL,(LAB_EB51)	;3C20:	2A51EB
	LD	A,(HL)		;3C23:	7E
	OR	A		;3C24:	B7
	JP	NZ,LAB_3C30	;3C25:	C2303C
	LD	HL,(LAB_EB12)	;3C28:	2A12EB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3C39	;3C2D:	CA393C
LAB_3C30
	LD	HL,0000h	;3C30:	210000
	LD	(LAB_EC3B),HL	;3C33:	223BEC
	JP	LAB_3DC2	;3C36:	C3C23D
LAB_3C39
	LD	HL,LAB_E7C1	;3C39:	21C1E7
	PUSH	HL		;3C3C:	E5
	LD	HL,(LAB_EB51)	;3C3D:	2A51EB
	LD	DE,0006h	;3C40:	110600
	ADD	HL,DE		;3C43:	19
	LD	E,(HL)		;3C44:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3C46:	56
	PUSH	DE		;3C47:	D5
	CALL	LAB_EED0	;3C48:	CDD0EE
	POP	DE		;3C4B:	D1
	POP	DE		;3C4C:	D1
	LD	HL,(LAB_E7C1)	;3C4D:	2AC1E7
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3C6E	;3C52:	C26E3C
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EC3B),HL	;3C58:	223BEC
	LD	HL,(LAB_EB51)	;3C5B:	2A51EB
	LD	DE,0006h	;3C5E:	110600
	ADD	HL,DE		;3C61:	19
	LD	E,(HL)		;3C62:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3C64:	56
	PUSH	DE		;3C65:	D5
	CALL	LAB_3987	;3C66:	CD8739
	POP	DE		;3C69:	D1
	LD	HL,0000h	;3C6A:	210000
	RET				;

LAB_3C6E
	LD	HL,LAB_E7BF	;3C6E:	21BFE7
	PUSH	HL		;3C71:	E5
	LD	HL,(LAB_EB51)	;3C72:	2A51EB
	LD	DE,0006h	;3C75:	110600
	ADD	HL,DE		;3C78:	19
	LD	E,(HL)		;3C79:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3C7B:	56
	PUSH	DE		;3C7C:	D5
	CALL	LAB_EEC8	;3C7D:	CDC8EE
	POP	DE		;3C80:	D1
	POP	DE		;3C81:	D1
	JP	NZ,LAB_3C9A	;3C82:	C29A3C
	LD	HL,(LAB_EB51)	;3C85:	2A51EB
	LD	DE,0006h	;3C88:	110600
	ADD	HL,DE		;3C8B:	19
	LD	E,(HL)		;3C8C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3C8E:	56
	PUSH	DE		;3C8F:	D5
	CALL	LAB_EE6C	;3C90:	CD6CEE
	POP	DE		;3C93:	D1
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E7BF),HL	;3C97:	22BFE7
LAB_3C9A
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3C9E:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;3CA1:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_3CD5	;3CA7:	CAD53C
	LD	HL,(LAB_EB51)	;3CAA:	2A51EB
	LD	DE,0006h	;3CAD:	110600
	ADD	HL,DE		;3CB0:	19
	LD	E,(HL)		;3CB1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3CB3:	56
	PUSH	DE		;3CB4:	D5
	CALL	LAB_EE78	;3CB5:	CD78EE
	POP	DE		;3CB8:	D1
	JP	Z,LAB_3E13	;3CB9:	CA133E
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EC3B),HL	;3CBF:	223BEC
	LD	HL,(LAB_EB51)	;3CC2:	2A51EB
	LD	DE,0006h	;3CC5:	110600
	ADD	HL,DE		;3CC8:	19
	LD	E,(HL)		;3CC9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3CCB:	56
	PUSH	DE		;3CCC:	D5
	CALL	LAB_3987	;3CCD:	CD8739
	POP	DE		;3CD0:	D1
	LD	HL,0000h	;3CD1:	210000
	RET				;

LAB_3CD5
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3CD9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3CDB:	56
	LD	HL,000Ch	;3CDC:	210C00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_3CF5	;3CE2:	C2F53C

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3CE9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3CEB:	56
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_3D26		; jump if DE<>0001

LAB_3CF5
	LD	HL,(LAB_E7BF)	;3CF5:	2ABFE7
	LD	DE,0001h	;3CF8:	110100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_3D04	;3CFE:	CA043D
	JP	LAB_3D26	;3D01:	C3263D
LAB_3D04
	LD	HL,(LAB_EC3B)	;3D04:	2A3BEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3D14	;3D09:	CA143D
	LD	HL,(LAB_EC61)	;3D0C:	2A61EC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3D26	;3D11:	CA263D
LAB_3D14
	LD	HL,(LAB_EB51)	;3D14:	2A51EB
	LD	DE,0006h	;3D17:	110600
	ADD	HL,DE		;3D1A:	19
	LD	E,(HL)		;3D1B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3D1D:	56
	PUSH	DE		;3D1E:	D5
	CALL	LAB_EE80	;3D1F:	CD80EE
	POP	DE		;3D22:	D1
	JP	Z,LAB_3E13	;3D23:	CA133E
LAB_3D26
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3D2A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3D2C:	56
	LD	HL,000Bh	;3D2D:	210B00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_3D46	;3D33:	C2463D
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3D3A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3D3C:	56
	LD	HL,0006h	;3D3D:	210600
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_3D7E	;3D43:	CA7E3D
LAB_3D46
	LD	HL,(LAB_E7BF)	;3D46:	2ABFE7
	EX	DE,HL		;3D49:	EB
	LD	HL,(LAB_E7C1)	;3D4A:	2AC1E7
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
LAB_3D50
	JP	Z,LAB_3D6C	;3D50:	CA6C3D
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EC3B),HL	;3D56:	223BEC
	LD	HL,(LAB_EB51)	;3D59:	2A51EB
	LD	DE,0006h	;3D5C:	110600
	ADD	HL,DE		;3D5F:	19
	LD	E,(HL)		;3D60:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3D62:	56
	PUSH	DE		;3D63:	D5
	CALL	LAB_3987	;3D64:	CD8739
	POP	DE		;3D67:	D1
	LD	HL,0000h	;3D68:	210000
	RET				;

LAB_3D6C
	LD	HL,(LAB_EB51)	;3D6C:	2A51EB
	LD	DE,0006h	;3D6F:	110600
	ADD	HL,DE		;3D72:	19
	LD	E,(HL)		;3D73:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3D75:	56
	PUSH	DE		;3D76:	D5
	CALL	LAB_EE7C	;3D77:	CD7CEE
	POP	DE		;3D7A:	D1
	JP	Z,LAB_3E13	;3D7B:	CA133E
LAB_3D7E
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3D82:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3D84:	56
	LD	HL,0011h	;3D85:	211100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_3DA0	;3D8B:	CAA03D
	LD	HL,(LAB_EB51)	;3D8E:	2A51EB
	LD	DE,0006h	;3D91:	110600
	ADD	HL,DE		;3D94:	19
	LD	E,(HL)		;3D95:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3D97:	56
	PUSH	DE		;3D98:	D5
	CALL	LAB_EE6C	;3D99:	CD6CEE
	POP	DE		;3D9C:	D1
	JP	Z,LAB_3E13	;3D9D:	CA133E
LAB_3DA0
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3DA4:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3DA6:	56
	LD	HL,0012h	;3DA7:	211200
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_3DC2	;3DAD:	CAC23D
	LD	HL,(LAB_EB51)	;3DB0:	2A51EB
	LD	DE,0006h	;3DB3:	110600
	ADD	HL,DE		;3DB6:	19
	LD	E,(HL)		;3DB7:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3DB9:	56
	PUSH	DE		;3DBA:	D5
	CALL	LAB_EE78	;3DBB:	CD78EE
	POP	DE		;3DBE:	D1
	JP	Z,LAB_3E13	;3DBF:	CA133E
LAB_3DC2
	LD	HL,(LAB_EB51)	;3DC2:	2A51EB
	LD	A,(HL)		;3DC5:	7E
	OR	A		;3DC6:	B7
	JP	NZ,LAB_3DF4	;3DC7:	C2F43D
	LD	HL,(LAB_EB51)	;3DCA:	2A51EB
	LD	DE,0006h	;3DCD:	110600
	ADD	HL,DE		;3DD0:	19
	LD	E,(HL)		;3DD1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3DD3:	56
	PUSH	DE		;3DD4:	D5
	CALL	LAB_3B7B	;3DD5:	CD7B3B
	POP	DE		;3DD8:	D1
	JP	Z,LAB_3E13	;3DD9:	CA133E
	LD	HL,0000h	;3DDC:	210000
	LD	(LAB_EC3B),HL	;3DDF:	223BEC
	LD	HL,0000h	;3DE2:	210000
	LD	(LAB_EC61),HL	;3DE5:	2261EC
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;3DEB:	E5
	LD	HL,(LAB_EB51)	;3DEC:	2A51EB
	INC	HL		;3DEF:	23
	INC	HL		;3DF0:	23
	INC	HL		;3DF1:	23
	POP	DE		;3DF2:	D1
	LD	(HL),E		;3DF3:	73
LAB_3DF4
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3DF8:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0010h	;3DFB:	211000
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_3E0F	;3E01:	CA0F3E
	LD	HL,(LAB_EC3B)	;3E04:	2A3BEC
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3E0F	;3E09:	C20F3E
	CALL	LAB_3E24	;3E0C:	CD243E
LAB_3E0F
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_3E13
	LD	HL,E310h	;3E13:	2110E3
	PUSH	HL		;3E16:	E5
	CALL	LAB_EE8C	;3E17:	CD8CEE
	PUSH	HL			; push error #
	CALL	LAB_6602		; display error # & message ??
	POP	DE			; dump error #
	POP	DE			; dump message pointer
	LD	HL,0000h	;3E20:	210000
	RET				;

LAB_3E24
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC53)	;3E2A:	2A53EC
	LD	(LAB_E7C5),HL	;3E2D:	22C5E7
LAB_3E30
	LD	HL,(LAB_E7C5)	;3E30:	2AC5E7
	LD	A,(HL)		;3E33:	7E
	OR	A		;3E34:	B7
	JP	Z,LAB_3E6E	;3E35:	CA6E3E
	LD	HL,(LAB_E7C5)	;3E38:	2AC5E7
	LD	E,(HL)		;3E3B:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;3E3E:	D5
	LD	HL,LAB_E7C3	;3E3F:	21C3E7
	PUSH	HL		;3E42:	E5
	CALL	LAB_3F33	;3E43:	CD333F
	POP	DE		;3E46:	D1
	POP	DE		;3E47:	D1
	LD	HL,(LAB_E7C3)	;3E48:	2AC3E7
	PUSH	HL		;3E4B:	E5
	CALL	LAB_3E72	;3E4C:	CD723E
	POP	DE		;3E4F:	D1
	JP	NZ,LAB_3E64	;3E50:	C2643E
	LD	HL,E311h	;3E53:	2111E3
	PUSH	HL		;3E56:	E5
	CALL	LAB_EE8C	;3E57:	CD8CEE
	PUSH	HL			; push error #
	CALL	LAB_6602		; display error # & message ??
	POP	DE			; dump error #
	POP	DE			; dump message pointer
	LD	HL,0000h	;3E60:	210000
	RET				;

LAB_3E64
	LD	HL,(LAB_E7C5)	;3E64:	2AC5E7
	INC	HL		;3E67:	23
	LD	(LAB_E7C5),HL	;3E68:	22C5E7
	JP	LAB_3E30	;3E6B:	C3303E
LAB_3E6E
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_3E72
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3E7C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3E7E:	56
	PUSH	DE		;3E7F:	D5
	CALL	LAB_EEB4	;3E80:	CDB4EE
	POP	DE		;3E83:	D1
	JP	NZ,LAB_3F2F	;3E84:	C22F3F
	LD	HL,LAB_E7C9	;3E87:	21C9E7
	PUSH	HL		;3E8A:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3E8F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3E91:	56
	PUSH	DE		;3E92:	D5
	CALL	LAB_EE9C	;3E93:	CD9CEE
	POP	DE		;3E96:	D1
	POP	DE		;3E97:	D1
	JP	Z,LAB_3F2F	;3E98:	CA2F3F

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3E9F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3EA1:	56
	EX	DE,HL		;3EA2:	EB
	INC	HL		;3EA3:	23
	PUSH	HL		;3EA4:	E5
	CALL	LAB_EEB8	;3EA5:	CDB8EE
	POP	DE		;3EA8:	D1
	JP	Z,LAB_3EB7	;3EA9:	CAB73E
	LD	HL,(LAB_E7C9)	;3EAC:	2AC9E7
	PUSH	HL		;3EAF:	E5
	CALL	LAB_3987	;3EB0:	CD8739
	POP	DE		;3EB3:	D1
	JP	LAB_3F2F	;3EB4:	C32F3F
LAB_3EB7
	LD	HL,LAB_EB57	;3EB7:	2157EB
	LD	(LAB_E7C7),HL	;3EBA:	22C7E7
	LD	HL,0000h	;3EBD:	210000
	LD	(LAB_E7CB),HL	;3EC0:	22CBE7
	JP	LAB_3EDC	;3EC3:	C3DC3E
LAB_3EC6
	LD	HL,(LAB_E7CB)	;3EC6:	2ACBE7
	INC	HL		;3EC9:	23
	LD	(LAB_E7CB),HL	;3ECA:	22CBE7
	DEC	HL		;3ECD:	2B
	LD	HL,(LAB_E7C7)	;3ECE:	2AC7E7
	LD	DE,000Ah	;3ED1:	110A00
	ADD	HL,DE		;3ED4:	19
	LD	(LAB_E7C7),HL	;3ED5:	22C7E7
	LD	DE,FFF6h	;3ED8:	11F6FF
	ADD	HL,DE		;3EDB:	19
LAB_3EDC
	LD	HL,(LAB_E7CB)	;3EDC:	2ACBE7
	EX	DE,HL		;3EDF:	EB
	LD	HL,(LAB_EC45)	;3EE0:	2A45EC
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_3F2F	;3EE6:	CA2F3F
	LD	HL,(LAB_E7C7)	;3EE9:	2AC7E7
	LD	DE,0006h	;3EEC:	110600
	ADD	HL,DE		;3EEF:	19
	LD	E,(HL)		;3EF0:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3EF2:	56
	PUSH	DE		;3EF3:	D5
	LD	HL,(LAB_E7C9)	;3EF4:	2AC9E7
	POP	DE		;3EF7:	D1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_3F2C	;3EFB:	CA2C3F

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3F02:	5E
	INC	HL		;3F03:	23
	LD	D,(HL)		;3F04:	56
	PUSH	DE		;3F05:	D5
	CALL	LAB_EE88	;3F06:	CD88EE
	POP	DE		;3F09:	D1
	JP	NZ,LAB_3F11	;3F0A:	C2113F
	LD	HL,0000h	;3F0D:	210000
	RET				;

LAB_3F11
	LD	HL,(LAB_E7C9)	;3F11:	2AC9E7
	PUSH	HL		;3F14:	E5
	CALL	LAB_3B7B	;3F15:	CD7B3B
	POP	DE		;3F18:	D1
	JP	NZ,LAB_3F20	;3F19:	C2203F
	LD	HL,0000h	;3F1C:	210000
	RET				;

LAB_3F20
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;3F23:	E5
	LD	HL,(LAB_E7C7)	;3F24:	2AC7E7
	INC	HL		;3F27:	23
	INC	HL		;3F28:	23
	INC	HL		;3F29:	23
	POP	DE		;3F2A:	D1
	LD	(HL),E		;3F2B:	73
LAB_3F2C
	JP	LAB_3EC6	;3F2C:	C3C63E
LAB_3F2F
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_3F33
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,LAB_EB57	;3F39:	2157EB
	LD	(LAB_E7CD),HL	;3F3C:	22CDE7
	LD	HL,(LAB_E7CD)	;3F3F:	2ACDE7
	LD	DE,0004h	;3F42:	110400
	ADD	HL,DE		;3F45:	19
	LD	E,(HL)		;3F46:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3F48:	56
	EX	DE,HL		;3F49:	EB
	LD	(LAB_E7CF),HL	;3F4A:	22CFE7
LAB_3F4D
	LD	HL,(LAB_E7CF)	;3F4D:	2ACFE7
	INC	HL		;3F50:	23
	LD	E,(HL)		;3F51:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;3F54:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3F59:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3F5B:	56
	EX	DE,HL		;3F5C:	EB
	DEC	HL		;3F5D:	2B
	POP	DE		;3F5E:	D1
	EX	DE,HL		;3F5F:	EB
	CALL	LAB_E0D9		; does CP DE,HL, returns HL=1 if HL<=DE (LAB_7C14 ROM 1)
	JP	Z,LAB_3F9A	;3F63:	CA9A3F
	LD	HL,(LAB_E7CF)	;3F66:	2ACFE7
	INC	HL		;3F69:	23
	LD	E,(HL)		;3F6A:	5E
	LD	D,#00h		; clear high byte
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;3F71:	E5
	LD	A,(HL)		;3F72:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;3F74:	66
	LD	L,A		;3F75:	6F
	EX	DE,HL		;3F76:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	EX	DE,HL		;3F7A:	EB
	POP	HL		;3F7B:	E1
	LD	(HL),E		;3F7C:	73
	INC	HL			; increment pointer
	LD	(HL),D		;3F7E:	72
	LD	HL,(LAB_E7CD)	;3F7F:	2ACDE7
	LD	DE,000Ah	;3F82:	110A00
	ADD	HL,DE		;3F85:	19
	LD	(LAB_E7CD),HL	;3F86:	22CDE7
	LD	HL,(LAB_E7CD)	;3F89:	2ACDE7
	LD	DE,0004h	;3F8C:	110400
	ADD	HL,DE		;3F8F:	19
	LD	E,(HL)		;3F90:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3F92:	56
	EX	DE,HL		;3F93:	EB
	LD	(LAB_E7CF),HL	;3F94:	22CFE7
	JP	LAB_3F4D	;3F97:	C34D3F
LAB_3F9A
	LD	HL,(LAB_E7CD)	;3F9A:	2ACDE7
	LD	DE,0008h	;3F9D:	110800
	ADD	HL,DE		;3FA0:	19
	LD	E,(HL)		;3FA1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3FA3:	56
	PUSH	DE		;3FA4:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3FA9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3FAB:	56
	EX	DE,HL		;3FAC:	EB
	DEC	HL		;3FAD:	2B
	ADD	HL,HL		;3FAE:	29
	ADD	HL,HL		;3FAF:	29
	EX	DE,HL		;3FB0:	EB
	LD	HL,(LAB_E7CF)	;3FB1:	2ACFE7
	ADD	HL,DE		;3FB4:	19
	INC	HL		;3FB5:	23
	INC	HL		;3FB6:	23
	INC	HL		;3FB7:	23
	LD	E,(HL)		;3FB8:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;3FBB:	E1
	ADD	HL,DE		;3FBC:	19
	PUSH	HL		;3FBD:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3FC2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3FC4:	56
	EX	DE,HL		;3FC5:	EB
	POP	DE		;3FC6:	D1
	LD	(HL),E		;3FC7:	73
	INC	HL			; increment pointer
	LD	(HL),D		;3FC9:	72
	RET				;

LAB_3FCB
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EB00)	;3FD1:	2A00EB
	LD	DE,F168h	;3FD4:	1168F1
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_3FE5	;3FDA:	CAE53F
	LD	HL,(LAB_EC61)	;3FDD:	2A61EC
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3FEB	;3FE2:	C2EB3F
LAB_3FE5
	LD	HL,0000h	;3FE5:	210000
	JP	LAB_3FEE	;3FE8:	C3EE3F
LAB_3FEB
	LD	HL,0001h		; set HL = 0001h
LAB_3FEE
	LD	A,L		;3FEE:	7D
	LD	(LAB_E7D2),A	;3FEF:	32D2E7
	LD	HL,LAB_EB57	;3FF2:	2157EB
	LD	(LAB_E7D3),HL	;3FF5:	22D3E7
	LD	HL,0000h	;3FF8:	210000
	LD	A,L		;3FFB:	7D
	LD	(LAB_E7D1),A	;3FFC:	32D1E7
	JP	LAB_401A	;3FFF:	C31A40
LAB_4002
	LD	A,(LAB_E7D1)	;4002:	3AD1E7
	LD	L,A		;4005:	6F
	INC	HL		;4006:	23
	LD	A,L		;4007:	7D
	LD	(LAB_E7D1),A	;4008:	32D1E7
	DEC	HL		;400B:	2B
	LD	HL,(LAB_E7D3)	;400C:	2AD3E7
	LD	DE,000Ah	;400F:	110A00
	ADD	HL,DE		;4012:	19
	LD	(LAB_E7D3),HL	;4013:	22D3E7
	LD	DE,FFF6h	;4016:	11F6FF
	ADD	HL,DE		;4019:	19
LAB_401A
	LD	A,(LAB_E7D1)	;401A:	3AD1E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	EX	DE,HL		;4020:	EB
	LD	HL,(LAB_EC45)	;4021:	2A45EC
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_408D	;4027:	CA8D40
	LD	HL,(LAB_E7D3)	;402A:	2AD3E7
	LD	A,(HL)		;402D:	7E
	OR	A		;402E:	B7
	JP	NZ,LAB_408A	;402F:	C28A40
	LD	HL,(LAB_E7D3)	;4032:	2AD3E7
	INC	HL		;4035:	23
	INC	HL		;4036:	23
	LD	A,(HL)		;4037:	7E
	OR	A		;4038:	B7
	JP	NZ,LAB_4043	;4039:	C24340
	LD	A,(LAB_E7D2)	;403C:	3AD2E7
	OR	A		;403F:	B7
	JP	Z,LAB_408A	;4040:	CA8A40
LAB_4043
	LD	HL,(LAB_EC3B)	;4043:	2A3BEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_406D	;4048:	CA6D40
	LD	HL,(LAB_E7D3)	;404B:	2AD3E7
	EX	DE,HL		;404E:	EB
	LD	HL,(LAB_EB53)	;404F:	2A53EB
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_406A	;4055:	CA6A40
	LD	HL,(LAB_E7D3)	;4058:	2AD3E7
	LD	DE,0006h	;405B:	110600
	ADD	HL,DE		;405E:	19
	LD	E,(HL)		;405F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4061:	56
	PUSH	DE		;4062:	D5
	CALL	LAB_EE64	;4063:	CD64EE
	POP	DE		;4066:	D1
	JP	Z,LAB_4091	;4067:	CA9140
LAB_406A
	JP	LAB_408A	;406A:	C38A40
LAB_406D
	LD	HL,(LAB_E7D3)	;406D:	2AD3E7
	INC	HL		;4070:	23
	INC	HL		;4071:	23
	INC	HL		;4072:	23
	LD	A,(HL)		;4073:	7E
	OR	A		;4074:	B7
	JP	Z,LAB_408A	;4075:	CA8A40
	LD	HL,(LAB_E7D3)	;4078:	2AD3E7
	LD	DE,0006h	;407B:	110600
	ADD	HL,DE		;407E:	19
	LD	E,(HL)		;407F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4081:	56
	PUSH	DE		;4082:	D5
	CALL	LAB_EE84	;4083:	CD84EE
	POP	DE		;4086:	D1
	JP	Z,LAB_4091	;4087:	CA9140
LAB_408A
	JP	LAB_4002	;408A:	C30240
LAB_408D
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_4091
	LD	HL,E312h	;4091:	2112E3
	PUSH	HL		;4094:	E5
	CALL	LAB_EE8C	;4095:	CD8CEE
	PUSH	HL			; push error #
	CALL	LAB_6602		; display error # & message ??
	POP	DE			; dump error #
	POP	DE			; dump message pointer
	LD	HL,0000h	;409E:	210000
	RET				;

LAB_40A2
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EB12)	;40A8:	2A12EB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_40BD	;40AD:	C2BD40

	LD	HL,(LAB_EB10)	;40B0:	2A10EB
	PUSH	HL		;40B3:	E5
	LD	HL,(LAB_EC41)	;40B4:	2A41EC
	PUSH	HL		;40B7:	E5
	CALL	LAB_3BA8	;40B8:	CDA83B
	POP	DE		;40BB:	D1
	POP	DE		;40BC:	D1
LAB_40BD
	LD	HL,0000h	;40BD:	210000
	LD	(LAB_EC61),HL	;40C0:	2261EC
	RET				;

LAB_40C4
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC5B)	;40CA:	2A5BEC
	LD	(LAB_E7D7),HL	;40CD:	22D7E7
	LD	HL,(LAB_EB10)	;40D0:	2A10EB
	LD	DE,0001h	;40D3:	110100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_40E8	;40D9:	CAE840
	LD	HL,(LAB_EC49)	;40DC:	2A49EC
	LD	DE,000Ch	;40DF:	110C00
	ADD	HL,DE		;40E2:	19
	LD	A,(HL)		;40E3:	7E
	OR	A		;40E4:	B7
	JP	NZ,LAB_40EE	;40E5:	C2EE40
LAB_40E8
	LD	HL,0000h	;40E8:	210000
	JP	LAB_40F1	;40EB:	C3F140
LAB_40EE
	LD	HL,0001h		; set HL = 0001h
LAB_40F1
	LD	(LAB_E7D5),HL	;40F1:	22D5E7
	LD	HL,(LAB_E7D5)	;40F4:	2AD5E7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_411A	;40F9:	CA1A41

	LD	HL,(LAB_EC41)	;40FC:	2A41EC
	LD	DE,0011h	;40FF:	111100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_4114	;4105:	C21441
	LD	HL,(LAB_EC41)	;4108:	2A41EC
	LD	DE,0012h	;410B:	111200
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_411A	;4111:	CA1A41
LAB_4114
	CALL	LAB_2659	;4114:	CD5926
	JP	LAB_4127	;4117:	C32741
LAB_411A
	LD	HL,(LAB_EC4D)	;411A:	2A4DEC
	PUSH	HL		;411D:	E5
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;4121:	E5
	CALL	LAB_1B0A	;4122:	CD0A1B
	POP	DE		;4125:	D1
	POP	DE		;4126:	D1
LAB_4127
	LD	HL,(LAB_EB1E)	;4127:	2A1EEB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_418D	;412C:	CA8D41

	LD	HL,(LAB_EB3D)	;412F:	2A3DEB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4148	;4134:	CA4841

	LD	HL,(LAB_EB3D)	;4137:	2A3DEB
	PUSH	HL		;413A:	E5
	CALL	LAB_2CD3	;413B:	CDD32C
	POP	DE		;413E:	D1
	LD	HL,0000h	;413F:	210000
	LD	(LAB_EB3D),HL	;4142:	223DEB
	JP	LAB_418D	;4145:	C38D41
LAB_4148
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;414B:	E5
	CALL	LAB_41D5	;414C:	CDD541
	POP	DE		;414F:	D1
	LD	HL,(LAB_EC41)	;4150:	2A41EC
	LD	DE,0006h	;4153:	110600
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_418D	;4159:	CA8D41
	LD	HL,(LAB_EC41)	;415C:	2A41EC
	LD	DE,0001h	;415F:	110100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_4179	;4165:	CA7941
LAB_4168
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;416B:	E5
	CALL	LAB_4281	;416C:	CD8142
	POP	DE		;416F:	D1
	JP	Z,LAB_4176	;4170:	CA7641
	JP	LAB_4168	;4173:	C36841
LAB_4176
	JP	LAB_418D	;4176:	C38D41
LAB_4179
	LD	HL,(LAB_EC49)	;4179:	2A49EC
	LD	DE,000Ch	;417C:	110C00
	ADD	HL,DE		;417F:	19
	LD	A,(HL)		;4180:	7E
	OR	A		;4181:	B7
	JP	Z,LAB_418D	;4182:	CA8D41
	LD	HL,(LAB_E7D7)	;4185:	2AD7E7
	PUSH	HL		;4188:	E5
	CALL	LAB_418E	;4189:	CD8E41
	POP	DE		;418C:	D1
LAB_418D
	RET				;

LAB_418E
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EB1E)	;4194:	2A1EEB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_41D4	;4199:	CAD441

	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;419F:	E5
	CALL	LAB_41D5	;41A0:	CDD541
	POP	DE		;41A3:	D1
LAB_41A4
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;41A8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;41AA:	56
	LD	HL,(LAB_EC5B)	;41AB:	2A5BEC
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_41C3	;41B1:	CAC341
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;41B7:	E5
	CALL	LAB_4281	;41B8:	CD8142
	POP	DE		;41BB:	D1
	JP	NZ,LAB_41C0	;41BC:	C2C041
	RET				;

LAB_41C0
	JP	LAB_41A4	;41C0:	C3A441
LAB_41C3
	LD	HL,(LAB_EB16)	;41C3:	2A16EB
	LD	E,(HL)		;41C6:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0002h	;41C9:	210200
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL		;41CF:	E5
	CALL	LAB_444F	;41D0:	CD4F44
	POP	DE		;41D3:	D1
LAB_41D4
	RET				;

LAB_41D5
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC4D)	;41DB:	2A4DEC
	LD	(LAB_EB16),HL	;41DE:	2216EB
	LD	HL,0000h	;41E1:	210000
	LD	(LAB_EB06),HL	;41E4:	2206EB
	LD	HL,0000h	;41E7:	210000
	LD	A,L		;41EA:	7D
	LD	(LAB_E7D9),A	;41EB:	32D9E7
	JP	LAB_41FA	;41EE:	C3FA41
LAB_41F1
	LD	A,(LAB_E7D9)	;41F1:	3AD9E7
	LD	L,A		;41F4:	6F
	INC	HL		;41F5:	23
	LD	A,L		;41F6:	7D
	LD	(LAB_E7D9),A	;41F7:	32D9E7
LAB_41FA
	LD	A,(LAB_E7D9)	;41FA:	3AD9E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	EX	DE,HL		;4200:	EB
	LD	HL,(LAB_EC45)	;4201:	2A45EC
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_427D	;4207:	CA7D42
	LD	A,(LAB_E7D9)	;420A:	3AD9E7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;4210:	E5
	CALL	LAB_36F3		; setup LAB_EB4D, LAB_EC47 & LAB_EB51 for #
	POP	DE		;4214:	D1
	LD	HL,0000h	;4215:	210000
	LD	A,L		;4218:	7D
	LD	(LAB_E7DA),A	;4219:	32DAE7
	JP	LAB_4239	;421C:	C33942
LAB_421F
	LD	A,(LAB_E7DA)	;421F:	3ADAE7
	LD	L,A		;4222:	6F
	INC	HL		;4223:	23
	LD	A,L		;4224:	7D
	LD	(LAB_E7DA),A	;4225:	32DAE7
	DEC	HL		;4228:	2B
	LD	HL,(LAB_EB16)	;4229:	2A16EB
	INC	HL		;422C:	23
	LD	(LAB_EB16),HL	;422D:	2216EB
	DEC	HL		;4230:	2B
	LD	HL,(LAB_EB06)	;4231:	2A06EB
	INC	HL		;4234:	23
	LD	(LAB_EB06),HL	;4235:	2206EB
	DEC	HL		;4238:	2B
LAB_4239
	LD	HL,(LAB_EC47)	;4239:	2A47EC
	INC	HL		;423C:	23
	LD	E,(HL)		;423D:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4240:	D5
	LD	A,(LAB_E7DA)	;4241:	3ADAE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;4247:	D1
	EX	DE,HL		;4248:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_427A	;424C:	CA7A42
	LD	HL,(LAB_EB16)	;424F:	2A16EB
	LD	E,(HL)		;4252:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_4268	;425B:	C26842

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;4262:	7E
	INC	HL			; increment pointer
	OR	(HL)		;4264:	B6
	JP	NZ,LAB_4277	;4265:	C27742
LAB_4268
	LD	A,(LAB_E7DA)	;4268:	3ADAE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;426E:	E5
	CALL	LAB_3732	;426F:	CD3237
	POP	DE		;4272:	D1
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_4277
	JP	LAB_421F	;4277:	C31F42
LAB_427A
	JP	LAB_41F1	;427A:	C3F141
LAB_427D
	LD	HL,0000h	;427D:	210000
	RET				;

; stack is
; ??	(word)
; end.

LAB_4281
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		; get low byte
	INC	HL			; increment pointer
	OR	(HL)			; OR high byte
	JP	Z,LAB_429D		; jump if word=0000h

	LD	HL,(LAB_EB1E)	;4291:	2A1EEB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_429D		; jump if not 0000h

	LD	HL,0000h		; clear HL
	RET				;

LAB_429D
	LD	HL,(LAB_EB4D)	;429D:	2A4DEB
	LD	(LAB_E7DF),HL	;42A0:	22DFE7
	LD	HL,(LAB_EB0E)	;42A3:	2A0EEB
	LD	(LAB_E7E1),HL	;42A6:	22E1E7
	LD	HL,(LAB_EB16)	;42A9:	2A16EB
	LD	(LAB_E7E5),HL	;42AC:	22E5E7
	LD	HL,(LAB_EB06)	;42AF:	2A06EB
	LD	(LAB_E7E3),HL	;42B2:	22E3E7
	LD	HL,(LAB_EB4D)	;42B5:	2A4DEB
	LD	(LAB_E7DB),HL	;42B8:	22DBE7
LAB_42BB
	LD	HL,(LAB_E7DB)	;42BB:	2ADBE7
	EX	DE,HL		;42BE:	EB
	LD	HL,(LAB_EC45)	;42BF:	2A45EC
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_4347	;42C5:	CA4743
	LD	HL,(LAB_EB0E)	;42C8:	2A0EEB
	INC	HL		;42CB:	23
	LD	(LAB_EB0E),HL	;42CC:	220EEB
	LD	(LAB_E7DD),HL	;42CF:	22DDE7
	JP	LAB_42DC	;42D2:	C3DC42
LAB_42D5
	LD	HL,(LAB_E7DD)	;42D5:	2ADDE7
	INC	HL		;42D8:	23
	LD	(LAB_E7DD),HL	;42D9:	22DDE7
LAB_42DC
	LD	HL,(LAB_EC47)	;42DC:	2A47EC
	INC	HL		;42DF:	23
	LD	E,(HL)		;42E0:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;42E3:	D5
	LD	HL,(LAB_E7DD)	;42E4:	2ADDE7
	POP	DE		;42E7:	D1
	EX	DE,HL		;42E8:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_4325	;42EC:	CA2543
	LD	HL,(LAB_EB16)	;42EF:	2A16EB
	INC	HL		;42F2:	23
	LD	(LAB_EB16),HL	;42F3:	2216EB
	LD	HL,(LAB_EB06)	;42F6:	2A06EB
	INC	HL		;42F9:	23
	LD	(LAB_EB06),HL	;42FA:	2206EB
	LD	HL,(LAB_EB16)	;42FD:	2A16EB
	LD	E,(HL)		;4300:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_4316	;4309:	C21643
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;4310:	7E
	INC	HL			; increment pointer
	OR	(HL)		;4312:	B6
	JP	NZ,LAB_4322	;4313:	C22243
LAB_4316
	LD	HL,(LAB_E7DD)	;4316:	2ADDE7
	PUSH	HL		;4319:	E5
	CALL	LAB_3732	;431A:	CD3237
	POP	DE		;431D:	D1
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_4322
	JP	LAB_42D5	;4322:	C3D542
LAB_4325
	LD	HL,(LAB_E7DB)	;4325:	2ADBE7
	INC	HL		;4328:	23
	LD	(LAB_E7DB),HL	;4329:	22DBE7
	EX	DE,HL		;432C:	EB
	LD	HL,(LAB_EC45)	;432D:	2A45EC
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_4344	;4333:	CA4443
	LD	HL,(LAB_E7DB)	;4336:	2ADBE7
	PUSH	HL		;4339:	E5
	CALL	LAB_36F3		; setup LAB_EB4D, LAB_EC47 & LAB_EB51 for #
	POP	DE		;433D:	D1
	LD	HL,FFFFh	;433E:	21FFFF
	LD	(LAB_EB0E),HL	;4341:	220EEB
LAB_4344
	JP	LAB_42BB	;4344:	C3BB42
LAB_4347
	LD	HL,(LAB_E7DF)	;4347:	2ADFE7
	PUSH	HL		;434A:	E5
	CALL	LAB_36F3		; setup LAB_EB4D, LAB_EC47 & LAB_EB51 for #
	POP	DE		;434E:	D1
	LD	HL,(LAB_E7E1)	;434F:	2AE1E7
	PUSH	HL		;4352:	E5
	CALL	LAB_3732	;4353:	CD3237
	POP	DE		;4356:	D1
	LD	HL,(LAB_E7E5)	;4357:	2AE5E7
	LD	(LAB_EB16),HL	;435A:	2216EB
	LD	HL,(LAB_E7E3)	;435D:	2AE3E7
	LD	(LAB_EB06),HL	;4360:	2206EB
	LD	HL,0000h	;4363:	210000
	RET				;

LAB_4367
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;4371:	7E
	INC	HL			; increment pointer
	OR	(HL)		;4373:	B6
	JP	Z,LAB_4383	;4374:	CA8343
	LD	HL,(LAB_EB1E)	;4377:	2A1EEB
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4383	;437C:	C28343

	LD	HL,0000h	;437F:	210000
	RET				;

LAB_4383
	LD	HL,(LAB_EB4D)	;4383:	2A4DEB
	LD	(LAB_E7EB),HL	;4386:	22EBE7
	LD	HL,(LAB_EB0E)	;4389:	2A0EEB
	LD	(LAB_E7ED),HL	;438C:	22EDE7
	LD	HL,(LAB_EB16)	;438F:	2A16EB
	LD	(LAB_E7F1),HL	;4392:	22F1E7
	LD	HL,(LAB_EB06)	;4395:	2A06EB
	LD	(LAB_E7EF),HL	;4398:	22EFE7
	LD	HL,(LAB_EB4D)	;439B:	2A4DEB
	LD	(LAB_E7E7),HL	;439E:	22E7E7
LAB_43A1
	LD	HL,(LAB_E7E7)	;43A1:	2AE7E7
	LD	DE,0000h	;43A4:	110000
	EX	DE,HL		;43A7:	EB
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_442F	;43AB:	CA2F44
	LD	HL,(LAB_EB0E)	;43AE:	2A0EEB
	DEC	HL		;43B1:	2B
	LD	(LAB_EB0E),HL	;43B2:	220EEB
	LD	(LAB_E7E9),HL	;43B5:	22E9E7
	JP	LAB_43C2	;43B8:	C3C243
LAB_43BB
	LD	HL,(LAB_E7E9)	;43BB:	2AE9E7
	DEC	HL		;43BE:	2B
	LD	(LAB_E7E9),HL	;43BF:	22E9E7
LAB_43C2
	LD	HL,(LAB_E7E9)	;43C2:	2AE9E7
	LD	DE,0000h	;43C5:	110000
	EX	DE,HL		;43C8:	EB
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_4405	;43CC:	CA0544
	LD	HL,(LAB_EB16)	;43CF:	2A16EB
	DEC	HL		;43D2:	2B
	LD	(LAB_EB16),HL	;43D3:	2216EB
	LD	HL,(LAB_EB06)	;43D6:	2A06EB
	DEC	HL		;43D9:	2B
	LD	(LAB_EB06),HL	;43DA:	2206EB
	LD	HL,(LAB_EB16)	;43DD:	2A16EB
	LD	E,(HL)		;43E0:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_43F6	;43E9:	C2F643
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;43F0:	7E
	INC	HL			; increment pointer
	OR	(HL)		;43F2:	B6
	JP	NZ,LAB_4402	;43F3:	C20244
LAB_43F6
	LD	HL,(LAB_E7E9)	;43F6:	2AE9E7
	PUSH	HL		;43F9:	E5
	CALL	LAB_3732	;43FA:	CD3237
	POP	DE		;43FD:	D1
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_4402
	JP	LAB_43BB	;4402:	C3BB43
LAB_4405
	LD	HL,(LAB_E7E7)	;4405:	2AE7E7
	DEC	HL		;4408:	2B
	LD	(LAB_E7E7),HL	;4409:	22E7E7
	LD	HL,(LAB_E7E7)	;440C:	2AE7E7
	LD	DE,0000h	;440F:	110000
	EX	DE,HL		;4412:	EB
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_442C	;4416:	CA2C44
	LD	HL,(LAB_E7E7)	;4419:	2AE7E7
	PUSH	HL		;441C:	E5
	CALL	LAB_36F3		; setup LAB_EB4D, LAB_EC47 & LAB_EB51 for #
	POP	DE		;4420:	D1
	LD	HL,(LAB_EC47)	;4421:	2A47EC
	INC	HL		;4424:	23
	LD	E,(HL)		;4425:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;4428:	EB
	LD	(LAB_EB0E),HL	;4429:	220EEB
LAB_442C
	JP	LAB_43A1	;442C:	C3A143
LAB_442F
	LD	HL,(LAB_E7EB)	;442F:	2AEBE7
	PUSH	HL		;4432:	E5
	CALL	LAB_36F3		; setup LAB_EB4D, LAB_EC47 & LAB_EB51 for #
	POP	DE		;4436:	D1
	LD	HL,(LAB_E7ED)	;4437:	2AEDE7
	PUSH	HL		;443A:	E5
	CALL	LAB_3732	;443B:	CD3237
	POP	DE		;443E:	D1
	LD	HL,(LAB_E7F1)	;443F:	2AF1E7
	LD	(LAB_EB16),HL	;4442:	2216EB
	LD	HL,(LAB_E7EF)	;4445:	2AEFE7
	LD	(LAB_EB06),HL	;4448:	2206EB
	LD	HL,0000h	;444B:	210000
	RET				;

LAB_444F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EC6B)	;4455:	2A6BEC
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4474	;445A:	C27444

	LD	HL,(LAB_EB16)	;445D:	2A16EB
	LD	E,(HL)		;4460:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_4474	;4469:	CA7444
	LD	HL,(LAB_EC4D)	;446C:	2A4DEC
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_447A	;4471:	C27A44

LAB_4474
	LD	HL,0000h	;4474:	210000
	JP	LAB_447D	;4477:	C37D44
LAB_447A
	LD	HL,0001h		; set HL = 0001h
LAB_447D
	LD	A,L		;447D:	7D
	LD	(LAB_E7F3),A	;447E:	32F3E7
	LD	HL,(LAB_EB16)	;4481:	2A16EB
	LD	E,(HL)		;4484:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0002h	;4487:	210200
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_449E	;448D:	C29E44
	LD	HL,(LAB_EC4D)	;4490:	2A4DEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_449E	;4495:	CA9E44

	LD	HL,0000h	;4498:	210000
	JP	LAB_44A1	;449B:	C3A144
LAB_449E
	LD	HL,0001h		; set HL = 0001h
LAB_44A1
	LD	A,L		;44A1:	7D
	LD	(LAB_E7F4),A	;44A2:	32F4E7
	LD	HL,(LAB_EB55)	;44A5:	2A55EB
	EX	DE,HL		;44A8:	EB
	LD	HL,(LAB_EB4D)	;44A9:	2A4DEB
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	LD	A,L		;44AF:	7D
	LD	(LAB_E7F5),A	;44B0:	32F5E7
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;44B7:	7E
	OR	A		;44B8:	B7
	JP	Z,LAB_44E7	;44B9:	CAE744
	LD	A,(LAB_E7F3)	;44BC:	3AF3E7
	OR	A		;44BF:	B7
	JP	NZ,LAB_44CA	;44C0:	C2CA44
	LD	A,(LAB_E7F5)	;44C3:	3AF5E7
	OR	A		;44C6:	B7
	JP	Z,LAB_44E1	;44C7:	CAE144
LAB_44CA
	LD	A,(LAB_E7F4)	;44CA:	3AF4E7
	OR	A		;44CD:	B7
	JP	Z,LAB_44D9	;44CE:	CAD944
	LD	HL,(LAB_EC3B)	;44D1:	2A3BEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_44E1	;44D6:	CAE144

LAB_44D9
	LD	HL,(LAB_EC43)	;44D9:	2A43EC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_44E7	;44DE:	CAE744

LAB_44E1
	LD	HL,0000h	;44E1:	210000
	JP	LAB_44EA	;44E4:	C3EA44
LAB_44E7
	LD	HL,0001h		; set HL = 0001h
LAB_44EA
	LD	A,L		;44EA:	7D
	LD	(LAB_E7F6),A	;44EB:	32F6E7
	LD	A,(LAB_E7F3)	;44EE:	3AF3E7
	OR	A		;44F1:	B7
	JP	Z,LAB_4500	;44F2:	CA0045
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;44F8:	E5
	CALL	LAB_35D8	;44F9:	CDD835
	POP	DE		;44FC:	D1
	JP	LAB_4508	;44FD:	C30845
LAB_4500
	LD	HL,0000h	;4500:	210000
	PUSH	HL		;4503:	E5
	CALL	LAB_35D8	;4504:	CDD835
	POP	DE		;4507:	D1
LAB_4508
	LD	HL,(LAB_EC5B)	;4508:	2A5BEC
	INC	HL		;450B:	23
	INC	HL		;450C:	23
	LD	E,(HL)		;450D:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0018h	;4510:	211800
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_453B	;4516:	CA3B45
	LD	HL,002Ah		; set byte "*"
	PUSH	HL			; push byte
	LD	HL,0018h		; set count
	PUSH	HL			; push count
	LD	HL,LAB_EB20		; set destination
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,LAB_E313		; set message pointer
	PUSH	HL			; push message pointer
	LD	HL,03EAh		; set error #
	PUSH	HL			; push error #
	CALL	LAB_6602		; display error # & message ??
	POP	DE			; dump error #
	POP	DE			; dump message pointer
	JP	LAB_462F	;4538:	C32F46
LAB_453B
	LD	A,(LAB_E7F6)	;453B:	3AF6E7
	OR	A		;453E:	B7
	JP	Z,LAB_4568	;453F:	CA6845
	LD	HL,(LAB_EB06)	;4542:	2A06EB
	LD	DE,EBFBh	;4545:	11FBEB
	ADD	HL,DE		;4548:	19
	LD	A,(HL)		;4549:	7E
	OR	A		;454A:	B7
	JP	NZ,LAB_4568	;454B:	C26845

	LD	HL,0020h		; set byte " "
	PUSH	HL			; push byte
	LD	HL,(LAB_EC5B)	;4552:	2A5BEC
	INC	HL		;4555:	23
	INC	HL		;4556:	23
	LD	E,(HL)		; get count
	LD	D,#00h		; clear high byte
	PUSH	HL			; push count
	LD	HL,LAB_EB20		; set destination
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	JP	LAB_462F	;4565:	C32F46

LAB_4568
	LD	HL,E7F9h	;4568:	21F9E7
	LD	(LAB_E7F7),HL	;456B:	22F7E7
	LD	HL,0000h	;456E:	210000
	LD	A,L		;4571:	7D
	LD	(LAB_E7FB),A	;4572:	32FBE7
	LD	HL,(LAB_EC5B)	;4575:	2A5BEC
	INC	HL		;4578:	23
	INC	HL		;4579:	23
	INC	HL		;457A:	23
	LD	E,(HL)		;457B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;457D:	56
	LD	HL,006Eh	;457E:	216E00
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	LAB_45D1	;4584:	C3D145

LAB_4587
	LD	HL,LAB_EE50	;4587:	2150EE
	LD	(LAB_E7FC),HL	;458A:	22FCE7
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;4590:	7D
	LD	(LAB_E7FB),A	;4591:	32FBE7
	JP	LAB_45EC	;4594:	C3EC45

LAB_4597
	LD	HL,LAB_EEC8	;4597:	21C8EE
	LD	(LAB_E7FC),HL	;459A:	22FCE7
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;45A0:	7D
	LD	(LAB_E7FB),A	;45A1:	32FBE7
	JP	LAB_45EC	;45A4:	C3EC45

LAB_45A7
	LD	HL,LAB_EED0	;45A7:	21D0EE
	LD	(LAB_E7FC),HL	;45AA:	22FCE7
	JP	LAB_45EC	;45AD:	C3EC45

LAB_45B0
	LD	HL,LAB_EEB0	;45B0:	21B0EE
	LD	(LAB_E7FC),HL	;45B3:	22FCE7
	JP	LAB_45EC	;45B6:	C3EC45

LAB_45B9
	LD	HL,LAB_EEBC	;45B9:	21BCEE
	LD	(LAB_E7FC),HL	;45BC:	22FCE7
	JP	LAB_45EC	;45BF:	C3EC45

LAB_45C2
	LD	HL,(LAB_EB1A)	;45C2:	2A1AEB
	LD	(LAB_E7F7),HL	;45C5:	22F7E7
	LD	HL,0000h	;45C8:	210000
	LD	(LAB_E7FC),HL	;45CB:	22FCE7
	JP	LAB_45EC	;45CE:	C3EC45

LAB_45D1
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0005

	DW	0002
	DW	LAB_4587

	DW	0004
	DW	LAB_45B0

	DW	0008
	DW	LAB_45B9

	DW	0020
	DW	LAB_4597

	DW	0040
	DW	LAB_45A7

	DW	LAB_45C2

LAB_45EC
	LD	HL,(LAB_E7FC)	;45EC:	2AFCE7
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4622	;45F1:	CA2246

	LD	HL,E7F9h	;45F4:	21F9E7
	PUSH	HL		;45F7:	E5
	LD	HL,(LAB_EB51)	;45F8:	2A51EB
	LD	DE,0006h	;45FB:	110600
	ADD	HL,DE		;45FE:	19
	LD	E,(HL)		;45FF:	5E
LAB_4600
	INC	HL			; increment pointer
	LD	D,(HL)		;4601:	56
	PUSH	DE		;4602:	D5
	LD	HL,(LAB_E7FC)	;4603:	2AFCE7
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;4609:	D1
	POP	DE		;460A:	D1
	LD	A,(LAB_E7FB)	;460B:	3AFBE7
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	EX	DE,HL		;4611:	EB
	LD	HL,(LAB_EC3B)	;4612:	2A3BEC
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_4622	;4618:	CA2246
	LD	HL,(LAB_E7F9)	;461B:	2AF9E7
	INC	HL		;461E:	23
	LD	(LAB_E7F9),HL	;461F:	22F9E7
LAB_4622
	LD	HL,EB20h	;4622:	2120EB
	PUSH	HL		;4625:	E5
	LD	HL,(LAB_E7F7)	;4626:	2AF7E7
	PUSH	HL		;4629:	E5
	CALL	LAB_3624	;462A:	CD2436
	POP	DE		;462D:	D1
	POP	DE		;462E:	D1
LAB_462F
	LD	A,(LAB_E7F3)	;462F:	3AF3E7
	OR	A		;4632:	B7
	JP	Z,LAB_463E	;4633:	CA3E46
	LD	HL,0000h	;4636:	210000
	PUSH	HL		;4639:	E5
	CALL	LAB_2E6F	;463A:	CD6F2E
	POP	DE		;463D:	D1
LAB_463E
	RET				;

LAB_463F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4649:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;464C:	D5
	CALL	LAB_444F	;464D:	CD4F44
	POP	DE		;4650:	D1
	LD	HL,(LAB_EC49)	;4651:	2A49EC
	LD	DE,000Bh	;4654:	110B00
	ADD	HL,DE		;4657:	19
	LD	E,(HL)		;4658:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;465B:	D5
	LD	HL,(LAB_EC5B)	;465C:	2A5BEC
	LD	E,(HL)		;465F:	5E
	EX	DE,HL		;4660:	EB
	LD	A,L		;4661:	7D
	LD	(LAB_E800),A	;4662:	3200E8
	LD	H,#00h		;4665:	2600
	POP	DE		;4667:	D1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_467D	;466B:	CA7D46

	LD	HL,(LAB_EB04)	;466E:	2A04EB
	EX	DE,HL		;4671:	EB
	LD	A,(LAB_E800)	;4672:	3A00E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,DE		;4678:	19
	LD	A,L		;4679:	7D
LAB_467A
	LD	(LAB_E800),A	;467A:	3200E8
LAB_467D
	LD	HL,(LAB_EC5B)	;467D:	2A5BEC
	INC	HL		;4680:	23
	LD	E,(HL)		;4681:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4684:	D5
	LD	A,(LAB_E800)	;4685:	3A00E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;468B:	E5
	CALL	LAB_70AE		; set cursor X,Y
	POP	DE			; dump cursor Y
	POP	DE			; dump cursor X
	LD	HL,EB20h	;4691:	2120EB
	LD	(LAB_E7FE),HL	;4694:	22FEE7
	LD	HL,0000h	;4697:	210000
	LD	A,L		;469A:	7D
	LD	(LAB_E801),A	;469B:	3201E8
	JP	LAB_46AA	;469E:	C3AA46

LAB_46A1
	LD	A,(LAB_E801)	;46A1:	3A01E8
	LD	L,A		;46A4:	6F
	INC	HL		;46A5:	23
	LD	A,L		;46A6:	7D
	LD	(LAB_E801),A	;46A7:	3201E8
LAB_46AA
	LD	HL,(LAB_EC5B)	;46AA:	2A5BEC
	INC	HL		;46AD:	23
	INC	HL		;46AE:	23
	LD	E,(HL)		;46AF:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;46B2:	D5
	LD	A,(LAB_E801)	;46B3:	3A01E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;46B9:	D1
	EX	DE,HL		;46BA:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_46F7	;46BE:	CAF746

	LD	HL,(LAB_EC5B)	;46C1:	2A5BEC
	INC	HL		;46C4:	23
	INC	HL		;46C5:	23
	INC	HL		;46C6:	23
	LD	E,(HL)		;46C7:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;46C9:	56
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_46D9	;46D0:	CAD946

	LD	HL,0020h		; else make character " "
	JP	LAB_46E5		;

LAB_46D9
	LD	HL,(LAB_E7FE)	;46D9:	2AFEE7
	INC	HL		;46DC:	23
	LD	(LAB_E7FE),HL	;46DD:	22FEE7
	DEC	HL		;46E0:	2B
	LD	E,(HL)		; get character
	LD	D,#00h		; clear high byte
	EX	DE,HL			; swap to HL
LAB_46E5
	LD	A,L			; copy character to A
	LD	(LAB_E802),A	;46E6:	3202E8
	LD	A,(LAB_E802)	;46E9:	3A02E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push character
	CALL	LAB_356E		; character out (does "_" if chr=" " & (LAB_EB0C).w=0)
	POP	DE			; dump character
	JP	LAB_46A1	;46F4:	C3A146

LAB_46F7
	RET				;

; stack is ..
; ??
; dest ??
; count
; end.

LAB_46F8
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0020h		; set byte " "
	PUSH	HL			; push byte
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;4706:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4708:	56
	PUSH	DE			; push count
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;470E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4710:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,(LAB_EC49)	;4718:	2A49EC
	LD	DE,0007h	;471B:	110700
	ADD	HL,DE		;471E:	19
	LD	E,(HL)		;471F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4721:	56
	EX	DE,HL		;4722:	EB
	LD	(LAB_E81B),HL	;4723:	221BE8
	LD	HL,0000h	;4726:	210000
	LD	A,L		;4729:	7D
	LD	(LAB_E81D),A	;472A:	321DE8
	JP	LAB_4748	;472D:	C34847
LAB_4730
	LD	A,(LAB_E81D)	;4730:	3A1DE8
	LD	L,A		;4733:	6F
	INC	HL		;4734:	23
	LD	A,L		;4735:	7D
	LD	(LAB_E81D),A	;4736:	321DE8
	DEC	HL		;4739:	2B
	LD	HL,(LAB_E81B)	;473A:	2A1BE8
	LD	DE,0004h	;473D:	110400
	ADD	HL,DE		;4740:	19
	LD	(LAB_E81B),HL	;4741:	221BE8
	LD	DE,FFFCh	;4744:	11FCFF
	ADD	HL,DE		;4747:	19
LAB_4748
	LD	HL,(LAB_EC49)	;4748:	2A49EC
	LD	DE,0005h	;474B:	110500
	ADD	HL,DE		;474E:	19
	LD	E,(HL)		;474F:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4752:	D5
	LD	A,(LAB_E81D)	;4753:	3A1DE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;4759:	D1
	EX	DE,HL		;475A:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_47A7	;475E:	CAA747
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4765:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4768:	D5
	LD	HL,(LAB_E81B)	;4769:	2A1BE8
	LD	E,(HL)		;476C:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;476F:	E1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_47A4	;4773:	CAA447

	LD	HL,(LAB_E81B)	;4776:	2A1BE8
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	E,(HL)		; get ?? pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ?? pointer high byte
	PUSH	DE			; push ?? pointer
	CALL	LAB_DBEE		; search for null byte from pointer
					; returns offset to null in HL
	POP	DE			; dump ?? pointer
	PUSH	HL		;4783:	E5
	LD	HL,(LAB_E81B)	;4784:	2A1BE8
	INC	HL		;4787:	23
	LD	E,(HL)		;4788:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;478F:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;4791:	66
	LD	L,A		;4792:	6F
	ADD	HL,DE		;4793:	19
	PUSH	HL		;4794:	E5
	LD	HL,(LAB_E81B)	;4795:	2A1BE8
	INC	HL		;4798:	23
	INC	HL		;4799:	23
	LD	E,(HL)		;479A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;479C:	56
	PUSH	DE		;479D:	D5
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
LAB_47A4
	JP	LAB_4730	;47A4:	C33047
LAB_47A7
	LD	HL,0000h	;47A7:	210000
	PUSH	HL		;47AA:	E5
	CALL	LAB_41D5	;47AB:	CDD541
	POP	DE		;47AE:	D1
	JP	Z,LAB_47FE	;47AF:	CAFE47
LAB_47B2
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;47B6:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;47B9:	D5
	LD	HL,(LAB_EC5B)	;47BA:	2A5BEC
	LD	E,(HL)		;47BD:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;47C0:	E1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_47F3	;47C4:	CAF347
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;47CA:	E5
	CALL	LAB_444F	;47CB:	CD4F44
	POP	DE		;47CE:	D1
	LD	HL,(LAB_EC5B)	;47CF:	2A5BEC
	INC	HL		;47D2:	23
	INC	HL		;47D3:	23
	LD	E,(HL)		;47D4:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;47D7:	D5
	LD	HL,(LAB_EC5B)	;47D8:	2A5BEC
	INC	HL		;47DB:	23
	LD	E,(HL)		;47DC:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;47E3:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;47E5:	66
	LD	L,A		;47E6:	6F
	ADD	HL,DE		;47E7:	19
	PUSH	HL		;47E8:	E5
	LD	HL,EB20h	;47E9:	2120EB
	PUSH	HL		;47EC:	E5
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
LAB_47F3
	LD	HL,0000h	;47F3:	210000
	PUSH	HL		;47F6:	E5
	CALL	LAB_4281	;47F7:	CD8142
	POP	DE		;47FA:	D1
	JP	NZ,LAB_47B2	;47FB:	C2B247
LAB_47FE
	RET				;

LAB_47FF
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4809:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;480B:	56
	EX	DE,HL		;480C:	EB
	LD	A,L		;480D:	7D
	LD	(LAB_E820),A	;480E:	3220E8
	LD	A,L		;4811:	7D
	LD	(LAB_E81F),A	;4812:	321FE8
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4819:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;481B:	56
	LD	HL,FFFFh	;481C:	21FFFF
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_48CF	;4822:	CACF48
	LD	HL,0000h	;4825:	210000
	LD	A,L		;4828:	7D
	LD	(LAB_E81F),A	;4829:	321FE8
	LD	HL,0000h	;482C:	210000
	LD	A,L		;482F:	7D
	LD	(LAB_E820),A	;4830:	3220E8
	LD	HL,(LAB_EC49)	;4833:	2A49EC
	LD	DE,0007h	;4836:	110700
	ADD	HL,DE		;4839:	19
	LD	E,(HL)		;483A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;483C:	56
	EX	DE,HL		;483D:	EB
	LD	(LAB_E821),HL	;483E:	2221E8
	LD	HL,0000h	;4841:	210000
	LD	A,L		;4844:	7D
	LD	(LAB_E81E),A	;4845:	321EE8
	JP	LAB_4863	;4848:	C36348
LAB_484B
	LD	A,(LAB_E81E)	;484B:	3A1EE8
	LD	L,A		;484E:	6F
	INC	HL		;484F:	23
	LD	A,L		;4850:	7D
	LD	(LAB_E81E),A	;4851:	321EE8
	DEC	HL		;4854:	2B
	LD	HL,(LAB_E821)	;4855:	2A21E8
	LD	DE,0004h	;4858:	110400
	ADD	HL,DE		;485B:	19
	LD	(LAB_E821),HL	;485C:	2221E8
	LD	DE,FFFCh	;485F:	11FCFF
	ADD	HL,DE		;4862:	19
LAB_4863
	LD	HL,(LAB_EC49)	;4863:	2A49EC
	LD	DE,0005h	;4866:	110500
	ADD	HL,DE		;4869:	19
	LD	E,(HL)		;486A:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;486D:	D5
	LD	A,(LAB_E81E)	;486E:	3A1EE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;4874:	D1
	EX	DE,HL		;4875:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_489C	;4879:	CA9C48
	LD	A,(LAB_E820)	;487C:	3A20E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;4882:	E5
	LD	HL,(LAB_E821)	;4883:	2A21E8
	LD	E,(HL)		;4886:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;4889:	E1
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_4899	;488D:	CA9948
	LD	HL,(LAB_E821)	;4890:	2A21E8
	LD	E,(HL)		;4893:	5E
	EX	DE,HL		;4894:	EB
	LD	A,L		;4895:	7D
	LD	(LAB_E820),A	;4896:	3220E8
LAB_4899
	JP	LAB_484B	;4899:	C34B48
LAB_489C
	LD	HL,0000h	;489C:	210000
	PUSH	HL		;489F:	E5
	CALL	LAB_41D5	;48A0:	CDD541
	POP	DE		;48A3:	D1
	JP	Z,LAB_48CF	;48A4:	CACF48
LAB_48A7
	LD	A,(LAB_E820)	;48A7:	3A20E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;48AD:	E5
	LD	HL,(LAB_EC5B)	;48AE:	2A5BEC
	LD	E,(HL)		;48B1:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;48B4:	E1
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_48C4	;48B8:	CAC448
	LD	HL,(LAB_EC5B)	;48BB:	2A5BEC
	LD	E,(HL)		;48BE:	5E
	EX	DE,HL		;48BF:	EB
	LD	A,L		;48C0:	7D
	LD	(LAB_E820),A	;48C1:	3220E8
LAB_48C4
	LD	HL,0000h	;48C4:	210000
	PUSH	HL		;48C7:	E5
	CALL	LAB_4281	;48C8:	CD8142
	POP	DE		;48CB:	D1
	JP	NZ,LAB_48A7	;48CC:	C2A748
LAB_48CF
	LD	A,(LAB_E81F)	;48CF:	3A1FE8
	LD	L,A		;48D2:	6F
	LD	A,L		;48D3:	7D
	LD	(LAB_E81E),A	;48D4:	321EE8
	JP	LAB_48E3	;48D7:	C3E348
LAB_48DA
	LD	A,(LAB_E81E)	;48DA:	3A1EE8
	LD	L,A		;48DD:	6F
	INC	HL		;48DE:	23
	LD	A,L		;48DF:	7D
	LD	(LAB_E81E),A	;48E0:	321EE8
LAB_48E3
	LD	A,(LAB_E820)	;48E3:	3A20E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;48E9:	E5
	LD	A,(LAB_E81E)	;48EA:	3A1EE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;48F0:	D1
	EX	DE,HL		;48F1:	EB
	CALL	LAB_E06B		; does signed CP HL,DE. returns HL=1 if DE<=HL
					; (LAB_7BA6 ROM 1)
	JP	Z,LAB_497D	;48F5:	CA7D49
	LD	HL,E803h	;48F8:	2103E8
	LD	(LAB_E823),HL	;48FB:	2223E8
	LD	HL,0018h	;48FE:	211800
	PUSH	HL		;4901:	E5
	LD	HL,(LAB_E823)	;4902:	2A23E8
	PUSH	HL		;4905:	E5
	LD	A,(LAB_E81E)	;4906:	3A1EE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;490C:	E5
	CALL	LAB_46F8	;490D:	CDF846
	POP	DE		;4910:	D1
	POP	DE		;4911:	D1
	POP	DE		;4912:	D1
	LD	HL,(LAB_E823)	;4913:	2A23E8
	LD	DE,0017h	;4916:	111700
	ADD	HL,DE		;4919:	19
	LD	(LAB_E825),HL	;491A:	2225E8
LAB_491D
	LD	HL,(LAB_E825)	;491D:	2A25E8
	EX	DE,HL		;4920:	EB
	LD	HL,(LAB_E823)	;4921:	2A23E8
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_4943	;4927:	CA4349
	LD	HL,(LAB_E825)	;492A:	2A25E8
	LD	E,(HL)		;492D:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0020h	;4930:	212000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_4943	;4936:	CA4349
	LD	HL,(LAB_E825)	;4939:	2A25E8
	DEC	HL		;493C:	2B
	LD	(LAB_E825),HL	;493D:	2225E8
	JP	LAB_491D	;4940:	C31D49
LAB_4943
	LD	HL,(LAB_E823)	;4943:	2A23E8
	EX	DE,HL		;4946:	EB
	LD	HL,(LAB_E825)	;4947:	2A25E8
	CALL	LAB_E0DA		; does CP HL,DE, returns HL=1 if DE<=HL (LAB_7C15 ROM 1)
	JP	Z,LAB_496A	;494D:	CA6A49
	LD	HL,(LAB_E823)	;4950:	2A23E8
	INC	HL		;4953:	23
	LD	(LAB_E823),HL	;4954:	2223E8
	DEC	HL		;4957:	2B
	LD	E,(HL)		;4958:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;495B:	D5
	CALL	LAB_EF2C	;495C:	CD2CEF
	POP	DE		;495F:	D1
	JP	NZ,LAB_4967	;4960:	C26749
	LD	HL,0000h	;4963:	210000
	RET				;

LAB_4967
	JP	LAB_4943	;4967:	C34349
LAB_496A
	LD	HL,000Dh	;496A:	210D00
	PUSH	HL		;496D:	E5
	CALL	LAB_EF2C	;496E:	CD2CEF
	POP	DE		;4971:	D1
	LD	HL,000Ah	;4972:	210A00
	PUSH	HL		;4975:	E5
	CALL	LAB_EF2C	;4976:	CD2CEF
	POP	DE		;4979:	D1
	JP	LAB_48DA	;497A:	C3DA48
LAB_497D
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_4981
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	A,(HL)		;498B:	7E
	INC	HL			; increment pointer
	OR	(HL)		;498D:	B6
	JP	Z,LAB_49A0	;498E:	CAA049

	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;4995:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4997:	56
	EX	DE,HL		;4998:	EB
	LD	E,(HL)		;4999:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;499B:	56
	EX	DE,HL		;499C:	EB
	JP	LAB_49A3	;499D:	C3A349
LAB_49A0
	LD	HL,0000h	;49A0:	210000
LAB_49A3
	LD	(LAB_E827),HL	;49A3:	2227E8
	LD	HL,(LAB_E827)	;49A6:	2A27E8
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_49C4	;49AB:	C2C449

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;49B2:	5E
	LD	D,#00h		; clear high byte
	LD	HL,E104h	;49B5:	2104E1
	ADD	HL,DE		;49B8:	19
	INC	HL		;49B9:	23
	LD	E,(HL)		;49BA:	5E
	LD	D,#00h		; clear high byte
	LD	HL,00C7h	;49BD:	21C700
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	RET				;

LAB_49C4
	LD	HL,(LAB_E827)	;49C4:	2A27E8
	EX	DE,HL		;49C7:	EB
	LD	HL,(LAB_EC3D)	;49C8:	2A3DEC
	ADD	HL,DE		;49CB:	19
	LD	E,(HL)		;49CC:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;49CF:	EB
	JP	LAB_4A2D	;49D0:	C32D4A

LAB_49D3
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;49D7:	5E
	LD	D,#00h		; clear high byte
	LD	HL,E104h	;49DA:	2104E1
	ADD	HL,DE		;49DD:	19
	INC	HL		;49DE:	23
	LD	E,(HL)		;49DF:	5E
	LD	D,#00h		; clear high byte
	LD	HL,00C7h	;49E2:	21C700
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	RET				;

LAB_49E9
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;49ED:	5E
	LD	D,#00h		; clear high byte
	LD	HL,E104h	;49F0:	2104E1
	ADD	HL,DE		;49F3:	19
	INC	HL		;49F4:	23
	LD	E,(HL)		;49F5:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;49F8:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	RET				;

LAB_49FF
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4A03:	5E
	LD	D,#00h		; clear high byte
	LD	HL,E104h	;4A06:	2104E1
	ADD	HL,DE		;4A09:	19
	INC	HL		;4A0A:	23
	LD	E,(HL)		;4A0B:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0003h	;4A0E:	210300
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	RET				;

LAB_4A15
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4A19:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4A1C:	D5
	LD	HL,(LAB_E827)	;4A1D:	2A27E8
	EX	DE,HL		;4A20:	EB
	LD	HL,(LAB_EC3D)	;4A21:	2A3DEC
	ADD	HL,DE		;4A24:	19
	LD	E,(HL)		;4A25:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;4A28:	E1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	RET				;

LAB_4A2D
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0003

	DW	0039
	DW	LAB_49E9

	DW	0041
	DW	LAB_49FF

	DW	0058
	DW	LAB_49D3

	DW	LAB_4A15

LAB_4A40
	RET				;

; set HL=0001h

LAB_4A41
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_4A4B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4A55:	5E
	LD	D,#00h		; clear high byte
	LD	HL,LAB_E104	;4A58:	2104E1
	ADD	HL,DE		;4A5B:	19
	INC	HL		;4A5C:	23
	LD	E,(HL)		;4A5D:	5E
	LD	D,#00h		; clear high byte
	LD	HL,00C7h	;4A60:	21C700
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	RET				;

; set HL=0001h

LAB_4A67
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_4A71
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;4A7B:	7E
	INC	HL			; increment pointer
	OR	(HL)		;4A7D:	B6
	JP	Z,LAB_4A90	;4A7E:	CA904A
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4A85:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4A87:	56
	EX	DE,HL		;4A88:	EB
	LD	E,(HL)		;4A89:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;4A8C:	EB
	JP	LAB_4A93	;4A8D:	C3934A
LAB_4A90
	LD	HL,0000h	;4A90:	210000
LAB_4A93
	LD	A,L		;4A93:	7D
	LD	(LAB_E829),A	;4A94:	3229E8
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4A9B:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_4AAD	;4AA4:	CAAD4A
	LD	HL,0000h	;4AA7:	210000
	JP	LAB_4AB0	;4AAA:	C3B04A
LAB_4AAD
	LD	HL,0001h		; set HL = 0001h
LAB_4AB0
	LD	A,L		;4AB0:	7D
	LD	(LAB_E82A),A	;4AB1:	322AE8
	LD	A,(LAB_E829)	;4AB4:	3A29E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0000h	;4ABA:	110000
	EX	DE,HL		;4ABD:	EB
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	LD	A,L		;4AC1:	7D
	LD	(LAB_E82B),A	;4AC2:	322BE8
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4AC9:	5E
	LD	D,#00h		; clear high byte
	LD	HL,E104h	;4ACC:	2104E1
	ADD	HL,DE		;4ACF:	19
	INC	HL		;4AD0:	23
	LD	E,(HL)		;4AD1:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;4AD4:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_4B01	;4ADA:	CA014B
	LD	HL,(LAB_EC59)	;4ADD:	2A59EC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4AFD	;4AE2:	CAFD4A

	LD	A,(LAB_E829)	;4AE5:	3A29E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;4AEB:	E5
	LD	HL,(LAB_EC55)	;4AEC:	2A55EC
	POP	DE		;4AEF:	D1
	EX	DE,HL		;4AF0:	EB
	CALL	LAB_E0D9		; does CP DE,HL, returns HL=1 if HL<=DE (LAB_7C14 ROM 1)
	JP	Z,LAB_4AFD	;4AF4:	CAFD4A
	LD	HL,0000h	;4AF7:	210000
	JP	LAB_4B00	;4AFA:	C3004B
LAB_4AFD
	LD	HL,0001h		; set HL = 0001h
LAB_4B00
	RET				;

LAB_4B01
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4B05:	5E
	LD	D,#00h		; clear high byte
	LD	HL,002Eh	;4B08:	212E00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_4B2A	;4B0E:	CA2A4B
	LD	HL,(LAB_EC59)	;4B11:	2A59EC
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4B20	;4B16:	C2204B

	LD	A,(LAB_E82B)	;4B19:	3A2BE8
	OR	A		;4B1C:	B7
	JP	NZ,LAB_4B26	;4B1D:	C2264B
LAB_4B20
	LD	HL,0000h	;4B20:	210000
	JP	LAB_4B29	;4B23:	C3294B
LAB_4B26
	LD	HL,0001h		; set HL = 0001h
LAB_4B29
	RET				;

LAB_4B2A
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4B2E:	5E
	LD	D,#00h		; clear high byte
	LD	HL,002Dh	;4B31:	212D00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_4B5B	;4B37:	CA5B4B
	LD	HL,(LAB_EC4B)	;4B3A:	2A4BEC
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4B51	;4B3F:	C2514B

	LD	A,(LAB_E82A)	;4B42:	3A2AE8
	OR	A		;4B45:	B7
	JP	Z,LAB_4B51	;4B46:	CA514B
	LD	HL,(LAB_EC3D)	;4B49:	2A3DEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4B57	;4B4E:	CA574B

LAB_4B51
	LD	HL,0000h	;4B51:	210000
	JP	LAB_4B5A	;4B54:	C35A4B
LAB_4B57
	LD	HL,0001h		; set HL = 0001h
LAB_4B5A
	RET				;

LAB_4B5B
	LD	HL,0000h	;4B5B:	210000
	RET				;

; set HL=0001h

LAB_4B5F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	RET				;

stack is ..
; source ??
; dest ??
; count ??
; count ??

LAB_4B69
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;4B73:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4B76:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;4B7B:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;4B7E:	E1
	CALL	LAB_E0D9		; does CP DE,HL, returns HL=1 if HL<=DE (LAB_7C14 ROM 1)
	JP	Z,LAB_4BD5		; jump if HL>DE

	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;4B89:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push count
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4B91:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4B93:	56
	PUSH	DE			; push destination pointer
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4B99:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4B9B:	56
	PUSH	DE			; push source pointer
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	LD	HL,0000h	;4BA3:	210000
	PUSH	HL		;4BA6:	E5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4BAB:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4BAE:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4BB3:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;4BB6:	E1
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL			; push count
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4BBF:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;4BC6:	7E
	INC	HL		;4BC7:	23
	LD	H,(HL)		;4BC8:	66
	LD	L,A		;4BC9:	6F
	ADD	HL,DE		;4BCA:	19
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	JP	LAB_4BF3		; set HL = 0001h & exit

LAB_4BD5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;4BD9:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push byte count
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;4BE1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4BE3:	56
	PUSH	DE			; push destination pointer
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4BE9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4BEB:	56
	PUSH	DE			; push source pointer
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
LAB_4BF3
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_4BF7
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4C01:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4C03:	56
	EX	DE,HL		;4C04:	EB
	LD	(LAB_E82E),HL	;4C05:	222EE8
	LD	HL,0000h	;4C08:	210000
	LD	(LAB_E82C),HL	;4C0B:	222CE8
	JP	LAB_4C18	;4C0E:	C3184C
LAB_4C11
	LD	HL,(LAB_E82C)	;4C11:	2A2CE8
	INC	HL		;4C14:	23
	LD	(LAB_E82C),HL	;4C15:	222CE8
LAB_4C18
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4C1C:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4C1F:	D5
	LD	HL,(LAB_E82C)	;4C20:	2A2CE8
	POP	DE		;4C23:	D1
	EX	DE,HL		;4C24:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_4C47	;4C28:	CA474C
	LD	HL,(LAB_E82E)	;4C2B:	2A2EE8
	INC	HL		;4C2E:	23
	LD	(LAB_E82E),HL	;4C2F:	222EE8
	DEC	HL		;4C32:	2B
	LD	A,(HL)		;4C33:	7E
	OR	A		;4C34:	B7
	JP	NZ,LAB_4C44	;4C35:	C2444C
	LD	HL,(LAB_E82C)	;4C38:	2A2CE8
	EX	DE,HL		;4C3B:	EB
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	(HL),E		;4C40:	73
	JP	LAB_4C47	;4C41:	C3474C
LAB_4C44
	JP	LAB_4C11	;4C44:	C3114C
LAB_4C47
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4C4B:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4C4E:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4C53:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;4C56:	E1
	CALL	LAB_E0D9		; does CP DE,HL, returns HL=1 if HL<=DE (LAB_7C14 ROM 1)
	JP	Z,LAB_4CAD	;4C5A:	CAAD4C
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4C61:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4C64:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4C69:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4C6B:	56
	PUSH	DE		;4C6C:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4C71:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4C73:	56
	PUSH	DE		;4C74:	D5
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	LD	HL,0020h	;4C7B:	212000
	PUSH	HL		;4C7E:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4C83:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4C86:	D5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4C8B:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;4C8E:	E1
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL			; push count
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4C97:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;4C9E:	7E
	INC	HL		;4C9F:	23
	LD	H,(HL)		;4CA0:	66
	LD	L,A		;4CA1:	6F
	ADD	HL,DE		;4CA2:	19
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	JP	LAB_4CCB	;4CAA:	C3CB4C
LAB_4CAD
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4CB1:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4CB4:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4CB9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4CBB:	56
	PUSH	DE		;4CBC:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4CC1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4CC3:	56
	PUSH	DE		;4CC4:	D5
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
LAB_4CCB
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_4CCF
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,E830h	;4CD5:	2130E8
	PUSH	HL		;4CD8:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4CDD:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4CDF:	56
	PUSH	DE		;4CE0:	D5
	CALL	LAB_EEC0	;4CE1:	CDC0EE
	POP	DE		;4CE4:	D1
	POP	DE		;4CE5:	D1
	LD	(LAB_E834),HL	;4CE6:	2234E8
	LD	HL,003Ah	;4CE9:	213A00
	PUSH	HL		;4CEC:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;4CF1:	E5
	LD	A,(HL)		;4CF2:	7E
	INC	HL		;4CF3:	23
	LD	H,(HL)		;4CF4:	66
	LD	L,A		;4CF5:	6F
	INC	HL		;4CF6:	23
	EX	DE,HL		;4CF7:	EB
	POP	HL		;4CF8:	E1
	LD	(HL),E		;4CF9:	73
	INC	HL			; increment pointer
	LD	(HL),D		;4CFB:	72
	EX	DE,HL		;4CFC:	EB
	DEC	HL		;4CFD:	2B
	POP	DE		;4CFE:	D1
	LD	(HL),E		;4CFF:	73
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4D04:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4D06:	56
	PUSH	DE		;4D07:	D5
	CALL	LAB_EE88	;4D08:	CD88EE
	POP	DE		;4D0B:	D1
	JP	NZ,LAB_4D18	;4D0C:	C2184D
	LD	HL,0000h	;4D0F:	210000
	LD	(LAB_E836),HL	;4D12:	2236E8
	JP	LAB_4D29	;4D15:	C3294D
LAB_4D18
	LD	HL,E836h	;4D18:	2136E8
	PUSH	HL		;4D1B:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4D20:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4D22:	56
	PUSH	DE		;4D23:	D5
	CALL	LAB_EE50	;4D24:	CD50EE
	POP	DE		;4D27:	D1
	POP	DE		;4D28:	D1
LAB_4D29
	LD	HL,0000h		; clear area
	PUSH	HL			; push fill byte
	LD	HL,0006h		; 6 bytes to do
	PUSH	HL			; push count
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4D35:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4D37:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,0000h	;4D3F:	210000
	PUSH	HL		;4D42:	E5
	LD	HL,0005h	;4D43:	210500
	PUSH	HL		;4D46:	E5
	LD	HL,0005h	;4D47:	210500
	PUSH	HL		;4D4A:	E5
	LD	HL,0002h	;4D4B:	210200
	PUSH	HL		;4D4E:	E5
	LD	HL,0018h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4D53:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4D55:	56
	PUSH	DE		;4D56:	D5
	LD	HL,LAB_E836	;4D57:	2136E8
	PUSH	HL		;4D5A:	E5
	CALL	LAB_53C6	;4D5B:	CDC653
	EX	DE,HL		;4D5E:	EB
	LD	HL,000Ch		; C ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,0005h	;4D64:	210500
	PUSH	HL		;4D67:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4D6C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4D6E:	56
	PUSH	DE		;4D6F:	D5
	CALL	LAB_34AB	;4D70:	CDAB34
	POP	DE		;4D73:	D1
	POP	DE		;4D74:	D1
	LD	HL,(LAB_E834)	;4D75:	2A34E8
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4D85	;4D7A:	CA854D

	LD	HL,E830h	;4D7D:	2130E8
	PUSH	HL		;4D80:	E5
	CALL	LAB_EE88	;4D81:	CD88EE
	POP	DE		;4D84:	D1
LAB_4D85
	RET				;

LAB_4D86
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;4D90:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4D92:	56
	EX	DE,HL		;4D93:	EB
	LD	(LAB_E83C),HL	;4D94:	223CE8
	LD	HL,0020h		; byte is " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;4D9F:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push count
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;4DA7:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4DA9:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,LAB_E83A	;4DB1:	213AE8
	PUSH	HL		;4DB4:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4DB9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4DBB:	56
	PUSH	DE		;4DBC:	D5
	CALL	LAB_EE9C	;4DBD:	CD9CEE
	POP	DE		;4DC0:	D1
	POP	DE		;4DC1:	D1
	JP	NZ,LAB_4DC9	;4DC2:	C2C94D
	LD	HL,0000h	;4DC5:	210000
	RET				;

LAB_4DC9
	LD	HL,(LAB_E83A)	;4DC9:	2A3AE8
	PUSH	HL			; push source pointer
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get destination pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination pointer high byte
	PUSH	DE			; push destination pointer
	CALL	LAB_DB6D		; copy null terminated string from source to destination
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get destination pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination pointer high byte
	PUSH	DE			; push destination pointer
	CALL	LAB_DBEE		; search for null byte from destination pointer
					; returns offset to null in HL
	POP	DE			; dump destination pointer
	EX	DE,HL			; swap offset to DE
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	PUSH	HL			; save last pushed but 1 pointer
	LD	A,(HL)		; get destination pointer low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get destination pointer high byte
	LD	L,A			; copy low byte to L
	ADD	HL,DE			; add null offset
	EX	DE,HL			; swap to DE
	POP	HL			; restore last pushed but 1 pointer
	LD	(HL),E		; save new destination pointer low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save new destination pointer high byte
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get new destination pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get new destination pointer high byte
	PUSH	DE			; push new destination pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4E02:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4E04:	56
	PUSH	DE		;4E05:	D5
	LD	HL,(LAB_E83A)	;4E06:	2A3AE8
	PUSH	HL		;4E09:	E5
	CALL	LAB_4CCF	;4E0A:	CDCF4C
	POP	DE		;4E0D:	D1
	POP	DE		;4E0E:	D1
	POP	DE		;4E0F:	D1
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		; get ?? pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ?? pointer high byte
	PUSH	DE			; push ?? pointer
	CALL	LAB_DBEE		; search for null byte from pointer
					; returns offset to null in HL
	POP	DE			; dump ?? pointer
	EX	DE,HL		;4E1C:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;4E21:	E5
	LD	A,(HL)		;4E22:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;4E24:	66
	LD	L,A		;4E25:	6F
	ADD	HL,DE		;4E26:	19
	EX	DE,HL		;4E27:	EB
	POP	HL		;4E28:	E1
	LD	(HL),E		;4E29:	73
	INC	HL			; increment pointer
	LD	(HL),D		;4E2B:	72
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4E30:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4E33:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4E38:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4E3A:	56
	LD	HL,(LAB_E83C)	;4E3B:	2A3CE8
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	POP	DE		;4E41:	D1
	EX	DE,HL		;4E42:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_4E75	;4E46:	CA754E

	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4E51:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4E53:	56
	LD	HL,(LAB_E83C)	;4E54:	2A3CE8
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL		;4E5A:	E5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4E5F:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;4E62:	E1
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL		;4E66:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4E6B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4E6D:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
LAB_4E75
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_4E79
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4E83:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4E85:	56
	EX	DE,HL		;4E86:	EB
	LD	(LAB_E842),HL	;4E87:	2242E8
	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4E92:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4E95:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4E9A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4E9C:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,E840h	;4EA4:	2140E8
	PUSH	HL		;4EA7:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4EAC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4EAE:	56
	EX	DE,HL		;4EAF:	EB
	LD	E,(HL)		;4EB0:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4EB2:	56
	PUSH	DE		;4EB3:	D5
	CALL	LAB_EE9C	;4EB4:	CD9CEE
	POP	DE		;4EB7:	D1
	POP	DE		;4EB8:	D1
	JP	NZ,LAB_4EC0	;4EB9:	C2C04E
	LD	HL,0000h	;4EBC:	210000
	RET				;

LAB_4EC0
	LD	HL,(LAB_E840)	; get source pointer
	PUSH	HL			; push source pointer
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		; get destination pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination pointer low byte
	PUSH	DE			; push destination pointer
	CALL	LAB_DB6D		; copy null terminated string from source to destination
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4ED5:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4ED7:	56
	PUSH	DE		;4ED8:	D5
	CALL	LAB_DBEE		; search for null byte from pointer
					; returns offset to null in HL
	POP	DE		;4EDC:	D1
	EX	DE,HL		;4EDD:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;4EE2:	E5
	LD	A,(HL)		;4EE3:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;4EE5:	66
	LD	L,A		;4EE6:	6F
	ADD	HL,DE		;4EE7:	19
	EX	DE,HL		;4EE8:	EB
	POP	HL		;4EE9:	E1
	LD	(HL),E		;4EEA:	73
	INC	HL			; increment pointer
	LD	(HL),D		;4EEC:	72
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4EF1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4EF3:	56
	PUSH	DE		;4EF4:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4EF9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4EFB:	56
	EX	DE,HL		;4EFC:	EB
	LD	E,(HL)		;4EFD:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4EFF:	56
	PUSH	DE		;4F00:	D5
	LD	HL,(LAB_E840)	;4F01:	2A40E8
	PUSH	HL		;4F04:	E5
	CALL	LAB_4CCF	;4F05:	CDCF4C
	POP	DE		;4F08:	D1
	POP	DE		;4F09:	D1
	POP	DE		;4F0A:	D1
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4F0F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4F11:	56
	PUSH	DE		;4F12:	D5
	CALL	LAB_DBEE		; search for null byte from pointer
					; returns offset to null in HL
	POP	DE		;4F16:	D1
	EX	DE,HL		;4F17:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;4F1C:	E5
	LD	A,(HL)		;4F1D:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;4F1F:	66
	LD	L,A		;4F20:	6F
	ADD	HL,DE		;4F21:	19
	EX	DE,HL		;4F22:	EB
	POP	HL		;4F23:	E1
	LD	(HL),E		;4F24:	73
	INC	HL			; increment pointer
	LD	(HL),D		;4F26:	72
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4F2B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4F2D:	56
	PUSH	DE		;4F2E:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4F33:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4F35:	56
	EX	DE,HL		;4F36:	EB
	INC	HL		;4F37:	23
	INC	HL		;4F38:	23
	LD	E,(HL)		;4F39:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4F3B:	56
	PUSH	DE		;4F3C:	D5
	LD	HL,(LAB_E840)	;4F3D:	2A40E8
	PUSH	HL		;4F40:	E5
	CALL	LAB_4CCF	;4F41:	CDCF4C
	POP	DE		;4F44:	D1
	POP	DE		;4F45:	D1
	POP	DE		;4F46:	D1
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4F4B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4F4D:	56
	PUSH	DE		;4F4E:	D5
	CALL	LAB_DBEE		; search for null byte from pointer
					; returns offset to null in HL
	POP	DE		;4F52:	D1
	EX	DE,HL		;4F53:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;4F58:	E5
	LD	A,(HL)		;4F59:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;4F5B:	66
	LD	L,A		;4F5C:	6F
	ADD	HL,DE		;4F5D:	19
	EX	DE,HL		;4F5E:	EB
	POP	HL		;4F5F:	E1
	LD	(HL),E		;4F60:	73
	INC	HL			; increment pointer
	LD	(HL),D		;4F62:	72
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4F67:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4F6A:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4F6F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4F71:	56
	LD	HL,(LAB_E842)	;4F72:	2A42E8
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	POP	DE		;4F78:	D1
	EX	DE,HL		;4F79:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_4FAC	;4F7D:	CAAC4F
	LD	HL,0020h	;4F80:	212000
	PUSH	HL		;4F83:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4F88:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4F8A:	56
	LD	HL,(LAB_E842)	;4F8B:	2A42E8
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL		;4F91:	E5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4F96:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;4F99:	E1
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL		;4F9D:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4FA2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4FA4:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
LAB_4FAC
	LD	HL,0001h		; set HL = 0001h
	RET				;

; routine to select ...
; 'WORKSTATION MEMORY'
; 'WORKSTATION RAMDISK'
; 'PLINTH'
; 'V24 ADAPTOR'
; 'EXT STORAGE ADAPTOR' ???

LAB_4FB0
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4FBA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4FBC:	56
	EX	DE,HL		;4FBD:	EB
	LD	(LAB_E845),HL	;4FBE:	2245E8
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;4FC5:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;4FC8:	EB
	LD	(LAB_E849),HL	;4FC9:	2249E8
LAB_4FCC
	LD	HL,(LAB_E849)	;4FCC:	2A49E8
	LD	DE,0000h	;4FCF:	110000
	EX	DE,HL		;4FD2:	EB
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL
					; (LAB_7BC1 ROM 1)
	JP	Z,LAB_4FFB	;4FD6:	CAFB4F
	LD	HL,(LAB_E845)	;4FD9:	2A45E8
	LD	E,(HL)		;4FDC:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0020h	;4FDF:	212000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_4FFB	;4FE5:	CAFB4F
	LD	HL,(LAB_E845)	;4FE8:	2A45E8
	INC	HL		;4FEB:	23
	LD	(LAB_E845),HL	;4FEC:	2245E8
	DEC	HL		;4FEF:	2B
	LD	HL,(LAB_E849)	;4FF0:	2A49E8
	DEC	HL		;4FF3:	2B
	LD	(LAB_E849),HL	;4FF4:	2249E8
	INC	HL		;4FF7:	23
	JP	LAB_4FCC	;4FF8:	C3CC4F
LAB_4FFB
	LD	HL,(LAB_E849)	;4FFB:	2A49E8
	LD	DE,0000h	;4FFE:	110000
	EX	DE,HL		;5001:	EB
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL
					; (LAB_7BC1 ROM 1)
	JP	Z,LAB_5027	;5005:	CA2750
	LD	HL,(LAB_E845)	;5008:	2A45E8
	EX	DE,HL		;500B:	EB
	LD	HL,(LAB_E849)	;500C:	2A49E8
	ADD	HL,DE		;500F:	19
	DEC	HL		;5010:	2B
	LD	E,(HL)		;5011:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0020h	;5014:	212000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_5027	;501A:	CA2750
	LD	HL,(LAB_E849)	;501D:	2A49E8
	DEC	HL		;5020:	2B
	LD	(LAB_E849),HL	;5021:	2249E8
	JP	LAB_4FFB	;5024:	C3FB4F
LAB_5027
	LD	HL,(LAB_E849)	;5027:	2A49E8
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5041	;502C:	C24150

	LD	HL,00FFh	;502F:	21FF00
	PUSH	HL		;5032:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5037:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5039:	56
	EX	DE,HL		;503A:	EB
	POP	DE		;503B:	D1
	LD	(HL),E		;503C:	73
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_5041
	LD	HL,(LAB_E845)	;5041:	2A45E8
	EX	DE,HL		;5044:	EB
	LD	HL,(LAB_E849)	;5045:	2A49E8
	ADD	HL,DE		;5048:	19
	LD	E,(HL)		;5049:	5E
	EX	DE,HL		;504A:	EB
	LD	A,L		;504B:	7D
	LD	(LAB_E844),A	;504C:	3244E8
	LD	HL,0000h	;504F:	210000
	PUSH	HL		;5052:	E5
	LD	HL,(LAB_E845)	;5053:	2A45E8
	EX	DE,HL		;5056:	EB
	LD	HL,(LAB_E849)	;5057:	2A49E8
	ADD	HL,DE		;505A:	19
	POP	DE		;505B:	D1
	LD	(HL),E		;505C:	73
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5061:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5063:	56
	EX	DE,HL		;5064:	EB
	LD	E,(HL)		;5065:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5067:	56
	EX	DE,HL		;5068:	EB
	LD	(LAB_E847),HL	;5069:	2247E8
	JP	LAB_5077	;506C:	C37750
LAB_506F
	LD	HL,(LAB_E847)	;506F:	2A47E8
	INC	HL		;5072:	23
	INC	HL		;5073:	23
	LD	(LAB_E847),HL	;5074:	2247E8
LAB_5077
	LD	HL,(LAB_E847)	;5077:	2A47E8
	LD	A,(HL)		;507A:	7E
	INC	HL			; increment pointer
	OR	(HL)		;507C:	B6
	JP	Z,LAB_50CF	;507D:	CACF50

	LD	HL,(LAB_E845)	; get string 2 pointer
	PUSH	HL			; push string 2 pointer
	LD	HL,(LAB_E847)	;5084:	2A47E8
	LD	E,(HL)		; get string 1 pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get string 1 pointer low byte
	PUSH	DE			; push string 1 pointer
	CALL	LAB_DB35		; compare string 1 & string 2 until a difference is found
					; or string 1 terminates
	POP	DE			; dump string 1 pointer
	POP	DE			; dump string 2 pointer
	JP	NZ,LAB_50CC		; jump if not match or end string 1

	LD	A,(LAB_E844)	;5093:	3A44E8
	LD	L,A		;5096:	6F
	PUSH	HL		;5097:	E5
	LD	HL,(LAB_E845)	;5098:	2A45E8
	EX	DE,HL		;509B:	EB
	LD	HL,(LAB_E849)	;509C:	2A49E8
	ADD	HL,DE		;509F:	19
	POP	DE		;50A0:	D1
	LD	(HL),E		;50A1:	73
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;50A6:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;50A8:	56
	EX	DE,HL		;50A9:	EB
	LD	E,(HL)		;50AA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;50AC:	56
	PUSH	DE		;50AD:	D5
	LD	HL,(LAB_E847)	;50AE:	2A47E8
	POP	DE		;50B1:	D1
	EX	DE,HL		;50B2:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	DE,0001h	;50B6:	110100
	EX	DE,HL		;50B9:	EB
	CALL	LAB_E00E		; does HL = DE>>HL (HL=0 to 1Fh) (LAB_7B49 ROM 1)
	PUSH	HL		;50BD:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;50C2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;50C4:	56
	EX	DE,HL		;50C5:	EB
	POP	DE		;50C6:	D1
	LD	(HL),E		;50C7:	73
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_50CC
	JP	LAB_506F	;50CC:	C36F50
LAB_50CF
	LD	A,(LAB_E844)	;50CF:	3A44E8
	LD	L,A		;50D2:	6F
	PUSH	HL		;50D3:	E5
	LD	HL,(LAB_E845)	;50D4:	2A45E8
	EX	DE,HL		;50D7:	EB
	LD	HL,(LAB_E849)	;50D8:	2A49E8
	ADD	HL,DE		;50DB:	19
	POP	DE		;50DC:	D1
	LD	(HL),E		;50DD:	73
	LD	HL,0000h	;50DE:	210000
	RET				;

LAB_50E2
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;50F0:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;50F3:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;50F8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;50FA:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5106:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5108:	56
	EX	DE,HL		;5109:	EB
	LD	E,(HL)		;510A:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;510D:	EB
	LD	A,L		;510E:	7D
	LD	(LAB_E84D),A	;510F:	324DE8
	LD	A,(LAB_E84D)	;5112:	3A4DE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,00FFh	;5118:	11FF00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_5125	;511E:	CA2551
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_5125
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5129:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;512B:	56
	EX	DE,HL		;512C:	EB
	LD	E,(HL)		;512D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;512F:	56
	PUSH	DE		;5130:	D5
	LD	A,(LAB_E84D)	;5131:	3A4DE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,HL		;5137:	29
	POP	DE		;5138:	D1
	ADD	HL,DE		;5139:	19
	LD	E,(HL)		;513A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;513C:	56
	EX	DE,HL		;513D:	EB
	LD	(LAB_E84B),HL	;513E:	224BE8
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5145:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0010h	;5148:	211000
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_518B	;514E:	CA8B51

	LD	HL,(LAB_E84B)	; get ?? pointer
	PUSH	HL			; push  ?? pointer
	CALL	LAB_DBEE		; search for null byte from pointer
					; returns offset to null in HL
	POP	DE			; dump ?? pointer
	LD	(LAB_E84E),HL	; save offset to null
	JP	LAB_5166	;515C:	C36651

LAB_515F
	LD	HL,(LAB_E84E)	;515F:	2A4EE8
	INC	HL		;5162:	23
	LD	(LAB_E84E),HL	;5163:	224EE8
LAB_5166
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;516A:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;516D:	D5
	LD	HL,(LAB_E84E)	;516E:	2A4EE8
	POP	DE		;5171:	D1
	EX	DE,HL		;5172:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_518B	;5176:	CA8B51
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;517D:	E5
	LD	A,(HL)		;517E:	7E
	INC	HL		;517F:	23
	LD	H,(HL)		;5180:	66
	LD	L,A		;5181:	6F
	INC	HL		;5182:	23
	EX	DE,HL		;5183:	EB
	POP	HL		;5184:	E1
	LD	(HL),E		;5185:	73
	INC	HL			; increment pointer
	LD	(HL),D		;5187:	72
	JP	LAB_515F	;5188:	C35F51
LAB_518B
	LD	HL,(LAB_E84B)	;518B:	2A4BE8
	LD	A,(HL)		;518E:	7E
	OR	A		;518F:	B7
	JP	Z,LAB_51BD	;5190:	CABD51
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;5197:	7E
	INC	HL			; increment pointer
	OR	(HL)		;5199:	B6
	JP	Z,LAB_51BD	;519A:	CABD51
	LD	HL,(LAB_E84B)	;519D:	2A4BE8
	INC	HL		;51A0:	23
	LD	(LAB_E84B),HL	;51A1:	224BE8
	DEC	HL		;51A4:	2B
	LD	E,(HL)		;51A5:	5E
	PUSH	DE		;51A6:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;51AB:	E5
	LD	A,(HL)		;51AC:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;51AE:	66
	LD	L,A		;51AF:	6F
	INC	HL		;51B0:	23
	EX	DE,HL		;51B1:	EB
	POP	HL		;51B2:	E1
	LD	(HL),E		;51B3:	73
	INC	HL			; increment pointer
	LD	(HL),D		;51B5:	72
	EX	DE,HL		;51B6:	EB
	DEC	HL		;51B7:	2B
	POP	DE		;51B8:	D1
	LD	(HL),E		;51B9:	73
	JP	LAB_518B	;51BA:	C38B51
LAB_51BD
	LD	HL,0001h		; set HL = 0001h
	RET				;

; stack is ..
; ??
; ??
; ??
; ??
; ??
; ??
; end.

LAB_51C1
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;51CB:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL		;51D4:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;51D9:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;51DC:	E1
	ADD	HL,DE		;51DD:	19
	DEC	HL		;51DE:	2B
	DEC	HL		;51DF:	2B
	LD	A,L		;51E0:	7D
	LD	(LAB_E857),A	;51E1:	3257E8
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;51E8:	7E
	INC	HL			; increment pointer
	OR	(HL)		;51EA:	B6
	JP	Z,LAB_51FD	;51EB:	CAFD51
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;51F2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;51F4:	56
	EX	DE,HL		;51F5:	EB
	LD	E,(HL)		;51F6:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;51F9:	EB
	JP	LAB_5200	;51FA:	C30052
LAB_51FD
	LD	HL,0000h	;51FD:	210000
LAB_5200
	LD	A,L		;5200:	7D
	LD	(LAB_E859),A	;5201:	3259E8
	LD	HL,0000h	;5204:	210000
	LD	A,L		;5207:	7D
	LD	(LAB_E856),A	;5208:	3256E8
	LD	HL,0000h	;520B:	210000
	LD	A,L		;520E:	7D
	LD	(LAB_E858),A	;520F:	3258E8
	LD	HL,0000h	;5212:	210000
	LD	A,L		;5215:	7D
	LD	(LAB_E85A),A	;5216:	325AE8
	LD	HL,0000h	;5219:	210000
	LD	A,L		;521C:	7D
	LD	(LAB_E85B),A	;521D:	325BE8
	LD	HL,E850h	;5220:	2150E8
	PUSH	HL		;5223:	E5
	CALL	LAB_DC30		; copies next four bytes after the call to LAB_E3B1
					; returns to instruction after the bytes (LAB_776B)

	DB	00h,00h,00h,00h

	POP	HL		;522B:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
	LD	HL,0000h	;522F:	210000
	LD	A,L		;5232:	7D
	LD	(LAB_E855),A	;5233:	3255E8
	JP	LAB_5242	;5236:	C34252
LAB_5239
	LD	A,(LAB_E855)	;5239:	3A55E8
	LD	L,A		;523C:	6F
	INC	HL		;523D:	23
	LD	A,L		;523E:	7D
	LD	(LAB_E855),A	;523F:	3255E8
LAB_5242
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5246:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5249:	D5
	LD	A,(LAB_E855)	;524A:	3A55E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;5250:	D1
	EX	DE,HL		;5251:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_52FD	;5255:	CAFD52
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;525C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;525E:	56
	EX	DE,HL		;525F:	EB
	LD	E,(HL)		;5260:	5E
	EX	DE,HL		;5261:	EB
	LD	A,L		;5262:	7D
	LD	(LAB_E854),A	;5263:	3254E8
	LD	A,(LAB_E854)	;5266:	3A54E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,E104h	;526C:	1104E1
	ADD	HL,DE		;526F:	19
	INC	HL		;5270:	23
	LD	E,(HL)		;5271:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;5274:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_52B2	;527A:	CAB252
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;5280:	7D
	LD	(LAB_E856),A	;5281:	3256E8
	LD	A,(LAB_E85A)	;5284:	3A5AE8
	OR	A		;5287:	B7
	JP	Z,LAB_5294	;5288:	CA9452
	LD	A,(LAB_E85B)	;528B:	3A5BE8
	LD	L,A		;528E:	6F
	INC	HL		;528F:	23
	LD	A,L		;5290:	7D
	LD	(LAB_E85B),A	;5291:	325BE8
LAB_5294
	LD	A,(LAB_E854)	;5294:	3A54E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,FFD0h	;529A:	11D0FF
	ADD	HL,DE		;529D:	19
	PUSH	HL		;529E:	E5
	LD	HL,E850h	;529F:	2150E8
	PUSH	HL		;52A2:	E5
	CALL	LAB_564C	;52A3:	CD4C56
	POP	DE		;52A6:	D1
	POP	DE		;52A7:	D1
	JP	NZ,LAB_52AF	;52A8:	C2AF52
	LD	HL,0000h	;52AB:	210000
	RET				;

LAB_52AF
	JP	LAB_52EB	;52AF:	C3EB52
LAB_52B2
	LD	A,(LAB_E854)	;52B2:	3A54E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,002Dh	;52B8:	112D00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_52CB	;52BE:	CACB52
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;52C4:	7D
	LD	(LAB_E858),A	;52C5:	3258E8
	JP	LAB_52EB	;52C8:	C3EB52
LAB_52CB
	LD	A,(LAB_E854)	;52CB:	3A54E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,002Eh	;52D1:	112E00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_52E4	;52D7:	CAE452
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;52DD:	7D
	LD	(LAB_E85A),A	;52DE:	325AE8
	JP	LAB_52EB	;52E1:	C3EB52
LAB_52E4
	LD	A,(LAB_E856)	;52E4:	3A56E8
	OR	A		;52E7:	B7
	JP	NZ,LAB_52FD	;52E8:	C2FD52
LAB_52EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;52EF:	E5
	LD	A,(HL)		;52F0:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;52F2:	66
	LD	L,A		;52F3:	6F
	INC	HL		;52F4:	23
	EX	DE,HL		;52F5:	EB
	POP	HL		;52F6:	E1
	LD	(HL),E		;52F7:	73
	INC	HL			; increment pointer
	LD	(HL),D		;52F9:	72
	JP	LAB_5239	;52FA:	C33952
LAB_52FD
	LD	A,(LAB_E856)	;52FD:	3A56E8
	OR	A		;5300:	B7
	JP	NZ,LAB_5319	;5301:	C21953
	LD	A,(LAB_E857)	;5304:	3A57E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;530A:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;530F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5311:	56
	PUSH	DE		;5312:	D5
	CALL	LAB_5735	;5313:	CD3557
	POP	DE		;5316:	D1
	POP	DE		;5317:	D1
	RET				;

LAB_5319
	LD	A,(LAB_E85B)	;5319:	3A5BE8
	LD	L,A		;531C:	6F
	LD	A,L		;531D:	7D
	LD	(LAB_E855),A	;531E:	3255E8
	JP	LAB_532D	;5321:	C32D53
LAB_5324
	LD	A,(LAB_E855)	;5324:	3A55E8
	LD	L,A		;5327:	6F
	INC	HL		;5328:	23
	LD	A,L		;5329:	7D
	LD	(LAB_E855),A	;532A:	3255E8
LAB_532D
	LD	A,(LAB_E859)	;532D:	3A59E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;5333:	E5
	LD	A,(LAB_E855)	;5334:	3A55E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;533A:	D1
	EX	DE,HL		;533B:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_5359	;533F:	CA5953
	LD	HL,0000h	;5342:	210000
	PUSH	HL		;5345:	E5
	LD	HL,E850h	;5346:	2150E8
	PUSH	HL		;5349:	E5
	CALL	LAB_564C	;534A:	CD4C56
	POP	DE		;534D:	D1
	POP	DE		;534E:	D1
	JP	NZ,LAB_5356	;534F:	C25653
	LD	HL,0000h	;5352:	210000
	RET				;

LAB_5356
	JP	LAB_5324	;5356:	C32453
LAB_5359
	LD	A,(LAB_E857)	;5359:	3A57E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;535F:	E5
	LD	HL,E850h	;5360:	2150E8
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC5B		; does push (LAB_E3B1).L	(LAB_7796 ROM 1)
	CALL	LAB_5704	;5369:	CD0457
	POP	DE		;536C:	D1
	POP	DE		;536D:	D1
	POP	DE		;536E:	D1
	JP	NZ,LAB_5376	;536F:	C27653
	LD	HL,0000h	;5372:	210000
	RET				;

LAB_5376
	LD	A,(LAB_E858)	;5376:	3A58E8
	OR	A		;5379:	B7
	JP	Z,LAB_538E	;537A:	CA8E53
	LD	HL,E850h	;537D:	2150E8
	PUSH	HL		;5380:	E5
	LD	HL,E850h	;5381:	2150E8
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC91		; does NEG.L (LAB_E3B1) (LAB_77CC)
	POP	HL		;538A:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
LAB_538E
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5392:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5395:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;539A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;539C:	56
	PUSH	DE		;539D:	D5
	LD	HL,E850h	;539E:	2150E8
	PUSH	HL		;53A1:	E5
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	LD	A,(LAB_E857)	;53A8:	3A57E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;53AE:	E5
	LD	HL,0018h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;53B3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;53B5:	56
	PUSH	DE		;53B6:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;53BB:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;53BD:	56
	PUSH	DE		;53BE:	D5
	CALL	LAB_583A	;53BF:	CD3A58
	POP	DE		;53C2:	D1
	POP	DE		;53C3:	D1
	POP	DE		;53C4:	D1
	RET				;

; stack is ..
; ??
; ??
; ?? (byte)
; ??
; ?? (byte)
; ??
; end.

LAB_53C6
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 4 before call
	LD	E,(HL)		;53D0:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h		; set HL = 0001h
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	PUSH	HL		;53D9:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;53DE:	5E
	LD	D,#00h		; clear high byte
	POP	HL		;53E1:	E1
	ADD	HL,DE		;53E2:	19
	DEC	HL		;53E3:	2B
	DEC	HL		;53E4:	2B
	LD	A,L		;53E5:	7D
	LD	(LAB_E868),A	;53E6:	3268E8
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;53ED:	7E
	INC	HL			; increment pointer
	OR	(HL)		;53EF:	B6
	JP	Z,LAB_5402	;53F0:	CA0254

	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;53F7:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;53F9:	56
	EX	DE,HL		;53FA:	EB
	LD	E,(HL)		;53FB:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;53FE:	EB
	JP	LAB_5405	;53FF:	C30554

LAB_5402
	LD	HL,0000h	;5402:	210000
LAB_5405
	LD	A,L		;5405:	7D
	LD	(LAB_E860),A	;5406:	3260E8
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;540D:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;5410:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_541F	;5416:	CA1F54

	LD	HL,0030h	;5419:	213000
	JP	LAB_5422	;541C:	C32254

LAB_541F
	LD	HL,0020h	;541F:	212000
LAB_5422
	LD	A,L		;5422:	7D
	LD	(LAB_E865),A	;5423:	3265E8
	LD	A,(LAB_E868)	;5426:	3A68E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;542C:	E5
	LD	HL,0018h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5431:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5433:	56
	PUSH	DE		;5434:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5439:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;543B:	56
	PUSH	DE		;543C:	D5
	CALL	LAB_583A	;543D:	CD3A58
	POP	DE		;5440:	D1
	POP	DE		;5441:	D1
	POP	DE		;5442:	D1
	JP	NZ,LAB_5464	;5443:	C26454

	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;544E:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5451:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5456:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5458:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_5464
	LD	HL,0000h	;5464:	210000
	LD	A,L		;5467:	7D
	LD	(LAB_E869),A	;5468:	3269E8
	LD	A,(LAB_E865)	;546B:	3A65E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;5471:	E5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5476:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5479:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;547E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5480:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;548C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;548E:	56
	EX	DE,HL		;548F:	EB
	LD	(LAB_E861),HL	;5490:	2261E8
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5497:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;549A:	EB
	DEC	HL		;549B:	2B
	EX	DE,HL		;549C:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;54A1:	E5
	LD	A,(HL)		;54A2:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;54A4:	66
	LD	L,A		;54A5:	6F
	ADD	HL,DE		;54A6:	19
	EX	DE,HL		;54A7:	EB
	POP	HL		;54A8:	E1
	LD	(HL),E		;54A9:	73
	INC	HL			; increment pointer
	LD	(HL),D		;54AB:	72
	LD	A,(LAB_E868)	;54AC:	3A68E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;54B2:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;54B7:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;54B9:	56
	PUSH	DE		;54BA:	D5
	CALL	LAB_576C	;54BB:	CD6C57
	POP	DE		;54BE:	D1
	POP	DE		;54BF:	D1
	LD	DE,FFFFh	;54C0:	11FFFF
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_54D0	;54C6:	CAD054

	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;54CC:	7D
	LD	(LAB_E869),A	;54CD:	3269E8
LAB_54D0
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;54D4:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0002h	;54D7:	210200
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_5513	;54DD:	CA1355

	LD	HL,LAB_E85C	;54E0:	215CE8
	PUSH	HL		;54E3:	E5
	LD	A,(LAB_E869)	;54E4:	3A69E8
	OR	A		;54E7:	B7
	JP	Z,LAB_54FD	;54E8:	CAFD54

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;54EF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;54F1:	56
	EX	DE,HL		;54F2:	EB
	LD	E,(HL)		;54F3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;54F5:	56
	EX	DE,HL		;54F6:	EB
	CALL	LAB_E09F		; does NEG HL (LAB_7BDA ROM 1)
	JP	LAB_5509	;54FA:	C30955

LAB_54FD
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5501:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5503:	56
	EX	DE,HL		;5504:	EB
	LD	E,(HL)		;5505:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5507:	56
	EX	DE,HL		;5508:	EB
LAB_5509
	CALL	LAB_DF42		; save HL as unsigned integer @  LAB_E3B1 (LAB_7A7D ROM 1)
	POP	HL		;550C:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
	JP	LAB_553E	;5510:	C33E55

LAB_5513
	LD	HL,LAB_E85C	;5513:	215CE8
	PUSH	HL		;5516:	E5
	LD	A,(LAB_E869)	;5517:	3A69E8
	OR	A		;551A:	B7
	JP	Z,LAB_552F	;551B:	CA2F55

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5522:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5524:	56
	EX	DE,HL		;5525:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC91		; does NEG.L (LAB_E3B1) (LAB_77CC)
	JP	LAB_553A	;552C:	C33A55
LAB_552F
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5533:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5535:	56
	EX	DE,HL		;5536:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
LAB_553A
	POP	HL		;553A:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
LAB_553E
	LD	A,(LAB_E860)	;553E:	3A60E8
	OR	A		;5541:	B7
	JP	NZ,LAB_554B	;5542:	C24B55

	LD	HL,0001h		; set HL = 0001h
	JP	LAB_5552	;5548:	C35255

LAB_554B
	LD	A,(LAB_E860)	;554B:	3A60E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	INC	HL		;5551:	23
LAB_5552
	LD	(LAB_E863),HL	;5552:	2263E8
	LD	HL,0000h	;5555:	210000
	LD	(LAB_E866),HL	;5558:	2266E8
LAB_555B
	LD	HL,LAB_E85C	;555B:	215CE8
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DCA1	;5561:	CDA1DC
	JP	NZ,LAB_5574	;5564:	C27455

	LD	HL,(LAB_E863)	;5567:	2A63E8
	LD	DE,0000h	;556A:	110000
	EX	DE,HL		;556D:	EB
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL
					; (LAB_7BC1 ROM 1)
	JP	Z,LAB_561F	;5571:	CA1F56
LAB_5574
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5578:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;557A:	56
	LD	HL,(LAB_E861)	;557B:	2A61E8
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_5588	;5581:	CA8855
	LD	HL,0000h	;5584:	210000
	RET				;

LAB_5588
	LD	A,(LAB_E860)	;5588:	3A60E8
	OR	A		;558B:	B7
	JP	Z,LAB_55BD	;558C:	CABD55
	LD	A,(LAB_E860)	;558F:	3A60E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;5595:	E5
	LD	HL,(LAB_E866)	;5596:	2A66E8
	POP	DE		;5599:	D1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_55BD	;559D:	CABD55
	LD	HL,002Eh	;55A0:	212E00
	PUSH	HL		;55A3:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;55A8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;55AA:	56
	EX	DE,HL		;55AB:	EB
	POP	DE		;55AC:	D1
	LD	(HL),E		;55AD:	73
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;55B2:	E5
	LD	A,(HL)		;55B3:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;55B5:	66
	LD	L,A		;55B6:	6F
	DEC	HL		;55B7:	2B
	EX	DE,HL		;55B8:	EB
	POP	HL		;55B9:	E1
	LD	(HL),E		;55BA:	73
	INC	HL			; increment pointer
	LD	(HL),D		;55BC:	72
LAB_55BD
	LD	HL,E85Ch	;55BD:	215CE8
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	0Ah,00h,00h,00h

	CALL	LAB_DDFA	;55CA:	CDFADD
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	30h,00h,00h,00h

	CALL	LAB_DCE9		; does ADC.L (LAB_E3B1),(LAB_E3B9) (LAB_7824)
	CALL	LAB_DF5B		; get unsigned integer from LAB_E3B1	(LAB_7A96 ROM 1)
	PUSH	HL		;55DA:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;55DF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;55E1:	56
	EX	DE,HL		;55E2:	EB
	POP	DE		;55E3:	D1
	LD	(HL),E		;55E4:	73
	LD	HL,E85Ch	;55E5:	215CE8
	PUSH	HL		;55E8:	E5
	CALL	LAB_DC30		; copies next four bytes after the call to LAB_E3B1
					; returns to instruction after the bytes (LAB_776B)

	DB	0Ah,00h,00h,00h

	CALL	LAB_DC74		; swap (LAB_E3B1) with (LAB_E3B9)	(LAB_77AF ROM 1)
	POP	HL		;55F3:	E1
	PUSH	HL		;55F4:	E5
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DDF4	;55F8:	CDF4DD
	POP	HL		;55FB:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;5603:	E5
	LD	A,(HL)		;5604:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;5606:	66
	LD	L,A		;5607:	6F
	DEC	HL		;5608:	2B
	EX	DE,HL		;5609:	EB
	POP	HL		;560A:	E1
	LD	(HL),E		;560B:	73
	INC	HL			; increment pointer
	LD	(HL),D		;560D:	72
	LD	HL,(LAB_E863)	;560E:	2A63E8
	DEC	HL		;5611:	2B
	LD	(LAB_E863),HL	;5612:	2263E8
	LD	HL,(LAB_E866)	;5615:	2A66E8
	INC	HL		;5618:	23
	LD	(LAB_E866),HL	;5619:	2266E8
	JP	LAB_555B	;561C:	C35B55
LAB_561F
	LD	A,(LAB_E869)	;561F:	3A69E8
	OR	A		;5622:	B7
	JP	Z,LAB_5648	;5623:	CA4856
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;562A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;562C:	56
	LD	HL,(LAB_E861)	;562D:	2A61E8
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_563A	;5633:	CA3A56
	LD	HL,0000h	;5636:	210000
	RET				;

LAB_563A
	LD	HL,002Dh	;563A:	212D00
	PUSH	HL		;563D:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5642:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5644:	56
	EX	DE,HL		;5645:	EB
	POP	DE		;5646:	D1
	LD	(HL),E		;5647:	73
LAB_5648
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_564C
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5656:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5658:	56
	EX	DE,HL		;5659:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	99h,99h,99h,19h

	CALL	LAB_DF36		; do IF (LAB_E3B1)>=(LAB_E3B9)	(LAB_7A71 ROM 1)
	JP	Z,LAB_566E	;5667:	CA6E56
	LD	HL,0000h	;566A:	210000
	RET				;

LAB_566E
	LD	HL,LAB_E86A	;566E:	216AE8
	PUSH	HL		;5671:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5676:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5678:	56
	EX	DE,HL		;5679:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	01h,00h,00h,00h	; shift count is 1

	CALL	LAB_DD5D		; does (LAB_E3B1)<<(LAB_E3B9) (LAB_7898)
	POP	HL		;5687:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
	LD	HL,LAB_E86E	;568B:	216EE8
	PUSH	HL		;568E:	E5
	LD	HL,LAB_E86A	;568F:	216AE8
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	02h,00h,00h,00h

	CALL	LAB_DD5D		; does (LAB_E3B1)<<(LAB_E3B9) (LAB_7898)
	POP	HL		;569F:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
	LD	HL,LAB_E86E	;56A3:	216EE8
	PUSH	HL		;56A6:	E5
	LD	HL,LAB_E86A	;56A7:	216AE8
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC74		; swap (LAB_E3B1) with (LAB_E3B9)	(LAB_77AF ROM 1)
	POP	HL		;56B0:	E1
	PUSH	HL		;56B1:	E5
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DCE9		; does ADC.L (LAB_E3B1),(LAB_E3B9) (LAB_7824)
	POP	HL		;56B8:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
	LD	HL,LAB_E86A	;56BC:	216AE8
	PUSH	HL		;56BF:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;56C4:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;56C7:	EB
	CALL	LAB_DF42		; save HL as unsigned integer @  LAB_E3B1 (LAB_7A7D ROM 1)
	LD	HL,LAB_E86E	;56CB:	216EE8
	CALL	LAB_DC2A		; copies four bytes from (HL) to LAB_E3B9 (LAB_7765)
	CALL	LAB_DCE9		; does ADC.L (LAB_E3B1),(LAB_E3B9) (LAB_7824)
	POP	HL		;56D4:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
	LD	HL,LAB_E86A	;56D8:	216AE8
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	LD	HL,LAB_E86E	;56DE:	216EE8
	CALL	LAB_DC2A		; copies four bytes from (HL) to LAB_E3B9 (LAB_7765)
	CALL	LAB_DF18		; do IF (LAB_E3B1)<(LAB_E3B9)		(LAB_7A53 ROM 1)
	JP	Z,LAB_56EE	;56E7:	CAEE56
	LD	HL,0000h	;56EA:	210000
	RET				;

LAB_56EE
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;56F2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;56F4:	56
	PUSH	DE		;56F5:	D5
	LD	HL,LAB_E86A	;56F6:	216AE8
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	POP	HL		;56FC:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
LAB_5700
	LD	HL,0001h		; set HL = 0001h
	RET				;

; stack is ..
; .L low word
; .L high word
; ??
;

LAB_5704
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;570E:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;5711:	EB
	ADD	HL,HL		;5712:	29
	ADD	HL,HL		;5713:	29
	LD	DE,LAB_E314	;5714:	1114E3
	ADD	HL,DE		;5717:	19
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	CALL	LAB_DC2A		; copies four bytes from (HL) to LAB_E3B9 (LAB_7765)
	CALL	LAB_DD13		; does AND.L (LAB_E3B1),(LAB_E3B9) (LAB_784E)
	CALL	LAB_DCA1	;5725:	CDA1DC
	JP	Z,LAB_5731	;5728:	CA3157

	LD	HL,0000h	;572B:	210000
	JP	LAB_5734		; may as well RET here

LAB_5731
	LD	HL,0001h		; set HL = 0001h
LAB_5734
	RET				;

LAB_5735
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;573F:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0002h	;5742:	210200
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	INC	HL		;5748:	23
	INC	HL		;5749:	23
	PUSH	HL		;574A:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;574F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5751:	56
	PUSH	DE		;5752:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5757:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;575A:	EB
	ADD	HL,HL		;575B:	29
	ADD	HL,HL		;575C:	29
	LD	DE,lab_E324	;575D:	1124E3
	ADD	HL,DE		;5760:	19
	PUSH	HL		;5761:	E5
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_576C
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;5776:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;5779:	EB
	JP	LAB_581F	;577A:	C31F58

LAB_577D
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5781:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5783:	56
	EX	DE,HL		;5784:	EB
	LD	E,(HL)		;5785:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5787:	56
	LD	HL,0000h		; set compare value
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_579A		; jump if DE+ve

	LD	HL,FFFFh	;5791:	21FFFF
	LD	(LAB_E872),HL	;5794:	2272E8
	JP	LAB_57AE	;5797:	C3AE57

LAB_579A
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;579E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;57A0:	56
	EX	DE,HL		;57A1:	EB
	LD	E,(HL)		;57A2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;57A4:	56
	LD	HL,0000h	;57A5:	210000
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL
					; (LAB_7BC1 ROM 1)
	LD	(LAB_E872),HL	;57AB:	2272E8
LAB_57AE
	JP	LAB_5836	;57AE:	C33658

LAB_57B1
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;57B5:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;57B7:	56
	EX	DE,HL		;57B8:	EB
	LD	E,(HL)		;57B9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;57BB:	56
	LD	HL,0000h	;57BC:	210000
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	LD	(LAB_E872),HL	;57C2:	2272E8
	JP	LAB_5836	;57C5:	C33658

LAB_57C8
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;57CC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;57CE:	56
	EX	DE,HL		;57CF:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	00h,00h,00h,00h

	CALL	LAB_DEEE		; do signed IF (LAB_E3B1)<(LAB_E3B9)	(LAB_7A29 ROM 1)
	JP	Z,LAB_57E9	;57DD:	CAE957
	LD	HL,FFFFh	;57E0:	21FFFF
	LD	(LAB_E872),HL	;57E3:	2272E8
	JP	LAB_5801	;57E6:	C30158

LAB_57E9
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;57ED:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;57EF:	56
	EX	DE,HL		;57F0:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	00h,00h,00h,00h

	CALL	LAB_DF0C		; do signed IF (LAB_E3B1)>=(LAB_E3B9)	(LAB_7A47 ROM 1)
	LD	(LAB_E872),HL	;57FE:	2272E8
LAB_5801
	JP	LAB_5836	;5801:	C33658

LAB_5804
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5808:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;580A:	56
	EX	DE,HL		;580B:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	00h,00h,00h,00h

	CALL	LAB_DF36		; do IF (LAB_E3B1)>=(LAB_E3B9)	(LAB_7A71 ROM 1)
	LD	(LAB_E872),HL	;5819:	2272E8
	JP	LAB_5836	;581C:	C33658

LAB_581F
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0004

	DW	0000
	DW	LAB_577D

	DW	0001
	DW	LAB_57B1

	DW	0002
	DW	LAB_57C8

	DW	0003
	DW	LAB_5804

	DW	LAB_5836

LAB_5836
	LD	HL,(LAB_E872)	;5836:	2A72E8
	RET				;

; stack is ..
; ??
; ??
; ??
; end.

LAB_583A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;5844:	7E
	INC	HL			; increment pointer
	OR	(HL)		;5846:	B6
	JP	NZ,LAB_584E	;5847:	C24E58

	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_584E
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5852:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;5855:	EB
	JP	LAB_5991	;5856:	C39159

LAB_5859
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;585D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;585F:	56
	EX	DE,HL		;5860:	EB
	INC	HL			; increment pointer
	LD	E,(HL)		;5862:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5864:	56
	PUSH	DE		;5865:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;586A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;586C:	56
	EX	DE,HL		;586D:	EB
	LD	E,(HL)		;586E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5870:	56
	POP	HL		;5871:	E1
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_5899	;5875:	CA9958
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;587C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;587E:	56
	EX	DE,HL		;587F:	EB
	INC	HL		;5880:	23
	INC	HL		;5881:	23
	INC	HL		;5882:	23
	LD	E,(HL)		;5883:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5885:	56
	PUSH	DE		;5886:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;588B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;588D:	56
	EX	DE,HL		;588E:	EB
	LD	E,(HL)		;588F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5891:	56
	POP	HL		;5892:	E1
	CALL	LAB_E06B		; does signed CP HL,DE. returns HL=1 if DE<=HL
					; (LAB_7BA6 ROM 1)
	JP	NZ,LAB_589F	;5896:	C29F58
LAB_5899
	LD	HL,0000h	;5899:	210000
	JP	LAB_58A2	;589C:	C3A258

LAB_589F
	LD	HL,0001h		; set HL = 0001h
LAB_58A2
	RET				;

LAB_58A3
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;58A7:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58A9:	56
	EX	DE,HL		;58AA:	EB
	INC	HL			; increment pointer
	LD	E,(HL)		;58AC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58AE:	56
	PUSH	DE		;58AF:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;58B4:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58B6:	56
	EX	DE,HL		;58B7:	EB
	LD	E,(HL)		;58B8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58BA:	56
	POP	HL		;58BB:	E1
	CALL	LAB_E0D9		; does CP DE,HL, returns HL=1 if HL<=DE (LAB_7C14 ROM 1)
	JP	Z,LAB_58E3	;58BF:	CAE358
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;58C6:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58C8:	56
	EX	DE,HL		;58C9:	EB
	INC	HL		;58CA:	23
	INC	HL		;58CB:	23
	INC	HL		;58CC:	23
	LD	E,(HL)		;58CD:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58CF:	56
	PUSH	DE		;58D0:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;58D5:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58D7:	56
	EX	DE,HL		;58D8:	EB
	LD	E,(HL)		;58D9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58DB:	56
	POP	HL		;58DC:	E1
	CALL	LAB_E0DA		; does CP HL,DE, returns HL=1 if DE<=HL (LAB_7C15 ROM 1)
	JP	NZ,LAB_58E9	;58E0:	C2E958
LAB_58E3
	LD	HL,0000h	;58E3:	210000
	JP	LAB_58EC	;58E6:	C3EC58
LAB_58E9
	LD	HL,0001h		; set HL = 0001h
LAB_58EC
	RET				;

LAB_58ED
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;58F1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58F3:	56
	EX	DE,HL		;58F4:	EB
	INC	HL		;58F5:	23
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC5B		; does push (LAB_E3B1).L	(LAB_7796 ROM 1)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5900:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5902:	56
	EX	DE,HL		;5903:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC69		; does pop (LAB_E3B9).L		(LAB_77A4 ROM 1)
	CALL	LAB_DF03		; do signed IF (LAB_E3B1)>(LAB_E3B9)	(LAB_7A3E ROM 1)
	JP	Z,LAB_5935	;590D:	CA3559
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5914:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5916:	56
	LD	HL,0005h	;5917:	210500
	ADD	HL,DE		;591A:	19
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC5B		; does push (LAB_E3B1).L	(LAB_7796 ROM 1)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5925:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5927:	56
	EX	DE,HL		;5928:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC69		; does pop (LAB_E3B9).L		(LAB_77A4 ROM 1)
	CALL	LAB_DEF7		; do signed IF (LAB_E3B1)<=(LAB_E3B9)	(LAB_7A32 ROM 1)
	JP	NZ,LAB_593B	;5932:	C23B59
LAB_5935
	LD	HL,0000h	;5935:	210000
	JP	LAB_593E	;5938:	C33E59

LAB_593B
	LD	HL,0001h		; set HL = 0001h
LAB_593E
	RET				;

LAB_593F
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5943:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5945:	56
	EX	DE,HL		;5946:	EB
	INC	HL		;5947:	23
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC5B		; does push (LAB_E3B1).L	(LAB_7796 ROM 1)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5952:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5954:	56
	EX	DE,HL		;5955:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC69		; does pop (LAB_E3B9).L		(LAB_77A4 ROM 1)
	CALL	LAB_DF2D		; do IF (LAB_E3B1)>(LAB_E3B9)		(LAB_7A68 ROM 1)
	JP	Z,LAB_5987	;595F:	CA8759
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5966:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5968:	56
	LD	HL,0005h	;5969:	210500
	ADD	HL,DE		;596C:	19
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC5B		; does push (LAB_E3B1).L	(LAB_7796 ROM 1)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5977:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5979:	56
	EX	DE,HL		;597A:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC69		; does pop (LAB_E3B9).L		(LAB_77A4 ROM 1)
	CALL	LAB_DF21	;5981:	CD21DF
	JP	NZ,LAB_598D	;5984:	C28D59
LAB_5987
	LD	HL,0000h	;5987:	210000
	JP	LAB_5990	;598A:	C39059
LAB_598D
	LD	HL,0001h		; set HL = 0001h
LAB_5990
	RET				;

LAB_5991
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0004

	DW	0000
	DW	LAB_5859

	DW	0001
	DW	LAB_58A3

	DW	0002
	DW	LAB_58ED

	DW	0003
	DW	LAB_593F

	DW	LAB_59A8

LAB_59A8
	RET				;

LAB_59A9
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;59B3:	5E
	LD	D,#00h		; clear high byte
	LD	HL,002Fh	;59B6:	212F00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_59DD	;59BC:	C2DD59

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;59C3:	5E
	LD	D,#00h		; clear high byte
	LD	HL,E104h	;59C6:	2104E1
	ADD	HL,DE		;59C9:	19
	INC	HL		;59CA:	23
	LD	E,(HL)		;59CB:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;59CE:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_59DD	;59D4:	C2DD59
	LD	HL,0000h	;59D7:	210000
	JP	LAB_59E0	;59DA:	C3E059
LAB_59DD
	LD	HL,0001h		; set HL = 0001h
LAB_59E0
	RET				;

LAB_59E1
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;59E7:	210000
	LD	(LAB_E879),HL	;59EA:	2279E8
	LD	A,L		;59ED:	7D
	LD	(LAB_E878),A	;59EE:	3278E8
	LD	A,L		;59F1:	7D
	LD	(LAB_E877),A	;59F2:	3277E8
	LD	HL,0020h	;59F5:	212000
	LD	A,L		;59F8:	7D
	LD	(LAB_E874),A	;59F9:	3274E8
	LD	HL,0000h	;59FC:	210000
	LD	A,L		;59FF:	7D
	LD	(LAB_E876),A	;5A00:	3276E8
	JP	LAB_5A0F	;5A03:	C30F5A
LAB_5A06
	LD	A,(LAB_E876)	;5A06:	3A76E8
	LD	L,A		;5A09:	6F
	INC	HL		;5A0A:	23
	LD	A,L		;5A0B:	7D
	LD	(LAB_E876),A	;5A0C:	3276E8
LAB_5A0F
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5A13:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5A16:	D5
	LD	A,(LAB_E876)	;5A17:	3A76E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;5A1D:	D1
	EX	DE,HL		;5A1E:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_5AFD	;5A22:	CAFD5A
	LD	A,(LAB_E874)	;5A25:	3A74E8
	LD	L,A		;5A28:	6F
	LD	A,L		;5A29:	7D
	LD	(LAB_E875),A	;5A2A:	3275E8
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5A31:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5A33:	56
	EX	DE,HL		;5A34:	EB
	LD	E,(HL)		;5A35:	5E
	EX	DE,HL		;5A36:	EB
	LD	A,L		;5A37:	7D
	LD	(LAB_E874),A	;5A38:	3274E8
	LD	A,(LAB_E874)	;5A3B:	3A74E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,E104h	;5A41:	1104E1
	ADD	HL,DE		;5A44:	19
	INC	HL		;5A45:	23
	LD	E,(HL)		;5A46:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;5A49:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_5A9B	;5A4F:	CA9B5A
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E879),HL	;5A55:	2279E8
	LD	A,(LAB_E875)	;5A58:	3A75E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,E104h	;5A5E:	1104E1
	ADD	HL,DE		;5A61:	19
	INC	HL		;5A62:	23
	LD	E,(HL)		;5A63:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;5A66:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_5A78	;5A6C:	C2785A
	LD	A,(LAB_E878)	;5A6F:	3A78E8
	LD	L,A		;5A72:	6F
	INC	HL		;5A73:	23
	LD	A,L		;5A74:	7D
	LD	(LAB_E878),A	;5A75:	3278E8
LAB_5A78
	LD	A,(LAB_E877)	;5A78:	3A77E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;5A7E:	E5
	LD	A,(LAB_E878)	;5A7F:	3A78E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;5A85:	D1
	EX	DE,HL		;5A86:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	DE,0001h	;5A8A:	110100
	EX	DE,HL		;5A8D:	EB
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL
					; (LAB_7BC1 ROM 1)
	JP	Z,LAB_5A98	;5A91:	CA985A
	LD	HL,0000h	;5A94:	210000
	RET				;

LAB_5A98
	JP	LAB_5AEB	;5A98:	C3EB5A
LAB_5A9B
	LD	A,(LAB_E874)	;5A9B:	3A74E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,002Fh	;5AA1:	112F00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_5AD5	;5AA7:	CAD55A
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E879),HL	;5AAD:	2279E8
	LD	A,(LAB_E877)	;5AB0:	3A77E8
	LD	L,A		;5AB3:	6F
	INC	HL		;5AB4:	23
	LD	A,L		;5AB5:	7D
	LD	(LAB_E877),A	;5AB6:	3277E8
	LD	A,(LAB_E878)	;5AB9:	3A78E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;5ABF:	E5
	LD	A,(LAB_E877)	;5AC0:	3A77E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;5AC6:	D1
	EX	DE,HL		;5AC7:	EB
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL
					; (LAB_7BC1 ROM 1)
	JP	Z,LAB_5AD2	;5ACB:	CAD25A
	LD	HL,0000h	;5ACE:	210000
	RET				;

LAB_5AD2
	JP	LAB_5AEB	;5AD2:	C3EB5A
LAB_5AD5
	LD	A,(LAB_E874)	;5AD5:	3A74E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0020h	;5ADB:	112000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_5AE7	;5AE1:	CAE75A
	JP	LAB_5AEB	;5AE4:	C3EB5A
LAB_5AE7
	LD	HL,0000h	;5AE7:	210000
	RET				;

LAB_5AEB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;5AEF:	E5
	LD	A,(HL)		;5AF0:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;5AF2:	66
	LD	L,A		;5AF3:	6F
	INC	HL		;5AF4:	23
	EX	DE,HL		;5AF5:	EB
	POP	HL		;5AF6:	E1
	LD	(HL),E		;5AF7:	73
	INC	HL			; increment pointer
	LD	(HL),D		;5AF9:	72
	JP	LAB_5A06	;5AFA:	C3065A
LAB_5AFD
	LD	HL,(LAB_E879)	;5AFD:	2A79E8
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_5B29	;5B02:	CA295B

	LD	A,(LAB_E878)	;5B05:	3A78E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0003h	;5B0B:	110300
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_5B23	;5B11:	CA235B
	LD	A,(LAB_E877)	;5B14:	3A77E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0002h	;5B1A:	110200
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_5B29	;5B20:	C2295B
LAB_5B23
	LD	HL,0000h	;5B23:	210000
	JP	LAB_5B2C	;5B26:	C32C5B
LAB_5B29
	LD	HL,0001h		; set HL = 0001h
LAB_5B2C
	RET				;

LAB_5B2D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5B37:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5B39:	56
	PUSH	DE		;5B3A:	D5
	CALL	LAB_DC30		; copies next four bytes after the call to LAB_E3B1
					; returns to instruction after the bytes (LAB_776B)

	DB	00h,00h,00h,00h

	POP	HL		;5B42:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
	LD	HL,0000h	;5B46:	210000
	LD	A,L		;5B49:	7D
	LD	(LAB_E87C),A	;5B4A:	327CE8
	LD	HL,0000h	;5B4D:	210000
	LD	A,L		;5B50:	7D
	LD	(LAB_E87B),A	;5B51:	327BE8
	JP	LAB_5B60	;5B54:	C3605B
LAB_5B57
	LD	A,(LAB_E87B)	;5B57:	3A7BE8
	LD	L,A		;5B5A:	6F
	INC	HL		;5B5B:	23
	LD	A,L		;5B5C:	7D
	LD	(LAB_E87B),A	;5B5D:	327BE8
LAB_5B60
	LD	A,(LAB_E87B)	;5B60:	3A7BE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0003h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_5CB7		; jump if DE>=3

LAB_5B70
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5B74:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5B76:	56
	EX	DE,HL		;5B77:	EB
	LD	E,(HL)		;5B78:	5E
	LD	D,#00h		; clear high byte
	LD	HL,E104h	;5B7B:	2104E1
	ADD	HL,DE		;5B7E:	19
	INC	HL		;5B7F:	23
	LD	E,(HL)		;5B80:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;5B83:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_5BC0	;5B89:	C2C05B
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5B90:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5B93:	D5
	LD	A,(LAB_E87C)	;5B94:	3A7CE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;5B9A:	D1
	EX	DE,HL		;5B9B:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_5BC0	;5B9F:	CAC05B
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;5BA6:	E5
	LD	A,(HL)		;5BA7:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;5BA9:	66
	LD	L,A		;5BAA:	6F
	INC	HL		;5BAB:	23
	EX	DE,HL		;5BAC:	EB
	POP	HL		;5BAD:	E1
	LD	(HL),E		;5BAE:	73
	INC	HL			; increment pointer
	LD	(HL),D		;5BB0:	72
	EX	DE,HL		;5BB1:	EB
	DEC	HL		;5BB2:	2B
	LD	A,(LAB_E87C)	;5BB3:	3A7CE8
	LD	L,A		;5BB6:	6F
	INC	HL		;5BB7:	23
	LD	A,L		;5BB8:	7D
	LD	(LAB_E87C),A	;5BB9:	327CE8
	DEC	HL		;5BBC:	2B
	JP	LAB_5B70	;5BBD:	C3705B
LAB_5BC0
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5BC4:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5BC7:	D5
	LD	A,(LAB_E87C)	;5BC8:	3A7CE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;5BCE:	D1
	EX	DE,HL		;5BCF:	EB
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_5BDA	;5BD3:	CADA5B
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_5BDA
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5BDE:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5BE0:	56
	EX	DE,HL		;5BE1:	EB
	LD	(LAB_E87D),HL	;5BE2:	227DE8
LAB_5BE5
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5BE9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5BEB:	56
	EX	DE,HL		;5BEC:	EB
	LD	E,(HL)		;5BED:	5E
	LD	D,#00h		; clear high byte
	LD	HL,E104h	;5BF0:	2104E1
	ADD	HL,DE		;5BF3:	19
	INC	HL		;5BF4:	23
	LD	E,(HL)		;5BF5:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;5BF8:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_5C35	;5BFE:	CA355C
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5C05:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5C08:	D5
	LD	A,(LAB_E87C)	;5C09:	3A7CE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;5C0F:	D1
	EX	DE,HL		;5C10:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_5C35	;5C14:	CA355C
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;5C1B:	E5
	LD	A,(HL)		;5C1C:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;5C1E:	66
	LD	L,A		;5C1F:	6F
	INC	HL		;5C20:	23
	EX	DE,HL		;5C21:	EB
	POP	HL		;5C22:	E1
	LD	(HL),E		;5C23:	73
	INC	HL			; increment pointer
	LD	(HL),D		;5C25:	72
	EX	DE,HL		;5C26:	EB
	DEC	HL		;5C27:	2B
	LD	A,(LAB_E87C)	;5C28:	3A7CE8
	LD	L,A		;5C2B:	6F
	INC	HL		;5C2C:	23
	LD	A,L		;5C2D:	7D
	LD	(LAB_E87C),A	;5C2E:	327CE8
	DEC	HL		;5C31:	2B
	JP	LAB_5BE5	;5C32:	C3E55B
LAB_5C35
	LD	HL,0000h	;5C35:	210000
	PUSH	HL		;5C38:	E5
	LD	HL,0000h	;5C39:	210000
	PUSH	HL		;5C3C:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5C41:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5C43:	56
	LD	HL,(LAB_E87D)	;5C44:	2A7DE8
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL		;5C4A:	E5
	LD	HL,0004h	;5C4B:	210400
	PUSH	HL		;5C4E:	E5
	LD	A,(LAB_E87B)	;5C4F:	3A7BE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,HL		;5C55:	29
	LD	DE,E87Fh	;5C56:	117FE8
	ADD	HL,DE		;5C59:	19
	PUSH	HL		;5C5A:	E5
	LD	HL,(LAB_E87D)	;5C5B:	2A7DE8
	PUSH	HL		;5C5E:	E5
	CALL	LAB_51C1	;5C5F:	CDC151
	EX	DE,HL		;5C62:	EB
	LD	HL,000Ch		; C ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	A,(LAB_E87B)	;5C68:	3A7BE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,HL		;5C6E:	29
	LD	DE,E33Ah	;5C6F:	113AE3
	ADD	HL,DE		;5C72:	19
	LD	E,(HL)		;5C73:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5C75:	56
	PUSH	DE		;5C76:	D5
	LD	A,(LAB_E87B)	;5C77:	3A7BE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,HL		;5C7D:	29
	LD	DE,E87Fh	;5C7E:	117FE8
	ADD	HL,DE		;5C81:	19
	LD	E,(HL)		;5C82:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5C84:	56
	POP	HL		;5C85:	E1
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	NZ,LAB_5CB0	;5C89:	C2B05C
	LD	A,(LAB_E87B)	;5C8C:	3A7BE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,HL		;5C92:	29
	LD	DE,E334h	;5C93:	1134E3
	ADD	HL,DE		;5C96:	19
	LD	E,(HL)		;5C97:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5C99:	56
	PUSH	DE		;5C9A:	D5
	LD	A,(LAB_E87B)	;5C9B:	3A7BE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,HL		;5CA1:	29
	LD	DE,E87Fh	;5CA2:	117FE8
	ADD	HL,DE		;5CA5:	19
	LD	E,(HL)		;5CA6:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5CA8:	56
	POP	HL		;5CA9:	E1
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_5CB4	;5CAD:	CAB45C
LAB_5CB0
	LD	HL,0000h	;5CB0:	210000
	RET				;

LAB_5CB4
	JP	LAB_5B57	;5CB4:	C3575B
LAB_5CB7
	LD	HL,(LAB_E881)	;5CB7:	2A81E8
	LD	DE,0002h	;5CBA:	110200
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_5CEB	;5CC0:	CAEB5C
	LD	HL,(LAB_E883)	;5CC3:	2A83E8
	LD	DE,0003h	;5CC6:	110300
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_5CD5	;5CCC:	CAD55C
	LD	HL,001Ch	;5CCF:	211C00
	JP	LAB_5CD8	;5CD2:	C3D85C
LAB_5CD5
	LD	HL,001Dh	;5CD5:	211D00
LAB_5CD8
	PUSH	HL		;5CD8:	E5
	LD	HL,(LAB_E87F)	;5CD9:	2A7FE8
	POP	DE		;5CDC:	D1
	EX	DE,HL		;5CDD:	EB
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_5CE8	;5CE1:	CAE85C
	LD	HL,0000h	;5CE4:	210000
	RET				;

LAB_5CE8
	JP	LAB_5D06	;5CE8:	C3065D
LAB_5CEB
	LD	HL,(LAB_E881)	;5CEB:	2A81E8
	LD	DE,E343h	;5CEE:	1143E3
	ADD	HL,DE		;5CF1:	19
	DEC	HL		;5CF2:	2B
	LD	E,(HL)		;5CF3:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5CF6:	D5
	LD	HL,(LAB_E87F)	;5CF7:	2A7FE8
	POP	DE		;5CFA:	D1
	EX	DE,HL		;5CFB:	EB
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_5D06	;5CFF:	CA065D
	LD	HL,0000h	;5D02:	210000
	RET				;

LAB_5D06
	LD	HL,(LAB_E883)	;5D06:	2A83E8
	LD	DE,076Ch	;5D09:	116C07
	ADD	HL,DE		;5D0C:	19
	PUSH	HL		;5D0D:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5D12:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5D14:	56
	EX	DE,HL		;5D15:	EB
	INC	HL		;5D16:	23
	INC	HL		;5D17:	23
	POP	DE		;5D18:	D1
	LD	(HL),E		;5D19:	73
	INC	HL			; increment pointer
	LD	(HL),D		;5D1B:	72
	LD	HL,(LAB_E87F)	;5D1C:	2A7FE8
	PUSH	HL		;5D1F:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5D24:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5D26:	56
	EX	DE,HL		;5D27:	EB
	POP	DE		;5D28:	D1
	LD	(HL),E		;5D29:	73
	LD	HL,(LAB_E881)	;5D2A:	2A81E8
	PUSH	HL		;5D2D:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5D32:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5D34:	56
	EX	DE,HL		;5D35:	EB
	INC	HL		;5D36:	23
	POP	DE		;5D37:	D1
	LD	(HL),E		;5D38:	73
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_5D3D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;5D47:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0008h		; set compare value
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_5D57		; jump if DE>=8

	LD	HL,0000h	;5D53:	210000
	RET				;

LAB_5D57
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5D5B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5D5D:	56
	EX	DE,HL		;5D5E:	EB
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DCA1	;5D62:	CDA1DC
	JP	NZ,LAB_5D86	;5D65:	C2865D

	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5D70:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5D73:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5D78:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5D7A:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_5D86
	LD	HL,002Fh	;5D86:	212F00
	PUSH	HL		;5D89:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5D8E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5D90:	56
	LD	HL,0005h	;5D91:	210500
	ADD	HL,DE		;5D94:	19
	POP	DE		;5D95:	D1
	LD	(HL),E		;5D96:	73
	PUSH	DE		;5D97:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5D9C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5D9E:	56
	EX	DE,HL		;5D9F:	EB
	INC	HL		;5DA0:	23
	INC	HL		;5DA1:	23
	POP	DE		;5DA2:	D1
	LD	(HL),E		;5DA3:	73
	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5DAC:	5E
	LD	D,#00h		; clear high byte
	LD	HL,FFF8h	;5DAF:	21F8FF
	ADD	HL,DE		;5DB2:	19
	PUSH	HL		;5DB3:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5DB8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5DBA:	56
	LD	HL,0008h	;5DBB:	210800
	ADD	HL,DE		;5DBE:	19
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,0000h	;5DC6:	210000
	LD	A,L		;5DC9:	7D
	LD	(LAB_E887),A	;5DCA:	3287E8
	JP	LAB_5DD9	;5DCD:	C3D95D
LAB_5DD0
	LD	A,(LAB_E887)	;5DD0:	3A87E8
	LD	L,A		;5DD3:	6F
	INC	HL		;5DD4:	23
	LD	A,L		;5DD5:	7D
	LD	(LAB_E887),A	;5DD6:	3287E8
LAB_5DD9
	LD	A,(LAB_E887)	;5DD9:	3A87E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0003h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_5E78		; jump if DE>=3

	LD	A,(LAB_E887)	;5DE9:	3A87E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	JP	LAB_5E2E	;5DEF:	C32E5E

LAB_5DF2
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5DF6:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5DF8:	56
	EX	DE,HL		;5DF9:	EB
	LD	E,(HL)		;5DFA:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;5DFD:	EB
	LD	(LAB_E885),HL	;5DFE:	2285E8
	JP	LAB_5E41	;5E01:	C3415E

LAB_5E04
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5E08:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5E0A:	56
	EX	DE,HL		;5E0B:	EB
	INC	HL		;5E0C:	23
	LD	E,(HL)		;5E0D:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;5E10:	EB
	LD	(LAB_E885),HL	;5E11:	2285E8
	JP	LAB_5E41	;5E14:	C3415E

LAB_5E17
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5E1B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5E1D:	56
	EX	DE,HL		;5E1E:	EB
	INC	HL		;5E1F:	23
	INC	HL		;5E20:	23
	LD	E,(HL)		;5E21:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5E23:	56
	LD	HL,F894h	;5E24:	2194F8
	ADD	HL,DE		;5E27:	19
	LD	(LAB_E885),HL	;5E28:	2285E8
	JP	LAB_5E41	;5E2B:	C3415E

LAB_5E2E
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0003

	DW	0000
	DW	LAB_5DF2

	DW	0001
	DW	LAB_5E04

	DW	0002
	DW	LAB_5E17

	DW	LAB_5E41

LAB_5E41
	LD	HL,0000h	;5E41:	210000
	PUSH	HL		;5E44:	E5
	LD	HL,0004h	;5E45:	210400
	PUSH	HL		;5E48:	E5
	LD	HL,0002h	;5E49:	210200
	PUSH	HL		;5E4C:	E5
	LD	HL,0002h	;5E4D:	210200
	PUSH	HL		;5E50:	E5
	LD	A,(LAB_E887)	;5E51:	3A87E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,E340h	;5E57:	1140E3
	ADD	HL,DE		;5E5A:	19
	LD	E,(HL)		;5E5B:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;5E62:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;5E64:	66
	LD	L,A		;5E65:	6F
	ADD	HL,DE		;5E66:	19
	PUSH	HL		;5E67:	E5
	LD	HL,LAB_E885	;5E68:	2185E8
	PUSH	HL		;5E6B:	E5
	CALL	LAB_53C6	;5E6C:	CDC653
	EX	DE,HL		;5E6F:	EB
	LD	HL,000Ch		; C ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	JP	LAB_5DD0	;5E75:	C3D05D
LAB_5E78
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_5E7C
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5E86:	5E
	LD	D,#00h		; clear high byte
	LD	HL,002Eh	;5E89:	212E00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_5EB0	;5E8F:	C2B05E

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5E96:	5E
	LD	D,#00h		; clear high byte
	LD	HL,E104h	;5E99:	2104E1
	ADD	HL,DE		;5E9C:	19
	INC	HL		;5E9D:	23
	LD	E,(HL)		;5E9E:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;5EA1:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_5EB0	;5EA7:	C2B05E
	LD	HL,0000h	;5EAA:	210000
	JP	LAB_5EB3	;5EAD:	C3B35E
LAB_5EB0
	LD	HL,0001h		; set HL = 0001h
LAB_5EB3
	RET				;

LAB_5EB4
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;5EBA:	210000
	LD	(LAB_E88D),HL	;5EBD:	228DE8
	LD	A,L		;5EC0:	7D
	LD	(LAB_E88C),A	;5EC1:	328CE8
	LD	A,L		;5EC4:	7D
	LD	(LAB_E88B),A	;5EC5:	328BE8
	LD	HL,0020h	;5EC8:	212000
	LD	A,L		;5ECB:	7D
	LD	(LAB_E888),A	;5ECC:	3288E8
	LD	HL,0000h	;5ECF:	210000
	LD	A,L		;5ED2:	7D
	LD	(LAB_E88A),A	;5ED3:	328AE8
	JP	LAB_5EE2	;5ED6:	C3E25E
LAB_5ED9
	LD	A,(LAB_E88A)	;5ED9:	3A8AE8
	LD	L,A		;5EDC:	6F
	INC	HL		;5EDD:	23
	LD	A,L		;5EDE:	7D
	LD	(LAB_E88A),A	;5EDF:	328AE8
LAB_5EE2
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5EE6:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5EE9:	D5
	LD	A,(LAB_E88A)	;5EEA:	3A8AE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;5EF0:	D1
	EX	DE,HL		;5EF1:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_5FD0	;5EF5:	CAD05F
	LD	A,(LAB_E888)	;5EF8:	3A88E8
	LD	L,A		;5EFB:	6F
	LD	A,L		;5EFC:	7D
	LD	(LAB_E889),A	;5EFD:	3289E8
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5F04:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5F06:	56
	EX	DE,HL		;5F07:	EB
	LD	E,(HL)		;5F08:	5E
	EX	DE,HL		;5F09:	EB
	LD	A,L		;5F0A:	7D
	LD	(LAB_E888),A	;5F0B:	3288E8
	LD	A,(LAB_E888)	;5F0E:	3A88E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,E104h	;5F14:	1104E1
	ADD	HL,DE		;5F17:	19
	INC	HL		;5F18:	23
	LD	E,(HL)		;5F19:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;5F1C:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_5F6E	;5F22:	CA6E5F
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E88D),HL	;5F28:	228DE8
	LD	A,(LAB_E889)	;5F2B:	3A89E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,E104h	;5F31:	1104E1
	ADD	HL,DE		;5F34:	19
	INC	HL		;5F35:	23
	LD	E,(HL)		;5F36:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;5F39:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_5F4B	;5F3F:	C24B5F
	LD	A,(LAB_E88C)	;5F42:	3A8CE8
	LD	L,A		;5F45:	6F
	INC	HL		;5F46:	23
	LD	A,L		;5F47:	7D
	LD	(LAB_E88C),A	;5F48:	328CE8
LAB_5F4B
	LD	A,(LAB_E88B)	;5F4B:	3A8BE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;5F51:	E5
	LD	A,(LAB_E88C)	;5F52:	3A8CE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;5F58:	D1
	EX	DE,HL		;5F59:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	DE,0001h	;5F5D:	110100
	EX	DE,HL		;5F60:	EB
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL
					; (LAB_7BC1 ROM 1)
	JP	Z,LAB_5F6B	;5F64:	CA6B5F
	LD	HL,0000h	;5F67:	210000
	RET				;

LAB_5F6B
	JP	LAB_5FBE	;5F6B:	C3BE5F
LAB_5F6E
	LD	A,(LAB_E888)	;5F6E:	3A88E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,002Eh	;5F74:	112E00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_5FA8	;5F7A:	CAA85F
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E88D),HL	;5F80:	228DE8
	LD	A,(LAB_E88B)	;5F83:	3A8BE8
	LD	L,A		;5F86:	6F
	INC	HL		;5F87:	23
	LD	A,L		;5F88:	7D
	LD	(LAB_E88B),A	;5F89:	328BE8
	LD	A,(LAB_E88C)	;5F8C:	3A8CE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;5F92:	E5
	LD	A,(LAB_E88B)	;5F93:	3A8BE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;5F99:	D1
	EX	DE,HL		;5F9A:	EB
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL
					; (LAB_7BC1 ROM 1)
	JP	Z,LAB_5FA5	;5F9E:	CAA55F
	LD	HL,0000h	;5FA1:	210000
	RET				;

LAB_5FA5
	JP	LAB_5FBE	;5FA5:	C3BE5F
LAB_5FA8
	LD	A,(LAB_E888)	;5FA8:	3A88E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0020h	;5FAE:	112000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_5FBA	;5FB4:	CABA5F
	JP	LAB_5FBE	;5FB7:	C3BE5F
LAB_5FBA
	LD	HL,0000h	;5FBA:	210000
	RET				;

LAB_5FBE
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;5FC2:	E5
	LD	A,(HL)		;5FC3:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;5FC5:	66
	LD	L,A		;5FC6:	6F
	INC	HL		;5FC7:	23
	EX	DE,HL		;5FC8:	EB
	POP	HL		;5FC9:	E1
	LD	(HL),E		;5FCA:	73
	INC	HL			; increment pointer
	LD	(HL),D		;5FCC:	72
	JP	LAB_5ED9	;5FCD:	C3D95E
LAB_5FD0
	LD	HL,(LAB_E88D)	;5FD0:	2A8DE8
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_5FFC	;5FD5:	CAFC5F

	LD	A,(LAB_E88C)	;5FD8:	3A8CE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0002h	;5FDE:	110200
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_5FF6	;5FE4:	CAF65F
	LD	A,(LAB_E88B)	;5FE7:	3A8BE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0001h	;5FED:	110100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_5FFC	;5FF3:	C2FC5F
LAB_5FF6
	LD	HL,0000h	;5FF6:	210000
	JP	LAB_5FFF	;5FF9:	C3FF5F
LAB_5FFC
	LD	HL,0001h		; set HL = 0001h
LAB_5FFF
	RET				;

LAB_6000
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;6006:	210000
	PUSH	HL		;6009:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;600E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6010:	56
	EX	DE,HL		;6011:	EB
	POP	DE		;6012:	D1
	LD	(HL),E		;6013:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6015:	72
	LD	HL,0000h	;6016:	210000
	LD	A,L		;6019:	7D
	LD	(LAB_E890),A	;601A:	3290E8
	LD	HL,0000h	;601D:	210000
	LD	A,L		;6020:	7D
	LD	(LAB_E88F),A	;6021:	328FE8
	JP	LAB_6030	;6024:	C33060
LAB_6027
	LD	A,(LAB_E88F)	;6027:	3A8FE8
	LD	L,A		;602A:	6F
	INC	HL		;602B:	23
	LD	A,L		;602C:	7D
	LD	(LAB_E88F),A	;602D:	328FE8
LAB_6030
	LD	A,(LAB_E88F)	;6030:	3A8FE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0002h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_6180		; jump if DE>=2

LAB_6040
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6044:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6046:	56
	EX	DE,HL		;6047:	EB
	LD	E,(HL)		;6048:	5E
	LD	D,#00h		; clear high byte
	LD	HL,E104h	;604B:	2104E1
	ADD	HL,DE		;604E:	19
	INC	HL		;604F:	23
	LD	E,(HL)		;6050:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;6053:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	NZ,LAB_6090	;6059:	C29060
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6060:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;6063:	D5
	LD	A,(LAB_E890)	;6064:	3A90E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;606A:	D1
	EX	DE,HL		;606B:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_6090	;606F:	CA9060
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;6076:	E5
	LD	A,(HL)		;6077:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;6079:	66
	LD	L,A		;607A:	6F
	INC	HL		;607B:	23
	EX	DE,HL		;607C:	EB
	POP	HL		;607D:	E1
	LD	(HL),E		;607E:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6080:	72
	EX	DE,HL		;6081:	EB
	DEC	HL		;6082:	2B
	LD	A,(LAB_E890)	;6083:	3A90E8
	LD	L,A		;6086:	6F
	INC	HL		;6087:	23
	LD	A,L		;6088:	7D
	LD	(LAB_E890),A	;6089:	3290E8
	DEC	HL		;608C:	2B
	JP	LAB_6040	;608D:	C34060
LAB_6090
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6094:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;6097:	D5
	LD	A,(LAB_E890)	;6098:	3A90E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;609E:	D1
	EX	DE,HL		;609F:	EB
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_60BA	;60A3:	CABA60
	LD	HL,FFFFh	;60A6:	21FFFF
	PUSH	HL		;60A9:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;60AE:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;60B0:	56
	EX	DE,HL		;60B1:	EB
	POP	DE		;60B2:	D1
	LD	(HL),E		;60B3:	73
	INC	HL			; increment pointer
	LD	(HL),D		;60B5:	72
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_60BA
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;60BE:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;60C0:	56
	EX	DE,HL		;60C1:	EB
	LD	(LAB_E891),HL	;60C2:	2291E8
LAB_60C5
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;60C9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;60CB:	56
	EX	DE,HL		;60CC:	EB
	LD	E,(HL)		;60CD:	5E
	LD	D,#00h		; clear high byte
	LD	HL,E104h	;60D0:	2104E1
	ADD	HL,DE		;60D3:	19
	INC	HL		;60D4:	23
	LD	E,(HL)		;60D5:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;60D8:	210400
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_6115	;60DE:	CA1561
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;60E5:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;60E8:	D5
	LD	A,(LAB_E890)	;60E9:	3A90E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;60EF:	D1
	EX	DE,HL		;60F0:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_6115	;60F4:	CA1561
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;60FB:	E5
	LD	A,(HL)		;60FC:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;60FE:	66
	LD	L,A		;60FF:	6F
	INC	HL		;6100:	23
	EX	DE,HL		;6101:	EB
	POP	HL		;6102:	E1
	LD	(HL),E		;6103:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6105:	72
	EX	DE,HL		;6106:	EB
	DEC	HL		;6107:	2B
	LD	A,(LAB_E890)	;6108:	3A90E8
	LD	L,A		;610B:	6F
	INC	HL		;610C:	23
	LD	A,L		;610D:	7D
	LD	(LAB_E890),A	;610E:	3290E8
	DEC	HL		;6111:	2B
	JP	LAB_60C5	;6112:	C3C560
LAB_6115
	LD	HL,0000h	;6115:	210000
	PUSH	HL		;6118:	E5
	LD	HL,0000h	;6119:	210000
	PUSH	HL		;611C:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6121:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6123:	56
	LD	HL,(LAB_E891)	;6124:	2A91E8
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	PUSH	HL		;612A:	E5
	LD	HL,0004h	;612B:	210400
	PUSH	HL		;612E:	E5
	LD	HL,E893h	;612F:	2193E8
	PUSH	HL		;6132:	E5
	LD	HL,(LAB_E891)	;6133:	2A91E8
	PUSH	HL		;6136:	E5
	CALL	LAB_51C1	;6137:	CDC151
	EX	DE,HL		;613A:	EB
	LD	HL,000Ch		; C ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	A,(LAB_E88F)	;6140:	3A8FE8
LAB_6143
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,HL		;6146:	29
	LD	DE,E34Fh	;6147:	114FE3
	ADD	HL,DE		;614A:	19
	LD	E,(HL)		;614B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;614D:	56
	PUSH	DE		;614E:	D5
	LD	HL,(LAB_E893)	;614F:	2A93E8
	POP	DE		;6152:	D1
	EX	DE,HL		;6153:	EB
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_615E	;6157:	CA5E61
	LD	HL,0000h	;615A:	210000
	RET				;

LAB_615E
	LD	HL,(LAB_E893)	;615E:	2A93E8
	PUSH	HL		;6161:	E5
	LD	A,(LAB_E88F)	;6162:	3A8FE8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;6168:	E5
	LD	HL,0001h		; set HL = 0001h
	POP	DE		;616C:	D1
	EX	DE,HL		;616D:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	EX	DE,HL		;6171:	EB
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;6176:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;6178:	66
	LD	L,A		;6179:	6F
	ADD	HL,DE		;617A:	19
	POP	DE		;617B:	D1
	LD	(HL),E		;617C:	73
	JP	LAB_6027	;617D:	C32760
LAB_6180
	LD	HL,0001h		; set HL = 0001h
	RET				;

; stack is ..
; ?? pointer
; ??
; ??
; ??

LAB_6184
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;618E:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0005h		; set compare value
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_619E		; jump if DE>=5

	LD	HL,0000h		; else clear HL
	RET				;

LAB_619E
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;61A2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;61A4:	56
	EX	DE,HL		;61A5:	EB
	LD	E,(HL)		;61A6:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;61A8:	56
	LD	HL,FFFFh	;61A9:	21FFFF
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_61D0	;61AF:	CAD061

	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;61BA:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;61BD:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;61C2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;61C4:	56
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_61D0
	LD	HL,002Eh		; "."
	PUSH	HL		;61D3:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;61D8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;61DA:	56
	EX	DE,HL		;61DB:	EB
	INC	HL		;61DC:	23
	INC	HL		;61DD:	23
	POP	DE		;61DE:	D1
	LD	(HL),E		;61DF:	73
	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;61E8:	5E
	LD	D,#00h		; clear high byte
	LD	HL,FFFBh		; -5
	ADD	HL,DE		;61EE:	19
	PUSH	HL			; push count
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;61F4:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;61F6:	56
	LD	HL,0005h	;61F7:	210500
	ADD	HL,DE		;61FA:	19
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,0000h	;6202:	210000
	LD	A,L		;6205:	7D
	LD	(LAB_E897),A	;6206:	3297E8
	JP	LAB_6215	;6209:	C31562
LAB_620C
	LD	A,(LAB_E897)	;620C:	3A97E8
	LD	L,A		;620F:	6F
	INC	HL		;6210:	23
	LD	A,L		;6211:	7D
	LD	(LAB_E897),A	;6212:	3297E8
LAB_6215
	LD	A,(LAB_E897)	;6215:	3A97E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0002h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_627C		; jump if DE>=2

	LD	A,(LAB_E897)	;6225:	3A97E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;622B:	E5
	LD	HL,0001h		; set HL = 0001h
	POP	DE		;622F:	D1
	EX	DE,HL		;6230:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	EX	DE,HL		;6234:	EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;6239:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;623B:	66
	LD	L,A		;623C:	6F
	ADD	HL,DE		;623D:	19
	LD	E,(HL)		;623E:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;6241:	EB
	LD	(LAB_E895),HL	;6242:	2295E8
	LD	HL,0000h	;6245:	210000
	PUSH	HL		;6248:	E5
	LD	HL,0004h	;6249:	210400
	PUSH	HL		;624C:	E5
	LD	HL,0002h	;624D:	210200
	PUSH	HL		;6250:	E5
	LD	HL,0002h	;6251:	210200
	PUSH	HL		;6254:	E5
	LD	A,(LAB_E897)	;6255:	3A97E8
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,E353h	;625B:	1153E3
	ADD	HL,DE		;625E:	19
	LD	E,(HL)		;625F:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;6266:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;6268:	66
	LD	L,A		;6269:	6F
	ADD	HL,DE		;626A:	19
	PUSH	HL		;626B:	E5
	LD	HL,LAB_E895	;626C:	2195E8
	PUSH	HL		;626F:	E5
	CALL	LAB_53C6	;6270:	CDC653
	EX	DE,HL		;6273:	EB
	LD	HL,000Ch		; C ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	JP	LAB_620C	;6279:	C30C62
LAB_627C
	LD	HL,0001h		; set HL = 0001h
	RET				;

LAB_6280
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_EB18)	;6286:	2A18EB
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_6291		; exit if null (could RET Z here)

	CALL	LAB_EF24		; do BIOS function 19
LAB_6291
	RET				;

LAB_6292
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;629C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;629E:	56
	EX	DE,HL		;629F:	EB
	INC	HL		;62A0:	23
	INC	HL		;62A1:	23
	LD	E,(HL)		;62A2:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;62A5:	EB
	JP	LAB_62D1	;62A6:	C3D162

LAB_62A9
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;62AD:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;62AF:	56
	EX	DE,HL		;62B0:	EB
	LD	E,(HL)		;62B1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;62B3:	56
	EX	DE,HL		;62B4:	EB
	RET				;

LAB_62B6
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;62BA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;62BC:	56
	EX	DE,HL		;62BD:	EB
	LD	E,(HL)		;62BE:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;62C0:	56
	PUSH	DE		;62C1:	D5
	CALL	LAB_6633	;62C2:	CD3366
	POP	DE		;62C5:	D1
	LD	HL,(LAB_EC5D)	;62C6:	2A5DEC
	RET				;

; set (LAB_E89A) = 0001h

LAB_62CA
	CALL	LAB_65F5		; set (LAB_E89A) = 0001h
	LD	HL,0000h		; clear HL
	RET				;

LAB_62D1
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0003

	DW	0001
	DW	LAB_62A9

	DW	0002
	DW	LAB_62B6

	DW	0004
	DW	LAB_62CA		; set (LAB_E89A) = 0001h

	DW	LAB_62E4		; exit

LAB_62E4
	RET				;

LAB_62E5
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;62EF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;62F1:	56
	EX	DE,HL		;62F2:	EB
	INC	HL		;62F3:	23
	INC	HL		;62F4:	23
	LD	E,(HL)		;62F5:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0004h	;62F8:	210400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	NZ,LAB_6315	;62FE:	C21563
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6305:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6307:	56
	EX	DE,HL		;6308:	EB
	LD	A,(HL)		;6309:	7E
	INC	HL			; increment pointer
	OR	(HL)		;630B:	B6
	JP	NZ,LAB_6315	;630C:	C21563
	LD	HL,0000h	;630F:	210000
	JP	LAB_6318	;6312:	C31863
LAB_6315
	LD	HL,0001h		; set HL = 0001h
LAB_6318
	RET				;

LAB_6319
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,F168h	;631F:	2168F1
	LD	(LAB_EB39),HL	;6322:	2239EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6329:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;632B:	56
	EX	DE,HL		;632C:	EB
	INC	HL		;632D:	23
	LD	E,(HL)		;632E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6330:	56
	EX	DE,HL		;6331:	EB
	LD	(LAB_EB08),HL	;6332:	2208EB
	LD	HL,0004h	;6335:	210400
	LD	(LAB_EBF7),HL	;6338:	22F7EB
	CALL	LAB_6280	;633B:	CD8062
	LD	HL,(LAB_EB08)	;633E:	2A08EB
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	LD	HL,0005h	;6344:	210500
	LD	(LAB_EBF7),HL	;6347:	22F7EB
	CALL	LAB_6280	;634A:	CD8062
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6351:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6353:	56
	EX	DE,HL		;6354:	EB
	INC	HL		;6355:	23
	INC	HL		;6356:	23
	INC	HL		;6357:	23
	PUSH	HL		;6358:	E5
	CALL	LAB_6292	;6359:	CD9262
	POP	DE		;635C:	D1
	RET				;

; stack is ..
; ??
;

LAB_635E
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;6364:	210000
	LD	(LAB_EB43),HL	;6367:	2243EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;636E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6370:	56
	LD	HL,0004h	;6371:	210400
	ADD	HL,DE		;6374:	19
	LD	E,(HL)		;6375:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6377:	56
	EX	DE,HL		;6378:	EB
	LD	(LAB_EB39),HL	;6379:	2239EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6380:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6382:	56
	LD	HL,0006h	;6383:	210600
	ADD	HL,DE		;6386:	19
	LD	E,(HL)		;6387:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6389:	56
	EX	DE,HL		;638A:	EB
	LD	(LAB_EB08),HL	;638B:	2208EB
	LD	HL,0000h	;638E:	210000
	LD	(LAB_EBF7),HL	;6391:	22F7EB
	LD	HL,(LAB_EB39)	;6394:	2A39EB
	LD	DE,F168h	;6397:	1168F1
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_63A3	;639D:	CAA363
	CALL	LAB_6280	;63A0:	CD8062
LAB_63A3
	LD	HL,(LAB_EB39)	;63A3:	2A39EB
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EBF7),HL	;63AC:	22F7EB
	CALL	LAB_6280	;63AF:	CD8062
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #_0 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get #_0 high byte
	EX	DE,HL			; swap to HL
	INC	HL			; +1
	INC	HL			; +2
	LD	E,(HL)		;63BC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;63BE:	56
	PUSH	DE		;63BF:	D5
	CALL	LAB_183C	;63C0:	CD3C18
	POP	DE		;63C3:	D1
	CALL	LAB_198E	;63C4:	CD8E19
	LD	HL,0000h	;63C7:	210000
	PUSH	HL		;63CA:	E5
	LD	HL,0000h	;63CB:	210000
	PUSH	HL		;63CE:	E5
	CALL	LAB_1ADD	;63CF:	CDDD1A
	POP	DE		;63D2:	D1
	POP	DE		;63D3:	D1
LAB_63D4
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;63D8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;63DA:	56
	LD	HL,0008h	;63DB:	210800
	ADD	HL,DE		;63DE:	19
	PUSH	HL		;63DF:	E5
	CALL	LAB_62E5	;63E0:	CDE562
	POP	DE		;63E3:	D1
	PUSH	HL		;63E4:	E5
	CALL	LAB_1D80	;63E5:	CD801D
	POP	DE		;63E8:	D1
	LD	(LAB_EB43),HL	;63E9:	2243EB
	LD	HL,0002h	;63EC:	210200
	LD	(LAB_EBF7),HL	;63EF:	22F7EB
	LD	HL,(LAB_EB08)	;63F2:	2A08EB
	LD	DE,F168h	;63F5:	1168F1
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_6401	;63FB:	CA0164
	CALL	LAB_6280	;63FE:	CD8062
LAB_6401
	LD	HL,(LAB_EB08)	;6401:	2A08EB
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL)
					; (LAB_71D7 ROM 1)
	LD	(LAB_E8DA),HL	;6407:	22DAE8
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_6412	;640C:	C21264

	CALL	LAB_7279		; send BELL character to console
LAB_6412
	LD	HL,0003h	;6412:	210300
	LD	(LAB_EBF7),HL	;6415:	22F7EB
	CALL	LAB_6280	;6418:	CD8062
	LD	HL,(LAB_E8DA)	;641B:	2ADAE8
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_63D4	;6420:	CAD463

	CALL	LAB_2116		; get HL from (LAB_EC41)
	LD	DE,0014h	;6426:	111400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_6440	;642C:	CA4064
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6433:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6435:	56
	LD	HL,0008h	;6436:	210800
	ADD	HL,DE		;6439:	19
	PUSH	HL		;643A:	E5
	CALL	LAB_6292	;643B:	CD9262
	POP	DE		;643E:	D1
	RET				;

LAB_6440
	LD	HL,(LAB_EB43)	;6440:	2A43EB
	LD	DE,0003h	;6443:	110300
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	EX	DE,HL		;6449:	EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;644E:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;6450:	66
	LD	L,A		;6451:	6F
	ADD	HL,DE		;6452:	19
	LD	DE,000Bh	;6453:	110B00
	ADD	HL,DE		;6456:	19
	PUSH	HL		;6457:	E5
	CALL	LAB_6292	;6458:	CD9262
	POP	DE		;645B:	D1
	RET				;

LAB_645D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	RET				;

LAB_6464
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	CALL	LAB_227D		; store word 0000h @ LAB_EC41
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6471:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6473:	56
	EX	DE,HL		;6474:	EB
	INC	HL		;6475:	23
	INC	HL		;6476:	23
	INC	HL		;6477:	23
	LD	E,(HL)		;6478:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;647A:	56
	EX	DE,HL		;647B:	EB
	LD	(LAB_EB39),HL	;647C:	2239EB
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6483:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6485:	56
	LD	HL,0005h	;6486:	210500
	ADD	HL,DE		;6489:	19
	LD	E,(HL)		;648A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;648C:	56
	EX	DE,HL		;648D:	EB
	LD	(LAB_EB08),HL	;648E:	2208EB
	LD	HL,0000h	;6491:	210000
	LD	(LAB_EB12),HL	;6494:	2212EB
	LD	(LAB_EB4F),HL	;6497:	224FEB
	LD	HL,0000h	;649A:	210000
	LD	(LAB_EB3D),HL	;649D:	223DEB
	LD	HL,0000h	;64A0:	210000
	LD	(LAB_EBF7),HL	;64A3:	22F7EB
	LD	HL,(LAB_EB39)	;64A6:	2A39EB
	LD	DE,F168h	;64A9:	1168F1
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_64B5	;64AF:	CAB564
	CALL	LAB_6280	;64B2:	CD8062
LAB_64B5
	LD	HL,(LAB_EB39)	;64B5:	2A39EB
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_EBF7),HL	;64BE:	22F7EB
	CALL	LAB_6280	;64C1:	CD8062
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;64C8:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;64CA:	56
	EX	DE,HL		;64CB:	EB
	INC	HL		;64CC:	23
	LD	E,(HL)		;64CD:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;64CF:	56
	PUSH	DE		;64D0:	D5
	CALL	LAB_183C	;64D1:	CD3C18
	POP	DE		;64D4:	D1
	CALL	LAB_198E	;64D5:	CD8E19
LAB_64D8
	LD	HL,0001h		; set HL = 0001h
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_6587	;64DD:	CA8765

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;64E4:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;64E6:	56
	LD	HL,000Bh	;64E7:	210B00
	ADD	HL,DE		;64EA:	19
	LD	E,(HL)		;64EB:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;64ED:	56
	PUSH	DE		;64EE:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;64F3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;64F5:	56
	LD	HL,000Dh	;64F6:	210D00
	ADD	HL,DE		;64F9:	19
	PUSH	HL		;64FA:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;64FF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6501:	56
	LD	HL,0007h	;6502:	210700
	ADD	HL,DE		;6505:	19
	LD	E,(HL)		;6506:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6508:	56
	PUSH	DE		;6509:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;650E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6510:	56
	LD	HL,0009h	;6511:	210900
	ADD	HL,DE		;6514:	19
	LD	E,(HL)		;6515:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6517:	56
	PUSH	DE		;6518:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;651D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;651F:	56
	LD	HL,0005h	;6520:	210500
	ADD	HL,DE		;6523:	19
	LD	E,(HL)		;6524:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6526:	56
	PUSH	DE		;6527:	D5
	LD	HL,0016h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;652C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;652E:	56
	EX	DE,HL		;652F:	EB
	INC	HL		;6530:	23
	INC	HL		;6531:	23
	INC	HL		;6532:	23
	LD	E,(HL)		;6533:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6535:	56
	PUSH	DE		;6536:	D5
	CALL	LAB_1B7D	;6537:	CD7D1B
	EX	DE,HL		;653A:	EB
	LD	HL,000Ch		; C ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_2116		; get HL from (LAB_EC41)
	LD	(LAB_E8DE),HL	;6543:	22DEE8
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;654A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;654C:	56
	LD	HL,000Dh	;654D:	210D00
	ADD	HL,DE		;6550:	19
	LD	(LAB_E8DC),HL	;6551:	22DCE8
LAB_6554
	LD	HL,(LAB_E8DC)	;6554:	2ADCE8
	LD	A,(HL)		;6557:	7E
	OR	A		;6558:	B7
	JP	Z,LAB_6584	;6559:	CA8465
	LD	HL,(LAB_E8DC)	;655C:	2ADCE8
	LD	E,(HL)		;655F:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;6562:	D5
	LD	HL,(LAB_E8DE)	;6563:	2ADEE8
	POP	DE		;6566:	D1
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_6577	;656A:	CA7765
	LD	HL,(LAB_E8DC)	;656D:	2ADCE8
	INC	HL		;6570:	23
	PUSH	HL		;6571:	E5
	CALL	LAB_6292	;6572:	CD9262
	POP	DE		;6575:	D1
	RET				;

LAB_6577
	LD	HL,(LAB_E8DC)	;6577:	2ADCE8
	LD	DE,0004h	;657A:	110400
	ADD	HL,DE		;657D:	19
	LD	(LAB_E8DC),HL	;657E:	22DCE8
	JP	LAB_6554	;6581:	C35465
LAB_6584
	JP	LAB_64D8	;6584:	C3D864
LAB_6587
	RET				;

LAB_6588
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6592:	5E
	INC	HL		;6593:	23
	LD	D,(HL)		;6594:	56
	LD	HL,000Bh	;6595:	210B00
	ADD	HL,DE		;6598:	19
	PUSH	HL		;6599:	E5
	CALL	LAB_6292	;659A:	CD9262
	POP	DE		;659D:	D1
	RET				;

; setup LAB_E89C, LAB_E8D6, LAB_EC5D & LAB_E898

LAB_659F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;65A5:	210000
	LD	(LAB_E89C),HL	;65A8:	229CE8
	LD	HL,LAB_E89E	;65AB:	219EE8
	LD	(LAB_E8D6),HL	;65AE:	22D6E8
	LD	HL,0000h	;65B1:	210000
	LD	(LAB_EC5D),HL	;65B4:	225DEC
	LD	HL,LAB_F118		; set word
	PUSH	HL			; push word
	CALL	LAB_6621		; saves word @ (LAB_E898)
	POP	DE			; dump word
	RET				;

; puts 0001h @ (LAB_E8D6) & word @ (LAB_E8D6)+2

; stack is ..
; word
; end.

LAB_65C0
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL			; save it
	LD	HL,(LAB_E8D6)	; get pointer
	POP	DE			; get value back
	LD	(HL),E		; save value low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save value high byte
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get ?? low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ?? high byte
	PUSH	DE			; save ??
	LD	HL,(LAB_E8D6)	; get pointer
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	POP	DE			; restore ??
	LD	(HL),E		; save ?? low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save ?? high byte
	RET				;

; clear word @ (LAB_E8D6)

LAB_65E3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h		; clear HL
	PUSH	HL			; save zero
	LD	HL,(LAB_E8D6)	; get pointer
	POP	DE			; restore zero
	LD	(HL),E		; clear high byte
	INC	HL			; increment pointer
	LD	(HL),D		; clear low byte
	RET				;

; set (LAB_E89A) = 0001h

LAB_65F5
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	LD	(LAB_E89A),HL	;65FE:	229AE8
	RET				;

; display error # & message ??

; stack is
; error #
; message pointer
; end.

LAB_6602
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	PUSH	DE			; push message pointer

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get error # low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get error # high byte
	PUSH	DE			; push error #

	LD	HL,(LAB_E898)	;6618:	2A98E8
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL)
					; (LAB_71D7 ROM 1)
	POP	DE			; dump error #
	POP	DE			; dump message pointer
	RET				;

; saves word @ (LAB_E898)

; stack is
; word
; end.

LAB_6621
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;662B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;662D:	56
	EX	DE,HL		;662E:	EB
	LD	(LAB_E898),HL	;662F:	2298E8
	RET				;

; copy ...

; word @ LAB_EC41 to (LAB_E8D6)+6
; word @ LAB_EC5D to (LAB_E8D6)+4
; ...

LAB_6633
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h	;6639:	210000
	LD	(LAB_E89A),HL	;663C:	229AE8
	LD	HL,(LAB_EC41)	;663F:	2A41EC
	PUSH	HL		;6642:	E5
	LD	HL,(LAB_E8D6)	;6643:	2AD6E8
	LD	DE,0006h	;6646:	110600
	ADD	HL,DE		;6649:	19
	POP	DE		;664A:	D1
	LD	(HL),E		;664B:	73
	INC	HL			; increment pointer
	LD	(HL),D		;664D:	72
	LD	HL,(LAB_EC5D)	;664E:	2A5DEC
	PUSH	HL		;6651:	E5
	LD	HL,(LAB_E8D6)	;6652:	2AD6E8
	LD	DE,0004h	;6655:	110400
	ADD	HL,DE		;6658:	19
	POP	DE		;6659:	D1
	LD	(HL),E		;665A:	73
	INC	HL			; increment pointer
	LD	(HL),D		;665C:	72
	LD	HL,(LAB_E8D6)	;665D:	2AD6E8
	LD	DE,0008h	;6660:	110800
	ADD	HL,DE		;6663:	19
	LD	(LAB_E8D6),HL	;6664:	22D6E8
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;666B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;666D:	56
	EX	DE,HL		;666E:	EB
	LD	(LAB_EC5D),HL	;666F:	225DEC
LAB_6672
	LD	HL,0000h	;6672:	210000
	PUSH	HL		;6675:	E5
	LD	HL,(LAB_E8D6)	;6676:	2AD6E8
	POP	DE		;6679:	D1
	LD	(HL),E		;667A:	73
	INC	HL			; increment pointer
	LD	(HL),D		;667C:	72
	CALL	LAB_EEE4		; wait for key, no echo ??
	LD	HL,(LAB_EC5D)	;6680:	2A5DEC
	LD	(LAB_E8E0),HL	;6683:	22E0E8
	LD	HL,(LAB_E8D8)	;6686:	2AD8E8
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_669C	;668B:	CA9C66

	LD	HL,(LAB_E8E0)	;668E:	2AE0E8
	PUSH	HL		;6691:	E5
	LD	HL,(LAB_E8D8)	;6692:	2AD8E8
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL) (LAB_71D7 ROM 1)
	POP	DE		;6698:	D1
	LD	(LAB_E8E0),HL	;6699:	22E0E8
LAB_669C
	LD	HL,(LAB_E8E0)	;669C:	2AE0E8
	LD	E,(HL)		;669F:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;66A2:	EB
	JP	LAB_66EC	;66A3:	C3EC66

LAB_66A6
	LD	HL,(LAB_E8E0)	;66A6:	2AE0E8
	PUSH	HL		;66A9:	E5
	CALL	LAB_6319	;66AA:	CD1963
	POP	DE		;66AD:	D1
	LD	(LAB_E8E0),HL	;66AE:	22E0E8
	JP	LAB_6707	;66B1:	C30767

LAB_66B4
	LD	HL,(LAB_E8E0)	;66B4:	2AE0E8
	PUSH	HL		;66B7:	E5
	CALL	LAB_635E	;66B8:	CD5E63
	POP	DE		;66BB:	D1
	LD	(LAB_E8E0),HL	;66BC:	22E0E8
	JP	LAB_6707	;66BF:	C30767

LAB_66C2
	LD	HL,(LAB_E8E0)	;66C2:	2AE0E8
	PUSH	HL		;66C5:	E5
	CALL	LAB_645D	;66C6:	CD5D64
	POP	DE		;66C9:	D1
	LD	(LAB_E8E0),HL	;66CA:	22E0E8
	JP	LAB_6707	;66CD:	C30767

LAB_66D0
	LD	HL,(LAB_E8E0)	;66D0:	2AE0E8
	PUSH	HL		;66D3:	E5
	CALL	LAB_6464	;66D4:	CD6464
	POP	DE		;66D7:	D1
	LD	(LAB_E8E0),HL	;66D8:	22E0E8
	JP	LAB_6707	;66DB:	C30767

LAB_66DE
	LD	HL,(LAB_E8E0)	;66DE:	2AE0E8
	PUSH	HL		;66E1:	E5
	CALL	LAB_6588	;66E2:	CD8865
	POP	DE		;66E5:	D1
	LD	(LAB_E8E0),HL	;66E6:	22E0E8
	JP	LAB_6707	;66E9:	C30767

LAB_66EC
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0005

	DW	0000
	DW	LAB_66A6

	DW	0001
	DW	LAB_66B4

	DW	0002
	DW	LAB_66C2

	DW	0003
	DW	LAB_66D0

	DW	0004
	DW	LAB_66DE

	DW	LAB_6707

LAB_6707
	LD	HL,(LAB_E8D6)	;6707:	2AD6E8
	LD	A,(HL)		;670A:	7E
	INC	HL			; increment pointer
	OR	(HL)		;670C:	B6
	JP	Z,LAB_671F	;670D:	CA1F67
	LD	HL,(LAB_E8D6)	;6710:	2AD6E8
	INC	HL		;6713:	23
	INC	HL		;6714:	23
	LD	E,(HL)		;6715:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6717:	56
	EX	DE,HL		;6718:	EB
	LD	(LAB_EC5D),HL	;6719:	225DEC
	JP	LAB_6725	;671C:	C32567

LAB_671F
	LD	HL,(LAB_E8E0)	;671F:	2AE0E8
	LD	(LAB_EC5D),HL	;6722:	225DEC
LAB_6725
	LD	HL,(LAB_E89A)	;6725:	2A9AE8
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_6672	;672A:	CA7266

	LD	HL,(LAB_E8D6)	;672D:	2AD6E8
	LD	DE,FFF8h	;6730:	11F8FF
	ADD	HL,DE		;6733:	19
	LD	(LAB_E8D6),HL	;6734:	22D6E8
	LD	HL,(LAB_E8D6)	;6737:	2AD6E8
	LD	DE,0004h	;673A:	110400
	ADD	HL,DE		;673D:	19
	LD	E,(HL)		;673E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6740:	56
	EX	DE,HL		;6741:	EB
	LD	(LAB_EC5D),HL	;6742:	225DEC
	LD	HL,(LAB_E8D6)	;6745:	2AD6E8
	LD	DE,0006h	;6748:	110600
	ADD	HL,DE		;674B:	19
	LD	E,(HL)		;674C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;674E:	56
	EX	DE,HL		;674F:	EB
	LD	(LAB_EC41),HL	;6750:	2241EC
	LD	HL,0000h	;6753:	210000
	LD	(LAB_E89A),HL	;6756:	229AE8
	RET				;

; get HL from pointer @ LAB_E8D6

LAB_675A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,(LAB_E8D6)	; get pointer
	LD	E,(HL)		; get word low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get word high byte
	EX	DE,HL			; swap to HL
	RET				;

; set HL = 0001h

LAB_6768
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	RET				;

; save word @ LAB_E8D8

; stack ..
; word
; end.

LAB_6772
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get word low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get word high byte
	EX	DE,HL			; swap to HL
	LD	(LAB_E8D8),HL	; save word
	RET				;

; clears bytes @ LAB_E8E2, +29h, ++29h & +++29h
; clears words @ LAB_EC3F & LAB_E986

LAB_6784
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h		; clear HL
	LD	(LAB_E988),HL	; clear ??
	JP	LAB_679A		; go enter loop

LAB_6793
	LD	HL,(LAB_E988)	; get ??
	INC	HL			; increment ??
	LD	(LAB_E988),HL	; save ??
LAB_679A
	LD	HL,(LAB_E988)	; get ??
	LD	DE,0004h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_67BD		; exit if DE>=4

	LD	HL,0000h	;67A7:	210000
	PUSH	HL		;67AA:	E5
	LD	HL,(LAB_E988)	; get ??
	LD	DE,0029h		; *29h
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	LD	DE,LAB_E8E2		;67B4:	11E2E8
	ADD	HL,DE		;67B7:	19
	POP	DE		;67B8:	D1
	LD	(HL),E		;67B9:	73
	JP	LAB_6793		; go do next

LAB_67BD
	LD	HL,0000h	;67BD:	210000
	LD	(LAB_EC3F),HL	;67C0:	223FEC
	LD	HL,0000h	;67C3:	210000
	LD	(LAB_E986),HL	;67C6:	2286E9
	RET				;

; stack is ..
; ??
; ??
; ??
; end.

LAB_67CA
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,LAB_E8E2		; set base to 4*29h buffers
	LD	(LAB_E98A),HL	; save it
	JP	LAB_67E3		; enter empty search loop

LAB_67D9
	LD	HL,(LAB_E98A)	; get ?? pointer
	LD	DE,0029h		; offset to next block
	ADD	HL,DE			; add to ?? pointer
	LD	(LAB_E98A),HL	; save new ?? pointer
LAB_67E3
	LD	HL,(LAB_E98A)	; get ?? pointer
	LD	DE,LAB_E986		; set DE to end+1
	EX	DE,HL			; swap into HL
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22 ROM 1)
	JP	Z,LAB_68C1		; exit if passed end

	LD	HL,(LAB_E98A)	; get ?? pointer
	LD	A,(HL)		; get first byte
	OR	A			; set the flags
	JP	NZ,LAB_68BE		; loop if not null (eventually reaches LAB_67D9)

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	PUSH	HL			; save pointer
	LD	A,(HL)		;67FD:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;67FF:	66
	LD	L,A		;6800:	6F
	INC	HL			; increment it
	EX	DE,HL			; swap to DE
	POP	HL			; restore pointer
	LD	(HL),E		;6804:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6806:	72
	LD	HL,0003h		; set AND opperand
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_6820		; jump if bits 1,0=00

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;6814:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6816:	56
	LD	HL,FFFCh		; set AND opperand
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_682A		;681D:	CA2A68

					; exit if (0> last pushed but 1 >3)
LAB_6820
	LD	HL,1774h	;6820:	217417
	LD	(LAB_EC3F),HL	;6823:	223FEC
	LD	HL,FFFFh	;6826:	21FFFF
	RET				;

LAB_682A
	LD	HL,(LAB_E98A)	; get ?? pointer
	LD	DE,0005h		; offset to ??
	ADD	HL,DE			; add to ?? pointer
	PUSH	HL			; save it
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6836:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6838:	56
	PUSH	DE		;6839:	D5
	CALL	LAB_DA4C	;683A:	CD4CDA
	POP	DE		;683D:	D1
	POP	DE		;683E:	D1
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;6843:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6845:	56
	LD	HL,0016h	;6846:	211600
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_6860	;684C:	CA6068

	LD	HL,(LAB_E98A)	; get ?? pointer
	LD	DE,0005h	;6852:	110500
	ADD	HL,DE		;6855:	19
	PUSH	HL			; push parameter
	LD	HL,0013h		; BDOS function 19 - delete file
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
LAB_6860
	LD	HL,(LAB_E98A)	;6860:	2A8AE9
	LD	DE,0005h	;6863:	110500
	ADD	HL,DE		;6866:	19
	PUSH	HL			; push parameter
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;686C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;686E:	56
	PUSH	DE			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	DE,00FFh	;6875:	11FF00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_6888	;687B:	CA8868

	LD	HL,1775h	;687E:	217517
	LD	(LAB_EC3F),HL	;6881:	223FEC
	LD	HL,FFFFh	;6884:	21FFFF
	RET				;

LAB_6888
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;688C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;688E:	56
	PUSH	DE		;688F:	D5
	LD	HL,(LAB_E98A)	;6890:	2A8AE9
	POP	DE		;6893:	D1
	LD	(HL),E		;6894:	73
	LD	HL,0000h	;6895:	210000
	PUSH	HL		;6898:	E5
	LD	HL,(LAB_E98A)	;6899:	2A8AE9
	INC	HL		;689C:	23
	INC	HL		;689D:	23
	INC	HL		;689E:	23
	POP	DE		;689F:	D1
	LD	(HL),E		;68A0:	73
	INC	HL			; increment pointer
	LD	(HL),D		;68A2:	72
	PUSH	DE		;68A3:	D5
	LD	HL,(LAB_E98A)	;68A4:	2A8AE9
	INC	HL		;68A7:	23
	POP	DE		;68A8:	D1
	LD	(HL),E		;68A9:	73
	INC	HL			; increment pointer
	LD	(HL),D		;68AB:	72
	LD	HL,(LAB_E98A)	;68AC:	2A8AE9
	LD	DE,LAB_E8E2	;68AF:	11E2E8
	EX	DE,HL		;68B2:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	DE,0029h	;68B6:	112900
	EX	DE,HL		;68B9:	EB
	CALL	LAB_DF6D	;68BA:	CD6DDF
	RET				;

LAB_68BE
	JP	LAB_67D9	;68BE:	C3D967

					; found no empty 4*29h buffer
LAB_68C1
	LD	HL,1772h	;68C1:	217217
	LD	(LAB_EC3F),HL	;68C4:	223FEC
	LD	HL,FFFFh	;68C7:	21FFFF
	RET				;

; stack
; ??
; ??
; end.

LAB_68CB
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Fh	;68D1:	210F00
	PUSH	HL		;68D4:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;68D9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;68DB:	56
	PUSH	DE		;68DC:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;68E1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;68E3:	56
	PUSH	DE		;68E4:	D5
	CALL	LAB_67CA	;68E5:	CDCA67
	POP	DE		;68E8:	D1
	POP	DE		;68E9:	D1
	POP	DE		;68EA:	D1
	RET				;

; stack
; ??
; end.

LAB_68EC
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0016h	;68F2:	211600
	PUSH	HL		;68F5:	E5
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;68F9:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;68FE:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6900:	56
	PUSH	DE		;6901:	D5
	CALL	LAB_67CA	;6902:	CDCA67
	POP	DE		;6905:	D1
	POP	DE		;6906:	D1
	POP	DE		;6907:	D1
	RET				;

LAB_6909
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h		; set compare value
	EX	DE,HL			; swap to DE
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;6917:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;6919:	66
	LD	L,A		;691A:	6F
	CALL	LAB_E06B		; does signed CP HL,DE. returns HL=1 if DE<=HL
					; (LAB_7BA6 ROM 1)
	JP	Z,LAB_6965		; jump if HL>0

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6925:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6927:	56
	LD	HL,0004h		; set comapre value
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_6965		; jump if DE>=4

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6935:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6937:	56
	LD	HL,0029h		; set multiplier
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	LD	DE,LAB_E8E2	;693E:	11E2E8
	ADD	HL,DE		;6941:	19
	LD	E,(HL)		;6942:	5E
	LD	D,#00h		; clear high byte
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	A,(HL)		;6949:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;694B:	66
	LD	L,A		;694C:	6F
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E ROM 1)
	JP	Z,LAB_6965	;6950:	CA6569

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6957:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6959:	56
	LD	HL,0029h		; set multiplier
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	LD	DE,LAB_E8E2	;6960:	11E2E8
	ADD	HL,DE		;6963:	19
	RET				;

LAB_6965
	LD	HL,1773h	;6965:	217317
	LD	(LAB_EC3F),HL	;6968:	223FEC
	LD	HL,0000h	;696B:	210000
	RET				;

LAB_696F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0003h	;6975:	210300
	PUSH	HL		;6978:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;697D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;697F:	56
	PUSH	DE		;6980:	D5
	CALL	LAB_6909	;6981:	CD0969
	POP	DE		;6984:	D1
	POP	DE		;6985:	D1
	LD	(LAB_E98C),HL	;6986:	228CE9
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_6992	;698B:	C29269

	LD	HL,FFFFh	;698E:	21FFFF
	RET				;

LAB_6992
	LD	HL,0000h	;6992:	210000
	PUSH	HL		;6995:	E5
	LD	HL,(LAB_E98C)	;6996:	2A8CE9
	POP	DE		;6999:	D1
	LD	(HL),E		;699A:	73
	LD	HL,(LAB_E98C)	;699B:	2A8CE9
	LD	DE,0005h	;699E:	110500
	ADD	HL,DE		;69A1:	19
	PUSH	HL			; push parameter
	LD	HL,0010h		; BDOS function 16 - Close file
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	DE,00FFh	;69AC:	11FF00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_69BF	;69B2:	CABF69
	LD	HL,1776h	;69B5:	217617
	LD	(LAB_EC3F),HL	;69B8:	223FEC
	LD	HL,FFFFh	;69BB:	21FFFF
	RET				;

LAB_69BF
	LD	HL,0000h	;69BF:	210000
	RET				;

LAB_69C3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,00FFh	;69C9:	21FF00
	PUSH	HL		;69CC:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;69D1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;69D3:	56
	PUSH	DE		;69D4:	D5
	CALL	LAB_6909	;69D5:	CD0969
	POP	DE		;69D8:	D1
	POP	DE		;69D9:	D1
	LD	(LAB_E98E),HL	;69DA:	228EE9
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_69E6	;69DF:	C2E669

	LD	HL,FFFFh	;69E2:	21FFFF
	RET				;

LAB_69E6
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;69EA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;69EC:	56
	PUSH	DE		;69ED:	D5
	LD	HL,(LAB_E98E)	;69EE:	2A8EE9
	LD	DE,0026h	;69F1:	112600
	ADD	HL,DE		;69F4:	19
	POP	DE		;69F5:	D1
	LD	(HL),E		;69F6:	73
	INC	HL			; increment pointer
	LD	(HL),D		;69F8:	72
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		; get DMA address low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get DMA address high byte
	PUSH	DE			; push parameter
	LD	HL,001Ah		; BDOS function 26 - Set DMA address
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	HL,(LAB_E98E)	;6A0A:	2A8EE9
	LD	DE,0005h	;6A0D:	110500
	ADD	HL,DE		;6A10:	19
	PUSH	HL			; push parameter
	LD	HL,0021h		; BDOS function 33 - Random access read record
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	(LAB_EC3F),HL	;6A1B:	223FEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_6A32	;6A20:	CA326A

	LD	HL,17D4h	;6A23:	21D417
	EX	DE,HL		;6A26:	EB
	LD	HL,(LAB_EC3F)	;6A27:	2A3FEC
	ADD	HL,DE		;6A2A:	19
	LD	(LAB_EC3F),HL	;6A2B:	223FEC
	LD	HL,FFFFh	;6A2E:	21FFFF
	RET				;

LAB_6A32
	LD	HL,0000h	;6A32:	210000
	RET				;

LAB_6A36
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,00FFh	;6A3C:	21FF00
	PUSH	HL		;6A3F:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6A44:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6A46:	56
	PUSH	DE		;6A47:	D5
	CALL	LAB_6909	;6A48:	CD0969
	POP	DE		;6A4B:	D1
	POP	DE		;6A4C:	D1
	LD	(LAB_E990),HL	;6A4D:	2290E9
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_6A59	;6A52:	C2596A

	LD	HL,FFFFh	;6A55:	21FFFF
	RET				;

LAB_6A59
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6A5D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6A5F:	56
	PUSH	DE		;6A60:	D5
	LD	HL,(LAB_E990)	;6A61:	2A90E9
	LD	DE,0026h	;6A64:	112600
	ADD	HL,DE		;6A67:	19
	POP	DE		;6A68:	D1
	LD	(HL),E		;6A69:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6A6B:	72
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		; get DMA address low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get DMA address high byte
	PUSH	DE			; push parameter
	LD	HL,001Ah		; BDOS function 26 - Set DMA address
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	HL,(LAB_E990)	;6A7D:	2A90E9
	LD	DE,0005h	;6A80:	110500
	ADD	HL,DE		;6A83:	19
	PUSH	HL			; push parameter
	LD	HL,0022h		; BDOS function 34 - Random access write record
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	(LAB_EC3F),HL	;6A8E:	223FEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_6AA5		; jump if there was an error writing

	LD	HL,17D4h	;6A96:	21D417
	EX	DE,HL		;6A99:	EB
	LD	HL,(LAB_EC3F)	;6A9A:	2A3FEC
	ADD	HL,DE		;6A9D:	19
	LD	(LAB_EC3F),HL	;6A9E:	223FEC
	LD	HL,FFFFh		; falg failed
	RET				;

LAB_6AA5
	LD	HL,0000h		; flag ok
	RET				;

LAB_6AA9
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6AB3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6AB5:	56
	LD	HL,(LAB_E986)	;6AB6:	2A86E9
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	NZ,LAB_6ACF	;6ABC:	C2CF6A
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6AC3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6AC5:	56
	LD	HL,(LAB_E992)	;6AC6:	2A92E9
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_6B69	;6ACC:	CA696B
LAB_6ACF
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6AD3:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6AD5:	56
	PUSH	DE		;6AD6:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6ADB:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6ADD:	56
	LD	HL,0021h	;6ADE:	212100
	ADD	HL,DE		;6AE1:	19
	POP	DE		;6AE2:	D1
	LD	(HL),E		;6AE3:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6AE5:	72
	LD	HL,LAB_E994		; set DMA address
	PUSH	HL			; push parameter
	LD	HL,001Ah		; BDOS function 26 - Set DMA address
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6AF7:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6AF9:	56
	PUSH	DE			; push parameter
	LD	HL,0021h		; BDOS function 33 - Random access read record
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	(LAB_EC3F),HL	;6B04:	223FEC
	LD	HL,(LAB_EC3F)	;6B07:	2A3FEC
	JP	LAB_6B40	;6B0A:	C3406B

LAB_6B0D
	JP	LAB_6B53	;6B0D:	C3536B

LAB_6B10
	LD	HL,0000h	;6B10:	210000
	PUSH	HL		;6B13:	E5
	LD	HL,0080h	;6B14:	218000
	PUSH	HL		;6B17:	E5
	LD	HL,LAB_E994	;6B18:	2194E9
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,17D5h	;6B22:	21D517
	LD	(LAB_EC3F),HL	;6B25:	223FEC
	JP	LAB_6B53	;6B28:	C3536B

LAB_6B2B
	LD	HL,17D4h	;6B2B:	21D417
	EX	DE,HL		;6B2E:	EB
	LD	HL,(LAB_EC3F)	;6B2F:	2A3FEC
	ADD	HL,DE		;6B32:	19
	LD	(LAB_EC3F),HL	;6B33:	223FEC
	LD	HL,0000h	;6B36:	210000
	LD	(LAB_E986),HL	;6B39:	2286E9
	LD	HL,0000h	;6B3C:	210000
	RET				;

LAB_6B40
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0003

	DW	0000
	DW	LAB_6B0D

	DW	0001
	DW	LAB_6B10

	DW	0004
	DW	LAB_6B10

	DW	LAB_6B2B

LAB_6B53
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6B57:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6B59:	56
	EX	DE,HL		;6B5A:	EB
	LD	(LAB_E986),HL	;6B5B:	2286E9
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6B62:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6B64:	56
	EX	DE,HL		;6B65:	EB
	LD	(LAB_E992),HL	;6B66:	2292E9
LAB_6B69
	LD	HL,E994h	;6B69:	2194E9
	RET				;

; stack is ..
; ??
; ??
; ??
; end.

LAB_6B6D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0001h		; set HL = 0001h
	PUSH	HL		;6B76:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6B7B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6B7D:	56
	PUSH	DE		;6B7E:	D5
	CALL	LAB_6909	;6B7F:	CD0969
	POP	DE		;6B82:	D1
	POP	DE		;6B83:	D1
	LD	(LAB_EA1A),HL	;6B84:	221AEA
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_6B90	;6B89:	C2906B

	LD	HL,FFFFh	;6B8C:	21FFFF
	RET				;

LAB_6B90
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6B94:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6B96:	56
	EX	DE,HL		;6B97:	EB
	LD	(LAB_EA14),HL	;6B98:	2214EA
LAB_6B9B
	LD	HL,(LAB_EA14)	;6B9B:	2A14EA
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_6C7B	;6BA0:	CA7B6C

	LD	HL,(LAB_EA1A)	;6BA3:	2A1AEA
	INC	HL		;6BA6:	23
	INC	HL		;6BA7:	23
	INC	HL		;6BA8:	23
	LD	E,(HL)		;6BA9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6BAB:	56
	PUSH	DE		;6BAC:	D5
	LD	HL,0080h	;6BAD:	218000
	POP	DE		;6BB0:	D1
	EX	DE,HL		;6BB1:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_EA16),HL	;6BB5:	2216EA
	EX	DE,HL		;6BB8:	EB
	LD	HL,(LAB_EA14)	;6BB9:	2A14EA
LAB_6BBC
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_6BC8	;6BBF:	CAC86B
	LD	HL,(LAB_EA14)	;6BC2:	2A14EA
	LD	(LAB_EA16),HL	;6BC5:	2216EA
LAB_6BC8
	LD	HL,(LAB_EA1A)	;6BC8:	2A1AEA
	INC	HL		;6BCB:	23
	LD	E,(HL)		;6BCC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6BCE:	56
	PUSH	DE		;6BCF:	D5
	LD	HL,(LAB_EA1A)	;6BD0:	2A1AEA
	LD	DE,0005h	;6BD3:	110500
	ADD	HL,DE		;6BD6:	19
	PUSH	HL		;6BD7:	E5
	CALL	LAB_6AA9	;6BD8:	CDA96A
	POP	DE		;6BDB:	D1
	POP	DE		;6BDC:	D1
	LD	(LAB_EA18),HL	;6BDD:	2218EA
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_6BED	;6BE2:	CAED6B

	LD	HL,(LAB_EC3F)	;6BE5:	2A3FEC
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_6BFB	;6BEA:	CAFB6B

LAB_6BED
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6BF1:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6BF3:	56
	LD	HL,(LAB_EA14)	;6BF4:	2A14EA
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	RET				;

LAB_6BFB
	LD	HL,(LAB_EA16)	;6BFB:	2A16EA
	PUSH	HL		;6BFE:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6C03:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6C05:	56
	PUSH	DE		;6C06:	D5
	LD	HL,(LAB_EA1A)	;6C07:	2A1AEA
	INC	HL		;6C0A:	23
	INC	HL		;6C0B:	23
	INC	HL		;6C0C:	23
	LD	E,(HL)		;6C0D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6C0F:	56
	LD	HL,(LAB_EA18)	;6C10:	2A18EA
	ADD	HL,DE		;6C13:	19
	PUSH	HL		;6C14:	E5
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	LD	HL,(LAB_EA16)	;6C1B:	2A16EA
	EX	DE,HL		;6C1E:	EB
	LD	HL,(LAB_EA14)	;6C1F:	2A14EA
	EX	DE,HL		;6C22:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_EA14),HL	;6C26:	2214EA
	LD	HL,(LAB_EA16)	;6C29:	2A16EA
	EX	DE,HL		;6C2C:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;6C31:	E5
	LD	A,(HL)		;6C32:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;6C34:	66
	LD	L,A		;6C35:	6F
	ADD	HL,DE		;6C36:	19
	EX	DE,HL		;6C37:	EB
	POP	HL		;6C38:	E1
	LD	(HL),E		;6C39:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6C3B:	72
	LD	HL,(LAB_EA16)	;6C3C:	2A16EA
	PUSH	HL		;6C3F:	E5
	LD	HL,(LAB_EA1A)	;6C40:	2A1AEA
	INC	HL		;6C43:	23
	INC	HL		;6C44:	23
	INC	HL		;6C45:	23
	POP	DE		;6C46:	D1
	PUSH	HL		;6C47:	E5
	LD	A,(HL)		;6C48:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;6C4A:	66
	LD	L,A		;6C4B:	6F
	ADD	HL,DE		;6C4C:	19
	EX	DE,HL		;6C4D:	EB
	POP	HL		;6C4E:	E1
	LD	(HL),E		;6C4F:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6C51:	72
	LD	HL,0080h	;6C52:	218000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_6C78	;6C58:	CA786C
	LD	HL,0000h	;6C5B:	210000
	PUSH	HL		;6C5E:	E5
	LD	HL,(LAB_EA1A)	;6C5F:	2A1AEA
	INC	HL		;6C62:	23
	INC	HL		;6C63:	23
	INC	HL		;6C64:	23
	POP	DE		;6C65:	D1
	LD	(HL),E		;6C66:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6C68:	72
	LD	HL,(LAB_EA1A)	;6C69:	2A1AEA
	INC	HL		;6C6C:	23
	PUSH	HL		;6C6D:	E5
	LD	A,(HL)		;6C6E:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;6C70:	66
	LD	L,A		;6C71:	6F
	INC	HL		;6C72:	23
	EX	DE,HL		;6C73:	EB
	POP	HL		;6C74:	E1
	LD	(HL),E		;6C75:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6C77:	72
LAB_6C78
	JP	LAB_6B9B	;6C78:	C39B6B
LAB_6C7B
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6C7F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6C81:	56
	EX	DE,HL		;6C82:	EB
	RET				;

; stack is ..
; ??
; ??
; ??
; end.

LAB_6C84
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0002h	;6C8A:	210200
	PUSH	HL		;6C8D:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6C92:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6C94:	56
	PUSH	DE		;6C95:	D5
	CALL	LAB_6909	;6C96:	CD0969
	POP	DE		;6C99:	D1
	POP	DE		;6C9A:	D1
	LD	(LAB_EA22),HL	;6C9B:	2222EA
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_6CA7	;6CA0:	C2A76C

	LD	HL,FFFFh	;6CA3:	21FFFF
	RET				;

LAB_6CA7
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6CAB:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6CAD:	56
	EX	DE,HL		;6CAE:	EB
	LD	(LAB_EA1C),HL	;6CAF:	221CEA
LAB_6CB2
	LD	HL,(LAB_EA1C)	;6CB2:	2A1CEA
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_6DD6	;6CB7:	CAD66D

	LD	HL,(LAB_EA22)	;6CBA:	2A22EA
	INC	HL		;6CBD:	23
	INC	HL		;6CBE:	23
	INC	HL		;6CBF:	23
	LD	E,(HL)		;6CC0:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6CC2:	56
	PUSH	DE		;6CC3:	D5
	LD	HL,0080h	;6CC4:	218000
	POP	DE		;6CC7:	D1
	EX	DE,HL		;6CC8:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_EA1E),HL	;6CCC:	221EEA
	EX	DE,HL		;6CCF:	EB
	LD	HL,(LAB_EA1C)	;6CD0:	2A1CEA
	CALL	LAB_E0E8		; does CP HL,DE, returns HL=0 if DE<=HL (LAB_7C23 ROM 1)
	JP	Z,LAB_6CDF	;6CD6:	CADF6C
	LD	HL,(LAB_EA1C)	;6CD9:	2A1CEA
	LD	(LAB_EA1E),HL	;6CDC:	221EEA
LAB_6CDF
	LD	HL,(LAB_EA1E)	;6CDF:	2A1EEA
	LD	DE,0080h	;6CE2:	118000
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_6D39	;6CE8:	CA396D
	LD	HL,(LAB_EA22)	;6CEB:	2A22EA
	INC	HL		;6CEE:	23
	LD	E,(HL)		;6CEF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6CF1:	56
	PUSH	DE		;6CF2:	D5
	LD	HL,(LAB_EA22)	;6CF3:	2A22EA
	LD	DE,0005h	;6CF6:	110500
	ADD	HL,DE		;6CF9:	19
	PUSH	HL		;6CFA:	E5
	CALL	LAB_6AA9	;6CFB:	CDA96A
	POP	DE		;6CFE:	D1
	POP	DE		;6CFF:	D1
	LD	(LAB_EA20),HL	;6D00:	2220EA
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_6D16	;6D05:	C2166D

	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6D0C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6D0E:	56
	LD	HL,(LAB_EA1C)	;6D0F:	2A1CEA
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	RET				;

LAB_6D16
	LD	HL,(LAB_EA1E)	;6D16:	2A1EEA
	PUSH	HL		;6D19:	E5
	LD	HL,(LAB_EA22)	;6D1A:	2A22EA
	INC	HL		;6D1D:	23
	INC	HL		;6D1E:	23
	INC	HL		;6D1F:	23
	LD	E,(HL)		;6D20:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6D22:	56
	LD	HL,(LAB_EA20)	;6D23:	2A20EA
	ADD	HL,DE		;6D26:	19
	PUSH	HL		;6D27:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6D2C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6D2E:	56
	PUSH	DE		;6D2F:	D5
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	JP	LAB_6D44	;6D36:	C3446D
LAB_6D39
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6D3D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6D3F:	56
	EX	DE,HL		;6D40:	EB
	LD	(LAB_EA20),HL	;6D41:	2220EA
LAB_6D44
	LD	HL,(LAB_EA20)	;6D44:	2A20EA
	PUSH	HL		;6D47:	E5
	LD	HL,(LAB_EA22)	;6D48:	2A22EA
	INC	HL		;6D4B:	23
	LD	E,(HL)		;6D4C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6D4E:	56
	PUSH	DE		;6D4F:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6D54:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6D56:	56
	PUSH	DE		;6D57:	D5
	CALL	LAB_6A36	;6D58:	CD366A
	POP	DE		;6D5B:	D1
	POP	DE		;6D5C:	D1
	POP	DE		;6D5D:	D1
	LD	DE,0000h		; set comapre value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_6D76		; jump if DE+ve

	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6D6C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6D6E:	56
	LD	HL,(LAB_EA1C)	;6D6F:	2A1CEA
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	RET				;

LAB_6D76
	LD	HL,(LAB_EA1E)	;6D76:	2A1EEA
	EX	DE,HL		;6D79:	EB
	LD	HL,(LAB_EA1C)	;6D7A:	2A1CEA
	EX	DE,HL		;6D7D:	EB
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_EA1C),HL	;6D81:	221CEA
	LD	HL,(LAB_EA1E)	;6D84:	2A1EEA
	EX	DE,HL		;6D87:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;6D8C:	E5
	LD	A,(HL)		;6D8D:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;6D8F:	66
	LD	L,A		;6D90:	6F
	ADD	HL,DE		;6D91:	19
	EX	DE,HL		;6D92:	EB
	POP	HL		;6D93:	E1
	LD	(HL),E		;6D94:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6D96:	72
	LD	HL,(LAB_EA1E)	;6D97:	2A1EEA
	PUSH	HL		;6D9A:	E5
	LD	HL,(LAB_EA22)	;6D9B:	2A22EA
	INC	HL		;6D9E:	23
	INC	HL		;6D9F:	23
	INC	HL		;6DA0:	23
	POP	DE		;6DA1:	D1
	PUSH	HL		;6DA2:	E5
	LD	A,(HL)		;6DA3:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;6DA5:	66
	LD	L,A		;6DA6:	6F
	ADD	HL,DE		;6DA7:	19
	EX	DE,HL		;6DA8:	EB
	POP	HL		;6DA9:	E1
	LD	(HL),E		;6DAA:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6DAC:	72
	LD	HL,0080h	;6DAD:	218000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_6DD3	;6DB3:	CAD36D
	LD	HL,0000h	;6DB6:	210000
	PUSH	HL		;6DB9:	E5
	LD	HL,(LAB_EA22)	;6DBA:	2A22EA
	INC	HL		;6DBD:	23
	INC	HL		;6DBE:	23
	INC	HL		;6DBF:	23
	POP	DE		;6DC0:	D1
	LD	(HL),E		;6DC1:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6DC3:	72
	LD	HL,(LAB_EA22)	;6DC4:	2A22EA
	INC	HL		;6DC7:	23
	PUSH	HL		;6DC8:	E5
	LD	A,(HL)		;6DC9:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;6DCB:	66
	LD	L,A		;6DCC:	6F
	INC	HL		;6DCD:	23
	EX	DE,HL		;6DCE:	EB
	POP	HL		;6DCF:	E1
	LD	(HL),E		;6DD0:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6DD2:	72
LAB_6DD3
	JP	LAB_6CB2	;6DD3:	C3B26C
LAB_6DD6
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6DDA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6DDC:	56
	EX	DE,HL		;6DDD:	EB
	RET				;

LAB_6DDF
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0003h	;6DE5:	210300
	PUSH	HL		;6DE8:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6DED:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6DEF:	56
	PUSH	DE		;6DF0:	D5
	CALL	LAB_6909	;6DF1:	CD0969
	POP	DE		;6DF4:	D1
	POP	DE		;6DF5:	D1
	LD	(LAB_EA24),HL	;6DF6:	2224EA
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_6E06	;6DFB:	C2066E

	CALL	LAB_DC30		; copies next four bytes after the call to LAB_E3B1
					; returns to instruction after the bytes (LAB_776B)

	DB	FFh,FFh,FFh,FFh

	RET				;

LAB_6E06
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6E0A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6E0C:	56
	EX	DE,HL		;6E0D:	EB
	JP	LAB_6E64	;6E0E:	C3646E

LAB_6E11
	JP	LAB_6E77	;6E11:	C3776E

LAB_6E14
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	PUSH	HL		;6E18:	E5
	LD	HL,(LAB_EA24)	;6E19:	2A24EA
	INC	HL		;6E1C:	23
	LD	E,(HL)		;6E1D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6E1F:	56
	EX	DE,HL		;6E20:	EB
	CALL	LAB_DF42		; save HL as unsigned integer @  LAB_E3B1 (LAB_7A7D ROM 1)
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	07h,00h,00h,00h

	CALL	LAB_DD5D		; does (LAB_E3B1)<<(LAB_E3B9) (LAB_7898)
	CALL	LAB_DC5B		; does push (LAB_E3B1).L	(LAB_7796 ROM 1)
	LD	HL,(LAB_EA24)	;6E31:	2A24EA
	INC	HL		;6E34:	23
	INC	HL		;6E35:	23
	INC	HL		;6E36:	23
	LD	E,(HL)		;6E37:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6E39:	56
	EX	DE,HL		;6E3A:	EB
	CALL	LAB_DF42		; save HL as unsigned integer @  LAB_E3B1 (LAB_7A7D ROM 1)
	CALL	LAB_DC69		; does pop (LAB_E3B9).L		(LAB_77A4 ROM 1)
	CALL	LAB_DCE9		; does ADC.L (LAB_E3B1),(LAB_E3B9) (LAB_7824)
	CALL	LAB_DC74		; swap (LAB_E3B1) with (LAB_E3B9)	(LAB_77AF ROM 1)
	POP	HL		;6E47:	E1
	PUSH	HL		;6E48:	E5
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DCE9		; does ADC.L (LAB_E3B1),(LAB_E3B9) (LAB_7824)
	POP	HL		;6E4F:	E1
	CALL	LAB_DC49		; copies four bytes from LAB_E3B1 to (HL) (LAB_7784)
	JP	LAB_6E77	;6E53:	C3776E

LAB_6E56
	LD	HL,1774h	;6E56:	217417
	LD	(LAB_EC3F),HL	;6E59:	223FEC
	CALL	LAB_DC30		; copies next four bytes after the call to LAB_E3B1
					; returns to instruction after the bytes (LAB_776B)

	DB	FFh,FFh,FFh,FFh

	RET				;

LAB_6E64
	CALL	LAB_E0B2		; search following table for HL & execute vector
					; (LAB_7BED ROM 1)

	DW	0003

	DW	0000
	DW	LAB_6E11

	DW	0001
	DW	LAB_6E14

	DW	0003
	DW	LAB_6E56

	DW	LAB_6E56

LAB_6E77
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	00h,00h,00h,00h

	CALL	LAB_DEEE		; do signed IF (LAB_E3B1)<(LAB_E3B9)	(LAB_7A29 ROM 1)
	JP	Z,LAB_6EAA	;6E88:	CAAA6E
	LD	HL,0000h	;6E8B:	210000
	PUSH	HL		;6E8E:	E5
	LD	HL,(LAB_EA24)	;6E8F:	2A24EA
	INC	HL		;6E92:	23
	POP	DE		;6E93:	D1
	LD	(HL),E		;6E94:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6E96:	72
	PUSH	DE		;6E97:	D5
	LD	HL,(LAB_EA24)	;6E98:	2A24EA
	INC	HL		;6E9B:	23
	INC	HL		;6E9C:	23
	INC	HL		;6E9D:	23
	POP	DE		;6E9E:	D1
	LD	(HL),E		;6E9F:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6EA1:	72
	CALL	LAB_DC30		; copies next four bytes after the call to LAB_E3B1
					; returns to instruction after the bytes (LAB_776B)

	DB	FFh,FFh,FFh,FFh

	RET				;

LAB_6EAA
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	07h,00h,00h,00h

	CALL	LAB_DD81		; does #_1 >> #_2 (LAB_78BC)
	CALL	LAB_DF5B		; get unsigned integer from LAB_E3B1	(LAB_7A96 ROM 1)
	PUSH	HL		;6EBE:	E5
	LD	HL,(LAB_EA24)	;6EBF:	2A24EA
	INC	HL		;6EC2:	23
	POP	DE		;6EC3:	D1
	LD	(HL),E		;6EC4:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6EC6:	72
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	CALL	LAB_DC23		; copies next four bytes after the call to LAB_E3B9
					; returns to instruction after the bytes (LAB_775E)

	DB	7Fh,00h,00h,00h

	CALL	LAB_DD13		; does AND.L (LAB_E3B1),(LAB_E3B9) (LAB_784E)
	CALL	LAB_DF5B		; get unsigned integer from LAB_E3B1	(LAB_7A96 ROM 1)
	PUSH	HL		;6EDB:	E5
	LD	HL,(LAB_EA24)	;6EDC:	2A24EA
	INC	HL		;6EDF:	23
	INC	HL		;6EE0:	23
	INC	HL		;6EE1:	23
	POP	DE		;6EE2:	D1
	LD	(HL),E		;6EE3:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6EE5:	72
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	CALL	LAB_DC37		; copies four bytes from (HL) to LAB_E3B1 (LAB_7772)
	RET				;

LAB_6EEE
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,EA26h	;6EF4:	2126EA
	PUSH	HL		;6EF7:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6EFC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6EFE:	56
	PUSH	DE		;6EFF:	D5
	CALL	LAB_DA4C	;6F00:	CD4CDA
	POP	DE		;6F03:	D1
	POP	DE		;6F04:	D1
	LD	HL,LAB_EA26		; set FCB address
	PUSH	HL			; push parameter
	LD	HL,0013h		; BDOS function 19 - delete file
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	DE,00FFh	;6F12:	11FF00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_6F25	;6F18:	CA256F
	LD	HL,1777h	;6F1B:	217717
	LD	(LAB_EC3F),HL	;6F1E:	223FEC
	LD	HL,FFFFh	;6F21:	21FFFF
	RET				;

LAB_6F25
	LD	HL,0000h	;6F25:	210000
	RET				;

; character out to console

; stack is
; character (byte)
; end.

LAB_6F29
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get character
	LD	D,#00h		; clear high byte
	PUSH	DE			; push character
	LD	HL,0002h		; BDOS function 2 - Console output
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	RET				;

; message out until null

; stack is
; message pointer
; end.

LAB_6F41
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	EX	DE,HL			; swap messagepointer to HL
LAB_6F4F
	LD	A,(HL)		; get byte from message
	OR	A			; set the flags
	RET	Z			; exit if null

	PUSH	HL			; else save pointer
	LD	E,A			; copy byte to E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push character
	CALL	LAB_6F29		; character out to console
	POP	DE			; dump character
	POP	HL			; restore message pointer
	INC	HL			; increment message pointer
	JP	LAB_6F4F		; loop

LAB_6F60
	RET				;

; clear screen & screen buffer

LAB_6F61
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0000h		; clear HL
	LD	A,L			; copy to A
	LD	(LAB_EA4B),A	; set cursor Y position
	LD	HL,0000h		; clear HL
	LD	A,L			; copy to A
	LD	(LAB_EA4C),A	; set cursor X position
	LD	HL,0007h		; set HL
	LD	A,L			; copy to A
	LD	(LAB_EA4D),A	; set display height ??
	LD	HL,0013h		; set HL
	LD	A,L			; copy to A
	LD	(LAB_EA4E),A	; set display width ??
	LD	HL,0000h		; clear HL
	LD	A,L			; copy to A
	LD	(LAB_EA4F),A	;6F87:	324FEA
	LD	HL,0000h		; clear HL
	LD	A,L			; copy to A
	LD	(LAB_EA51),A	;6F8E:	3251EA
	LD	HL,0001h		; set HL = 0001h
	LD	A,L			; copy to A
	LD	(LAB_EA50),A	; set cursor blink flag
	LD	HL,LAB_E357		; set message pointer [ESC] "R", set cursor on
	PUSH	HL			; push message pointer
	CALL	LAB_6F41		; message out until null
	POP	DE			; dump message pointer
	LD	HL,0014h		; 20d wide
	PUSH	HL			; push x size
	LD	HL,0008h		; 8d high
	PUSH	HL			; push y size
	LD	HL,0000h		; x = 0
	PUSH	HL			; push x
	LD	HL,0000h		; y = 0
	PUSH	HL			; push y
	CALL	LAB_6FBA		; clear screen area
	EX	DE,HL			; copy result to DE
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	RET				;

; clear screen area

; stack is ..
; y
; x
; ysize
; xsize
; end.

LAB_6FBA
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get low byte
	LD	D,#00h		; clear high byte
	LD	HL,0008h		; test value
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_6FFD		; jump if last pushed -2 wasn't 0008h

					; else check last pushed -3
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get low byte
	LD	D,#00h		; clear high byte
	LD	HL,0014h		; test value
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
					; (LAB_7B86 ROM 1)
	JP	Z,LAB_6FFD		; jump if last pushed -3 wasn't 0014h

					; else clear screen & screen buffer
	LD	HL,LAB_E35A		; set message pointer [ESC] "K",
					; clear display & home cursor
	PUSH	HL			; push message pointer
	CALL	LAB_6F41		; message out until null
	POP	DE			; dump message pointer
	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,00A0h		; 00A0h bytes in buffer
	PUSH	HL			; on stack
	LD	HL,LAB_EA52		; start of screen buffer
	PUSH	HL			; on stack
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	JP	LAB_70AD		; exit (RET would be better)

					; size wasn't whole screen
LAB_6FFD
	LD	HL,0000h		; clear word
	LD	A,L			; clear byte
	LD	(LAB_EAF2),A	; clear y1
	JP	LAB_701D		;

LAB_7007
	LD	A,(LAB_EAF2)	;7007:	3AF2EA
	LD	L,A		;700A:	6F
	INC	HL		;700B:	23
	LD	A,L		;700C:	7D
	LD	(LAB_EAF2),A	;700D:	32F2EA
	DEC	HL		;7010:	2B
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;7015:	E5
	LD	L,(HL)		;7016:	6E
	INC	HL		;7017:	23
	EX	DE,HL		;7018:	EB
	POP	HL		;7019:	E1
	LD	(HL),E		;701A:	73
	EX	DE,HL			; don't need this
	DEC	HL			; don't need this either
LAB_701D
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get low byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; push y2
	LD	A,(LAB_EAF2)	; get y1
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE			; restore y2
	EX	DE,HL			; swap y1,y2
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_70AD		; exit if y1>y2

	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get low byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; save x2
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get low byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; save x1
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get low byte
	LD	D,#00h		; clear high byte
	LD	HL,0014h		; 14h bytes per screen line
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	POP	DE			; restore x1
	ADD	HL,DE			; add to y1*14h
	LD	DE,LAB_EA52		; start of screen buffer
	ADD	HL,DE			; add to y1*14h+x1
	PUSH	HL			; save pointer
	CALL	LAB_DC07		; fill count bytes, from destination, with " "
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get low byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; save x1
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get low byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; save y1
	CALL	LAB_70AE		; set cursor x,y
	POP	DE			; dump cursor y
	POP	DE			; dump cursor x
	LD	HL,0000h	;7076:	210000
	LD	A,L		;7079:	7D
	LD	(LAB_EAF3),A	;707A:	32F3EA
	JP	LAB_7089	;707D:	C38970

LAB_7080
	LD	A,(LAB_EAF3)	;7080:	3AF3EA
	LD	L,A		;7083:	6F
	INC	HL		;7084:	23
	LD	A,L		;7085:	7D
	LD	(LAB_EAF3),A	;7086:	32F3EA
LAB_7089
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get low byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; save x2
	LD	A,(LAB_EAF3)	;7091:	3AF3EA
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;7097:	D1
	EX	DE,HL		;7098:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_70AA		; jump if were =

	LD	HL,0020h		; set character = " "
	PUSH	HL			; push character
	CALL	LAB_6F29		; character out to console
	POP	DE			; dump character
	JP	LAB_7080		; loop

LAB_70AA
	JP	LAB_7007		; ?? main loop

LAB_70AD
	RET				;

; set cursor X,Y

; stack is ..
; y position
; x position
; end.

LAB_70AE
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get y low byte
	LD	D,#00h		; clear high byte
	LD	HL,0008h		; 0008h is max+1 y
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_70CA		; jump if y<8

	LD	HL,0007h		; else make y=7
	JP	LAB_70D2		; go save and do x

LAB_70CA
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get y low byte
	LD	D,#00h		; clear high byte
	EX	DE,HL			; swap to HL
LAB_70D2
	LD	A,L			; copy to A
	LD	(LAB_EA4B),A	; save cursor Y position
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get x low byte
	LD	D,#00h		; clear high byte
	LD	HL,0014h		; 0014h is max+1 x
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_70EC		; jump if x<14h

	LD	HL,0013h		; else make x=13h
	JP	LAB_70F4		; go save and do rest

LAB_70EC
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get x low byte
	LD	D,#00h		; clear high byte
	EX	DE,HL			; swap to HL
LAB_70F4
	LD	A,L			; copy to A
	LD	(LAB_EA4C),A	; save cursor x position
	LD	HL,LAB_E35D		; set message pointer [ESC] "Y", set cursor y position
	PUSH	HL			; push message pointer
	CALL	LAB_6F41		; message out until null
	POP	DE			; dump message pointer
	LD	A,(LAB_EA4B)	; get cursor y position
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	INC	HL			; increment cursor y position
	PUSH	HL			; push  cursor y position
	CALL	LAB_6F29		; character out to console
	POP	DE			; dump cursor y position
	LD	HL,LAB_E360		; set message pointer [ESC] "X", set cursor x position
	PUSH	HL			; push message pointer
	CALL	LAB_6F41		; message out until null
	POP	DE			; dump message pointer
	LD	A,(LAB_EA4C)	; get cursor x position
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	INC	HL			; increment cursor x position
	PUSH	HL			; push cursor x position
	CALL	LAB_6F29		; character out to console
	POP	DE			; dump cursor x position
	RET				;

; home cursor, clear cursor x,y

LAB_7121
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,LAB_E363		; set message pointer [ESC] "H", home cursor
	PUSH	HL			; push message pointer
	CALL	LAB_6F41		; message out until null
	POP	DE			; dump message pointer
	LD	HL,0000h		; clear word
	LD	A,L			; copy to A
	LD	(LAB_EA4C),A	; clear cursor X position
	LD	A,L			; copy to A (again)
	LD	(LAB_EA4B),A	; clear cursor Y position
	RET				;

; get cursor x,y to pointer x, pointer y

; stack is ..
; pointer y
; pointer x
; end.

LAB_713B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	A,(LAB_EA4B)	; get cursor Y position
	LD	L,A			; copy to L
	PUSH	HL			; on stack
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get pointer y low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer y high byte
	EX	DE,HL			; swap to HL
	POP	DE			; get cursor y position back
	LD	(HL),E		; save @ (HL)
	LD	A,(LAB_EA4C)	; get cursor X position
	LD	L,A			; copy to L
	PUSH	HL			; on stack
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get pointer x low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer x high byte
	EX	DE,HL			; swap to HL
	POP	DE			; get cursor x position back
	LD	(HL),E		; save @ (HL)
	RET				;

; set word @ addr_1 to 0008h and addr_2 to 0014h

; stack is ..
; addr_1
; addr_2
; end.

LAB_7160
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0008h		; set HL=0008h
	PUSH	HL			; on the stack
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get addr_1 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get addr_1 high byte
	EX	DE,HL			; swap addr_1 to HL
	POP	DE			; pop 0008h from stack
	LD	(HL),E		; save low byte at addr_1
	INC	HL			; increment pointer
	LD	(HL),D		; save low byte at addr_1
	LD	HL,0014h		; set HL=0008h
	PUSH	HL			; on the stack
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get addr_2 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get addr_2 high byte
	EX	DE,HL			; swap addr_2 to HL
	POP	DE			; pop 0014h from stack
	LD	(HL),E		; save low byte at addr_2
	INC	HL			; increment pointer
	LD	(HL),D		; save low byte at addr_2
	RET				;

; get character under cursor

LAB_7187
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	A,(LAB_EA4C)	; get cursor x position
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; on stack
	LD	A,(LAB_EA4B)	; get cursor y position
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0014h		; 14h bytes per display line
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	POP	DE			; get x position back
	ADD	HL,DE			; add to y*14h
	LD	DE,LAB_EA52		; start of screen buffer
	ADD	HL,DE			; add to x+y*14h
	LD	E,(HL)		; get byte from buffer
	LD	D,#00h		; clear high byte
	EX	DE,HL			; swap to HL
	RET				;

; does nothing

LAB_71AB
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	RET				;

; set cursor blink on/off
; this could be shorter

; stack is
; flag
; end.

LAB_71B2
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	A,(LAB_EA50)	; get cursor blink flag
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	EX	DE,HL			; swap to DE
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		; get flag low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get flag high byte
	LD	L,A			; copy low byte to L
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
					; (LAB_7B95 ROM 1)
	JP	Z,LAB_71E1		; exit if required state

	LD	HL,LAB_E366		; set message pointer [ESC] "C", invert cursor blink
	PUSH	HL			; push message pointer
	CALL	LAB_6F41		; message out until null
	POP	DE			; dump message pointer
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get flag low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get flag high byte
	EX	DE,HL			; swap to HL
	LD	A,L			; copy low byte to A
	LD	(LAB_EA50),A	; set cursor blink flag
LAB_71E1
	RET				;

; if flag is non zero set cursor off, else set cursor on

; stack is ..
; flag
; end.

LAB_71E2
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		; get low byte
	INC	HL			; increment pointer
	OR	(HL)			; OR high byte
	JP	Z,LAB_71FD		; jump if null

	LD	HL,LAB_E369		; set message pointer [ESC] "B" set cursor off & blink
	PUSH	HL			; push message pointer
	CALL	LAB_6F41		; message out until null
	POP	DE			; dump message pointer
	JP	LAB_7205		; exit (RET would be better)

LAB_71FD
	LD	HL,LAB_E36C		; set message pointer [ESC] "A" set cursor on & no blink
	PUSH	HL			; push message pointer
	CALL	LAB_6F41		; message out until null
	POP	DE			; dump message pointer
LAB_7205
	RET				;

; does nothing

LAB_7206
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	RET				;

; character out to screen & buffer

; stack is ..
; character (byte)
; end.

LAB_720D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get character
	LD	D,#00h		; clear character high byte
	PUSH	DE			; push character
	CALL	LAB_6F29		; character out to console
	POP	DE			; dump character
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get character
	PUSH	DE			; save character
	LD	A,(LAB_EA4C)	; get cursor X position
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; put x position on stack
	LD	A,(LAB_EA4B)	; get cursor Y position
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0014h		; 14h bytes per screen line
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	POP	DE			; get x position back
	ADD	HL,DE			; add to y*14h
	LD	DE,LAB_EA52		; start of screen buffer
	ADD	HL,DE			; add to x+y*14h
	POP	DE			; get character back
	LD	(HL),E		; save to buffer
	LD	A,(LAB_EA4C)	; get cursor X position
	LD	L,A			; copy to L
	INC	HL			; +1
	LD	A,L			; back to A
	LD	(LAB_EA4C),A	; set cursor X position
	LD	H,#00h		; clear H
	LD	DE,0014h		; set max+1 x
	EX	DE,HL			; swap DE,HL
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_7278		; exit if no roll round

	LD	HL,0000h		; clear HL
	LD	A,L			; copy to A
	LD	(LAB_EA4C),A	; clear cursor X position
	LD	A,(LAB_EA4B)	; get cursor Y position
	LD	L,A			; copy it
	INC	HL			; +1
	LD	A,L			; copy it back
	LD	(LAB_EA4B),A	; set cursor Y position
	LD	H,#00h		; clear high byte
	LD	DE,0008h		; set max+1 y
	EX	DE,HL			; swap DE,HL
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
					; (LAB_7BA5 ROM 1)
	JP	Z,LAB_7278		; exit if no roll over

	LD	HL,0000h		; clear HL
	LD	A,L			; copy L
	LD	(LAB_EA4B),A	; clear cursor Y position
LAB_7278
	RET				;

; send BELL character to console

LAB_7279
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,0007h		; set character = 07 (BELL)
	PUSH	HL			; push character
	CALL	LAB_6F29		; character out to console
	POP	DE			; dump character
	RET				;

; scroll region up ??

; stack is ..
; y
; x
; y size
; x size
; end.

LAB_7288
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get x
	LD	D,#00h		; clear high byte
	PUSH	DE			; save x
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get y
	LD	D,#00h		; clear high byte
	LD	HL,0014h		; 20d bytes per line
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	POP	DE			; restore x
	ADD	HL,DE			; add to y*20
	LD	DE,LAB_EA52		; start of screen buffer
	ADD	HL,DE			; add to y*20+x
	LD	(LAB_EAF6),HL	; save pointer
	LD	HL,(LAB_EAF6)	; get pointer (not needed)
	LD	DE,0014h		; 20d bytes per line
	ADD	HL,DE			; pointer + 20d
	LD	(LAB_EAF4),HL	; save ?? pointer
	LD	HL,0001h		; set HL = 0001h
	LD	A,L			; copy to L
	LD	(LAB_EAF8),A	; save line count
	JP	LAB_72C9	;72BD:	C3C972

LAB_72C0
	LD	A,(LAB_EAF8)	;72C0:	3AF8EA
	LD	L,A		;72C3:	6F
	INC	HL		;72C4:	23
	LD	A,L		;72C5:	7D
	LD	(LAB_EAF8),A	;72C6:	32F8EA
LAB_72C9
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;72CD:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;72D0:	D5
	LD	A,(LAB_EAF8)	;72D1:	3AF8EA
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;72D7:	D1
	EX	DE,HL		;72D8:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_730E	;72DC:	CA0E73

	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;72E3:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push byte count
	LD	HL,(LAB_EAF6)	;72E7:	2AF6EA
	PUSH	HL			; push destination pointer
	LD	HL,(LAB_EAF4)	;72EB:	2AF4EA
	PUSH	HL			; push source pointer
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	LD	HL,0014h	;72F5:	211400
	EX	DE,HL		;72F8:	EB
	LD	HL,(LAB_EAF4)	;72F9:	2AF4EA
	ADD	HL,DE		;72FC:	19
	LD	(LAB_EAF4),HL	;72FD:	22F4EA
	LD	HL,0014h	;7300:	211400
	EX	DE,HL		;7303:	EB
	LD	HL,(LAB_EAF6)	;7304:	2AF6EA
	ADD	HL,DE		;7307:	19
	LD	(LAB_EAF6),HL	;7308:	22F6EA
	JP	LAB_72C0	;730B:	C3C072
LAB_730E
	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;7316:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;7319:	D5
	LD	HL,(LAB_EAF6)	;731A:	2AF6EA
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;7328:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;732B:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;7330:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0014h		; 14h bytes per screen line
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	POP	DE		;7339:	D1
	ADD	HL,DE		;733A:	19
	LD	DE,LAB_EA52		; start of screen buffer
	ADD	HL,DE		;733E:	19
	LD	(LAB_EAF6),HL	;733F:	22F6EA
	LD	(LAB_EAF4),HL	;7342:	22F4EA
	LD	HL,0000h	;7345:	210000
	LD	A,L		;7348:	7D
	LD	(LAB_EAF8),A	;7349:	32F8EA
	JP	LAB_7365	;734C:	C36573
LAB_734F
	LD	A,(LAB_EAF8)	;734F:	3AF8EA
	LD	L,A		;7352:	6F
	INC	HL		;7353:	23
	LD	A,L		;7354:	7D
	LD	(LAB_EAF8),A	;7355:	32F8EA
	DEC	HL		;7358:	2B
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;735D:	E5
	LD	L,(HL)		;735E:	6E
	INC	HL		;735F:	23
	EX	DE,HL		;7360:	EB
	POP	HL		;7361:	E1
	LD	(HL),E		;7362:	73
	EX	DE,HL		;7363:	EB
	DEC	HL		;7364:	2B
LAB_7365
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;7369:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;736C:	D5
	LD	A,(LAB_EAF8)	;736D:	3AF8EA
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;7373:	D1
	EX	DE,HL		;7374:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_73DD	;7378:	CADD73
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;737F:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;7382:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;7387:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push cursor Y
	CALL	LAB_70AE		; set cursor X,Y
	POP	DE			; dump cursor Y
	POP	DE			; dump cursor X
	LD	HL,0000h	;7390:	210000
	LD	A,L		;7393:	7D
	LD	(LAB_EAF9),A	;7394:	32F9EA
	JP	LAB_73A3	;7397:	C3A373

LAB_739A
	LD	A,(LAB_EAF9)	;739A:	3AF9EA
	LD	L,A		;739D:	6F
	INC	HL		;739E:	23
	LD	A,L		;739F:	7D
	LD	(LAB_EAF9),A	;73A0:	32F9EA
LAB_73A3
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;73A7:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;73AA:	D5
	LD	A,(LAB_EAF9)	;73AB:	3AF9EA
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;73B1:	D1
	EX	DE,HL		;73B2:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_73CC	;73B6:	CACC73

	LD	HL,(LAB_EAF6)	;73B9:	2AF6EA
	INC	HL		;73BC:	23
	LD	(LAB_EAF6),HL	;73BD:	22F6EA
	DEC	HL		;73C0:	2B
	LD	E,(HL)		; get character
	LD	D,#00h		; clear character high byte
	PUSH	DE			; push character
	CALL	LAB_6F29		; character out to console
	POP	DE			; dump character
	JP	LAB_739A		; loop

LAB_73CC
	LD	HL,0014h	;73CC:	211400
	EX	DE,HL		;73CF:	EB
	LD	HL,(LAB_EAF4)	;73D0:	2AF4EA
	ADD	HL,DE		;73D3:	19
	LD	(LAB_EAF4),HL	;73D4:	22F4EA
	LD	(LAB_EAF6),HL	;73D7:	22F6EA
	JP	LAB_734F	;73DA:	C34F73
LAB_73DD
	RET				;

; scroll region down ??

; stack is ..
; y
; x
; y size
; x size
; end.

LAB_73DE
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6 ROM 1)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get x
	LD	D,#00h		; clear high byte
	PUSH	DE			; save x
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;73F0:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;73F3:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get y
	LD	D,#00h		; clear high byte
	POP	HL			; restore last pushed but 2
	ADD	HL,DE			; add last pushed
	DEC	HL			; -1
	LD	DE,0014h		; 20d bytes per line
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	POP	DE			; restore x
	ADD	HL,DE		;7405:	19
	LD	DE,LAB_EA52		; start of screen buffer
	ADD	HL,DE		;7409:	19
	LD	(LAB_EAFC),HL	;740A:	22FCEA
	LD	HL,(LAB_EAFC)	;740D:	2AFCEA
	LD	DE,FFECh		; -20d
	ADD	HL,DE		;7413:	19
	LD	(LAB_EAFA),HL	;7414:	22FAEA
	LD	HL,0001h		; set HL = 0001h
	LD	A,L		;741A:	7D
	LD	(LAB_EAFE),A	;741B:	32FEEA
	JP	LAB_742A	;741E:	C32A74

LAB_7421
	LD	A,(LAB_EAFE)	;7421:	3AFEEA
	LD	L,A		;7424:	6F
	INC	HL		;7425:	23
	LD	A,L		;7426:	7D
	LD	(LAB_EAFE),A	;7427:	32FEEA
LAB_742A
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;742E:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;7431:	D5
	LD	A,(LAB_EAFE)	;7432:	3AFEEA
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;7438:	D1
	EX	DE,HL		;7439:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_7475	;743D:	CA7574

	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;7444:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push byte count
	LD	HL,(LAB_EAFC)	;7448:	2AFCEA
	PUSH	HL			; push destination pointer
	LD	HL,(LAB_EAFA)	;744C:	2AFAEA
	PUSH	HL			; push source pointer
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source pointer
	POP	DE			; dump destination pointer
	POP	DE			; dump byte count
	LD	HL,0014h		; bytes per line
	EX	DE,HL			; swap to DE
	LD	HL,(LAB_EAFA)	; get source
	EX	DE,HL			; swap to DE
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_EAFA),HL	; save new source (old - 20d)
	LD	HL,0014h		; bytes per line
	EX	DE,HL			; swap to DE
	LD	HL,(LAB_EAFC)	; get destination
	EX	DE,HL			; swap to DE
	CALL	LAB_E0A9		; does HL=DE-HL, returns Zb=1 if equal (LAB_7BE4 ROM 1)
	LD	(LAB_EAFC),HL	; save new destination (old - 20d)
	JP	LAB_7421		; loop

LAB_7475
	LD	HL,0020h		; set byte " "
	PUSH	HL			; push fill byte
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get count
	LD	D,#00h		; clear high byte
	PUSH	DE			; push count
	LD	HL,(LAB_EAFC)	;7481:	2AFCEA
	PUSH	HL			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;748F:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;7492:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;7497:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0014h		; 14h bytes per screen line
	CALL	LAB_DFCC		; does HL = HL*DE (LAB_7B07 ROM 1)
	POP	DE		;74A0:	D1
	ADD	HL,DE		;74A1:	19
	LD	DE,LAB_EA52		; start of screen buffer
	ADD	HL,DE		;74A5:	19
	LD	(LAB_EAFC),HL	;74A6:	22FCEA
	LD	(LAB_EAFA),HL	;74A9:	22FAEA
	LD	HL,0000h	;74AC:	210000
	LD	A,L		;74AF:	7D
	LD	(LAB_EAFE),A	;74B0:	32FEEA
	JP	LAB_74CC	;74B3:	C3CC74

LAB_74B6
	LD	A,(LAB_EAFE)	;74B6:	3AFEEA
	LD	L,A		;74B9:	6F
	INC	HL		;74BA:	23
	LD	A,L		;74BB:	7D
	LD	(LAB_EAFE),A	;74BC:	32FEEA
	DEC	HL		;74BF:	2B
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;74C4:	E5
	LD	L,(HL)		;74C5:	6E
	INC	HL		;74C6:	23
	EX	DE,HL		;74C7:	EB
	POP	HL		;74C8:	E1
	LD	(HL),E		;74C9:	73
	EX	DE,HL		;74CA:	EB
	DEC	HL		;74CB:	2B
LAB_74CC
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;74D0:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;74D3:	D5
	LD	A,(LAB_EAFE)	;74D4:	3AFEEA
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;74DA:	D1
	EX	DE,HL		;74DB:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_7544		; exit if ??

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;74E6:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push cursur x
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;74EE:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE			; push cursur y
	CALL	LAB_70AE		; set cursor x,y
	POP	DE			; dump cursor y
	POP	DE			; dump cursor x
	LD	HL,0000h	;74F7:	210000
	LD	A,L		;74FA:	7D
	LD	(LAB_EAFF),A	;74FB:	32FFEA
	JP	LAB_750A	;74FE:	C30A75

LAB_7501
	LD	A,(LAB_EAFF)	;7501:	3AFFEA
	LD	L,A		;7504:	6F
	INC	HL		;7505:	23
	LD	A,L		;7506:	7D
	LD	(LAB_EAFF),A	;7507:	32FFEA
LAB_750A
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;750E:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;7511:	D5
	LD	A,(LAB_EAFF)	;7512:	3AFFEA
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE		;7518:	D1
	EX	DE,HL		;7519:	EB
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
					; (LAB_7BC0 ROM 1)
	JP	Z,LAB_7533	;751D:	CA3375

	LD	HL,(LAB_EAFC)	; get pointer
	INC	HL			; increment pointer
	LD	(LAB_EAFC),HL	; save new pointer
	DEC	HL			; decrement pointer
	LD	E,(HL)		; get character
	LD	D,#00h		; clear character high byte
	PUSH	DE			; push character
	CALL	LAB_6F29		; character out to console
	POP	DE			; dump character
	JP	LAB_7501		; loop

LAB_7533
	LD	HL,0014h	;7533:	211400
	EX	DE,HL		;7536:	EB
	LD	HL,(LAB_EAFA)	;7537:	2AFAEA
	ADD	HL,DE		;753A:	19
	LD	(LAB_EAFA),HL	;753B:	22FAEA
	LD	(LAB_EAFC),HL	;753E:	22FCEA
	JP	LAB_74B6	;7541:	C3B674

LAB_7544
	RET				;

; start of menu tables ??

LAB_7545
	NOP			;7545:	00
	NOP			;7546:	00
LAB_7547
	NOP			;7547:	00
	RET	P		;7548:	F0
	INC	D		;7549:	14
	POP	AF		;754A:	F1
	XOR	H		;754B:	AC
	RST	28h		;754C:	EF
	RET	PE		;754D:	E8
	RST	28h		;754E:	EF
	LD	(BC),A	;754F:	02
	JR	NZ,LAB_7552	;7550:	2000
	NOP			;7552:	00
	LD	(BC),A	;7553:	02
	LD	BC,0002h	;7554:	010200

LAB_7557
	DW	LAB_7547

LAB_7559
	RET	P		;7559:	F0
	RST	28h		;755A:	EF
	CALL	M,LAB_9CF0	;755B:	FCF09C
	RST	28h		;755E:	EF
	CALL	C,LAB_04EF	;755F:	DCEF04
	DJNZ	LAB_7564	;7562:	1000
LAB_7564
	NOP			;7564:	00
	INC	B		;7565:	04
	LD	BC,0004h	;7566:	010400

	DW	LAB_7559

LAB_756B
	DW	LAB_EFF8		; +00h (LAB_0115)
	INC	C		;756D:	0C
	POP	AF		;756E:	F1
	XOR	B		;756F:	A8
	RST	28h		;7570:	EF
	CALL	PO,LAB_0DEF	;7571:	E4EF0D
	LD	(BC),A	;7574:	02
	NOP			;7575:	00
	NOP			;7576:	00
	NOP			;7577:	00
	NOP			;7578:	00
	DEC	C		;7579:	0D
	LD	BC,000Dh	;757A:	010D00

	DW	LAB_756B

LAB_757F
	DW	LAB_79E1		; points to 'WORKSTATION MEMORY'
	DW	LAB_79F4		; points to 'WORKSTATION RAMDISK'
	DW	LAB_7A08		; points to 'PLINTH'
	DW	LAB_7A0F		; points to 'V24 ADAPTOR'
	DW	LAB_7A1B		; points to 'EXT STORAGE ADAPTOR'
	DW	0000

; table_1 used by LAB_0271 routine

LAB_758B
	DW	LAB_EFEC		; +00h (LAB_4FB0)
	DB	F8h
	RET	P		;758E:	F0
	SBC	A,B		;758F:	98
	RST	28h		;7590:	EF
	RET	C		;7591:	D8
	RST	28h		;7592:	EF

	DB	01h			; +08h
	DB	08h
	DB	20h			; +0Ah
	DB	01h
	DW	LAB_757F		; +0Ch pointer to option strings

LAB_7599
	LD	BC,0101h	;7599:	010101
	NOP			;759C:	00

	DW	LAB_758B

LAB_759F
	CALL	P,LAB_00EF	;759F:	F4EF00
	POP	AF		;75A2:	F1
	AND	B		;75A3:	A0
	RST	28h		;75A4:	EF
	RET	PO		;75A5:	E0
	RST	28h		;75A6:	EF
	LD	(BC),A	;75A7:	02
	LD	BC,0011h	;75A8:	011100
	NOP			;75AB:	00
	NOP			;75AC:	00
	NOP			;75AD:	00
	CP	#FFh		;75AE:	FEFF
	LD	(BC),A	;75B0:	02
	LD	BC,0002h	;75B1:	010200
	SBC	A,A		;75B4:	9F
	LD	(HL),L	;75B5:	75
	CALL	P,LAB_00EF	;75B6:	F4EF00
	POP	AF		;75B9:	F1
	AND	B		;75BA:	A0
	RST	28h		;75BB:	EF
	RET	PO		;75BC:	E0
	RST	28h		;75BD:	EF
	LD	(BC),A	;75BE:	02
	LD	BC,0009h	;75BF:	010900
	NOP			;75C2:	00
	NOP			;75C3:	00
	NOP			;75C4:	00
	CP	#FFh		;75C5:	FEFF
	LD	(BC),A	;75C7:	02
	LD	BC,0002h	;75C8:	010200
	OR	(HL)		;75CB:	B6
	LD	(HL),L	;75CC:	75

LAB_75CD
	RET	M		;75CD:	F8
	RST	28h		;75CE:	EF
	INC	C		;75CF:	0C
	POP	AF		;75D0:	F1
	XOR	B		;75D1:	A8
	RST	28h		;75D2:	EF
	CALL	PO,LAB_09EF	;75D3:	E4EF09
	LD	(BC),A	;75D6:	02
	SUB	B		;75D7:	90
	LD	BC,0000h	;75D8:	010000
	ADD	HL,BC		;75DB:	09
	LD	BC,0009h	;75DC:	010900

	DW	LAB_75CD

LAB_75E1
	DW	LAB_7A2F		; points to 'LOCAL LINK'
	DW	LAB_7A3A		; points to 'MODEM A/ANS'
	DW	LAB_7A46		; points to 'MODEM A/DIAL'
	DW	LAB_7A53		; points to 'MODEM MAN/D'
	DW	0000

; table_2 used by LAB_0271 routine

LAB_75EB
	DW	LAB_EFEC		; +00h
	DB	F8h
	RET	P		;75EE:	F0
	SBC	A,B		;75EF:	98
	RST	28h		;75F0:	EF
	RET	C		;75F1:	D8
	RST	28h		;75F2:	EF

	DB	01h			; +08h
	DB	08h
	DB	20h			; +0Ah
	DB	01h
	DW	LAB_75E1		; +0Ch

	LD	BC,0101h	;75F9:	010101
	NOP			;75FC:	00

LAB_75FD
	DW	LAB_75EB

LAB_75FF
	DW	LAB_7A5F		; points to '300'
	DW	LAB_7A63		; points to '600'
	DW	LAB_7A67		; points to '1200'
	DW	LAB_7A6C		; points to '2400'
	DW	LAB_7A71		; points to '4800'
	DW	LAB_7A76		; points to '9600'
	DW	0000			; end marker

; table_3 used by LAB_0271 routine

LAB_760D
	DW	LAB_EFEC		; +00h
	DB	F8h
	RET	P		;7610:	F0
	SBC	A,B		;7611:	98
	RST	28h		;7612:	EF
	RET	C		;7613:	D8
	RST	28h		;7614:	EF

	DB	01h			; +08h
	DB	08h
	DB	20h			; +0Ah
	DB	00h
	DW	LAB_75FF		; +0Ch

	LD	BC,0101h	;761B:	010101
	NOP			;761E:	00

LAB_761F
	DW	LAB_760D

	RET	M		;7621:	F8
	RST	28h		;7622:	EF
	INC	C		;7623:	0C
	POP	AF		;7624:	F1
	XOR	B		;7625:	A8
	RST	28h		;7626:	EF
	CALL	PO,LAB_09EF	;7627:	E4EF09
	LD	(BC),A		;762A:	02
	NOP			;762B:	00
	NOP			;762C:	00
	NOP			;762D:	00
	NOP			;762E:	00
	ADD	HL,BC		;762F:	09
	LD	BC,0009h	;7630:	010900

LAB_7633
	DW	LAB_7621

LAB_7635
	DW	LAB_EFF8

	INC	C		;7637:	0C
	POP	AF		;7638:	F1
	XOR	B		;7639:	A8
	RST	28h		;763A:	EF
	CALL	PO,LAB_13EF	;763B:	E4EF13
	LD	(BC),A		;763E:	02
	ADD	A,B		;763F:	80
	NOP			;7640:	00
	NOP			;7641:	00
	NOP			;7642:	00
	INC	DE		;7643:	13
	LD	BC,0013h	;7644:	011300

LAB_7647
	DW	LAB_7635

LAB_7649
	DW	LAB_7A7B		; 'OFF'
	DW	LAB_7A7F		; 'ON'
	DW	0000

LAB_764F
	DW	LAB_EFEC		; +00h
	DB	F8h
	RET	P		;7652:	F0
	SBC	A,B		;7653:	98
	RST	28h		;7654:	EF
	RET	C		;7655:	D8
	RST	28h		;7656:	EF
	DB	01			; +08h
	DB	08
	DB	20			; +0Ah
	DB	01h
	DW	LAB_7649		; +0Ch

	LD	BC,0101h	;765D:	010101
	NOP			;7660:	00

LAB_7661
	DW	LAB_764F

LAB_7663
	DW	LAB_7A08		; 'PLINTH'
	DW	LAB_7A0F		; 'V24 ADAPTOR'
	DW	0000

LAB_7669
	DW	LAB_EFEC		; +00h
	DB	F8h
	RET	P		;766C:	F0
	SBC	A,B		;766D:	98
	RST	28h		;766E:	EF
	RET	C		;766F:	D8
	RST	28h		;7670:	EF

	DB	01h			; +08h
	DB	08h
	DB	20h			; +0Ah
	DB	01h
	DW	LAB_7663		; +0Ch

	LD	BC,0101h	;7677:	010101
	NOP			;767A:	00
	LD	L,C		;767B:	69
	HALT			;767C:	76
LAB_767D
	CALL	M,LAB_10EF	;767D:	FCEF10
	POP	AF		;7680:	F1
	XOR	B		;7681:	A8
	RST	28h		;7682:	EF
	CALL	PO,LAB_01EF	;7683:	E4EF01
	LD	(BC),A		;7686:	02
	NOP			;7687:	00
	NOP			;7688:	00
	NOP			;7689:	00
	NOP			;768A:	00
	LD	BC,0101h	;768B:	010101
	NOP			;768E:	00

	DW	LAB_767D

	LD	C,#02h		;7691:	0E02
	DEC	C		;7693:	0D
	NOP			;7694:	00
	LD	L,E		;7695:	6B
	LD	(HL),L		;7696:	75
	LD	BC,8B0Dh	;7697:	010D8B
	LD	(HL),L		;769A:	75
	LD	B,#02h		;769B:	0602
	LD	(BC),A		;769D:	02
	NOP			;769E:	00
	LD	B,A		;769F:	47
	LD	(HL),L		;76A0:	75
	INC	B		;76A1:	04
	LD	(BC),A		;76A2:	02
	LD	E,C		;76A3:	59
	LD	(HL),L		;76A4:	75
	LD	(DE),A		;76A5:	12
	LD	B,#02h		;76A6:	0602
	NOP			;76A8:	00
	SBC	A,A		;76A9:	9F
	LD	(HL),L		;76AA:	75
	LD	(BC),A		;76AB:	02
	LD	(BC),A		;76AC:	02
	SBC	A,A		;76AD:	9F
	LD	(HL),L		;76AE:	75
	LD	BC,7D04h	;76AF:	01047D
	HALT			;76B2:	76
	LD	(BC),A		;76B3:	02
	DEC	B		;76B4:	05
	OR	(HL)		;76B5:	B6
	LD	(HL),L		;76B6:	75
	LD	(BC),A		;76B7:	02
	RLCA			;76B8:	07
	SBC	A,A		;76B9:	9F
	LD	(HL),L		;76BA:	75
	ADD	HL,BC		;76BB:	09
	ADD	HL,BC		;76BC:	09
	CALL	LAB_3075	;76BD:	CD7530
	LD	B,#01h		;76C0:	0601
	NOP			;76C2:	00
	EX	DE,HL		;76C3:	EB
	LD	(HL),L		;76C4:	75
	LD	BC,0D01h	;76C5:	01010D
	HALT			;76C8:	76
	ADD	HL,BC		;76C9:	09
	LD	(BC),A		;76CA:	02
	LD	HL,0976h	;76CB:	217609
	DEC	BC		;76CE:	0B
	LD	HL,0976h	;76CF:	217609
	INC	D		;76D2:	14
	LD	HL,1376h	;76D3:	217613
	DEC	E		;76D6:	1D
	DEC	(HL)		;76D7:	35
	HALT			;76D8:	76
	LD	(BC),A		;76D9:	02
	LD	(BC),A		;76DA:	02
	LD	BC,4F00h	;76DB:	01004F
	HALT			;76DE:	76
	LD	BC,6901h	;76DF:	010169
	HALT			;76E2:	76

LAB_76E3
	DB	00			; line 0
	DB	00			; position 0
LAB_76E5
	DW	LAB_7A82		; points to 'PARCON 1000'
	DB	02			; line 2
	DB	00			; position 0
	DW	LAB_7A8E		; 'Enter the'
	DB	03			; line 3
	DB	00			; position 0
	DW	LAB_7A98		; 'Workstation'
	DB	04			; line 4
	DB	00			; position 0
	DW	LAB_7AA4		; 'serial number'
	DB	05			; line 5
	DB	00			; position 0
	DW	LAB_7AB2		; 'shown on the back'
	DB	06
	DB	06

	EX	AF,AF'		;76F9:	08
	NOP			;76FA:	00
	NOP			;76FB:	00
	DEC	B		;76FC:	05
	NOP			;76FD:	00
	NOP			;76FE:	00
	NOP			;76FF:	00
	NOP			;7700:	00
	NOP			;7701:	00
	DEC	B		;7702:	05
	NOP			;7703:	00
	EX	(SP),HL		;7704:	E3
	HALT			;7705:	76
	NOP			;7706:	00
	NOP			;7707:	00
	NOP			;7708:	00
	NOP			;7709:	00
	LD	BC,0101h	;770A:	010101
	NOP			;770D:	00
	RST	30h		;770E:	F7
	HALT			;770F:	76
	AND	L		;7710:	A5
	HALT			;7711:	76
	ADD	A,L		;7712:	85
	CALL	PE,LAB_0303	;7713:	EC0303
	LD	(HL),(IY+#68h)	;7716:	FD7668
	POP	AF		;7719:	F1
	LD	L,B		;771A:	68
	POP	AF		;771B:	F1
	NOP			;771C:	00
	NOP			;771D:	00
	INC	D		;771E:	14
	LD	(HL),A		;771F:	77
	NOP			;7720:	00
	NOP			;7721:	00
	DEC	C		;7722:	0D
	LD	D,C		;7723:	51
	LD	(HL),A		;7724:	77
	LD	BC,0000h	;7725:	0100

LAB_7727
	DB	00			; line 0
	DB	00			; column 0
	DW	LAB_7A82		; points to 'PARCON 1000'
	DB	01			; line 1
	DB	00			; column 0
	DW	LAB_7AC4		; 'Main menu'
	DB	03			; line 3
	DB	01			; column 1
	DB	31h			; key = '1'
	DW	LAB_7ACE		; 'Load/Run Program'
	DB	04			; line 4
	DB	01			; column 1
	DB	32h			; key = '2'
	DW	LAB_7ADF		; 'Set Clock'
	DB	05			; line 5
	DB	01			; column 1
	DB	33h			; key = '3'
	DW	LAB_7AE9		; 'Display Status'
	DB	06			; line 6
	DB	01			; column 1
	DB	34h			; key = '4'
	DW	LAB_7AF8		; 'Diagnostics'

LAB_7743
	LD	BC,0000h	;7743:	010000
	NOP			;7746:	00
	NOP			;7747:	00
	LD	(BC),A		;7748:	02
	INC	B		;7749:	04
	DAA			;774A:	27
	LD	(HL),A		;774B:	77
	CPL			;774C:	2F
	LD	(HL),A		;774D:	77
	NOP			;774E:	00
	NOP			;774F:	00
	NOP			;7750:	00
	LD	BC,4304h	;7751:	010443
	LD	(HL),A		;7754:	77
	LD	D,B		;7755:	50
	RST	28h		;7756:	EF
	INC	A		;7757:	3C
	RST	28h		;7758:	EF
	NOP			;7759:	00
	NOP			;775A:	00
	NOP			;775B:	00
	SBC	A,L		;775C:	9D
	LD	(HL),A		;775D:	77
	LD	BC,77E8h	;775E:	01E877
	LD	BC,7853h	;7761:	015378
	LD	BC,7884h	;7764:	018478
	LD	BC,0000h	;7767:	01

LAB_7768
	DB	00			; line 0
	DB	00			; column 0
LAB_776A
	DW	LAB_7A82		; points to 'PARCON 1000'
	DB	01			; line 1
	DB	00			; column 0
	DW	LAB_7ACE		; 'Load/Run Program'
	DB	03			; line 3
	DB	00			; column 0
	DW	LAB_7B04		; 'Name'
	DB	05			; line 5
	DB	00			; column #0
	DW	LAB_7B09		; 'From'
	DB	04

	LD	BC,000Ch	;7779:	010C00
	NOP			;777C:	00
	NOP			;777D:	00
	LD	B,#01h		;777E:	0601
	INC	DE		;7780:	13
	NOP			;7781:	00
	NOP			;7782:	00
	LD	BC,0000h	;7783:	010000
	NOP			;7786:	00
	NOP			;7787:	00
	NOP			;7788:	00
	INC	B		;7789:	04
	NOP			;778A:	00
	LD	L,B		;778B:	68
	LD	(HL),A		;778C:	77
	NOP			;778D:	00
	NOP			;778E:	00
	NOP			;778F:	00
	NOP			;7790:	00
	LD	BC,0201h	;7791:	010102
	NOP			;7794:	00
	LD	A,B		;7795:	78
	LD	(HL),A		;7796:	77
	SUB	C		;7797:	91
	HALT			;7798:	76
	LD	(HL),C		;7799:	71
	CALL	PE,LAB_0303	;779A:	EC0303
	INC	BC		;779D:	03
	ADD	A,H		;779E:	84
	LD	(HL),A		;779F:	77
	LD	D,H		;77A0:	54
	RST	28h		;77A1:	EF
	LD	B,B		;77A2:	40
	RST	28h		;77A3:	EF
	NOP			;77A4:	00
	NOP			;77A5:	00
	SBC	A,E		;77A6:	9B
	LD	(HL),A		;77A7:	77
	NOP			;77A8:	00
	NOP			;77A9:	00
	DEC	C		;77AA:	0D
	LD	D,C		;77AB:	51
	LD	(HL),A		;77AC:	77
	LD	BC,5114h	;77AD:	011451
	LD	(HL),A		;77B0:	77
	DB	01,00

LAB_77B3
	DB	00			; line 0
	DB	00			; position 0
LAB_77B5
	DW	LAB_7A82		; points to 'PARCON 1000'
	DB	01			; line 1
	DB	00			; position 0
	DW	LAB_7ADF		; points to 'Set Clock'
	DB	03			; line 3
	DB	00			; position 0
	DW	LAB_7B0E		; points to 'Time'
	DB	05			; line 5
	DB	00			; position 0
	DW	LAB_7B13		; points to 'Date'

	INC	BC		;77C3:	03
	ADD	HL,BC		;77C4:	09
	DEC	B		;77C5:	05
	NOP			;77C6:	00
	NOP			;77C7:	00
	NOP			;77C8:	00
	DEC	B		;77C9:	05
	LD	B,#08h		;77CA:	0608
	NOP			;77CC:	00
	NOP			;77CD:	00
	LD	BC,0000h	;77CE:	010000
	NOP			;77D1:	00
	NOP			;77D2:	00
	NOP			;77D3:	00
	INC	B		;77D4:	04
	NOP			;77D5:	00
	OR	E		;77D6:	B3
	LD	(HL),A		;77D7:	77
	NOP			;77D8:	00
	NOP			;77D9:	00
	NOP			;77DA:	00
	NOP			;77DB:	00
	LD	BC,0201h	;77DC:	010102
	NOP			;77DF:	00
	JP	LAB_9B77	;77E0:	C3779B
	HALT			;77E3:	76
	LD	A,A		;77E4:	7F
	CALL	PE,LAB_0303	;77E5:	EC0303
	INC	BC		;77E8:	03
	RST	08h		;77E9:	CF
	LD	(HL),A		;77EA:	77
	LD	E,H		;77EB:	5C
	RST	28h		;77EC:	EF
	LD	B,H		;77ED:	44
	RST	28h		;77EE:	EF
	NOP			;77EF:	00
	NOP			;77F0:	00
	AND	#77h		;77F1:	E677
	NOP			;77F3:	00
	NOP			;77F4:	00
	DEC	C		;77F5:	0D
	LD	D,C		;77F6:	51
	LD	(HL),A		;77F7:	77
	LD	BC,5114h	;77F8:	011451
	LD	(HL),A		;77FB:	77
	DB	01,00
LAB_77FE
	DB	00			; line 0
	DB	00			; position 0
LAB_7800
	DW	LAB_7A82		; points to 'PARCON 1000'
	DB	01			; line 1
	DB	00			; position 0
	DW	LAB_7B18		; points to 'System Status'
	DB	03			; line 3
	DB	00			; position 0
	DW	LAB_7B26		; points to 'Version'
	DB	04			; line 4
	DB	00			; position 0
	DW	LAB_7B2E		; points to 'Serial No.'
	DB	05			; line 5
	DB	00			; position 0
	DW	LAB_7B39		; points to 'total RAM'
	DB	05			; line 5
	DB	13			; position 13
	DW	LAB_7B43		; points to 'k'
	DB	06			; line 6
	DB	00			; position 0
	DW	LAB_7B45		; points to 'RAMdisk size'
	DB	06			; line 6
	DB	13			; position 13
	DW	LAB_7B43		; points to 'k'

	INC	BC		;781E:	03
	EX	AF,AF'		;781F:	08
	LD	BC,0000h	;7820:	010000
	LD	(BC),A		;7823:	02
	INC	BC		;7824:	03
	ADD	HL,BC		;7825:	09
	DEC	B		;7826:	05
	NOP			;7827:	00
	NOP			;7828:	00
	INC	BC		;7829:	03
	INC	B		;782A:	04
	DEC	BC		;782B:	0B
	EX	AF,AF'		;782C:	08
	NOP			;782D:	00
	NOP			;782E:	00
	DEC	B		;782F:	05
	DEC	B		;7830:	05
	RRCA			;7831:	0F
	INC	B		;7832:	04
	NOP			;7833:	00
	NOP			;7834:	00
	NOP			;7835:	00
	LD	B,#0Fh		;7836:	060F
	INC	B		;7838:	04
	NOP			;7839:	00
	NOP			;783A:	00
	LD	BC,0000h	;783B:	010000
	NOP			;783E:	00
	NOP			;783F:	00
	NOP			;7840:	00
	EX	AF,AF'		;7841:	08
	NOP			;7842:	00
	CP	#77h		;7843:	FE77
	NOP			;7845:	00
	NOP			;7846:	00
	NOP			;7847:	00
	NOP			;7848:	00
	LD	BC,0501h	;7849:	010105
	NOP			;784C:	00
	LD	E,#78h		;784D:	1E78
	AND	L		;784F:	A5
	HALT			;7850:	76
	ADD	A,L		;7851:	85
	CALL	PE,LAB_3C03	;7852:	EC033C
	LD	A,B		;7855:	78
	LD	E,B		;7856:	58
	RST	28h		;7857:	EF
	LD	L,B		;7858:	68
	POP	AF		;7859:	F1
	NOP			;785A:	00
	NOP			;785B:	00
	NOP			;785C:	00
	NOP			;785D:	00
	NOP			;785E:	00
	NOP			;785F:	00
	INC	D		;7860:	14
	LD	D,C		;7861:	51
	LD	(HL),A		;7862:	77
	LD	BC,510Dh	;7863:	010D51
	LD	(HL),A		;7866:	77
	DB	01,00
LAB_7869
	DB	00			; line 0
	DB	00			; position 0
	DW	LAB_7A82		; points to 'PARCON 1000'
	DB	01			; line 1
	DB	00			; position 0
	DW	LAB_7AF8		; 'Diagnostics'
	DB	03			; line 3
	DB	01			; position 1
	DB	31			; key "1"
	DW	LAB_7B52		; 'Set Debug mode'

	LD	BC,0000h	;7876:	010000
	NOP			;7879:	00
	NOP			;787A:	00
	LD	(BC),A		;787B:	02
	LD	BC,7869h	;787C:	016978
	LD	(HL),C		;787F:	71
	LD	A,B		;7880:	78
	NOP			;7881:	00
	NOP			;7882:	00
	NOP			;7883:	00
	LD	BC,7601h	;7884:	010176
	LD	A,B		;7887:	78
	LD	C,H		;7888:	4C
	RST	28h		;7889:	EF
	INC	(HL)		;788A:	34
	RST	28h		;788B:	EF
	LD	D,C		;788C:	51
	LD	(HL),A		;788D:	77
	LD	BC,78C7h	;788E:	01C778
	LD	BC,0000h	;7891:	010000

	DW	LAB_7A82		; points to 'PARCON 1000'
	DB	01
	DB	00
	DW	LAB_7B61		; 'Set debug Mode'
	DB	03
	DB	00
	DW	LAB_7B70		; 'Status'
	DB	05
	DB	00
	DW	LAB_7B77		; 'Device'

	INC	BC		;78A2:	03
	EX	AF,AF'		;78A3:	08
	INC	BC		;78A4:	03
	NOP			;78A5:	00
	NOP			;78A6:	00
	NOP			;78A7:	00
	DEC	B		;78A8:	05
	EX	AF,AF'		;78A9:	08
	DEC	BC		;78AA:	0B
	NOP			;78AB:	00
	NOP			;78AC:	00
	LD	BC,0000h	;78AD:	010000
	NOP			;78B0:	00
	NOP			;78B1:	00
	NOP			;78B2:	00
	INC	B		;78B3:	04
	NOP			;78B4:	00
	SUB	D		;78B5:	92
	LD	A,B		;78B6:	78
	NOP			;78B7:	00
	NOP			;78B8:	00
	NOP			;78B9:	00
	NOP			;78BA:	00
	LD	BC,0201h	;78BB:	010102
	NOP			;78BE:	00
	AND	D		;78BF:	A2
	LD	A,B		;78C0:	78
	EXX			;78C1:	D9
	HALT			;78C2:	76
	RST	00h		;78C3:	C7
	CALL	PE,LAB_0303	;78C4:	EC0303
	INC	BC		;78C7:	03
	XOR	(HL)		;78C8:	AE
	LD	A,B		;78C9:	78
	LD	L,B		;78CA:	68
	POP	AF		;78CB:	F1
	LD	L,B		;78CC:	68
	POP	AF		;78CD:	F1
	NOP			;78CE:	00
	NOP			;78CF:	00
	PUSH	BC		;78D0:	C5
	LD	A,B		;78D1:	78
	NOP			;78D2:	00
	NOP			;78D3:	00
	DEC	C		;78D4:	0D
	ADD	A,H		;78D5:	84
	LD	A,B		;78D6:	78
	LD	BC,8414h	;78D7:	011484
	LD	A,B		;78DA:	78
	LD	BC,0000h	;78DB:	010000
	NOP			;78DE:	00
	LD	A,(HL)		;78DF:	7E
	LD	A,E		;78E0:	7B
	LD	BC,9100h	;78E1:	010091
	LD	A,E		;78E4:	7B
	LD	(BC),A		;78E5:	02
	NOP			;78E6:	00
	SUB	(HL)		;78E7:	96
	LD	A,E		;78E8:	7B
	INC	BC		;78E9:	03
	NOP			;78EA:	00
	AND	B		;78EB:	A0
	LD	A,E		;78EC:	7B
	INC	B		;78ED:	04
	NOP			;78EE:	00
	XOR	B		;78EF:	A8
	LD	A,E		;78F0:	7B
	DEC	B		;78F1:	05
	NOP			;78F2:	00
	OR	C		;78F3:	B1
	LD	A,E		;78F4:	7B
	LD	B,#00h		;78F5:	0600
	CP	D		;78F7:	BA
	LD	A,E		;78F8:	7B
	LD	BC,0D06h	;78F9:	01060D
	NOP			;78FC:	00
	NOP			;78FD:	00
	NOP			;78FE:	00
	LD	(BC),A		;78FF:	02
	RRCA			;7900:	0F
	INC	B		;7901:	04
	NOP			;7902:	00
	NOP			;7903:	00
	LD	BC,0B03h	;7904:	01030B
	EX	AF,AF'		;7907:	08
	NOP			;7908:	00
	NOP			;7909:	00
	LD	(BC),A		;790A:	02
	INC	B		;790B:	04
	DEC	BC		;790C:	0B
	EX	AF,AF'		;790D:	08
	NOP			;790E:	00
	NOP			;790F:	00
	INC	BC		;7910:	03
	DEC	B		;7911:	05
	DEC	BC		;7912:	0B
	EX	AF,AF'		;7913:	08
	NOP			;7914:	00
	NOP			;7915:	00
	INC	B		;7916:	04
	RLCA			;7917:	07
	LD	BC,0012h	;7918:	011200
	NOP			;791B:	00
	DEC	B		;791C:	05
	NOP			;791D:	00
	NOP			;791E:	00
	NOP			;791F:	00
	NOP			;7920:	00
	NOP			;7921:	00
	RLCA			;7922:	07
	NOP			;7923:	00
	DB	DDh,78h		;7924:	DD78
	NOP			;7926:	00
	NOP			;7927:	00
	NOP			;7928:	00
	NOP			;7929:	00
	LD	BC,0601h	;792A:	010106
	NOP			;792D:	00
	LD	SP,HL		;792E:	F9
	LD	A,B		;792F:	78
LAB_7930
	CP	A		;7930:	BF
	HALT			;7931:	76
	SUB	A		;7932:	97
	CALL	PE,LAB_0303	;7933:	EC0303
	INC	BC		;7936:	03
	INC	BC		;7937:	03
	INC	BC		;7938:	03
	INC	BC		;7939:	03
	INC	BC		;793A:	03
	DEC	E		;793B:	1D
	LD	A,C		;793C:	79
	LD	L,B		;793D:	68
	POP	AF		;793E:	F1
	JR	C,LAB_7930	;793F:	38EF
	NOP			;7941:	00
	NOP			;7942:	00
	INC	(HL)		;7943:	34
	LD	A,C		;7944:	79
	NOP			;7945:	00
	NOP			;7946:	00
	DEC	C		;7947:	0D
	NOP			;7948:	00
LAB_7949
	NOP			;7949:	00
	INC	B		;794A:	04
	INC	D		;794B:	14
	NOP			;794C:	00
	NOP			;794D:	00
	INC	B		;794E:	04
	IN	A,(3Ah)		;794F:	DB3A
	LD	A,C		;7951:	79
	LD	BC,FC00h	;7952:	0100FC
	RST	28h		;7955:	EF
	DJNZ	LAB_7949	;7956:	10F1
	XOR	B		;7958:	A8
	RST	28h		;7959:	EF
	CALL	PO,LAB_08EF	;795A:	E4EF08
	LD	(BC),A		;795D:	02
	NOP			;795E:	00
	NOP			;795F:	00
	NOP			;7960:	00
	NOP			;7961:	00
	CALL	P,LAB_00EF	;7962:	F4EF00
	POP	AF		;7965:	F1
	AND	B		;7966:	A0
	RST	28h		;7967:	EF
	RET	PO		;7968:	E0
	RST	28h		;7969:	EF
	LD	(BC),A		;796A:	02
	LD	BC,0001h	;796B:	010100
	LD	(BC),A		;796E:	02
	NOP			;796F:	00
	NOP			;7970:	00
	RST	38h		;7971:	FF
	RST	38h		;7972:	FF
	LD	A,(BC)		;7973:	0A
	LD	(BC),A		;7974:	02
	EX	AF,AF'		;7975:	08
	NOP			;7976:	00
	LD	D,H		;7977:	54
	LD	A,C		;7978:	79
	LD	(BC),A	;7979:	02
	EX	AF,AF'	;797A:	08
	LD	H,D		;797B:	62
	LD	A,C		;797C:	79
	INC	BC		;797D:	03
	LD	BC,79CEh	;797E:	01CE79
	INC	B		;7981:	04
	LD	BC,79D7h	;7982:	01D779
	INC	BC		;7985:	03
	DEC	BC		;7986:	0B
	EX	AF,AF'	;7987:	08
	NOP			;7988:	00
	NOP			;7989:	00
	NOP			;798A:	00
	INC	B		;798B:	04
	DEC	BC		;798C:	0B
	INC	B		;798D:	04
	NOP			;798E:	00
	NOP			;798F:	00
	LD	BC,0000h	;7990:	010000
	NOP			;7993:	00
	NOP			;7994:	00
	NOP			;7995:	00
	LD	(BC),A	;7996:	02
	NOP			;7997:	00
	LD	A,L		;7998:	7D
	LD	A,C		;7999:	79
	NOP			;799A:	00
	NOP			;799B:	00
	NOP			;799C:	00
	NOP			;799D:	00
	LD	BC,0201h	;799E:	010102
	NOP			;79A1:	00
	ADD	A,L		;79A2:	85
	LD	A,C		;79A3:	79
	LD	(HL),E	;79A4:	73
	LD	A,C		;79A5:	79
LAB_79A6
	XOR	B		;79A6:	A8
	LD	A,C		;79A7:	79
	LD	H,C		;79A8:	61
	LD	(HL),B	;79A9:	70
	LD	L,L		;79AA:	6D
	JR	NZ,LAB_79CD	;79AB:	2020
	JR	NZ,LAB_79CF	;79AD:	2020
	JR	NZ,LAB_79E8	;79AF:	2037
	LD	BC,9103h	;79B1:	010391
	LD	A,C		;79B4:	79
	DJNZ	LAB_79A6	;79B5:	10EF
	LD	L,B		;79B7:	68
	POP	AF		;79B8:	F1
	NOP			;79B9:	00
	NOP			;79BA:	00
	NOP			;79BB:	00
	NOP			;79BC:	00
	NOP			;79BD:	00
	NOP			;79BE:	00
	DEC	C		;79BF:	0D
	DEC	D		;79C0:	15
	LD	(HL),A		;79C1:	77
	DB	01h,00h	;79C2:	0100
LAB_79C4
	DB	'Text lost',00h
LAB_79CE
	DB	'Program:',00h
LAB_79D7
	DB	'Fastcode:',00h
LAB_79E1:
	DB	'WORKSTATION MEMORY',00h
LAB_79F4:
	DB	'WORKSTATION RAMDISK',00h
LAB_7A08:
	DB	'PLINTH',00h
LAB_7A0F:
	DB	'V24 ADAPTOR',00h
LAB_7A1B:
	DB	'EXT STORAGE ADAPTOR',00h
LAB_7A2F:
	DB	'LOCAL LINK',00h
LAB_7A3A:
	DB	'MODEM A/ANS',00h
LAB_7A46:
	DB	'MODEM A/DIAL',00h
LAB_7A53:
	DB	'MODEM MAN/D',00h
LAB_7A5F:
	DB	'300',00h
LAB_7A63:
	DB	'600',00h
LAB_7A67:
	DB	'1200',00h
LAB_7A6C:
	DB	'2400',00h
LAB_7A71:
	DB	'4800',00h
LAB_7A76:
	DB	'9600',00h
LAB_7A7B:
	DB	'OFF',00h
LAB_7A7F:
	DB	'ON',00h
LAB_7A82:
	DB	'PARCON 1000',00h
LAB_7A8E:
	DB	'Enter the',00h
LAB_7A98:
	DB	'Workstation',00h
LAB_7AA4:
	DB	'serial number',00h
LAB_7AB2:
	DB	'shown on the back',00h
LAB_7AC4:
	DB	'Main menu',00h
LAB_7ACE:
	DB	'Load/Run Program',00h
LAB_7ADF:
	DB	'Set Clock',00h
LAB_7AE9:
	DB	'Display Status',00h
LAB_7AF8:
	DB	'Diagnostics',00h
LAB_7B04:
	DB	'Name',00h
LAB_7B09:
	DB	'From',00h
LAB_7B0E:
	DB	'Time',00h
LAB_7B13:
	DB	'Date',00h
LAB_7B18:
	DB	'System Status',00h
LAB_7B26:
	DB	'Version',00h
LAB_7B2E:
	DB	'Serial No.',00h
LAB_7B39:
	DB	'total RAM',00h
LAB_7B43:
	DB	'k',00h
LAB_7B45:
	DB	'RAMdisk size',00h
LAB_7B52:
	DB	'Set Debug mode',00h
LAB_7B61:
	DB	'Set debug Mode',00h
LAB_7B70:
	DB	'Status',00h
LAB_7B77:
	DB	'Device',00h
LAB_7B7E
	DB	'Log-on information',00h
LAB_7B91
	DB	'Mode',00h
LAB_7B96
	DB	'Linespeed',00h
LAB_7BA0
	DB	'User id',00h
LAB_7BA8
	DB	'Password',00h
LAB_7BB1
	DB	'Group id',00h
LAB_7BBA
	DB	'Telephone number',00h

LAB_7BCB				; (LAB_D081)
	DW	LAB_D0F0		; (LAB_7C3A)
	DW	LAB_D13D		; (LAB_7C87)
	DW	LAB_D121		; (LAB_7C6B)
	DW	LAB_D12F		; (LAB_7C79)
	DW	LAB_D14B		; (LAB_7C95)
	DB	00h,00h,01h,03h,02h
LAB_7BDA
	DB	'PARCON 1000         ',0Ah
LAB_7BEF
	DB	'*** Error ***',00h
LAB_7BFD
	DB	'Press >> to continue',00h
LAB_7C12
	DB	'PLINTH',00h
LAB_7C19
	DB	'LOCAL LINK',0h
LAB_7C24
	DB	'9600',00h
LAB_7C29
	POP	HL		;7C29:	E1
	RET	NC		;7C2A:	D0
LAB_7C2B
	DB	'Consult Dealer',00h
LAB_7C3A
	LD	H,A		;7C3A:	67
	LD	A,(BC)	;7C3B:	0A
	ADD	A,D		;7C3C:	82
	DEC	BC		;7C3D:	0B
	RET	PE		;7C3E:	E8
	RET	P		;7C3F:	F0
	RET	P		;7C40:	F0
	RET	P		;7C41:	F0
LAB_7C42
	XOR	H		;7C42:	AC
LAB_7C43
	DEC	BC		;7C43:	0B
	LD	(BC),A	;7C44:	02
	DJNZ	LAB_7CA9	;7C45:	1062
	DJNZ	LAB_7C49	;7C47:	1000
LAB_7C49
	NOP			;7C49:	00
	NOP			;7C4A:	00
	NOP			;7C4B:	00
	DEC	B		;7C4C:	05
	LD	B,#07h	;7C4D:	0607
	LD	A,(BC)	;7C4F:	0A
	INC	C		;7C50:	0C
	LD	C,#04h	;7C51:	0E04
	DJNZ	LAB_7C43	;7C53:	10EE
	LD	C,#B4h	;7C55:	0EB4
	CALL	PE,LAB_0406	;7C57:	EC0604
	XOR	#07h		;7C5A:	EE07
	NOP			;7C5C:	00
	NOP			;7C5D:	00
	LD	B,#10h	;7C5E:	0610
	XOR	#07h		;7C60:	EE07
	OR	H		;7C62:	B4
	CALL	PE,LAB_2806	;7C63:	EC0628
	XOR	#07h		;7C66:	EE07
	NOP			;7C68:	00
	NOP			;7C69:	00
	NOP			;7C6A:	00
	LD	(HL),A	;7C6B:	77
LAB_7C6C
	LD	DE,1382h	;7C6C:	118213
	SUB	H		;7C6F:	94
	INC	DE		;7C70:	13
	RET	C		;7C71:	D8
	INC	DE		;7C72:	13
	RET	Z		;7C73:	C8
	INC	D		;7C74:	14
	RST	08h		;7C75:	CF
	INC	D		;7C76:	14
	LD	A,#15h	;7C77:	3E15
	LD	(HL),A	;7C79:	77
	LD	DE,13B1h	;7C7A:	11B113
	CP	E		;7C7D:	BB
	INC	DE		;7C7E:	13
	RET	C		;7C7F:	D8
	INC	DE		;7C80:	13
	RET	Z		;7C81:	C8
	INC	D		;7C82:	14
	RST	08h		;7C83:	CF
	INC	D		;7C84:	14
	LD	A,#15h	;7C85:	3E15
	LD	L,A		;7C87:	6F
	DEC	D		;7C88:	15
	RET	C		;7C89:	D8
	DEC	D		;7C8A:	15
	LD	(DE),A	;7C8B:	12
	LD	D,#64h	;7C8C:	1664
	LD	D,#8Eh	;7C8E:	168E
	LD	D,#B8h	;7C90:	16B8
	LD	D,#D0h	;7C92:	16D0
	LD	D,#6Fh	;7C94:	166F
	DEC	D		;7C96:	15
	PUSH	AF		;7C97:	F5
	DEC	D		;7C98:	15
	DEC	SP		;7C99:	3B
	LD	D,#64h	;7C9A:	1664
	LD	D,#8Eh	;7C9C:	168E
	LD	D,#B8h	;7C9E:	16B8
	LD	D,#EDh	;7CA0:	16ED
	DB	16h
LAB_7CA3				; (LAB_D159)
	DW	1775h,LAB_D191	; 'Can`t open or'...
	DW	17D9h,LAB_D1AB	; 'Out of file space'
	DW	2328h,LAB_D1BD	; 'No program in memory'
	DW	2329h,LAB_D1D2	; 'Requested program'...
	DW	232Ah,LAB_D1F2	; 'DIP file too big'
	DW	232Bh,LAB_D203	; 'Bad DIP file'
	DW	232Ch,LAB_D210	; 'COM file too big'
	DW	2331h,LAB_D221	; 'Program not built'...
	DW	2332h,LAB_D242	; 'Program corrupt'
	DW	2334h,LAB_D253	; 'DIP file has'...
	DW	2333h,LAB_D270	; 'Device not attached'
	DW	2335h,LAB_D284	; 'Source not available'
	DW	2336h,LAB_D299	; 'Dest. not available'
	DW	FFFFh,LAB_D2AD	; 'System error'...

LAB_7CDB				; (LAB_D191)
	DB	'Can`t open or',0Ah,'create file',00h	; error 6005
LAB_7CF5				; (LAB_D1AB)
	DB	'Out of file space',00h
LAB_7D07				; (LAB_D1BD)
	DB	'No program in memory',00h			; error 9000
LAB_7D1C				; (LAB_D1D2)
	DB	'Requested program',0Ah,'not in memory',00h
LAB_7D3C				; (LAB_D1F2)
	DB	'DIP file too big',00h
LAB_7D4D				; (LAB_D203)
	DB	'Bad DIP file',00h
LAB_7D5A				; (LAB_D210)
	DB	'COM file too big',00h
LAB_7D6B				; (LAB_D221)
	DB	'Program not built',0Ah,'for this system',00h
LAB_7D8D				; (LAB_D243)
	DB	'Program corrupt',00h
LAB_7D9D				; (LAB_D253)
	DB	'DIP file has',0Ah,'too many blocks',00h
LAB_7DBA				; (LAB_D270)
	DB	'Device not attached',00h
LAB_7DCE				; (LAB_D284)
	DB	'Source not available',00h
LAB_7DE3				; (LAB_D299)
	DB	'Dest. not available',00h
LAB_7DF7				; (LAB_D2AD)
	DB	'System error',0Ah
	DB	'Consult dealer',00h
LAB_7E13				; (LAB_D2C9)
	NOP			;7E13:	00
	NOP			;7E14:	00

LAB_7E15
	DW	0001h			; copy block

	DW	LAB_0080		; source pointer
	DW	LAB_E2FA		; destination pointer
	DW	0075h			; length

	DW	0000h			; zero block

	DW	LAB_E705		; pointer
	DW	0568h			; length

	DW	0001h			; copy block

	DW	LAB_7BCB		; source pointer
	DW	LAB_D081		; destination pointer
	DW	024Ah			; length

	DW	0000h			; zero block

	DW	LAB_D2CB		; pointer
	DW	01B6h			; length

	DW	0002h			; make table

	DW	0093h			; word count

; this table from LAB_EF34 to LAB_F180

	DW	LAB_0319		; copy word from (LAB_EB43) to (LAB_EC6F)		[LAB_EF34]
	DW	LAB_10CF		; copy (LAB_EB43) to (LAB_EC6D)			[LAB_EF38]
	DW	LAB_02F9		; copy (LAB_EB43) to (LAB_EC6D)			[LAB_EF3C]
	DW	LAB_0333		; *								[LAB_EF40]
	DW	LAB_03E3		; set clock from ??					[LAB_EF44]
	DW	LAB_0421		; set HL = 0001h, whatever (LAB_EC41) is ??	[LAB_EF48]
	DW	LAB_0309		; copy (LAB_EC6F) to (LAB_EB43)			[LAB_EF4C]
	DW	LAB_02E9		; copy (LAB_EC6D) to (LAB_EB43)			[LAB_EF50]
	DW	LAB_0329		; just does HL=0001h					[LAB_EF54]
	DW	LAB_040B		; *								[LAB_EF58]
	DW	LAB_03C3		; get system time ??					[LAB_EF5C]
	DW	LAB_0465		; print centre justified string on line #		[LAB_EF60]
	DW	LAB_07EE		; *								[LAB_EF64]
	DW	LAB_056D		; *								[LAB_EF68]
	DW	LAB_170A		; *								[LAB_EF6C]
	DW	LAB_106F		; *								[LAB_EF70]
	DW	LAB_0435		; null terminated string out to screen		[LAB_EF74]
	DW	LAB_0721		; copy string from LAB_EC8E to destination	[LAB_EF78]
	DW	LAB_1761		; save word @ LAB_D2C9 if empty (=0)		[LAB_EF7C]
	DW	LAB_177B		; *								[LAB_EF80]
	DW	LAB_05DC		; do press >> to cont & wait for [ENTER]		[LAB_EF84]
	DW	LAB_06A5		; *								[LAB_EF88]
	DW	LAB_5704		; *								[LAB_EF8C]
	DW	LAB_0907		; execute BIOS function 3Fh with carry clear	[LAB_EF90]
	DW	LAB_092F		; execute BIOS function 3Fh with carry set	[LAB_EF94]
	DW	LAB_4A4B		; *								[LAB_EF98]
	DW	LAB_59A9		; *								[LAB_EF9C]
	DW	LAB_4A71		; just does HL=0000h					[LAB_EFA0]
	DW	LAB_02DF		; just does HL=0000h					[LAB_EFA4]
	DW	LAB_4981		; *								[LAB_EFA8]
	DW	LAB_5E7C		; *								[LAB_EFAC]
	DW	LAB_696F		; *								[LAB_EFB0]
	DW	LAB_68EC		; *
	DW	LAB_6EEE		; *
	DW	LAB_69C3		; *
	DW	LAB_6784		; clears bytes @ LAB_E8E2, +29h, ++29h & +++29h
					; clears words @ LAB_EC3F & LAB_E986
	DW	LAB_6DDF		; *
	DW	LAB_68CB		; *
	DW	LAB_6A36		; *
	DW	LAB_6B6D		; *								[LAB_EFD0]
	DW	LAB_6C84		; *
	DW	LAB_4A67		; set HL=0001h
	DW	LAB_59E1		; *
	DW	LAB_4B5F		; set HL=0001h
	DW	LAB_4A41		; set HL=0001h
	DW	LAB_5EB4		; *
	DW	LAB_4FB0		; *								[LAB_EFEC]
	DW	LAB_5B2D		; *								[LAB_EFF0]
	DW	LAB_51C1		; *
	DW	LAB_0115		; copy string_1 to string_2				[LAB_EFF8]
	DW	LAB_4B69		; *
	DW	LAB_6000		; *								[LAB_F000]
	DW	LAB_0271		; *
	DW	LAB_34AB		; *
	DW	LAB_46F8		; *
	DW	LAB_35D8		; *								[LAB_F010]
	DW	LAB_2159		; store word @ LAB_EB3B
	DW	LAB_198E		; *
	DW	LAB_3987		; *
	DW	LAB_227D		; store word 0000h @ LAB_EC41
	DW	LAB_1D79		; does nothing
	DW	LAB_2A28		; *
	DW	LAB_3BA8		; *
	DW	LAB_3FCB		; *								[LAB_F030]
	DW	LAB_3E24		; *
	DW	LAB_2205		; *
	DW	LAB_3804		; *
	DW	LAB_1B7D		; *								[LAB_F040]
	DW	LAB_3B7B		; *
	DW	LAB_214C		; store word 0001h @ LAB_EB1C
	DW	LAB_2659		; *
	DW	LAB_2CD3		; *								[LAB_F050]
	DW	LAB_217D		; *
	DW	LAB_1ADD		; *
	DW	LAB_1B0A		; *
	DW	LAB_1803		; setup screen & other ??
	DW	LAB_1D80		; *
	DW	LAB_228A		; store word 0001h @ LAB_EB02
	DW	LAB_40A2		; *
	DW	LAB_2132		; store word 0001h @ LAB_EB12
	DW	LAB_213F		; store word 0001h @ LAB_EB4F
	DW	LAB_583A		; *
	DW	LAB_576C		; *
	DW	LAB_3624		; *								[LAB_F080]
	DW	LAB_2C4F		; *
	DW	LAB_1FF3		; *
	DW	LAB_47FF		; *
	DW	LAB_356E		; character out (does "_" if chr=" " & (LAB_EB0C).w=0)
					;								[LAB_F090]
	DW	LAB_35A2		; *
	DW	LAB_183C		; *
	DW	LAB_37BD		; *
	DW	LAB_40C4		; *								[LAB_F0A0]
	DW	LAB_36F3		; setup LAB_EB4D, LAB_EC47 & LAB_EB51 for #
	DW	LAB_2116		; get HL from (LAB_EC41)
	DW	LAB_2B43		; *
	DW	LAB_2120		; save byte @ LAB_EC41
	DW	LAB_2D3A		; *
	DW	LAB_38EF		; *
	DW	LAB_23FD		; *
	DW	LAB_463F		; *								[LAB_F0C0]
	DW	LAB_2E6F		; *
	DW	LAB_41D5		; *
	DW	LAB_444F		; *
	DW	LAB_4281		; *								[LAB_F0D0]
	DW	LAB_4367		; *
	DW	LAB_418E		; *
	DW	LAB_3732		; *
	DW	LAB_216B		; save word @ LAB_EB3D
	DW	LAB_0A42		; *
	DW	LAB_0FE6		; save 2335h @ LAB_D2C9 if empty (=0)
	DW	LAB_0AD3		; does HL = ((LAB_ECDA)+1)*32
	DW	LAB_0FF8		; set HL = FFFFh
	DW	LAB_6292		; *
	DW	LAB_50E2		; *
	DW	LAB_5D3D		; *
	DW	LAB_53C6		; *								[LAB_F100]
	DW	LAB_4D86		; *
	DW	LAB_4E79		; *
	DW	LAB_01E6		; copy string from pointer_1 to pointer_2 ??
	DW	LAB_4BF7		; *								[LAB_F110]
	DW	LAB_6184		; *
	DW	LAB_7279		; send BELL character to console			[LAB_F118]
	DW	LAB_6FBA		; clear screen area					[LAB_F11C]
	DW	LAB_71B2		; set cursor blink on/off				[LAB_F120]
	DW	LAB_713B		; get cursor x,y to pointer x, pointer y		[LAB_F124]
	DW	LAB_7160		; set word @ addr_1 to 0008h and addr_2 to 0014h[LAB_F128]
	DW	LAB_7187		; get character under cursor				[LAB_F12C]
	DW	LAB_7121		; home cursor, clear cursor X,Y			[LAB_F130]
	DW	LAB_6F61		; clear screen & screen buffer			[LAB_F134]
	DW	LAB_71AB		; does nothing						[LAB_F138]
	DW	LAB_71E2		; set cursor on/off					[LAB_F13C]
	DW	LAB_720D		; character out to screen & buffer			[LAB_F140]
	DW	LAB_73DE		; scroll region down ??					[LAB_F144]
	DW	LAB_7288		; scroll region up ??					[LAB_F148]
	DW	LAB_70AE		; set cursor X,Y						[LAB_F14C]
	DW	LAB_7206		; does nothing						[LAB_F150]
	DW	LAB_65E3		; clear word @ (LAB_E8D6)				[LAB_F154]
	DW	LAB_675A		; get HL from pointer @ LAB_E8D6			[LAB_F158]
	DW	LAB_6621		; saves word @ (LAB_E898)				[LAB_F15C]
	DW	LAB_6602		; display error # & message ??			[LAB_F160]
	DW	LAB_659F		; setup LAB_E89C, LAB_E8D6, LAB_EC5D & LAB_E898	[LAB_F164]
	DW	LAB_6768		; set HL = 0001h						[LAB_F168]
	DW	LAB_6772		; save word @ LAB_E8D8					[LAB_F16C]
	DW	LAB_65C0		; puts 0001h @ (LAB_E8D6) & word @ (LAB_E8D6)+2	[LAB_F170]
	DW	LAB_6633		; *								[LAB_F174]
	DW	LAB_6280		; *								[LAB_F178]
	DW	LAB_65F5		; set (LAB_E89A) = 0001h				[LAB_F17C]

	DW	FFFFh			; exit

LAB_7F5D
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	NOP			;7FF5:	00
	NOP			;7FF6:	00
	NOP			;7FF7:	00
	NOP			;7FF8:	00
	NOP			;7FF9:	00
	DB	EDh,D1h		;7FFA:	EDD1
LAB_7FFC
	DW	LAB_7E15
	DW	2E12h			; checksum

LAB_8469	EQU	8469h
LAB_9B77	EQU	9B77h
LAB_9CF0	EQU	9CF0h
LAB_A505	EQU	A505h
LAB_D0FE	EQU	D0FEh
LAB_D100	EQU	D100h
LAB_D2C9	EQU	D2C9h
LAB_D2CB	EQU	D2CBh
LAB_D2CD	EQU	D2CDh
LAB_D2D1	EQU	D2D1h
LAB_D2D3	EQU	D2D3h
LAB_D2DC	EQU	D2DCh
LAB_D2DE	EQU	D2DEh
LAB_D2E0	EQU	D2E0h
LAB_D362	EQU	D362h
LAB_D364	EQU	D364h
LAB_D366	EQU	D366h
LAB_D368	EQU	D368h
LAB_D36A	EQU	D36Ah
LAB_D36C	EQU	D36Ch
LAB_D36E	EQU	D36Eh
LAB_D370	EQU	D370h
LAB_D372	EQU	D372h
LAB_D374	EQU	D374h
LAB_D376	EQU	D376h
LAB_D377	EQU	D377h
LAB_D378	EQU	D378h
LAB_D37A	EQU	D37Ah
LAB_D37C	EQU	D37Ch
LAB_D37E	EQU	D37Eh
LAB_D381	EQU	D381h
LAB_D385	EQU	D385h
LAB_D388	EQU	D388h
LAB_D38B	EQU	D38Bh
LAB_D38C	EQU	D38Ch
LAB_D390	EQU	D390h
LAB_D392	EQU	D392h
LAB_D393	EQU	D393h
LAB_D395	EQU	D395h
LAB_D397	EQU	D397h
LAB_D399	EQU	D399h
LAB_D39B	EQU	D39Bh
LAB_D39D	EQU	D39Dh
LAB_D41E	EQU	D41Eh
LAB_D420	EQU	D420h
LAB_D422	EQU	D422h
LAB_D463	EQU	D463h
LAB_D465	EQU	D465h
LAB_D467	EQU	D467h
LAB_D469	EQU	D469h
LAB_D46B	EQU	D46Bh
LAB_D46D	EQU	D46Dh
LAB_D46E	EQU	D46Eh
LAB_D47D	EQU	D47Dh
LAB_D47F	EQU	D47Fh
LAB_D74B	EQU	D74Bh
LAB_D7B8	EQU	D7B8h
LAB_D7C5	EQU	D7C5h
LAB_D7CB	EQU	D7CBh
LAB_D7F0	EQU	D7F0h
LAB_D828	EQU	D828h
LAB_D893	EQU	D893h
LAB_D8CE	EQU	D8CEh
LAB_D9A0	EQU	D9A0h
LAB_D9F9	EQU	D9F9h
LAB_DA13	EQU	DA13h
LAB_DA4C	EQU	DA4Ch
LAB_DC07	EQU	DC07h
LAB_DCA1	EQU	DCA1h
LAB_DDF4	EQU	DDF4h
LAB_DDFA	EQU	DDFAh
LAB_DF21	EQU	DF21h
LAB_DF6D	EQU	DF6Dh
LAB_E3BD	EQU	E3BDh
LAB_E462	EQU	E462h
LAB_E720	EQU	E720h
LAB_E721	EQU	E721h
LAB_E723	EQU	E723h
LAB_E725	EQU	E725h
LAB_E726	EQU	E726h
LAB_E728	EQU	E728h
LAB_E72A	EQU	E72Ah
LAB_E72C	EQU	E72Ch
LAB_E72D	EQU	E72Dh
LAB_E730	EQU	E730h
LAB_E731	EQU	E731h
LAB_E734	EQU	E734h
LAB_E736	EQU	E736h
LAB_E738	EQU	E738h
LAB_E739	EQU	E739h
LAB_E73A	EQU	E73Ah
LAB_E73B	EQU	E73Bh
LAB_E73D	EQU	E73Dh
LAB_E73F	EQU	E73Fh
LAB_E741	EQU	E741h
LAB_E742	EQU	E742h
LAB_E744	EQU	E744h
LAB_E746	EQU	E746h
LAB_E748	EQU	E748h
LAB_E74A	EQU	E74Ah
LAB_E74C	EQU	E74Ch
LAB_E74D	EQU	E74Dh
LAB_E74E	EQU	E74Eh
LAB_E750	EQU	E750h
LAB_E752	EQU	E752h
LAB_E753	EQU	E753h
LAB_E755	EQU	E755h
LAB_E757	EQU	E757h
LAB_E759	EQU	E759h
LAB_E75B	EQU	E75Bh
LAB_E75D	EQU	E75Dh
LAB_E75F	EQU	E75Fh
LAB_E761	EQU	E761h
LAB_E767	EQU	E767h
LAB_E769	EQU	E769h
LAB_E76B	EQU	E76Bh
LAB_E76D	EQU	E76Dh
LAB_E76F	EQU	E76Fh
LAB_E771	EQU	E771h
LAB_E772	EQU	E772h
LAB_E774	EQU	E774h
LAB_E776	EQU	E776h
LAB_E778	EQU	E778h
LAB_E77A	EQU	E77Ah
LAB_E77B	EQU	E77Bh
LAB_E77C	EQU	E77Ch
LAB_E77E	EQU	E77Eh
LAB_E780	EQU	E780h
LAB_E782	EQU	E782h
LAB_E784	EQU	E784h
LAB_E785	EQU	E785h		; cursor y for ??
LAB_E786	EQU	E786h		; cursor x for ??
LAB_E787	EQU	E787h		; string length
LAB_E788	EQU	E788h
LAB_E789	EQU	E789h
LAB_E78B	EQU	E78Bh		; ?? string buffer pointer
LAB_E78D	EQU	E78Dh
LAB_E78E	EQU	E78Eh
LAB_E78F	EQU	E78Fh		; string character pointer
LAB_E790	EQU	E790h
LAB_E791	EQU	E791h
LAB_E792	EQU	E792h
LAB_E793	EQU	E793h
LAB_E795	EQU	E795h
LAB_E796	EQU	E796h
LAB_E798	EQU	E798h
LAB_E79A	EQU	E79Ah
LAB_E79C	EQU	E79Ch
LAB_E79E	EQU	E79Eh
LAB_E79F	EQU	E79Fh
LAB_E7A0	EQU	E7A0h
LAB_E7A1	EQU	E7A1h
LAB_E7A3	EQU	E7A3h
LAB_E7A5	EQU	E7A5h
LAB_E7A7	EQU	E7A7h
LAB_E7A9	EQU	E7A9h
LAB_E7AB	EQU	E7ABh
LAB_E7AD	EQU	E7ADh
LAB_E7AF	EQU	E7AFh
LAB_E7B1	EQU	E7B1h
LAB_E7B3	EQU	E7B3h
LAB_E7B5	EQU	E7B5h
LAB_E7B7	EQU	E7B7h
LAB_E7B9	EQU	E7B9h
LAB_E7BB	EQU	E7BBh
LAB_E7BD	EQU	E7BDh
LAB_E7BF	EQU	E7BFh
LAB_E7C1	EQU	E7C1h
LAB_E7C3	EQU	E7C3h
LAB_E7C5	EQU	E7C5h
LAB_E7C7	EQU	E7C7h
LAB_E7C9	EQU	E7C9h
LAB_E7CB	EQU	E7CBh
LAB_E7CD	EQU	E7CDh
LAB_E7CF	EQU	E7CFh
LAB_E7D1	EQU	E7D1h
LAB_E7D2	EQU	E7D2h
LAB_E7D3	EQU	E7D3h
LAB_E7D5	EQU	E7D5h
LAB_E7D7	EQU	E7D7h
LAB_E7D9	EQU	E7D9h
LAB_E7DA	EQU	E7DAh
LAB_E7DB	EQU	E7DBh
LAB_E7DD	EQU	E7DDh
LAB_E7DF	EQU	E7DFh
LAB_E7E1	EQU	E7E1h
LAB_E7E3	EQU	E7E3h
LAB_E7E5	EQU	E7E5h
LAB_E7E7	EQU	E7E7h
LAB_E7E9	EQU	E7E9h
LAB_E7EB	EQU	E7EBh
LAB_E7ED	EQU	E7EDh
LAB_E7EF	EQU	E7EFh
LAB_E7F1	EQU	E7F1h
LAB_E7F3	EQU	E7F3h
LAB_E7F4	EQU	E7F4h
LAB_E7F5	EQU	E7F5h
LAB_E7F6	EQU	E7F6h
LAB_E7F7	EQU	E7F7h
LAB_E7F9	EQU	E7F9h
LAB_E7FB	EQU	E7FBh
LAB_E7FC	EQU	E7FCh
LAB_E7FE	EQU	E7FEh
LAB_E800	EQU	E800h
LAB_E801	EQU	E801h
LAB_E802	EQU	E802h
LAB_E81B	EQU	E81Bh
LAB_E81D	EQU	E81Dh
LAB_E81E	EQU	E81Eh
LAB_E81F	EQU	E81Fh
LAB_E820	EQU	E820h
LAB_E821	EQU	E821h
LAB_E823	EQU	E823h
LAB_E825	EQU	E825h
LAB_E827	EQU	E827h
LAB_E829	EQU	E829h
LAB_E82A	EQU	E82Ah
LAB_E82B	EQU	E82Bh
LAB_E82C	EQU	E82Ch
LAB_E82E	EQU	E82Eh
LAB_E834	EQU	E834h
LAB_E836	EQU	E836h
LAB_E83A	EQU	E83Ah
LAB_E83C	EQU	E83Ch
LAB_E840	EQU	E840h
LAB_E842	EQU	E842h
LAB_E844	EQU	E844h
LAB_E845	EQU	E845h
LAB_E847	EQU	E847h
LAB_E849	EQU	E849h
LAB_E84B	EQU	E84Bh
LAB_E84D	EQU	E84Dh
LAB_E84E	EQU	E84Eh
LAB_E854	EQU	E854h
LAB_E855	EQU	E855h
LAB_E856	EQU	E856h
LAB_E857	EQU	E857h
LAB_E858	EQU	E858h
LAB_E859	EQU	E859h
LAB_E85A	EQU	E85Ah
LAB_E85B	EQU	E85Bh
LAB_E860	EQU	E860h
LAB_E861	EQU	E861h
LAB_E863	EQU	E863h
LAB_E865	EQU	E865h
LAB_E866	EQU	E866h
LAB_E868	EQU	E868h
LAB_E869	EQU	E869h
LAB_E872	EQU	E872h
LAB_E874	EQU	E874h
LAB_E875	EQU	E875h
LAB_E876	EQU	E876h
LAB_E877	EQU	E877h
LAB_E878	EQU	E878h
LAB_E879	EQU	E879h
LAB_E87B	EQU	E87Bh
LAB_E87C	EQU	E87Ch
LAB_E87D	EQU	E87Dh
LAB_E87F	EQU	E87Fh
LAB_E881	EQU	E881h
LAB_E883	EQU	E883h
LAB_E885	EQU	E885h
LAB_E887	EQU	E887h
LAB_E888	EQU	E888h
LAB_E889	EQU	E889h
LAB_E88A	EQU	E88Ah
LAB_E88B	EQU	E88Bh
LAB_E88C	EQU	E88Ch
LAB_E88D	EQU	E88Dh
LAB_E88F	EQU	E88Fh
LAB_E890	EQU	E890h
LAB_E891	EQU	E891h
LAB_E893	EQU	E893h
LAB_E895	EQU	E895h
LAB_E897	EQU	E897h
LAB_E898	EQU	E898h
LAB_E89A	EQU	E89Ah
LAB_E89C	EQU	E89Ch
LAB_E8D6	EQU	E8D6h
LAB_E8D8	EQU	E8D8h
LAB_E8DA	EQU	E8DAh
LAB_E8DC	EQU	E8DCh
LAB_E8DE	EQU	E8DEh
LAB_E8E0	EQU	E8E0h
LAB_E986	EQU	E986h
LAB_E988	EQU	E988h
LAB_E98A	EQU	E98Ah
LAB_E98C	EQU	E98Ch
LAB_E98E	EQU	E98Eh
LAB_E990	EQU	E990h
LAB_E992	EQU	E992h
LAB_EA14	EQU	EA14h
LAB_EA16	EQU	EA16h
LAB_EA18	EQU	EA18h
LAB_EA1A	EQU	EA1Ah
LAB_EA1C	EQU	EA1Ch
LAB_EA1E	EQU	EA1Eh
LAB_EA20	EQU	EA20h
LAB_EA22	EQU	EA22h
LAB_EA24	EQU	EA24h
LAB_EA4B	EQU	EA4Bh			; cursor Y position
LAB_EA4C	EQU	EA4Ch			; cursor X position
LAB_EA4D	EQU	EA4Dh
LAB_EA4E	EQU	EA4Eh
LAB_EA4F	EQU	EA4Fh
LAB_EA50	EQU	EA50h			; cursor blink flag
LAB_EA51	EQU	EA51h
LAB_EA52	EQU	EA52h			; start of screen buffer ??
LAB_EAF2	EQU	EAF2h
LAB_EAF3	EQU	EAF3h
LAB_EAF4	EQU	EAF4h
LAB_EAF6	EQU	EAF6h
LAB_EAF8	EQU	EAF8h
LAB_EAF9	EQU	EAF9h
LAB_EAFA	EQU	EAFAh
LAB_EAFC	EQU	EAFCh
LAB_EAFE	EQU	EAFEh
LAB_EAFF	EQU	EAFFh
LAB_EB00	EQU	EB00h
LAB_EB02	EQU	EB02h
LAB_EB04	EQU	EB04h
LAB_EB06	EQU	EB06h
LAB_EB08	EQU	EB08h
LAB_EB0A	EQU	EB0Ah
LAB_EB0C	EQU	EB0Ch
LAB_EB0E	EQU	EB0Eh
LAB_EB10	EQU	EB10h
LAB_EB12	EQU	EB12h
LAB_EB14	EQU	EB14h
LAB_EB16	EQU	EB16h
LAB_EB18	EQU	EB18h
LAB_EB1A	EQU	EB1Ah
LAB_EB1C	EQU	EB1Ch
LAB_EB1E	EQU	EB1Eh
LAB_EB39	EQU	EB39h
LAB_EB3B	EQU	EB3Bh
LAB_EB3D	EQU	EB3Dh
LAB_EB3F	EQU	EB3Fh
LAB_EB41	EQU	EB41h
LAB_EB43	EQU	EB43h
LAB_EB45	EQU	EB45h
LAB_EB47	EQU	EB47h
LAB_EB49	EQU	EB49h
LAB_EB4B	EQU	EB4Bh
LAB_EB4D	EQU	EB4Dh
LAB_EB4F	EQU	EB4Fh
LAB_EB51	EQU	EB51h
LAB_EB53	EQU	EB53h
LAB_EB55	EQU	EB55h
LAB_EBF7	EQU	EBF7h
LAB_EBF9	EQU	EBF9h
LAB_EC3B	EQU	EC3Bh
LAB_EC3D	EQU	EC3Dh
LAB_EC3F	EQU	EC3Fh
LAB_EC41	EQU	EC41h
LAB_EC43	EQU	EC43h
LAB_EC45	EQU	EC45h
LAB_EC47	EQU	EC47h
LAB_EC49	EQU	EC49h
LAB_EC4B	EQU	EC4Bh
LAB_EC4D	EQU	EC4Dh
LAB_EC4F	EQU	EC4Fh
LAB_EC51	EQU	EC51h
LAB_EC53	EQU	EC53h
LAB_EC55	EQU	EC55h
LAB_EC57	EQU	EC57h
LAB_EC59	EQU	EC59h
LAB_EC5B	EQU	EC5Bh
LAB_EC5D	EQU	EC5Dh
LAB_EC5F	EQU	EC5Fh
LAB_EC61	EQU	EC61h
LAB_EC63	EQU	EC63h
LAB_EC65	EQU	EC65h
LAB_EC67	EQU	EC67h
LAB_EC69	EQU	EC69h
LAB_EC6B	EQU	EC6Bh
LAB_EC6D	EQU	EC6Dh
LAB_EC6F	EQU	EC6Fh
LAB_EC71	EQU	EC71h
LAB_EC7E	EQU	EC7Eh
LAB_EC7F	EQU	EC7Fh			; hour/minute (H = hour, L = minute)
LAB_EC81	EQU	EC81h			; month, date & year (order ??)
LAB_EC85	EQU	EC85h
LAB_EC87	EQU	EC87h
LAB_EC89	EQU	EC89h
LAB_EC8A	EQU	EC8Ah
LAB_EC8C	EQU	EC8Ch
LAB_EC8E	EQU	EC8Eh
LAB_EC97	EQU	EC97h
LAB_EC98	EQU	EC98h
LAB_EC99	EQU	EC99h
LAB_ECA2	EQU	ECA2h
LAB_ECAB	EQU	ECABh
LAB_ECB4	EQU	ECB4h
LAB_ECC7	EQU	ECC7h
LAB_ECC8	EQU	ECC8h
LAB_ECC9	EQU	ECC9h
LAB_ECD8	EQU	ECD8h
LAB_ECDA	EQU	ECDAh
LAB_ECDC	EQU	ECDCh
LAB_ECDE	EQU	ECDEh
LAB_ECE0	EQU	ECE0h
LAB_ECE2	EQU	ECE2h
LAB_ECE4	EQU	ECE4h
LAB_ECE6	EQU	ECE6h
LAB_ECE8	EQU	ECE8h
LAB_ECEC	EQU	ECECh
LAB_ECEE	EQU	ECEEh
LAB_ECF0	EQU	ECF0h
LAB_EE00	EQU	EE00h		; re-mapped address
LAB_EE0C	EQU	EE0Ch		; re-mapped address
LAB_EE14	EQU	EE14h		; re-mapped address
LAB_EE20	EQU	EE20h		; re-mapped address
LAB_EE2C	EQU	EE2Ch		; receive program ??
LAB_EE3C	EQU	EE3Ch		; re-mapped address
LAB_EE50	EQU	EE50h		; set HL=0001h, OR A with 01h
LAB_EE64	EQU	EE64h		; set HL=0001h, OR A with 01h
LAB_EE68	EQU	EE68h		; set HL=0001h, OR A with 01h
LAB_EE6C	EQU	EE6Ch		; set HL=0001h, OR A with 01h
LAB_EE70	EQU	EE70h		; set HL=0001h, OR A with 01h
LAB_EE78	EQU	EE78h		; set HL=0001h, OR A with 01h
LAB_EE7C	EQU	EE7Ch		; set HL=0001h, OR A with 01h
LAB_EE80	EQU	EE80h		; set HL=0001h, OR A with 01h
LAB_EE84	EQU	EE84h		; set HL=0001h, OR A with 01h
LAB_EE88	EQU	EE88h		; set HL=0001h, OR A with 01h
LAB_EE8C	EQU	EE8Ch		; set HL=0001h, OR A with 01h
LAB_EE9C	EQU	EE9Ch		; set HL=0001h, OR A with 01h
LAB_EEB0	EQU	EEB0h		; set HL=0001h, OR A with 01h
LAB_EEB4	EQU	EEB4h		; set HL=0001h, OR A with 01h
LAB_EEB8	EQU	EEB8h		; set HL=0001h, OR A with 01h
LAB_EEBC	EQU	EEBCh		; set HL=0001h, OR A with 01h
LAB_EEC0	EQU	EEC0h		; set HL=0001h, OR A with 01h
LAB_EEC8	EQU	EEC8h		; set HL=0001h, OR A with 01h
LAB_EED0	EQU	EED0h		; set HL=0001h, OR A with 01h
LAB_EEDC	EQU	EEDCh		; re-mapped address
LAB_EEE4	EQU	EEE4h		; wait for key, no echo ??
LAB_EEE8	EQU	EEE8h		; get byte from key buffer ??
LAB_EEEC	EQU	EEECh		; setup LAB_E69D & LAB_E6A9 to LAB_E6AD
LAB_EEF0	EQU	EEF0h		; set cursor on/off
LAB_EEF8	EQU	EEF8h		; get key status without waiting
LAB_EF08	EQU	EF08h		; get RTC date, month & year to bytes starting at
					; pointer
LAB_EF0C	EQU	EF0Ch		; save RTC hour/minute word at pointer
LAB_EF14	EQU	EF14h		; do BDOS function 2Dh
LAB_EF18	EQU	EF18h		; set LAB_E2F8 depending on flag
LAB_EF1C	EQU	EF1Ch		; set RTC date, month & year from 4 bytes starting at
					; pointer
LAB_EF20	EQU	EF20h		; set RTC hours & minutes
LAB_EF24	EQU	EF24h		; do BIOS function 19
LAB_EF28	EQU	EF28h		; null routine
LAB_EF2C	EQU	EF2Ch		; null routine

LAB_F180	EQU	F180h		; BDOS function handler
LAB_F238	EQU	F238h
LAB_F340	EQU	F340h
LAB_F5E1	EQU	F5E1h
LAB_F5EA	EQU	F5EAh
LAB_F5ED	EQU	F5EDh
LAB_F5F0	EQU	F5F0h
LAB_F5F3	EQU	F5F3h
LAB_F5F6	EQU	F5F6h
LAB_F791	EQU	F791h
LAB_F8EF	EQU	F8EFh
LAB_FFFF	EQU	FFFFh

	END

